SystemOrganization addCategory: #'Roassal-Actions'!
SystemOrganization addCategory: #'Roassal-AttachPoint'!
SystemOrganization addCategory: #'Roassal-AttachPoint-Test'!
SystemOrganization addCategory: #'Roassal-Benchmarks'!
SystemOrganization addCategory: #'Roassal-Builder'!
SystemOrganization addCategory: #'Roassal-Builder-Tests'!
SystemOrganization addCategory: #'Roassal-Core'!
SystemOrganization addCategory: #'Roassal-Core-Tests'!
SystemOrganization addCategory: #'Roassal-Event'!
SystemOrganization addCategory: #'Roassal-Example'!
SystemOrganization addCategory: #'Roassal-Hooks'!
SystemOrganization addCategory: #'Roassal-Hooks-Tests'!
SystemOrganization addCategory: #'Roassal-Interaction'!
SystemOrganization addCategory: #'Roassal-Interaction-Tests'!
SystemOrganization addCategory: #'Roassal-Layout'!
SystemOrganization addCategory: #'Roassal-Layout-Tests'!
SystemOrganization addCategory: #'Roassal-Normalizers'!
SystemOrganization addCategory: #'Roassal-Normalizers-Tests'!
SystemOrganization addCategory: #'Roassal-PlatformIndependent'!
SystemOrganization addCategory: #'Roassal-Transformation'!
SystemOrganization addCategory: #'Roassal-Visitor'!
SystemOrganization addCategory: #'Roassal-Visitor-Tests'!
SystemOrganization addCategory: #'Roassal-Widgets'!
SystemOrganization addCategory: #'Roassal-Widgets-Tests'!

!Rectangle methodsFor: '*Roassal' stamp: 'VanessaPena 8/26/2012 10:19'!
origin: aPoint

	origin := aPoint! !

!Rectangle methodsFor: '*Roassal' stamp: 'gvc 6/7/2006 10:44'!
pointAtSideOrCorner: loc
	"Answer the point represented by the given location."
	
	^ self
		perform: (#(topLeft topCenter topRight rightCenter
					bottomRight bottomCenter bottomLeft leftCenter)
						at: (#(topLeft top topRight right
					bottomRight bottom bottomLeft left) indexOf: loc))

	! !

!Rectangle methodsFor: '*Roassal-Core' stamp: 'AlexandreBergel 8/27/2012 09:57'!
roCorner: aPoint
	"This method should not be. But the tree map layout works that way"
	corner := aPoint! !

!Rectangle methodsFor: '*Roassal-Core' stamp: 'AlexandreBergel 8/27/2012 09:57'!
roOrigin: aPoint
	"This method should not be. But the tree map layout works that way"
	origin := aPoint! !

!Rectangle methodsFor: '*Roassal' stamp: 'VanessaPena 8/26/2012 10:24'!
translateTo: aPoint

	| w h|
	w := self width.
	h := self height.
	
	origin := aPoint .
	corner := aPoint + (w@h)! !

!Class methodsFor: '*roassal-core' stamp: ''!
numberOfSubclasses
	^ self allSubclasses size! !

!Class methodsFor: '*roassal-core' stamp: ''!
numberOfVariables
	^ self instVarNames size! !

!SequenceableCollection methodsFor: '*roassal-core' stamp: ''!
asSorted: aBlockOrSymbol
	| c b |
	c := self copy.
	(aBlockOrSymbol isKindOf: BlockClosure)
		ifTrue: [ b := aBlockOrSymbol ].
		
	(aBlockOrSymbol isKindOf: Symbol)
		ifTrue: [ b := [ :v1 :v2 | (v1 perform: aBlockOrSymbol) <= (v2 perform: aBlockOrSymbol) ] ].
		
	c sort: b.
	^ c! !

!SequenceableCollection methodsFor: '*roassal-core' stamp: 'AlexandreBergel 5/3/2012 19:16'!
roSwapElement: u withElement: v
	| index1 index2 |
	index1 := self indexOf: u.
	index2 := self indexOf: v.
	self at: index2 put: u.
	self at: index1 put: v.! !

!Number methodsFor: '*roassal-core' stamp: ''!
max: max in: anInterval 
	"
	(0 max: 20 in: (1 to: 10)) == 1
	(0 max: 20 in: (0 to: 10)) == 0
	(0 max: 20 in: (1 to: 10)) == 1
	(2 max: 20 in: (0 to: 10)) == 1 
	(4 max: 20 in: (0 to: 10)) == 2
	(20 max: 20 in: (0 to: 10)) == 10
	"
	^ self min: 0 max: max in: anInterval! !

!Number methodsFor: '*roassal-core' stamp: ''!
min: min max: max in: anInterval 
	"
	(0 max: 20 in: (1 to: 10)) == 1
	(0 max: 20 in: (0 to: 10)) == 0
	(0 max: 20 in: (1 to: 10)) == 1
	(2 max: 20 in: (0 to: 10)) == 1 
	(4 max: 20 in: (0 to: 10)) == 2
	(19 max: 20 in: (0 to: 10)) == 10
	"
	^ (self - min) / (max - min) * (anInterval last - anInterval first) + anInterval first
! !

TestCase subclass: #ROAddNameTest
	instanceVariableNames: 'element view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROAddNameTest methodsFor: 'running' stamp: 'AlexandreBergel 10/3/2012 17:47'!
setUp
	super setUp.
	element := ROElement on: 42.
	view := ROView new.
	view add: element! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 17:49'!
testAddThenRemove

	ROAddName toElement: element.
	ROAddName removeFrom: element.
	
	self assert: view numberOfElements = 1.
	self assert: view elements first == element! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 18:17'!
testAddTwice

	ROAddName toElement: element.
	ROAddName toElement: element.
	
	self assert: view numberOfElements = 2.
! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 17:46'!
testAddition

	self assert: element view numberOfElements = 1.
	ROAddName toElement: element.
	self assert: element view numberOfElements = 2.	 ! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 17:47'!
testRemoveFromEmpty

	self assert: element view numberOfElements = 1.
	ROAddName removeFrom: element.
	self assert: element view numberOfElements = 1.! !

!ROAddNameTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/3/2012 18:17'!
testRemoveTwice

	ROAddName removeFrom: element.
	ROAddName removeFrom: element.
	
	self assert: view numberOfElements = 1.
! !

TestCase subclass: #ROConstraintTest
	instanceVariableNames: 'element1 element2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROConstraintTest methodsFor: 'running' stamp: 'AlexandreBergel 9/30/2012 18:51'!
setUp
	super setUp.
	element1 := ROElement sprite.
	element1 extent: 50 @ 50.
	
	element2 := ROElement sprite.
! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'AlexandreBergel 10/1/2012 09:25'!
testEvent

	| view outer inner innerLabel innerElement t |
	view := ROView new.

	outer := ROElement spriteOn: 'outter'.

	inner := ROElement spriteOn: 'inner'.
	innerLabel := ROElement labelOn: 'My sprite'.
	innerElement := ROElement spriteOn: 'Inner element'.
	outer add: inner; add: innerLabel.
	inner add: innerElement.

	"We layout the things"
	ROGridLayout on: inner elements.
	ROVerticalLineLayout on: outer elements.

	ROConstraint stick: innerLabel below: inner.
	view add: outer.

	"-------"
	t := 0.
	inner on: ROElementTranslated do: [ :event | t := t + 1 ].
	self assert: t = 0.

	innerElement translateBy: -1 @ 0.
	self assert: t = 0.
 
		
! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'AlexandreBergel 10/1/2012 09:30'!
testEvent2

	| view outer inner innerLabel innerElement t |
	view := ROView new.

	outer := ROElement spriteOn: 'outter'.

	inner := ROElement spriteOn: 'inner'.
	innerLabel := ROElement labelOn: 'My sprite'.
	innerElement := ROElement spriteOn: 'Inner element'.
	outer add: inner; add: innerLabel.
	inner add: innerElement.

	"We layout the things"
	ROGridLayout on: inner elements.
	ROVerticalLineLayout on: outer elements.

	ROConstraint stick: innerLabel below: inner.
	view add: outer.

	"-------"
	t := 0.
	inner on: ROElementEvent do: [ :event | t := t + 1 ].
	self assert: t = 0.

	innerElement translateBy: 5 @ 0.
	self assert: t = 1.
 ! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'AlexandreBergel 10/1/2012 09:23'!
testEventIfNoMoved

	| el t |
	el := ROElement new.
	t := 0.
	el on: ROElementTranslated do: [ :event | t := t + 1 ].
	
	el translateBy: 0 @ 0.
	self assert: t = 0.! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'AlexandreBergel 10/1/2012 09:29'!
testEventIfNoResized

	| el t |
	el := ROElement new.
	t := 0.
	el on: ROElementEvent do: [ :event | t := t + 1 ].
	
	el extent: el extent.
	self assert: t = 0.! !

!ROConstraintTest methodsFor: 'event generations' stamp: 'AlexandreBergel 10/1/2012 09:28'!
testEventIfResized

	| el t |
	el := ROElement new.
	t := 0.
	el on: ROElementEvent do: [ :event | t := t + 1 ].
	
	el extent: 10 @ 10.
	self assert: t = 1.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 9/30/2012 21:07'!
testStickAbove

	ROConstraint 
		stick: element1 above: element2.
		
	self assert: (element2 position - (0 @ element1 height)) = element1 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element2 position - (0 @ element1 height)) = element1 position.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 9/30/2012 21:06'!
testStickBelow

	ROConstraint 
		stick: element1 below: element2.
		
	self assert: (element2 position + (0 @ element2 height)) = element1 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element2 position + (0 @ element2 height)) = element1 position.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 9/30/2012 20:35'!
testStickToTheLeft

	ROConstraint 
		stick: element1 onTheLeftOf: element2.
		
	self assert: (element1 position + (element1 width @ 0)) = element2 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element1 position + (element1 width @ 0)) = element2 position.! !

!ROConstraintTest methodsFor: 'sticking' stamp: 'AlexandreBergel 9/30/2012 21:01'!
testStickToTheRight

	ROConstraint 
		stick: element1 onTheRightOf: element2.
		
	self assert: (element2 position + (element2 width @ 0)) = element1 position.
	
	element2 translateTo: 60 @ 30.
	self assert: (element2 position + (element2 width @ 0)) = element1 position.! !

TestCase subclass: #ROTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROTest subclass: #ROAbstractCanvasTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROAbstractCanvasTest classSide methodsFor: 'testing' stamp: 'AlexandreBergel 4/19/2012 12:21'!
isAbstract
	^ self name == #ROAbstractCanvasTest ! !

!ROAbstractCanvasTest methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:20'!
canvasClass
	^ ROAbstractCanvas! !

!ROAbstractCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/19/2012 12:20'!
testTransformationBijection

	| canvas camera |
	camera := ROCamera new realExtent: 100@50; extent: 200@100.
	canvas := self canvasClass onCamera: camera.
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 0@0)) = (0 @ 0).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: -100 @ -50)) = (-100 @ -50).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 100 @ 50)) = (100 @ 50).
	
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: -10@ -6)) = (-10 @ -6).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 40 @ 50)) = (40 @ 50).
	self assert: (canvas realToVirtualRectangle: (canvas virtualToRealRectangle: (-10 @ -6 corner: 40 @ 50))) =
					 (-10 @ -6 corner: 40 @ 50).! !

ROTest subclass: #ROAbstractLabelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROAbstractLabelTest classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 9/20/2012 12:00'!
isAbstract 
	^ self name == #ROAbstractLabelTest! !

!ROAbstractLabelTest methodsFor: 'hooks' stamp: 'AlexandreBergel 9/20/2012 11:58'!
classToTest
	self subclassResponsibility ! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 9/20/2012 11:59'!
testBounds
	| el |
	el := ROElement labelOn: 'hello world'.
	self assert: el bounds ~= ( 0@0 corner: 5@5).
	self assert: el extent = (self classToTest new preferedExtentFor: el).! !

!ROAbstractLabelTest methodsFor: 'colors' stamp: 'AlexandreBergel 10/14/2012 19:12'!
testColorFor

	 | rawView el1 shape |
	  rawView := ROView new.
	  el1 := ROElement on: 1.
	  el1 extent: 50@50.
	  el1 + (shape := self classToTest new color: [ :element | element model odd ifTrue: [ Color red ] ifFalse: [ Color blue ] ]). 

	  rawView add: el1.
	
	self assert: (shape colorFor: el1) = Color red.! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 9/20/2012 12:01'!
testDynamicBounds
	| el extent shape extentFromShape bounds |
	el := ROElement on: 'hello'.
	el + self classToTest.
	
	shape := el getShape: self classToTest.
	bounds := el bounds.
	
	el model: 'hello world'.
	
	self assert: (shape preferedExtentFor: el) = el extent.
	
	self assert: el bounds origin = bounds origin.
	
	self assert: el bounds extent x > bounds extent x.
	self assert: el bounds extent y = bounds extent y.! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 9/20/2012 12:01'!
testDynamicExtent
	| el extent shape extentFromShape |
	el := ROElement on: 'hello'.
	el + self classToTest.
	
	shape := el getShape: self classToTest.
	extent := el extent.
	extentFromShape := shape preferedExtentFor: el.
	
	self assert: extent = extentFromShape.
	
	el model: 'hello world'.
	
	self assert: (shape preferedExtentFor: el) x > extentFromShape x.
	self assert: (shape preferedExtentFor: el) y = extentFromShape y.
	
	self assert: (shape preferedExtentFor: el) = el extent.
	
	self assert: el extent x > extent x.
	self assert: el extent y = extent y.	! !

!ROAbstractLabelTest methodsFor: 'lines' stamp: 'AlexandreBergel 9/20/2012 11:59'!
testLinesOf

	| label |
	label := self classToTest new.
	self assert: (label linesOf: 'hello
world
	bravo') = #('hello' 'world' '	bravo')! !

!ROAbstractLabelTest methodsFor: 'lines' stamp: 'AlexandreBergel 9/20/2012 11:59'!
testLinesOfEmptyString

	| label |
	label := self classToTest new.
	self assert: (label linesOf: '') = #()! !

!ROAbstractLabelTest methodsFor: 'lines' stamp: 'AlexandreBergel 9/20/2012 11:59'!
testLinesOfWithTrailingCR

	| label |
	label := self classToTest new.
	self assert: (label linesOf: 'hello
world
	bravo
') = #('hello' 'world' '	bravo')! !

!ROAbstractLabelTest methodsFor: 'size minimum' stamp: 'AlexandreBergel 9/20/2012 12:01'!
testMinimumSize

	| el |
	el := ROElement on: 'hello'.
	el extent: (90 @ 45).
	self assert: el extent = (90 @ 45).
	
	el + self classToTest.
	self assert: el extent = (90 @ 45).! !

!ROAbstractLabelTest methodsFor: 'size minimum' stamp: 'AlexandreBergel 9/20/2012 12:01'!
testMinimumSize2

	| el |
	el := ROElement on: 'hello'.
	el extent: (3 @ 3).
	self assert: el extent = (3 @ 3).
	
	el + self classToTest.
	self assert: el extent > (3 @ 3).! !

!ROAbstractLabelTest methodsFor: 'lines' stamp: 'AlexandreBergel 6/10/2012 16:04'!
testMultilines
	"
	self debug: #testMultilines
	"
	| view elementWith2Lines elementWith1Line |
	view := ROView new.
	view add: (elementWith2Lines := ROElement  labelOn: 
'hello 
world').
	view add: (elementWith1Line := ROShape elementOn: 'bonjour le monde!!').
	"view openInWindow."
	
	self assert: (elementWith2Lines height >= (elementWith1Line height * 2))! !

!ROAbstractLabelTest methodsFor: 'white char' stamp: 'AlexandreBergel 10/17/2012 08:29'!
testReplaingWhiteCharacter

	| label element str |
	label := self classToTest new.
	element := ROElement on: (str := '	abc	def').
	self assert: (label textFor: element) = str.
	self assert: (label textAdaptedFor: element) =  '      abc      def'
! !

!ROAbstractLabelTest methodsFor: 'size' stamp: 'AlexandreBergel 9/20/2012 12:00'!
testSize
	| el1 el2 |
	el1 := ROElement on: 'hello'.
	el2 := ROElement on: 'h'.
	
	self assert: el1 bounds = el2 bounds.
	self assert: el1 bounds = ( 0@0 corner: 5@5).
	
	el1 + self classToTest.
	el2 + self classToTest.
	
	self assert: el1 extent = (self classToTest new preferedExtentFor: el1).
	self assert: el2 extent = (self classToTest new preferedExtentFor: el2).
	
	self assert: el1 bounds ~= el2 bounds.
	self assert: el1 bounds height = el2 bounds height.
	self assert: el1 bounds width > el2 bounds width.! !

!ROAbstractLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/20/2012 12:00'!
testTextFor

	| label el |
	label := self classToTest new.
	label text: [ :e | e model + 1].
	el := ROElement on: 2.
	self assert: (label textFor: el) = '3'! !

!ROAbstractLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/20/2012 12:00'!
testWidthFor

	| label element1 element2 |
	label := self classToTest new.
	element1 := ROElement on: 'abcdefghijk
abc
def'.
	element2 := ROElement on: 'abcdefghijk'.
	
	self assert: (label longestTextLineFor: element1) = (label longestTextLineFor: element2).
	self assert: (label longestTextLineFor: element1) = element2 model.
	self assert: (label widthFor: element1) = (label widthFor: element2).! !

ROAbstractLabelTest subclass: #ROCenteredLabelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCenteredLabelTest methodsFor: 'hooks' stamp: 'AlexandreBergel 9/20/2012 12:02'!
classToTest
	^ ROCenteredLabel! !

ROAbstractLabelTest subclass: #ROLabelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROLabelTest methodsFor: 'hooks' stamp: 'AlexandreBergel 9/20/2012 11:58'!
classToTest
	^ ROLabel! !

ROTest subclass: #ROAnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROAnnouncerTest methodsFor: 'running' stamp: ''!
setUp
	super setUp.
	announcer := ROAnnouncer new.! !

!ROAnnouncerTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 13:57'!
testIsForwarder

	| t |
	self deny: announcer isForwarder.

	t := 0.
	announcer when: ROEvent do: [ :ann | t := t + 1 ].
	self assert: t isZero.

	announcer announce: ROEvent.
	self assert: t = 1.
	announcer announce: ROMouseClick.
	self assert: t = 2.
	
	announcer forward: ROMouseClick.
	announcer announce: ROMouseClick.
	self assert: t = 2. "No increase since it is forwarded."
	announcer announce: ROEvent.
	self assert: t = 3.

! !

!ROAnnouncerTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 13:57'!
testIsForwarder2

	| t |

	t := 0.
	announcer when: ROEvent do: [ :ann | t := t + 1 ].
	self deny: (announcer isForwarded: ROMouseClick). 

	announcer forward: ROEvent.
	self assert: (announcer isForwarded: ROMouseClick).

	announcer announce: ROMouseClick.
	self assert: t = 0. "No increase since it is forwarded."

	announcer announce: ROEvent.
	self assert: t = 0.

! !

ROTest subclass: #ROArrowTest
	instanceVariableNames: 'arrow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROArrowTest methodsFor: 'running' stamp: 'AlexandreBergel 6/12/2012 15:01'!
setUp

	super setUp.
	arrow := ROArrow new.! !

!ROArrowTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/12/2012 15:02'!
testInitialization

	self assert: arrow offset = 0! !

!ROArrowTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/12/2012 16:54'!
testLine

	| line |
	line := ROLine new.
	self assert: line numberOfArrows = 0.
	self deny: line hasArrow.
	line add: arrow.
	self assert: line numberOfArrows = 1.
	self assert: line hasArrow.! !

ROTest subclass: #ROAttachPointTest
	instanceVariableNames: 'view el1 el2 edge shape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint-Test'!

!ROAttachPointTest methodsFor: 'running' stamp: 'AlexandreBergel 6/1/2012 06:02'!
setUp
	
	view := ROView new.
	el1 := ROElement spriteOn: 1.
	el2 := ROElement spriteOn: 2.
	el1 @ ROPopup.
	el2 @ ROPopup.
	
	edge := ROEdge from: el1 to: el2.
	view addAll: (Array with: el1 with: el2 with: edge).
	shape := ROLine new color: Color black.
	edge + shape.
	ROHorizontalLineLayout on: (Array with: el1 with: el2)! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:11'!
testHorizontalAttachPoint
	shape attachPoint: (ROHorizontalAttachPoint new).
	self assert: (shape startingPointOf: edge) = (el1 bounds topRight + (0 @ (el1 bounds extent y / 2)) asIntegerPoint ) .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + (0 @ (el2 bounds extent y / 2)) asIntegerPoint )  .! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:11'!
testShorterDistancePoint1
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el1 is on the left of el2"
	self assert: (shape startingPointOf: edge) = (el1 bounds topRight + (0 @ (el1 bounds extent y / 2)) asIntegerPoint)  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + (0 @ (el2 bounds extent y / 2)) asIntegerPoint)! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:12'!
testShorterDistancePoint2
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el2 is on the left of el1"
	p := el1 position.
	el1 translateTo: el2 position.
	el2 translateTo: p.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + (0 @ (el1 bounds extent y / 2)) asIntegerPoint)  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topRight + (0 @ (el2 bounds extent y / 2)) asIntegerPoint)! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:12'!
testShorterDistancePoint3
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el2 is on the left of el1"
	p := el1 position.
	el1 translateBy: 0 @ 80.
	el2 translateTo: p.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + ((el1 bounds width / 2) asInteger @0)) .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds width / 2) asInteger @ el2 bounds width))! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:12'!
testShorterDistancePoint4
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same vertical line. el1 is above el2"
	el2 translateTo: el1 position.
	el2 translateBy: 0 @ 80.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + ((el1 bounds width / 2) asInteger @ el1 bounds height)) .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds width / 2) asInteger @ 0))! !

!ROAttachPointTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/9/2012 08:52'!
testShorterDistancePoint4WithOffset
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new offset: 5).
	
	"el1 and el2 are on the same vertical line. el1 is above el2"
	el2 translateTo: el1 position.
	el2 translateBy: 0 @ 80.
	
	self assert: (shape startingPointOf: edge) = ((el1 bounds topLeft + ((el1 bounds width / 2) asInteger @ el1 bounds height)) + (5 @ 0)) .
	self assert: (shape endingPointOf: edge) = ((el2 bounds topLeft + ((el2 bounds width / 2) asInteger @ 0) + (5 @ 0)))! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:12'!
testVerticalAttachPoint
	shape attachPoint: (ROVerticalAttachPoint new).
	self assert: (shape startingPointOf: edge) = (el1 bounds bottomLeft + ((el1 bounds extent x / 2) asInteger @ 0))  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds extent x / 2) asInteger @ 0))  .! !

ROTest subclass: #ROBorderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROBorderTest methodsFor: 'tests' stamp: ''!
testInitialization
	| border |
	border := ROBorder new.
	self assert: border color == ROBorder defaultColor! !

!ROBorderTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/10/2012 22:49'!
testSetting
	| border |
	border := ROBorder new.
	border color: Color green.
	self assert: border color = Color green! !

ROTest subclass: #ROBoxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROBoxTest methodsFor: 'tests' stamp: ''!
testChangingBorderColor

	| box color |
	box := ROBox new.
	color := box borderColorFor: ROElement new.

	box borderColor: Color red.
	self assert: (box  borderColorFor: ROElement new) == Color red.
	self assert: (box  borderColorFor: ROElement new) ~= color! !

!ROBoxTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/17/2012 13:48'!
testChangingModel

	| el shape shape2 |
	el := ROElement on: 1.
	shape := ROBox new color: [ :element | element model odd ifTrue: [ Color red ] ifFalse: [ Color blue ] ].
	shape2 := ROCircle new color: [ :element | element model odd ifTrue: [ Color orange ] ifFalse: [ Color yellow ] ].
	shape next: shape2.
	el + shape.
	
	self assert: (shape colorFor: el) = Color red. 
	self assert: (shape2 colorFor: el) = Color orange.
	
	el model: 2.

	"We did not reset the cache"
	self assert: (shape colorFor: el) =  Color blue. 
	self assert: (shape2 colorFor: el) =  Color yellow.
	
! !

!ROBoxTest methodsFor: 'tests' stamp: ''!
testChangingWidthColor

	| box width |
	box := ROBox new.
	width := box borderWidthFor: ROElement new.

	box borderWidth: 4.
	self assert: (box  borderWidthFor: ROElement new) = 4.
	self assert: (box  borderWidthFor: ROElement new) ~= width! !

!ROBoxTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/14/2012 19:11'!
testColorAndCache 

	| el box |
	el := ROElement on: (Array with: Color blue).
	box := ROBox new color: [ :element | element model first ].
	
	self assert: (box colorFor: el) = Color blue.

	"el model at: 1 put: Color red."
	box color: Color green.

	self assert: (box colorFor: el) = Color green.
	! !

!ROBoxTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/14/2012 19:23'!
testComputingWidth

	| box width |
	box := ROBox new.
	width := box borderWidthFor: ROElement new.

	box borderWidth: 4.
	self assert: (box  borderWidthFor: ROElement new) = 4.
	self assert: (box  borderWidthFor: ROElement new) ~= width! !

!ROBoxTest methodsFor: 'tests' stamp: ''!
testInitialization 

	self assert: ROBox new color == ROBox defaultColor! !

ROTest subclass: #ROCameraTest
	instanceVariableNames: 'camera2 camera1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCameraTest methodsFor: 'running' stamp: ''!
setUp
	camera1 := ROCamera new.

	camera2 := ROCamera new.
	camera2 height: 20.! !

!ROCameraTest methodsFor: 'tests' stamp: ''!
testAngle

	self assert: camera1 angle = ROCamera defaultAngle! !

!ROCameraTest methodsFor: 'tests' stamp: ''!
testInitialization
	
	self assert: camera1 angle = ROCamera defaultAngle.
	self assert: camera1 position = ROCamera defaultPosition! !

!ROCameraTest methodsFor: 'initializing' stamp: ''!
testInitialize

	self assert: ROCamera new extent = ROCamera defaultExtent ! !

!ROCameraTest methodsFor: 'moving' stamp: ''!
testMovingUpAndDownCameraShouldBeCentered

	| view el b1 b2 |
	view := ROView new.
	view add: (el := ROElement sprite).
	"view open."

	self assert: (el bounds = ( 0@0 corner: 50@50)).

	b1 := (view camera virtualToRealRectangle: el bounds).

	"we move up"
	view camera moveDown.
	b2 := (view camera virtualToRealRectangle: el bounds).
	self assert: b1 extent < b2 extent.

	"check at the position of the element"
	self assert: b1 origin < b2 origin
! !

!ROCameraTest methodsFor: 'moving' stamp: ''!
testMovingUpAndDownCameraShouldBeCentered2

	| view el b1 b2 |
	view := ROView new.
	view add: (el := ROElement sprite).
	el center: 250@250.
	self assert: el center = (250@250).
	"view open."

	b1 := (view camera virtualToRealRectangle: el bounds).
	self assert: b1 center = (250@250).
	
	"we move up"
	view camera moveUp.
	b2 := (view camera virtualToRealRectangle: el bounds).
	self assert: b2 center = (230@230).! !

!ROCameraTest methodsFor: 'translating' stamp: ''!
testTranslating
	self assert: (camera1 virtualToRealPoint: (camera1 realToVirtualPoint: 250@500)) = ( 250@500).
	self assert: (camera1 realToVirtualPoint: 250@500) = ( 250@500).
	camera1 translateBy: 50@30.
	self assert: (camera1 virtualToRealPoint: (camera1 realToVirtualPoint: 250@500)) = ( 250@500).
	self assert: (camera1 realToVirtualPoint: 250@500) = ( 300@530).! !

ROTest subclass: #ROCircleTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCircleTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp

	node := ROElement on: 'hello'.
	node extent: 40 @ 30.
	node
		addShape: (ROCircle new color: Color green)
	! !

!ROCircleTest methodsFor: 'as yet unclassified' stamp: ''!
testInitialization
	self assert: (ROCircle new color = ROCircle defaultColor)! !

ROTest subclass: #ROCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCollectionTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/18/2012 14:44'!
testAddInteraction

	| elements |
	elements := ROElement forCollection: (1 to: 20).
	self assert: (elements allSatisfy: [ :e | (e is: RODraggable) not ]).
	
	elements @ RODraggable.
	self assert: (elements allSatisfy: [ :e | e is: RODraggable ]).! !

ROTest subclass: #ROColorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 18:02'!
testAdjustBrightness

	self assert: (((Color gray: 0.7) adjustBrightness: -0.2) brightness - 0.5) < 0.01 ! !

!ROColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 18:03'!
testAdjustBrightnessNegativo

	self assert: (((Color gray: 0.7) adjustBrightness: -0.2) brightness - 0.5) < 0.01 ! !

!ROColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 18:03'!
testAdjustBrightnessPositivo

	self assert: (((Color gray: 0.5) adjustBrightness: 0.2) brightness - 0.7) < 0.01 ! !

!ROColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 17:25'!
testBrightness
	self assert: Color red brightness = 1.0.
	self assert: Color green brightness = 1.0.
	self assert: Color blue brightness = 1.0.
	
	self assert: ((Color gray: 0.7) brightness -  0.7) < 0.1! !

ROTest subclass: #RODecoratorTest
	instanceVariableNames: 'box label element box2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!RODecoratorTest methodsFor: 'running' stamp: 'AlexandreBergel 4/14/2012 19:40'!
setUp

	box := ROBox new.
	box2 := ROBox new color: Color blue.
	label := ROLabel new.
	element := ROElement new.
! !

!RODecoratorTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/17/2012 08:48'!
testAddLast

	box addLast: box2.
	box2 addLast: label.
	self assert: box next == box2.
	self assert: label next class == RONullShape.! !

!RODecoratorTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/25/2012 20:26'!
testExample
	| el view |
	view := ROView new.
	view add: ((el := ROElement on: 10) + (ROBox new color: Color red; borderColor: Color blue)+ ROLabel).
	"
	view open
	"
	self assert: el shapes second borderColor == Color blue.
	self assert: el numberOfShapes = 4.! !

!RODecoratorTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/17/2012 08:48'!
testLinked
	"
	self debug: #testLinked
	"
				
	self assert: box next class == RONullShape.
	self assert: label next class == RONullShape.

	element 
		addShape: box;
		addShape: label.
	
	self assert: label next == box.
	self assert: box next class ==  ROChildrenShape.
! !

ROTest subclass: #RODraggableTest
	instanceVariableNames: 'node draggableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!RODraggableTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp
	node := ROElement new.
	node addShape: (ROBox new).

	draggableNode := ROElement new.
	draggableNode extent: 50@50.
	draggableNode + ROBox.
	draggableNode @ RODraggable.! !

!RODraggableTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/7/2012 11:54'!
testAddition

	
	| bounds |
	node := ROElement new.
	node addShape: (ROBox new).
	node addInteraction: RODraggable.
	bounds := node bounds.
	node announce: (ROMouseDragging new step: 5 @ 5).
	self assert: (bounds translateBy: 5 @ 5) = node bounds ! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testAnnouncingDraggingWhileBeingRegistered

	| bounds |
	bounds := node bounds.
	node addInteraction: RODraggable.
	node announce: (ROMouseDragging new step: 4@3).
	self assert: (bounds translateBy: 4@3) = node bounds.
! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testAnnouncingDraggingWithoutBeingRegistered

	| bounds |
	bounds := node bounds.
	node announce: (ROMouseDragging new step: 4@3).
	self assert: bounds = node bounds.
! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggable
	self deny: (node is: RODraggable).
	self assert: (node numberOfInteractions isZero).

	node addInteraction: RODraggable new.
	self assert: (node is: RODraggable).
		! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggableByClass
	self deny: (node is: RODraggable).
	self assert: (node numberOfInteractions isZero).

	node addInteraction: RODraggable.
	self assert: (node is: RODraggable).

		! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggingStep

	| view p1 |
	view := ROView new.
	view add: draggableNode.
	
	"dragging a node increases its position by the dragging step"
	p1 := draggableNode position.
	self assert: (p1 = (0@0)).
	draggableNode announce: (ROMouseDragging step: 10 @ 6).
	self assert: (draggableNode position = (10 @ 6)).
	draggableNode announce: (ROMouseDragging step: -10 @ -6).
	self assert: (draggableNode position = (0 @ 0)).
	
	"take care of real vs virtual steps"
	view camera bounds: (0@0 corner: 250@250).
	draggableNode announce: (ROMouseDragging step: 10 @ 6).
	self assert: (draggableNode position = ( 5@3)).! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testElementToBeAdded

	| drag |
	self assert: (RODraggable elementToBeAdded class == RODraggable).
	drag := RODraggable new.
	self assert: (drag elementToBeAdded == drag)! !

!RODraggableTest methodsFor: 'nesting' stamp: 'AlexandreBergel 9/5/2012 08:42'!
testNesting

	| view node1 b innerNode |
	view := ROView new.
	node1 := ROElement spriteOn: 'hello'.
	node1 add: (innerNode := ROElement spriteOn: 'world').
	view add: node1.
	
	node1 translateBy: 10@20.
	
	b := node1 bounds.

	ROAdjustSizeOfNesting on: node1.
	ROAdjustSizeOfNesting on: node1.
	self assert: (b = node1 bounds).

	innerNode extent: 10@10.
	innerNode translateBy: 1 @ 1.
	self assert: (b = node1 bounds).
	
	innerNode translateBy: 5 @ 5.
	innerNode translateBy: 5 @ 5.
	self assert: (b = node1 bounds).
	
	innerNode announce: (ROMouseDragging step: 5 @ 5).
	innerNode announce: (ROMouseDragging step: 5 @ 5).
	self assert: (b = node1 bounds).
	
	"
	view openInWindow 
	"! !

ROTest subclass: #ROElementTest
	instanceVariableNames: 'node draggableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROElementTest subclass: #ROContainingElementTest
	instanceVariableNames: 'node2 node3 node1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROContainingElementTest methodsFor: 'running' stamp: ''!
classToTest
	^ ROElement ! !

!ROContainingElementTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp

	node2 := self classToTest on: 'world'.
	node2 extent: 40@30.
	node2 addShape: (ROBox new color: Color green).

	node3 := self classToTest on: 'world'.
	node3 extent: 40@30.
	node3 addShape: (ROBox new color: Color yellow).
	node3 translateBy: 40@30.

	node1 := self classToTest on: 'hello'.
	node1 extent: 100 @ 130.
	node1
		addShape: ROBox new;
		addShape: ROBorder new.! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/22/2012 00:38'!
testAddingWithResize

	self assert: node3 extent < node1 extent.
	node3 add: node1.
	self assert: node3 extent > node1 extent! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/2/2012 14:27'!
testAddingWithoutResize

	self assert: node3 extent < node1 extent.
	node3 resizeStrategy: ROFixedSizedParent instance.
	node3 add: node1.
	self assert: node3 extent < node1 extent! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/25/2012 18:22'!
testContainsEdge
	| view roView nodes edge |

	view := ROMondrianViewBuilder new.
	view shape rectangle size: 50.
	nodes := view nodes: #( 1 2 ).
	node1 := nodes first.
	node2 := nodes second.

	view shape line width: 4.	
	view interaction popupText: 'edge!!'.
	edge := view edgeFromAssociation: 1 -> 2.

	view applyLayout.
	roView := view raw.
	
	self assert: (edge contains: 2 @ 0).
	self assert: (roView elementAt: 57 @ 30) == edge.
	self assert: (roView elementAt: edge bounds center) == edge.
	
	self assert: (roView elementAt: node1 center) == node1.
	self assert: (roView elementAt: node2 center) == node2.	
! !

!ROContainingElementTest methodsFor: 'dragging' stamp: ''!
testDraggingNestedElement

	| view b |
	"node1 bounds = 50@50 corner: 150@180 
	node3 bounds =  190@130 corner: 230@160 "
	node1 addInteraction: RODraggable.
	node3 addInteraction: RODraggable.
	node1 add: node3.
	view := (ROView new add: node1 ).

	node1 translateBy: 50 @ 50.
	
	"We move the inner node toward the bottom right corner"
	node3 translateBy: 150 @ 100.
	self assert: (node1 extent = ( 235@165)).
	
	"We move the inner node toward the top left corner"
	b := node1 bounds.
	node3 translateBy: -200 @ -150.
	self assert: node1 topLeft ~= b topLeft.
	self assert: node1 topLeft  = ( 40@30).
	"
	view open
	"! !

!ROContainingElementTest methodsFor: 'translation shape and inner nodes' stamp: 'AlexandreBergel 9/25/2012 15:10'!
testElementAt

	| el view |
	el := ROElement new + ROBox.
	el extent: 20 @ 20.
	
	view := ROView new.
	view add: el.
	el translateTo: 3 @ 3.
	
	self assert: (view elementAt: 3 @ 3) == el.
	self assert: (el elementAt: 0 @ 0) == el.
	self assert: (el elementAt: -1 @ 0) == view.! !

!ROContainingElementTest methodsFor: 'view' stamp: 'AlexandreBergel 9/25/2012 15:05'!
testElementAtAfterDragging

	| view |
	view := ROView new.
	node1 add: node2.
	view add: node1.
	
	node1 translateTo: 50@50.

	self assert: (node1 elementAt: (node1 extent)) == view.
	self assert: (node1 elementAt: (node1 extent - (1 @ 1))) == node1.
	self assert: (node1 elementAt: (1 @ 1)) == node2.
	self assert: (node1 elementAt: node2 topLeft) == node2.

	self assert: (view elementAt: node1 topLeft + (1 @ 1)) == node2
	
! !

!ROContainingElementTest methodsFor: 'events' stamp: 'AlexandreBergel 7/25/2012 16:14'!
testEventForNested

	| view circle grid options choice container t morph |
	t := 0.
	view := ROView new.
	circle := ROElement new 
				addInteraction: RODraggable;
				extent: 100@40; 
				addShape: (ROBorder red);
				addShape: (ROLabel text: 'circle'). 
	circle on: ROMouseClick do: [:e | t := t + 1 ].

	grid := ROElement new 
				addInteraction: RODraggable;
				extent: 100@40; 
				addShape: (ROBorder red);
				addShape: (ROLabel text: 'grid').
	grid on: ROMouseClick do: [:e | t := t + 10 ].
	options := (Array with: circle with: grid).

	choice := ROElement new.
	choice addAll: (ROHorizontalLineLayout on: options).
	
	view add: choice.
	"
	view openInWindow.
	"
	
	"grid adjustSizeOfParent  " 
	morph := ROPlatform current widgetFactory forView: view.
	morph extent: 200@200.
	
	self assert: choice bounds = ( 0@0 corner: 220@50).
	
	"virtual position = 63@29"
	self assert: (choice contains: 63@29).
	
	"real position 32@15"
	self assert: (morph elementForRealPosition: 32@15) ~~ view.
! !

!ROContainingElementTest methodsFor: 'translating shape' stamp: 'AlexandreBergel 9/25/2012 17:51'!
testNoTranslationShape

	| el |
	el := ROElement new.
	el + ROBox.
	el extent: 50 @ 50.

	self assert: (el contains: 0 @ 0).
	self assert: (el contains: 25 @ 25).
	self deny: (el contains: 50 @ 50).! !

!ROContainingElementTest methodsFor: 'translation shape and inner nodes' stamp: 'AlexandreBergel 9/24/2012 19:18'!
testNoTranslationShapeAndInnerElements

	| outterElement innerElement |
	outterElement := ROElement new.
	outterElement + ROBox.
	outterElement extent: 50 @ 50.
	
	innerElement := ROElement new.
	innerElement + ROBox.
	innerElement extent: 20 @ 20.

	outterElement add: innerElement.
	"+ (ROTranslatingShape new offset: 0 @ 20)"
	self assert: (outterElement elementAt: 0 @ 0) == innerElement.
	self assert: (outterElement elementAt: 25 @ 25) == outterElement.
	self assert: (outterElement elementAt: 49 @ 49) == outterElement.
	self deny: (outterElement elementAt: 51 @ 51) == outterElement.! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/15/2012 10:46'!
testRemovingWithResize

	node3 add: node1.
	self assert: node3 extent > node1 extent.
	node3 removeAllElements.
	ROShrikingSize on: node3.
	self assert: node3 extent < node1 extent! !

!ROContainingElementTest methodsFor: 'view' stamp: 'AlexandreBergel 9/10/2012 09:14'!
testSettingTheView

	| newNode view |
	newNode := ROElement new.
	self assert: (newNode view == ROView nullView).

	self assert: (node1 view == ROView nullView).
	view := ROView new.
	view add: node1.
	
	node1 add: newNode.
	
	self assert: (newNode view == view)! !

!ROContainingElementTest methodsFor: 'sizing' stamp: ''!
testSize

	| el el2 |
	el := ROElement new.
	self assert: (el extent = (5 @ 5)).
	el add: (el2 := ROElement sprite).
	
	ROAdjustSizeOfNesting on: el.
	self assert: (el extent = (el2 extent + (5@5)))
	! !

!ROContainingElementTest methodsFor: 'sizing' stamp: ''!
testSize2

	| bounds el |
	el := ROElement sprite.
	bounds := el bounds.
	
	ROAdjustSizeOfNesting on: el.
	self assert: (el bounds = bounds)
	! !

ROElementTest subclass: #ROEdgeTest
	instanceVariableNames: 'view edge node1 node2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROEdgeTest methodsFor: 'popup' stamp: 'AlexandreBergel 8/20/2012 11:06'!
doesNOTWORKtestPopup
	"Apparently this test run into concurency problems"

	| t |
	edge @ ROPopup.
	edge announce: ROMouseEnter.
	
	t := 0.
	10 timesRepeat: [ 
		(Delay forMilliseconds: 2) wait.
		t := t max: view raw elements size.
	].
	self assert: t = 4.! !

!ROEdgeTest methodsFor: 'running' stamp: 'AlexandreBergel 8/19/2012 18:59'!
setUp

	view := ROMondrianViewBuilder new.
	view shape rectangle size: 30.
	view nodes: (1 to: 2).
	node1 := view raw elements first.
	node2 := view raw elements second.

	view interaction popupText: 'FooZork'.
	edge := view edgeFromAssociation: 1 -> 2.
	view applyLayout! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/18/2012 09:35'!
testArrowedEdge

	| n1 n2 line |
	n1 := ROElement new.
	n2 := ROElement new.

	edge := ROEdge arrowedLineFrom: n1 to: n2.
	self assert: edge from == n1.
	self assert: edge to == n2.
	
	line := edge getShape: ROLine.
	self assert: line numberOfArrows = 1! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/20/2012 10:03'!
testContains

	self deny: ((ROEdge from: ROElement new to: ROElement new) contains: 10@40)! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 14:46'!
testCreation

	self should: [ ROEdge from: Object new to: Object new ] raise: Exception! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/17/2012 12:29'!
testEdgeBounds

	self assert: edge bounds = ( (5@5) corner: (75@35) ).
	
	
! !

!ROEdgeTest methodsFor: 'lookup' stamp: 'AlexandreBergel 10/2/2012 20:40'!
testElementFromModel

	edge model: 42.
	self assert: (edge elementFromModel: 42) == edge.
	self assert: (edge elementFromModel: 43) isNil! !

!ROEdgeTest methodsFor: 'lookup' stamp: 'AlexandreBergel 8/19/2012 21:49'!
testGetFromView

	| roView |
	roView := view raw.
	self assert: (roView elementAtRealPosition: edge bounds center) == edge! !

!ROEdgeTest methodsFor: 'popup' stamp: 'AlexandreBergel 8/20/2012 11:07'!
testInteraction

	self assert: edge numberOfInteractions = 1.
	edge @ ROPopup.
	self assert: edge numberOfInteractions = 2.! !

!ROEdgeTest methodsFor: 'line segment' stamp: 'AlexandreBergel 8/19/2012 21:04'!
testLineSegment

	| shape segments |
	shape := edge getShape: ROShape.
	segments := shape lineSegmentsFor: edge.
	self assert: segments size = 2. 
	self assert: segments first = node1 rightCenter.
	self assert: segments second = node2 leftCenter! !

!ROEdgeTest methodsFor: 'line segment' stamp: 'AlexandreBergel 8/19/2012 21:05'!
testLineSegment2

	| shape segments |
	node2 translateBy: 80 @ 60.

	shape := edge getShape: ROShape.
	segments := shape lineSegmentsFor: edge.
	self assert: segments size = 2. 
	self assert: segments first = node1 rightCenter.
	self assert: segments second = node2 leftCenter! !

!ROEdgeTest methodsFor: 'orthoHorizontal' stamp: 'AlexandreBergel 8/19/2012 19:11'!
testOrthoHorizontalLineSegmentWithTranslation

	| lineShape segments |
	node2 translateBy: 50@80.
	edge + (lineShape := ROOrthoHorizontalLineShape new).
	
	segments := lineShape lineSegmentsFor: edge.
	self assert: segments size = 4.
	self assert: segments = (Array 
								with: node1 topRight + (0 @ (node1 height / 2))
								with: (node2 topLeft x - node1 topRight x) / 2 + node1 topRight x @ (node1 position y + (node1 height / 2))
								with: (node2 topLeft x - node1 topRight x) / 2 + node1 topRight x @ (node2 position y + (node2 height / 2))
								with: node2 topLeft + (0 @ (node2 height / 2)) )! !

!ROEdgeTest methodsFor: 'orthoVertical' stamp: 'AlexandreBergel 9/25/2012 18:52'!
testOrthoVerticalLineContainsPoint

	| lineShape segments |
	edge change: ROLine for: (lineShape := ROOrthoVerticalLineShape new).
	view raw on: ROMouseClick do: [ :ann | Transcript show: ann position printString ;cr ].
	"view open."
	node2 translateBy: 50@100.
	
	segments := lineShape lineSegmentsFor: edge.
	self assert: (edge contains: (21 @ 52) - edge topLeft).
	self assert: (edge contains: (111 @ 88) - edge topLeft).
	self assert: (edge contains: (64 @ 70) - edge topLeft).! !

!ROEdgeTest methodsFor: 'orthoVertical' stamp: 'AlexandreBergel 8/19/2012 21:38'!
testOrthoVerticalLineSegmentWithTranslation

	| lineShape segments |
	node2 translateBy: 50@100.
	edge + (lineShape := ROOrthoVerticalLineShape new).
	
	segments := lineShape lineSegmentsFor: edge.
	self assert: segments size = 4.
	self assert: segments = (Array 
								with: node1 bottomCenter
								with: node1 bottomCenter x @ ((node2 topCenter y - node1 bottomCenter y) / 2 + node1 bottomCenter y)
								with: node2 bottomCenter x @ ((node2 topCenter y - node1 bottomCenter y) / 2 + node1 bottomCenter y)
								with: node2 topCenter) ! !

!ROEdgeTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/19/2012 12:12'!
testPopupFixture

	self assert: view raw elements size = 3.
! !

!ROElementTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp

	node := ROElement on: 'hello'.
	node extent: 40 @ 30.
	node
		addShape: ROBox new;
		addShape: ROBorder new.
	
	draggableNode := ROElement new.
	draggableNode @ RODraggable.
	draggableNode extent: 50@50.
	draggableNode + ROBorder red.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/25/2012 20:22'!
testAddShape

	| el shape1 shape2 |
	el := ROElement new.
	self assert: el numberOfShapes = 2.

	shape1 := ROBox new.
	shape2 := ROLabel new.
	shape1 next: shape2.
	el addShape: shape1.
	
	self assert: el numberOfShapes = 4! !

!ROElementTest methodsFor: 'event' stamp: 'TudorGirba 9/9/2012 21:41'!
testAllElementsDo

	| node1 node2 node21 edge root traversed |
	root := ROElement new.
	node1 := ROElement new.
	node2 := ROElement new.
	edge := ROEdge from: node1 to: node2.
	node21 := ROElement new.

	root add: node1.
	root add: node2.
	root add: edge.
	node2 add: node21.
	
	traversed := OrderedCollection new.
	root allElementsDo: [:each | traversed add: each].
	self assert: traversed size = 4.
	self assert: traversed first = node1.
	self assert: traversed second = node2.
	self assert: (traversed at: 3) = node21.
	self assert: traversed last = edge! !

!ROElementTest methodsFor: 'event' stamp: ''!
testAnnounce

	| node1 node2 bounds |
	node1 := ROElement new.
	node2 := ROElement new.
	
	node1 on: ROMouseClick do: [ ROGrow on: node2 by: 1 ].
	bounds := node2 bounds.

	node1 announce: ROMouseClick.
	self assert: (bounds extent < node2 bounds extent)! !

!ROElementTest methodsFor: 'attributes' stamp: 'AlexandreBergel 6/18/2012 14:11'!
testAttributes
	self deny: node hasAttributes.
	node attributes at: #oldColor put: Color black.
	self assert: node hasAttributes.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 17:02'!
testChangeShape
	"
	self debug: #testChangeShape
	"
	| element |
	element := ROEdge new.
	self deny: (element isShapedAs: ROLine).
	element + ROLine.
	element change: ROShape for: ROLine.
	self assert: (element isShapedAs: ROLine).
	self assert: (element isShapedAs: ROShape).
	
	element change: ROShape for: ROOrthoVerticalLineShape.
	self assert: (element isShapedAs: ROShape).
	self assert: (element isShapedAs: ROOrthoVerticalLineShape).
! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testContains

	self assert: (node contains: node position).
	self deny: (node contains: node position - (1 @ 1)).! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testCornerRadius

	node := ROElement new center: 10@8 radius: 5.
	self assert: node bounds = (5@3 corner: 15@13)! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/25/2012 20:24'!
testDecoration
	| el |
	
	el := ROElement bare.
	self deny: (el isShapedAs: ROShape).
	self deny: (el isShapedAs: ROLabel).
	
	el addShape: ROLabel.
	self assert: (el isShapedAs: ROShape).
	self assert: (el isShapedAs: ROLabel).! !

!ROElementTest methodsFor: 'event' stamp: 'AlexandreBergel 5/22/2012 21:01'!
testDragAndDropWithInner

	| view outter inner |
	view := ROView new.
	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	outter add: inner.
	view add: outter.
	
	self assert: outter bounds = (0@0 corner: 55@55).
	self assert: inner bounds = (0@0 corner: 50@50).
	
	inner translateBy: -10 @ -10.
	self assert: outter bounds = ( -10@ -10 corner: 55@55).
	self assert: inner bounds = (0@0 corner: 50@50).
! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 9/30/2012 18:43'!
testEventTranslation

	| t el |
	t := 0.
	el := ROElement new.
	el on: ROElementTranslated do: [ :event | t := t + 1 ].
	self assert: t = 0.

	el translateTo: 50 @ 50.
	self assert: t = 1.
	
	el translateBy: 50 @ 50.
	self assert: t = 2.! !

!ROElementTest methodsFor: 'event' stamp: 'AlexandreBergel 10/1/2012 09:10'!
testEventTranslation2

	| t outter inner1 inner2 |
	t := 0.
	outter := ROElement on: 'outter'.
	inner1 := ROElement on: 'inner1'.
	inner2 := ROElement on: 'inner1'.
	
	inner1 on: ROElementTranslated do: [ :event | t := t + 1 ].
	self assert: t = 0.

	inner1 translateTo: 50 @ 50.
	self assert: t = 1.
	
	inner2 translateBy: 50 @ 50.
	self assert: t = 1.
	
	outter translateBy: 50 @ 50.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 6/18/2012 13:53'!
testForShapeDo

	| border |
	border := node getShape: ROBorder.
	self assert: border color = ROBorder defaultColor.
	node forShape: ROBorder do: [ :s | s color: Color blue ].

	self assert: border color = Color blue! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testForwarding

	| inner view outter bInner bOutter |
	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	inner forward.
	outter add: inner. 
	view := ROView new.
	view add: outter.

	bInner := inner bounds.
	bOutter := outter bounds.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: inner bounds = bInner.
	self assert: outter bounds = (bOutter translateBy: (10@10)).! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/30/2012 18:48'!
testForwardingEvent

	| inner view outter bInner bOutter t |
	t := 0.
	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	inner forward.
	outter add: inner. 
	view := ROView new.
	view add: outter.

	bInner := inner bounds.
	bOutter := outter bounds.

	outter on: ROMouseDragging do: [ :evt | t := t + 1 ].
	self assert: t = 0.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: t = 1.
! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testForwardingEventWithView

	| inner view outter bInner bOutter t |
	t := 0.
	view := ROView new.
	view on: ROEvent do: [ :evt | t := t + 1 ].

	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	
	outter add: inner. 
	view add: outter.

	inner forward.
	outter forward.
	
	self assert: outter parent == view.
	self assert: inner parent == outter.

	self assert: t = 0.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: t = 1.
! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:48'!
testGetShape
	| el deco |
	
	el := ROElement new.
	deco := ROBox new.
	deco color: Color red.
	el addShape: deco.
	
	self assert: (el getShape: ROBox) == deco.! !

!ROElementTest methodsFor: 'group of nodes' stamp: ''!
testGroupOfNodes

	| nodes |
	nodes := ROElement forCollection: (1 to: 20).
	self assert: (nodes size = 20).
	self assert: (nodes collect: #model) = (1 to: 20)! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 13:55'!
testHeightAndWidth

	draggableNode width: 100.
	self assert: ((draggableNode getShape: ROBorder) width = 100).
	
	draggableNode height: 59.
	self assert: ((draggableNode getShape: ROBorder) height = 59).! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 14:01'!
testHeightAndWidthWithBlock

	draggableNode model: 42.
	draggableNode width: [ :element | element model + 10 ].
	draggableNode height: [ :element | element model + 20 ].
	self assert: (((draggableNode getShape: ROBorder) extentFor: draggableNode) = (52 @ 62)).! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/25/2012 20:24'!
testInitialization
	| aNode |
	aNode := ROElement new.
	self assert: aNode bounds = ROElement defaultBounds.
	self assert: aNode extent = aNode bounds extent.
	
	self assert: aNode numberOfShapes = 2! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 18:10'!
testInitialization2
	self assert: ROElement new view camera notNil.! !

!ROElementTest methodsFor: 'initialize-release' stamp: 'AlexandreBergel 9/25/2012 20:25'!
testInitializationBare
	| aNode |
	aNode := ROElement bare.
	self assert: aNode bounds = ROElement defaultBounds.
	self assert: aNode extent = aNode bounds extent.
	
	"Just the null shape"
	self assert: aNode numberOfShapes = 1! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testInteraction 

	| int int2 |

	self deny: (node is: ROMenuActivable).
	node @ (int := ROMenuActivable new item: 'act' action: #inspect).
	self assert: (node is: ROMenuActivable).
	
	self assert: int == (node getInteraction: ROMenuActivable).
	self assert: int numberOfEntries = 1.
	
	"We add a new action. We should fill the first interaction only"
	node @ (int2 := ROMenuActivable new item: 'act2' action: #inspect).
	self assert: int numberOfEntries = 2.
	self assert: int == (node getInteraction: ROMenuActivable).! !

!ROElementTest methodsFor: 'iteration' stamp: ''!
testIteratingOnEmptyCollections

	self shouldnt: [ ROElement new interactionsDo: [ :el | ] ]  raise: Error! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testModel
	| aNode object |
	aNode := ROElement new.
	self assert: aNode model isNil.

	aNode := ROElement on: (object := Object new).
	self assert: (aNode model == object)! !

!ROElementTest methodsFor: 'nesting' stamp: 'AlexandreBergel 9/29/2012 16:12'!
testMostSpecificParentCommonWith

	| view el1 el11 el111 el12 el2 el21 |
	view := ROView new.
	el1 := ROElement sprite @ ROPopup .
	el11 := ROElement sprite @ ROPopup .
	el111 := ROElement sprite @ ROPopup .
	el12 := ROElement sprite @ ROPopup .
	el2 := ROElement sprite @ ROPopup .
	el21 := ROElement sprite @ ROPopup .
	
	el1 add: el11; add: el12.
	el11 add: el111.
	el2 add: el21.
	
	view add: el1; add: el2. 
	
	self assert: (el1 mostSpecificParentCommonWith: el2) == view.
	self assert: (el1 mostSpecificParentCommonWith: el21) == view.
	
	self assert: (el1 mostSpecificParentCommonWith: el11) == view.
	self assert: (el12 mostSpecificParentCommonWith: el111) == el1.

	self assert: (el11 mostSpecificParentCommonWith: el111) == el1.! !

!ROElementTest methodsFor: 'event' stamp: 'AlexandreBergel 9/2/2012 21:14'!
testOnDoOnce

	| element t |
	element := ROElement new.
	t := 0.

	self assert: element numberOfInteractions = 0.
	element on: ROMouseClick doOnce: [ :ann | t := t + 1 ].

	"self assert: element numberOfInteractions = 1."
	self assert: t = 0.
	
	element announce: ROMouseClick.
	self assert: t = 1.
	"self assert: element numberOfInteractions = 0."
	
	element announce: ROMouseClick.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 8/2/2012 18:10'!
testOverridingIteraction

	"Ugly test, but we need to get the hand on it. A bug is hidding at the moment we are writting this test"
	"This test makes some strong assumption on the implementation of Announcement"
	
	| eventHandler |
	eventHandler := node instVarNamed: 'eventHandler'.

	self assert: eventHandler numberOfSubscriptions = 0.
	
	"Two subscription, one for entering and another for leaving"

	node @ ROPopup.
	self assert: eventHandler numberOfSubscriptions = 3.
	
	node changeInteraction: ROAbstractPopup for: (ROPopupView new view: ROView new).
	self assert: eventHandler numberOfSubscriptions = 3.	
! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 9/10/2012 09:14'!
testParentAndNesting

	| inner outter |
	inner := ROElement new.
	outter := ROElement new.
	
	self assert: inner parent == ROView nullView.
	self assert: outter parent == ROView nullView.
	
	outter add: inner. 

	self assert: inner parent == outter.
	self assert: outter parent == ROView nullView! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 9/10/2012 09:14'!
testParentAndView

	| element view |
	element := ROElement new.
	self assert: element parent == ROView nullView.

	view := ROView new.
	view add: element.

	self assert: element parent == view.! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 6/2/2012 14:26'!
testParentBehavior

	| element outterElement view |
	element := ROElement new.
	self assert: element resizeStrategy == ROExtensibleParent instance.
	
	outterElement := ROElement new.
	outterElement add: element.
	self assert: element resizeStrategy == ROExtensibleParent instance.
! !

!ROElementTest methodsFor: 'printing' stamp: 'AlexandreBergel 5/10/2012 16:39'!
testPrinting

	self assert: (#('a ROElement' 'a Roassal.ROElement') includes: ROElement new printString).
	self assert: (#( 'a ROElement<10>'  'a Roassal.ROElement<10>') includes: (ROElement on: 10) printString).

! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/5/2012 08:47'!
testReducingSize

	| el |
	el := (ROElement new extent: 90@20) + ROBox green.
	el extent: 10 @ 12.
	self assert: el extent = (10 @ 12)! !

!ROElementTest methodsFor: 'actions' stamp: ''!
testRemoveElements

	| elements |

	elements := node elementsSuchThat: [:e | true ].
	self assert: elements isEmpty.
	
	node addAll: (ROElement forCollection: (1 to: 20)).
	elements := node elementsSuchThat: [:e | true ].
	self assert: elements notEmpty.
	
	node removeAllElements.
	elements := node elementsSuchThat: [:e | true ].
	self assert: elements isEmpty.! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 6/16/2012 00:48'!
testRemoveElementsAndError

	self shouldnt:  [ node remove ] raise: Error! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:57'!
testRemoveInteraction

	| el |
	el := ROElement new.
	self deny: (el is: RODraggable).
	
	el @ RODraggable.
	self assert: (el is: RODraggable).

	el removeInteraction: RODraggable.
	self deny: (el is: RODraggable).! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 09:43'!
testRemoveInteraction2

	self shouldnt: [ ROElement new removeInteraction: ROAbstractPopup ] raise: Error ! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 6/5/2012 10:31'!
testRemoveOnElement

	| view |
	view := ROView new.
	view add: node.
	self assert: (view elements includes: node).
	
	node remove.
	self deny: (view elements includes: node).! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/25/2012 20:27'!
testRemoveShape

	self assert: (node shapes size = 4).
	node - ROBox.
	self assert: (node shapes size = 3).
	node + ROBox.
	self assert: (node shapes size = 4).
	
	"No error should happen here"
	self shouldnt: [ node - ROLine ] raise: Error.
	
	node - ROBorder.
	node - ROBox.
	self assert: (node shapes size = 1).
! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/25/2012 20:29'!
testRemoveShapeAfterAChangeFor

	node := ROElement new.
	self assert: node shapes asArray first class ==  ROChildrenShape.
	node change: ROShape for: ROBox.
	self assert: node shapes asArray first class ==  ROBox.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 7/23/2012 15:23'!
testRemoveShapeOnEdges

	| edge |
	edge := ROEdge new.
	self assert: (edge shapes size = 1).
	edge - ROLine.
	self assert: (edge shapes size = 1).
	edge + ROLine.
	self assert: (edge shapes size = 2).
	
	"No error should happen here"
	self shouldnt: [ edge - ROBox] raise: Error.
	
! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 8/2/2012 18:10'!
testRemoveSubscription

	"Ugly test, but we need to get the hand on it. A bug is hidding at the moment we are writting this test"
	"This test makes some strong assumption on the implementation of Announcement"
	
	| eventHandler aPopup |
	eventHandler := node instVarNamed: 'eventHandler'.

	self assert: eventHandler numberOfSubscriptions = 0.
	
	aPopup := ROPopup new.
	node @ aPopup.
	self assert: eventHandler numberOfSubscriptions = 3.

	eventHandler unsubscribe: aPopup.
	self assert: eventHandler numberOfSubscriptions = 0.! !

!ROElementTest methodsFor: 'removing' stamp: 'AlexandreBergel 10/18/2012 16:52'!
testRemoving

	| view |
	view := ROView new.
	view add: node.
	node remove.
	self assert: view numberOfElements = 0.! !

!ROElementTest methodsFor: 'removing' stamp: 'AlexandreBergel 10/18/2012 18:14'!
testRemovingNestedNode

	| innerNode |
	
	innerNode := ROElement new.
	node add: innerNode.
	self assert: node numberOfElements = 1.
	innerNode remove.
	self assert: node numberOfElements = 0.! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testRendering
	
	| nullCanvas |
	nullCanvas := ROCountingNullCanvas new.
	self assert: nullCanvas numberOfRectangles isZero.
	node drawOn: nullCanvas.

	self assert: nullCanvas numberOfRectangles = 1.
	self assert: nullCanvas numberOfLines = 4.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 08:54'!
testResizing

	| t |
	t := 0.
	node on: ROElementResized do: [ :event | t := t + 1 ].
	node extent: 20 @ 10.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 08:54'!
testResizing2

	| t |
	t := 0.
	node on: ROElementResized do: [ :event | t := t + 1 ].
	node extent: node extent.
	self assert: t = 0.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 08:55'!
testResizing3

	| t |
	t := 0.
	node on: ROElementResized do: [ :event | t := t + 1 ].
	node width: 60.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 08:55'!
testResizing4

	| t |
	t := 0.
	node on: ROElementResized do: [ :event | t := t + 1 ].
	node height: 60.
	self assert: t = 1.! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 13:23'!
testSize

	| el |
	el := (ROElement new extent: 90@20) + ROBox green.
	self assert: el extent = ( 90 @ 20 )! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 7/23/2012 11:56'!
testTranslatingByAFloatPoint

	| el |
	el := ROElement new.
	self assert: el position = (0 @ 0).
	
	el translateBy: 0.4 @ 0.3.
	self assert: el position = (0.4 @ 0.3).
	! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testTranslatingByFloats

	
	self assert: draggableNode position = (0@0).
	draggableNode translateBy: 4.5 @ 1.3.
	self assert: draggableNode position = (4.5 @ 1.3).
	
	node translateTo: 2.4 @ 6.4.
	self assert: node position = ( 2.4@6.4).
	
	node translateBy: 2.4 @ 6.4.
	self assert: node position = ( 4.8@12.8)! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testTranslatingByRealPoint

	| view p1 |
	view := ROView new.
	view add: draggableNode.
	
	"dragging a node increases its position by the dragging step"
	p1 := draggableNode position.
	self assert: (p1 = (0@0)).
	draggableNode translateByRealPoint: 10 @ 6.
	self assert: (draggableNode position = ( 10 @ 6)).
	draggableNode translateByRealPoint: -10 @ -6.
	self assert: (draggableNode position = ( 0 @ 0)).

	"take care of real vs virtual steps"
	view camera bounds: (0@0 corner: 250@250).
	draggableNode translateByRealPoint: 10 @ 6.
	self assert: (draggableNode position = ( 5@3)).! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 9/16/2012 22:19'!
testTranslation

	| elOutter elInner view |
	elOutter := ROElement new + ROBorder.
	elOutter @ RODraggable.

	elInner := ROElement new + ROBorder.
	elInner @ RODraggable.
	elOutter add: elInner .
	 
	"elInner is now centered"
	ROHorizontalLineLayout on: (Array with: elInner).
	
	"view := ROView new.
	view add: elOutter.
	view open."
	
	self assert: elInner position = (5 @ 5).

	elInner translateBy: -5 @ -5.
	self assert: elInner position = (0 @ 0).! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/10/2012 09:14'!
testView

	self assert: node view == ROView nullView.

	ROView new add: node.
	self assert: node view notNil.	  ! !

!ROElementTest methodsFor: 'event' stamp: 'TudorGirba 9/9/2012 21:42'!
testWithAllElementsDo

	| node1 node2 node21 edge root traversed |
	root := ROElement new.
	node1 := ROElement new.
	node2 := ROElement new.
	edge := ROEdge from: node1 to: node2.
	node21 := ROElement new.

	root add: node1.
	root add: node2.
	root add: edge.
	node2 add: node21.
	
	traversed := OrderedCollection new.
	root withAllElementsDo: [:each | traversed add: each].
	self assert: traversed size = 5.
	self assert: traversed first = root.
	self assert: (traversed at: 2) = node1.
	self assert: (traversed at: 3) = node2.
	self assert: (traversed at: 4) = node21.
	self assert: traversed last = edge! !

ROTest subclass: #ROEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROEventTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 15:48'!
testPositionNotNil

	| event |
	ROEvent withAllSubclasses do: [ :cls | 
		event := cls new.
		self assert: event position = (0@0)
		 ]! !

!ROEventTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 15:58'!
testProperlyInitialized 
	

	| event |
	ROEvent withAllSubclasses do: [ :cls | 
		event := cls new.
		self shouldnt: [ (event class selectors select: [ :k | (k includes: $:) not]) do: [ :k | event perform: k ] ] raise: Error.
		 ]! !

ROTest subclass: #ROExpandChildrenOnClickTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROExpandChildrenOnClickTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/7/2012 13:09'!
testChildrenForModel

	| expandChildren children elements |
	expandChildren := ROExpandChildrenOnClick childrenForModel: [ :v | Array with: v with: v + 1 with: v + 2 ].
	elements := expandChildren computeChildrenFor: (ROElement on: 10).
	
	self assert: elements size = 3.
	self assert: elements first numberOfShapes = 4.
	self assert: (elements first shapes collect: #class) asArray =  
					((Array with: ROBox with: ROLabel), (Array with: ROChildrenShape with: RONullShape))! !

!ROExpandChildrenOnClickTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/21/2012 15:35'!
testClickOnAddedNode

	| view el elements |
	view := ROView new.
	el := (ROElement on: 'hello') + ROLabel.
	el @ (ROExpandChildrenOnClick childrenBlock: [ :element | 
		Array with: ((ROElement on: (element model, ' world')) + ROBox) ]).
	view add: el. 
	
	el announce: ROMouseClick.
	elements := view elementsSuchThat: [ :e | e model = 'hello world' ].
	self assert: elements notEmpty.
	elements first announce: ROMouseClick.
	self assert: view numberOfElements = 3.! !

!ROExpandChildrenOnClickTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/21/2012 15:35'!
testClickOnRecursiveAddedNode

	| view el elements |
	view := ROView new.
	el := (ROElement on: 'hello') + ROLabel.
	el @ (RORecursiveExpandOnClick childrenBlock: [ :element | 
		Array with: ((ROElement on: (element model, ' world')) + ROBox) ]).
	view add: el. 
	
	el announce: ROMouseClick.
	elements := view elementsSuchThat: [ :e | e model = 'hello world' ].
	self assert: elements notEmpty.
	elements first announce: ROMouseClick.
	self assert: view numberOfElements = 5.! !

!ROExpandChildrenOnClickTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/21/2012 15:34'!
testClickOnRoot

	| view el |
	view := ROView new.
	el := (ROElement on: 'world') + ROLabel.
	el @ (ROExpandChildrenOnClick childrenBlock: [ :element | 
		Array with: (ROElement on: (element model, ' World')) ]).
	view add: el. 
	
	self assert: view numberOfElements = 1.
	el announce: ROMouseClick.
	self assert: view numberOfElements = 3.
	el announce: ROMouseClick.
	self assert: view numberOfElements = 5.! !

ROTest subclass: #ROFocusViewTest
	instanceVariableNames: 'view camera el1 el2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROFocusViewTest methodsFor: 'running' stamp: 'AlexandreBergel 5/6/2012 10:11'!
setUp

	view := ROView new.
	camera := view camera.

	view add: (el1 := ROElement sprite).
	view add: (el2 := ROElement sprite translateBy: 200 @ 20).
	
! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 5/6/2012 10:13'!
testCamera
	self assert: camera position = (0 @ 0).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 10/1/2012 13:35'!
testOnView

	"
	self debug: #testOnView
	"
	| focus |
	focus := ROFocusView on: el2.
	focus waitUntilDone.
	"el2 is now in the center of the screen"
	self assert: camera centerPosition =  (el2 position).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 10/1/2012 13:35'!
testOnViewWithInitialTranslation

	"
	self debug: #testOnView
	"
	| focus |
	camera translateTo: 10@30.
	
	focus := ROFocusView new.
	focus onWithoutProcess: el2.

	"el2 is now in the center of the screen"
	self assert: camera centerPosition =  (el2 position).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 10/1/2012 13:35'!
testOnViewWithoutProcess

	"
	self debug: #testOnView
	"
	| focus |
	focus := ROFocusView new.
	focus onWithoutProcess: el2.
	
	"el2 is now in the center of the screen"
	self assert: camera centerPosition =  (el2 position).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 10/2/2012 09:25'!
testPosition

	el1 translateTo:  (1650.5@134.0).
	
	camera translateTo:  (-14656.5@ -72.0).
	self assert: (camera position = (-14656.5@ -72.0)).
	
	self assert: camera == el1 view camera.
	
	ROFocusView new onWithoutProcess: el1.
	
	self assert: (camera centerPosition - (1651@134)) abs <= (2 @ 2)! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 9/1/2012 19:28'!
testToPositionView

	"
	self debug: #testToPositionView
	"
	| focus |
	self assert: camera position =  (0@ 0).
	focus := ROFocusView new toPosition: 500@20 view: view.
	focus waitUntilDone.
	"el2 is now in the center of the screen"
	self assert: camera position =  (250@ -230).
	
	focus := ROFocusView new toPosition: 500@250 view: view.
	focus waitUntilDone.
	"el2 is now in the center of the screen"
	self assert: camera position =  (250@ 0).! !

ROTest subclass: #ROGraphTransformationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Transformation'!

!ROGraphTransformationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/5/2012 11:11'!
OLDtestCheckCycleNoCycle

	| view nodes edges newNode transformation node1 node2 node3 |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3 with: 1 -> 3).
		
	transformation := ROGraphTransformation new.

	"self assert: (transformation containsCycleIn: nodes with: edges)"
	"self deny: (transformation containsCycleIn: nodes first with: edges passedNodes: OrderedCollection new)"
	self deny: (transformation hasCycleIn: nodes with: edges)! !

!ROGraphTransformationTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 10:10'!
testFromEdgesToNesting

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2).
	edges := view edgesFromAssociations: (Array with: 1 -> 2).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) = (Array with: nodes second).
	
	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 1.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	
	self assert: newNode == nodes first! !

!ROGraphTransformationTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/9/2012 15:20'!
testFromEdgesToNesting2

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 1 -> 3).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) 
				= (Array with: nodes second with: nodes third).
	
	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 2.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	self assert: newNode elements second model = 3.	
	
	"We make sure that the nodes that have been moved are removed from the view"
	self assert: (view raw elements includes: newNode).
	self deny: (view raw elements includes: nodes second).
	self deny: (view raw elements includes: nodes third).! !

!ROGraphTransformationTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 09:34'!
testFromEdgesToNesting3

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) 
				= (Array with: nodes second).
	
	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 1.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	
	self assert: newNode elements first  numberOfElements = 1.
	self assert: newNode elements first elements first model = 3.	! !

ROTest subclass: #ROHighlightElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/29/2012 15:26'!
testColor

	"el1 and el2 are the same, except el2 is lightly highlightable"
	| el1 el2 view |
	el1 := (ROElement on: 1) height: 50; width: 50.
	el1 + (ROCircle color: Color lightGreen).

	el2 := (ROElement on: 1) height: 50; width: 50.
	el2 + (ROCircle color: Color lightGreen) @ ROLightlyHighlightable.

	view := ROView new @ RODraggable.
	view add: el1.
	view add: el2.
	ROHorizontalLineLayout on: view elements.
	"view open."
	
	self assert: (el1 getShape: ROShape) color = Color lightGreen.
	self assert: (el2 getShape: ROShape) color = Color lightGreen.
	
	el2 announce: ROMouseEnter.
	self assert: (el2 getShape: ROShape) color = ROLightlyHighlightable new defaultHighlightColor.
	self assert: el2 hasAttributes.
	self assert: (el2 attributes at: #oldColor) = Color lightGreen.

	el2 announce: ROMouseLeave.
	self assert: (el2 getShape: ROShape) color = Color lightGreen.
	self deny: el2 hasAttributes.
! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/29/2012 15:20'!
testHighlightAndUnlight

	| element shape |
	element := ROElement new + ROBorder yellow.
	shape := (element getShape: ROShape).
	self assert: shape color = Color yellow.
	self deny: (ROHighlightElement isHighlighted: element).
	
	ROHighlightElement on: element.
	self assert: shape color = Color red.
	self assert: (ROHighlightElement isHighlighted: element).
	
	ROUnhighlightElement on: element.
	self assert: shape color = Color yellow.
	self deny: (ROHighlightElement isHighlighted: element).
! !

!ROHighlightElementTest methodsFor: 'highlight edges' stamp: 'AlexandreBergel 10/2/2012 19:53'!
testHighlightEdge

	| rawView node1 node2 edge lineShape |
	rawView := ROView new.
	node1 := ROBox elementOn: 'node1'. 
	node2 := ROBox elementOn: 'node2'.

	edge := ROEdge from: node1 to: node2.
	edge + (ROLine red).
	
	edge @ ROLightlyHighlightable.

	rawView add: edge; add: node1; add: node2.
	node2 translateBy: 100 @ 0.

	lineShape := edge getShape: ROLine.
	self assert: (lineShape colorFor: edge) = Color red.

	self shouldnt: [ edge announce: ROMouseEnter ] raise: Error.
	self assert: (lineShape colorFor: edge) = ROLightlyHighlightable highlightedColor.
	
	self shouldnt: [ edge announce: ROMouseLeave ] raise: Error.
	self assert: (lineShape colorFor: edge) = Color red.! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/25/2012 20:28'!
testHighlightingShape

	| shape1 shape2 el |
	shape1 := ROBox white.
	shape2 := ROBorder new.
	el := ROElement new.
	el + shape1 + shape2.
		
	el @ ROLightlyHighlightable.
	
	el announce: ROMouseEnter.
	
	self assert: el shapes asArray = (Array with: shape2 with: shape1 with: (el getShape: ROChildrenShape) with: (el getShape: RONullShape)).
	self assert: (shape1 colorFor: el) = Color white.
	self assert: (shape2 colorFor: el) = ROLightlyHighlightable highlightedColor.! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/6/2012 12:59'!
testLeavingWithoutEntering

	| el shape |
	el := ROElement new + (shape := ROBox new).
	self assert: (shape colorFor: el) = ROBox defaultColor.
	
	self deny: (ROHighlightElement isHighlighted: el).
		
	ROUnhighlightElement on: el.
	self assert: (shape colorFor: el) = ROBox defaultColor.
	self deny: (ROHighlightElement isHighlighted: el).! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/4/2012 16:15'!
testMultipleHighlight

	| el shape |
	el := ROElement new + (shape := ROBox new).
	self assert: (shape colorFor: el) = ROBox defaultColor.
	
	self deny: (ROHighlightElement isHighlighted: el).
	
	ROHighlightElement on: el.
	self assert: (shape colorFor: el) = Color red.
	self assert: (ROHighlightElement isHighlighted: el).
	
	ROHighlightElement on: el.
	self assert: (shape colorFor: el) = Color red.
	self assert: (ROHighlightElement isHighlighted: el).
	
	ROUnhighlightElement on: el.
	self assert: (shape colorFor: el) = ROBox defaultColor.
	self deny: (ROHighlightElement isHighlighted: el).! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/18/2012 14:23'!
testOnBox

	| el |
	el := ROElement on: 'hello'.
	el + ROBox.
	
	self assert: (el getShape: ROBox) color =  ROBox defaultColor.
	ROHighlightElement on: el.
	self assert: (el getShape: ROBox) color =  Color red.
	
	ROUnhighlightElement on: el.
	self assert: (el getShape: ROBox) color = ROCircle defaultColor.! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/18/2012 14:23'!
testOnCircle

	| el |
	el := ROElement on: 'hello'.
	el + ROCircle.
	
	self assert: (el getShape: ROCircle) color = ROCircle defaultColor.
	ROHighlightElement on: el.
	self assert: (el getShape: ROCircle) color = Color red.

	ROUnhighlightElement on: el.
	self assert: (el getShape: ROCircle) color = ROCircle defaultColor.! !

!ROHighlightElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/24/2012 12:08'!
testUnhighlightingShape

	| shape el |
	shape := ROBox white.
	el := ROElement new.
	el + shape.
		
	el @ ROLightlyHighlightable.
	
	el announce: ROMouseLeave.
	self assert: (shape colorFor: el) = Color white.
	! !

ROTest subclass: #ROLayoutTest
	instanceVariableNames: 'view elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

ROLayoutTest subclass: #ROCircleLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/9/2012 14:32'!
assertArrayOfPoint: computedArray isCloseTo: result
	"utility method useful to compare two set of points that are close to each other."
	
	self assert: computedArray size = result size.
	self assert: (computedArray allSatisfy: [ :p | p class = Point ]).
	computedArray with: result do: [ :e1 :e2 | (e1 x - e2 x) abs <= 1 and: [ (e1 y - e2 y) abs <= 1 ] ]
	
! !

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/9/2012 16:26'!
testAssertArrayOfPoint

	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 2@3).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 1@3).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 1@2).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 3@2).! !

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/9/2012 14:29'!
testLayout
	| result computedArray |
	ROCircleLayout on: elements.
	
	computedArray := elements collect: #positionAsInteger.
	result := ((Array new: 20) at: 1 put: ((440@220)); at: 2 put: ((429@287)); at: 3 put: ((397@349)); at: 4 put: ((349@397)); at: 5 put: ((287@429)); at: 6 put: ((220@440)); at: 7 put: ((152@429)); at: 8 put: ((90@397)); at: 9 put: ((42@349)); at: 10 put: ((10@287)); at: 11 put: ((0@220)); at: 12 put: ((10@152)); at: 13 put: ((42@90)); at: 14 put: ((90@42)); at: 15 put: ((152@10)); at: 16 put: ((219@0)); at: 17 put: ((287@10)); at: 18 put: ((349@42)); at: 19 put: ((397@90)); at: 20 put: ((429@152)); yourself).
	
	self assertArrayOfPoint: computedArray isCloseTo: result.
"
view openInWindow
" ! !

ROLayoutTest subclass: #ROFlowLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROFlowLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/20/2012 18:08'!
testLayout
	| result resultVW computed |
	ROFlowLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((5@65)); at: 4 put: ((65@65)); at: 5 put: ((5@125)); at: 6 put: ((65@125)); at: 7 put: ((5@185)); at: 8 put: ((65@185)); at: 9 put: ((5@245)); at: 10 put: ((65@245)); at: 11 put: ((5@305)); at: 12 put: ((65@305)); at: 13 put: ((5@365)); at: 14 put: ((65@365)); at: 15 put: ((5@425)); at: 16 put: ((65@425)); at: 17 put: ((5@485)); at: 18 put: ((65@485)); at: 19 put: ((5@545)); at: 20 put: ((65@545)); yourself).
	
	self assert: (elements collect: #position) = result! !

!ROFlowLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/20/2012 18:16'!
testLayoutASet
	| set |
	set := Set new. 
	set addAll: elements.
	ROFlowLayout on: set! !

ROLayoutTest subclass: #ROForceBasedLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROForceBasedLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 9/11/2012 16:02'!
testLayout
	| result resultVW computed resultVWWindow resultVW2 |
	ROForceBasedLayout on: elements.
	
	result :=  ((Array new: 20) at: 1 put: ((169@161)); at: 2 put: ((260@185)); at: 3 put: ((309@245)); at: 4 put: ((203@220)); at: 5 put: ((238@282)); at: 6 put: ((142@252)); at: 7 put: ((170@325)); at: 8 put: ((77@292)); at: 9 put: ((105@195)); at: 10 put: ((35@222)); at: 11 put: ((5@142)); at: 12 put: ((78@132)); at: 13 put: ((50@52)); at: 14 put: ((136@101)); at: 15 put: ((123@5)); at: 16 put: ((193@70)); at: 17 put: ((223@5)); at: 18 put: ((232@124)); at: 19 put: ((294@69)); at: 20 put: ((331@148)); yourself).
	
	resultVW := (( Array new: 20) at: 1 put: ( Point x: 162 y: 162); at: 2 put: ( Point x: 260 y: 174); at: 3 put: ( Point x: 314 y: 239); at: 4 put: ( Point x: 230 y: 235); at: 5 put: ( Point x: 238 y: 303); at: 6 put: ( Point x: 175 y: 224); at: 7 put: ( Point x: 140 y: 318); at: 8 put: ( Point x: 112 y: 242); at: 9 put: ( Point x: 50 y: 276); at: 10 put: ( Point x: 5 y: 187); at: 11 put: ( Point x: 86 y: 180); at: 12 put: ( Point x: 16 y: 89); at: 13 put: ( Point x: 78 y: 119); at: 14 put: ( Point x: 88 y: 21); at: 15 put: ( Point x: 131 y: 89); at: 16 put: ( Point x: 186 y: 5); at: 17 put: ( Point x: 197 y: 74); at: 18 put: ( Point x: 275 y: 52); at: 19 put: ( Point x: 219 y: 135); at: 20 put: ( Point x: 321 y: 139); yourself).
	
	resultVWWindow := ((Array new: 20) at: 1 put: (Point x: 162 y: 162); at: 2 put: (Point x: 259 y: 173); at: 3 put: (Point x: 314 y: 239); at: 4 put: (Point x: 230 y: 236); at: 5 put: (Point x: 237 y: 303); at: 6 put: (Point x: 174 y: 225); at: 7 put: (Point x: 139 y: 319); at: 8 put: (Point x: 112 y: 242); at: 9 put: (Point x: 50 y: 275); at: 10 put: (Point x: 5 y: 187); at: 11 put: (Point x: 85 y: 181); at: 12 put: (Point x: 17 y: 88); at: 13 put: (Point x: 78 y: 119); at: 14 put: (Point x: 88 y: 22); at: 15 put: (Point x: 130 y: 89); at: 16 put: (Point x: 186 y: 5); at: 17 put: (Point x: 196 y: 75); at: 18 put: (Point x: 274 y: 52); at: 19 put: (Point x: 220 y: 133); at: 20 put: (Point x: 320 y: 138); yourself).

	resultVW2 := ((Array new: 20) at: 1 put: (Point x: 157 y: 163); at: 2 put: (Point x: 250 y: 189); at: 3 put: (Point x: 307 y: 235); at: 4 put: (Point x: 208 y: 247); at: 5 put: (Point x: 238 y: 307); at: 6 put: (Point x: 158 y: 222); at: 7 put: (Point x: 139 y: 320); at: 8 put: (Point x: 95 y: 238); at: 9 put: (Point x: 46 y: 283); at: 10 put: (Point x: 5 y: 193); at: 11 put: (Point x: 73 y: 176); at: 12 put: (Point x: 11 y: 93); at: 13 put: (Point x: 73 y: 119); at: 14 put: (Point x: 80 y: 21); at: 15 put: (Point x: 130 y: 91); at: 16 put: (Point x: 178 y: 5); at: 17 put: (Point x: 195 y: 78); at: 18 put: (Point x: 265 y: 53); at: 19 put: (Point x: 216 y: 141); at: 20 put: (Point x: 315 y: 135); yourself).

	computed := (elements collect: #position) collect: #asIntegerPoint.
	self assert: (((computed = result or: [ computed = resultVW]) or: [ computed = resultVWWindow ]) or: [ computed = resultVW2 ])! !

!ROForceBasedLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 7/9/2012 08:34'!
testLayout2
	| result resultVW computed |
	ROForceBasedLayout new 
		layoutInitial: ROGridLayout;
		on: elements.
	
	result := ((Array new: 20) at: 1 put: ((174@164)); at: 2 put: ((111@22)); at: 3 put: ((172@64)); at: 4 put: ((210@4)); at: 5 put: ((297@53)); at: 6 put: ((29@79)); at: 7 put: ((85@118)); at: 8 put: ((141@117)); at: 9 put: ((229@102)); at: 10 put: ((272@146)); at: 11 put: ((5@176)); at: 12 put: ((79@195)); at: 13 put: ((137@216)); at: 14 put: ((236@202)); at: 15 put: ((334@175)); at: 16 put: ((49@265)); at: 17 put: ((123@315)); at: 18 put: ((191@256)); at: 19 put: ((221@322)); at: 20 put: ((292@258)); yourself).
	
	resultVW := (( Array new: 20) at: 1 put: ( Point x: 174 y: 165); at: 2 put: ( Point x: 110 y: 22); at: 3 put: ( Point x: 171 y: 64); at: 4 put: ( Point x: 210 y: 5); at: 5 put: ( Point x: 297 y: 55); at: 6 put: ( Point x: 30 y: 80); at: 7 put: ( Point x: 84 y: 119); at: 8 put: ( Point x: 141 y: 117); at: 9 put: ( Point x: 229 y: 103); at: 10 put: ( Point x: 270 y: 147); at: 11 put: ( Point x: 5 y: 176); at: 12 put: ( Point x: 78 y: 195); at: 13 put: ( Point x: 137 y: 218); at: 14 put: ( Point x: 236 y: 202); at: 15 put: ( Point x: 333 y: 175); at: 16 put: ( Point x: 49 y: 266); at: 17 put: ( Point x: 122 y: 316); at: 18 put: ( Point x: 192 y: 256); at: 19 put: ( Point x: 222 y: 323); at: 20 put: ( Point x: 291 y: 258); yourself).
	
	computed := (elements collect: #position) collect: #asIntegerPoint.
	self assert: ((computed = result) or: [ computed = resultVW ])! !

ROLayoutTest subclass: #ROGridLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/17/2012 17:06'!
testLayout
	| result |
	ROGridLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((125@5)); at: 4 put: ((185@5)); at: 5 put: ((245@5)); at: 6 put: ((5@65)); at: 7 put: ((65@65)); at: 8 put: ((125@65)); at: 9 put: ((185@65)); at: 10 put: ((245@65)); at: 11 put: ((5@125)); at: 12 put: ((65@125)); at: 13 put: ((125@125)); at: 14 put: ((185@125)); at: 15 put: ((245@125)); at: 16 put: ((5@185)); at: 17 put: ((65@185)); at: 18 put: ((125@185)); at: 19 put: ((185@185)); at: 20 put: ((245@185)); yourself).
	
	self assert: (elements collect: #position) = result! !

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 6/30/2012 01:23'!
testLayoutLineItemCount
	| result |
	ROGridLayout on: elements withLineItemsCount: 5.
	
	result := ((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((125@5)); at: 4 put: ((185@5)); at: 5 put: ((245@5)); at: 6 put: ((5@65)); at: 7 put: ((65@65)); at: 8 put: ((125@65)); at: 9 put: ((185@65)); at: 10 put: ((245@65)); at: 11 put: ((5@125)); at: 12 put: ((65@125)); at: 13 put: ((125@125)); at: 14 put: ((185@125)); at: 15 put: ((245@125)); at: 16 put: ((5@185)); at: 17 put: ((65@185)); at: 18 put: ((125@185)); at: 19 put: ((185@185)); at: 20 put: ((245@185)); yourself).
	
	self assert: (elements collect: #position) = result! !

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 6/30/2012 01:23'!
testLayoutLineItemCount2
	| result |
	ROGridLayout on: elements withLineItemsCount: 3.
	
	result := (((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((125@5)); at: 4 put: ((5@65)); at: 5 put: ((65@65)); at: 6 put: ((125@65)); at: 7 put: ((5@125)); at: 8 put: ((65@125)); at: 9 put: ((125@125)); at: 10 put: ((5@185)); at: 11 put: ((65@185)); at: 12 put: ((125@185)); at: 13 put: ((5@245)); at: 14 put: ((65@245)); at: 15 put: ((125@245)); at: 16 put: ((5@305)); at: 17 put: ((65@305)); at: 18 put: ((125@305)); at: 19 put: ((5@365)); at: 20 put: ((65@365)); yourself)).
	
	self assert: (elements collect: #position) = result! !

ROLayoutTest subclass: #ROHorizontalTreeLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROHorizontalTreeLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 7/29/2012 08:44'!
testLayout
	| result edges firstEdge shape |
	ROHorizontalTreeLayout on: elements.
	
	result := (((Array new: 20) at: 1 put: ((5@482.0)); at: 2 put: ((75@747.0)); at: 3 put: ((75@800.0)); at: 4 put: ((75@429.0)); at: 5 put: ((75@482.0)); at: 6 put: ((75@111.0)); at: 7 put: ((75@164.0)); at: 8 put: ((75@853.0)); at: 9 put: ((75@906.0)); at: 10 put: ((75@535.0)); at: 11 put: ((75@588.0)); at: 12 put: ((75@217.0)); at: 13 put: ((75@270.0)); at: 14 put: ((75@959.0)); at: 15 put: ((75@5.0)); at: 16 put: ((75@641.0)); at: 17 put: ((75@694.0)); at: 18 put: ((75@323.0)); at: 19 put: ((75@376.0)); at: 20 put: ((75@58.0)); yourself)).
	self assert: ((elements collect: #position) includesAllOf: result).
	
	edges := view elements select: #isEdge.
	edges do: [ :e | (e getShape: ROLine) attachPoint: ROHorizontalAttachPoint new ].
	
	firstEdge := edges first.
	shape := firstEdge getShape: ROLine.
	self assert: (shape startingPointOf: firstEdge) = (firstEdge from bounds topRight + (0 @ (firstEdge from bounds height / 2))).
	self assert: (shape endingPointOf: firstEdge) = (firstEdge to bounds topLeft + (0 @ (firstEdge to bounds height / 2))).! !

!ROLayoutTest classSide methodsFor: 'as yet unclassified' stamp: ''!
isAbstract 
	^ self name == #ROLayoutTest  ! !

!ROLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/22/2012 21:01'!
setUp

	elements := ROElement forCollection: (1 to: 20).
	elements do: [ :n | n extent: 50@50; addShape: (ROBox new) ].
	view := ROView new.
	view addAll: elements.
	elements allButFirst do: [:e | 
	 	view add: (ROEdge lineFrom: elements first to: e) ]! !

!ROLayoutTest methodsFor: 'test layout' stamp: ''!
testLayout
	self subclassResponsibility ! !

ROLayoutTest subclass: #ROSugiyamaLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROSugiyamaLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/17/2012 17:28'!
testLayout
	| result |
	ROSugiyamaLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((497.0@3.0)); at: 2 put: ((974.0@73.0)); at: 3 put: ((921.0@73.0)); at: 4 put: ((868.0@73.0)); at: 5 put: ((815.0@73.0)); at: 6 put: ((762.0@73.0)); at: 7 put: ((709.0@73.0)); at: 8 put: ((656.0@73.0)); at: 9 put: ((603.0@73.0)); at: 10 put: ((550.0@73.0)); at: 11 put: ((497.0@73.0)); at: 12 put: ((444.0@73.0)); at: 13 put: ((391.0@73.0)); at: 14 put: ((338.0@73.0)); at: 15 put: ((285.0@73.0)); at: 16 put: ((232.0@73.0)); at: 17 put: ((179.0@73.0)); at: 18 put: ((126.0@73.0)); at: 19 put: ((73.0@73.0)); at: 20 put: ((20.0@73.0)); yourself).
	self assert: (elements collect: #position) = result! !

ROLayoutTest subclass: #ROTreeLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROTreeLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/17/2012 17:08'!
testLayout
	| result |
	ROTreeLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((482@5)); at: 2 put: ((5@75)); at: 3 put: ((58@75)); at: 4 put: ((111@75)); at: 5 put: ((164@75)); at: 6 put: ((217@75)); at: 7 put: ((270@75)); at: 8 put: ((323@75)); at: 9 put: ((376@75)); at: 10 put: ((429@75)); at: 11 put: ((482@75)); at: 12 put: ((535@75)); at: 13 put: ((588@75)); at: 14 put: ((641@75)); at: 15 put: ((694@75)); at: 16 put: ((747@75)); at: 17 put: ((800@75)); at: 18 put: ((853@75)); at: 19 put: ((906@75)); at: 20 put: ((959@75)); yourself).
	self assert:  (result includesAllOf: (elements collect: #positionAsInteger))! !

ROTest subclass: #ROLayoutTranslatorTest
	instanceVariableNames: 'elements layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

ROLayoutTranslatorTest subclass: #ROAbsorbLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROAbsorbLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/17/2012 17:28'!
testLayout
	layout translator: ROAbsorbLayoutTranslator new.
	layout applyOn: elements.
	self assert: ((elements collect: #position) asSet asArray first = (0@0))! !

ROLayoutTranslatorTest subclass: #RODirectLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!RODirectLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/19/2012 10:22'!
testLayout
	| result |
	layout translator: RODirectLayoutTranslator new.
	layout applyOn: elements.
	result := ((Array new: 5) at: 1 put: (31@5); at: 2 put: (31@75); at: 3 put: (58@145); at: 4 put: (111@5); at: 5 put: (5@145); yourself).
	self assert: (result includesAllOf: (elements collect: #positionAsInteger))! !

!ROLayoutTranslatorTest methodsFor: 'running' stamp: 'AlexandreBergel 6/9/2012 18:42'!
setUp

	| view edges |
	view := ROView new.
	elements := ROElement spritesOn: (1 to: 5).
	view addAll: elements.
	view addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	layout := ROTreeLayout new! !

!ROLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 15:33'!
testDefault
	"
	Commented out because isAbstractClass is not in VW
	self assert: ROLayoutTranslator isAbstractClass.
	self assert: ROLayoutTranslator defaultClass isAbstractClass not.
	"
	
	self assert: (ROLayoutTranslator withAllSubclasses select: #isDefault) size = 1.
	
	self assert: ROLayoutTranslator default class ==  ROLayoutTranslator defaultClass! !

ROLayoutTranslatorTest subclass: #ROSmoothLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROSmoothLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 16:32'!
testLayout
	| result |
	layout translator: ROSmoothLayoutTranslator new.
	layout applyOn: elements.
	self assert: ((elements collect: #positionAsInteger) asSet asArray first = (0@0)).
	[ layout translator hasCompleted not ] whileTrue: [ self wait ].
	1 to: 10 do: [ :i | self wait ].

	result := ((Array new: 5) at: 1 put: (31@5); at: 2 put: (31@75); at: 3 put: (58@145); at: 4 put: (111@5); at: 5 put: (5@145); yourself).
	self assert: (result includesAllOf: (elements collect: #positionAsInteger))! !

!ROSmoothLayoutTranslatorTest methodsFor: 'waiting' stamp: ''!
wait
	(Delay forMilliseconds: 3) wait.! !

ROTest subclass: #ROLevelledChildrenShapeTest
	instanceVariableNames: 'levelledShape view el camera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROLevelledChildrenShapeTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/23/2012 15:52'!
setUp
	super setUp.

	view := ROView new.
	el := ROElement new.
	levelledShape := ROLevelledChildrenShape new.
	 el change: ROChildrenShape for: levelledShape.
	
	camera := view camera.
! !

!ROLevelledChildrenShapeTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 16:49'!
testZooming
	
	self assert: (levelledShape shouldDisplayChildrenFor: el).
	
! !

ROTest subclass: #ROLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROLineTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/14/2012 19:14'!
testColorBlockTakesTheElement
	| edge line |
	line := ROLine new 
		color: #model.
	edge := ROEdge on: 42.
	self assert: (line colorFor: edge) = 42! !

!ROLineTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/14/2012 19:15'!
testWidthBlockTakesTheElement
	| edge line |
	line := ROLine new 
		width: #model.
	edge := ROEdge on: 42.
	self assert: (line widthFor: edge) = 42! !

ROTest subclass: #ROMenuElementTest
	instanceVariableNames: 'emptyMenu menu counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets-Tests'!

!ROMenuElementTest methodsFor: 'running' stamp: 'AlexandreBergel 9/1/2012 19:54'!
setUp

	emptyMenu := ROMenuElement new.
	
	menu := ROMenuElement new.
	menu item: 'reset' action: [ :v | counter := 0. ].
	menu item: 'increase' action: [ :v | counter := counter + 1 ].! !

!ROMenuElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/1/2012 19:55'!
testEvaluateCallback

	self assert: counter isNil.
	menu evaluate: 'reset'.
	self assert: counter = 0.
	
	menu evaluate: 'increase'.
	self assert: counter = 1.

	menu evaluate: 'increase'.
	menu evaluate: 'increase'.
	self assert: counter = 3.
! !

!ROMenuElementTest methodsFor: 'test-initialization' stamp: 'AlexandreBergel 9/1/2012 23:35'!
testInitialization

	self assert: emptyMenu targetObject == emptyMenu.
	! !

!ROMenuElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/1/2012 19:49'!
testNumberOfActions

	self assert: emptyMenu numberOfActions = 0.
	self assert: menu numberOfActions = 2.
! !

!ROMenuElementTest methodsFor: 'test-rendering' stamp: 'AlexandreBergel 10/2/2012 08:40'!
testRendering

	self assert: menu numberOfElements = 0.
	self assert: menu extent = (5@5).
	
	menu create.
	
	self assert: menu numberOfElements = menu numberOfActions.
	self assert: menu extent >=  (50@50).
	
	"ROView new add: menu; open "! !

!ROMenuElementTest methodsFor: 'test-rendering' stamp: 'AlexandreBergel 9/1/2012 23:58'!
testRenderingEmpty

	self assert: emptyMenu numberOfElements = 0.
	self assert: emptyMenu extent = (5@5).
	
	emptyMenu create.
	
	self assert: emptyMenu numberOfElements = 0.
	self assert: emptyMenu extent = (5@5)! !

ROTest subclass: #ROMondrianScatterLayoutTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianScatterLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/21/2012 22:41'!
tearDown 
	window ifNotNil: [ window delete ]! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:39'!
testScatterplotLayout
	
	| nodes |
	view := ROMondrianViewBuilder new.
		
	nodes := view
		nodes: #(#(10 20) #(30 40)).
	view layout: (ROScatterplotLayout new 
						x: [:entity | entity first ];
						y: [:entity | entity last ]).
	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:39'!
testScatterplotLayoutBounds
	"
	self debug: #testScatterplotLayoutBounds
	"
	| nodes |
	view := ROMondrianViewBuilder new.
		
	view node: #foo forIt: [
		view layout: (ROScatterplotLayout new 
							x: #first ;
							y: #last).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:45'!
testScatterplotLayoutOffset
	
	| nodes |
	view := ROMondrianViewBuilder new.
		
	nodes := view
		nodes: #(#(10 20) #(30 40)).
		
	view layout: (ROScatterplotLayout new 
						offset: 2;
						x: [:entity | entity first ];
						y: [:entity | entity last ]).
	window := view open.
	self assert: nodes first bounds topLeft x = 12.
	self assert: nodes first bounds topLeft y = 22.

	self assert: nodes last bounds topLeft x = 32.
	self assert: nodes last bounds topLeft y = 42.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:45'!
testScatterplotLayoutScalled

	|  nodes |
	view := ROMondrianViewBuilder new.
		
	view node: #foo forIt: [
		view layout: (ROScatterplotLayout new 
							x: #first ;
							y: #last
							;
							scaledToWidth: 20;
							scaledToHeight: 15 ).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x = 6.
	self assert: nodes first bounds topLeft y =  7.

	self assert: nodes last bounds topLeft x = 20.
	self assert: nodes last bounds topLeft y = 15.

! !

ROTest subclass: #ROMondrianViewBuilderLayoutTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianViewBuilderLayoutTest methodsFor: 'edgesDefinedFromOutside' stamp: 'AlexandreBergel 7/25/2012 17:19'!
buildScenario

	view := ROMondrianViewBuilder new.
	view nodes: #(1 2) forEach: [ :each |
		view nodes: (Array with: each * 10 with: (each * 100)). 
		view treeLayout.
	].
	view edgesFromAssociations: (Array with: 10 -> 100 with: 20 -> 200).
	view applyLayout.
	! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 7/25/2012 11:24'!
setUp

	view := ROMondrianViewBuilder new.! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/21/2012 22:36'!
tearDown 
	window ifNotNil: [ window delete ]! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'edgesDefinedFromOutside' stamp: 'AlexandreBergel 7/24/2012 15:00'!
testEdgesDefinedOutside

	| firstNode secondNode |
	self buildScenario.
	
	firstNode := view raw elements first.
	secondNode := view raw elements second.
	
	"We check who has the edge"
	self assert: (firstNode elements size = 3).
	self assert: (secondNode elements size = 3).
	self assert: view raw elements size = 2.! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'edgesDefinedFromOutside' stamp: 'AlexandreBergel 8/19/2012 13:23'!
testEdgesDefinedOutsideLayout

	| firstNode secondNode |
	self buildScenario.
	
	firstNode := view raw elements first.
	secondNode := view raw elements second.
	
	"We check the layout" 
	self assert: (firstNode elementsNotEdge collect: #position) asArray = (Array with: 5 @ 5 with: 5 @ 30).
	self assert: (secondNode elementsNotEdge collect: #position) asArray = (Array with: 5 @ 5 with: 5 @ 30).
	
! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'edgesDefinedFromOutside' stamp: 'AlexandreBergel 7/25/2012 11:02'!
testEdgesDefinedOutsideLayoutStructure
	| firstInnerFrame secondInnerFrame |
	self buildScenario.
	
	self assert: view numberOfFrames = 3.
	
	"Outter frame"
	self assert: view structureTree elements size = 2.
	self assert: view structureTree nodes size = 2.
	
	"First inner frame"
	firstInnerFrame := view structureTree children first.
	self assert: firstInnerFrame elements size = 3. 
	self assert: firstInnerFrame nodes size = 2.
	self assert: firstInnerFrame edges size = 1.
	
	"Second inner frame"
	secondInnerFrame := view structureTree children second.
	self assert: secondInnerFrame elements size = 3. 
	self assert: secondInnerFrame nodes size = 2.
	self assert: secondInnerFrame edges size = 1.! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 11:26'!
testEdgesFrom

	| outterFrame firstInnerFrame secondInnerFrame |
	view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2 with: v + 3).
		view shape line.
		view edgesFrom: [ :el | v + 1 ].
		view treeLayout ].

	view horizontalLineLayout.
	view applyLayout.
	
	self assert: view structureTree numberOfFrames = 3.

	outterFrame := view structureTree .
	firstInnerFrame := outterFrame children first.
	secondInnerFrame := outterFrame children second.
	
	self assert: (outterFrame nodes size = 2).
	self assert: (outterFrame edges size = 0).
	
	self assert: (firstInnerFrame nodes size = 3).
	self assert: (firstInnerFrame edges size = 2).
	
	self assert: (secondInnerFrame nodes size = 3).
	self assert: (secondInnerFrame edges size = 2).! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 11:23'!
testLayouts

	| l |
	l := OrderedCollection new.
	l add: #treeLayout.
	l add: #gridLayout.
	l add: #forceBasedLayout.
	l add: #circleLayout.
	l add: #verticalLineLayout.
	l add: #horizontalLineLayout.
	l add: #sugiyamaLayout.
	l add: #bottomFlowLayout.
	l add: #flowLayout.
	l add: #radialTreeLayout.
	l add: #scatterPlotLayout.
	l add: #noLayout.

	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.

	l do: [ :sel | 
		self shouldnt:  [ view perform: sel. view applyLayout ] raise: Error ]! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 11:23'!
testTreeLayoutAndColor
	"Strange bug http://code.google.com/p/objectprofile/issues/detail?id=86&thanks=86&ts=1341240917"
	| edges |
	
	view shape rectangle size: 50.
	view nodes: (1 to: 5).
	view shape line color: Color blue.
	edges := view edgesFromAssociations: (Array with: 1 -> 5 with: 1 -> 2 with: 3 -> 4).
	self assert: (edges allSatisfy: [ :edge | (edge getShape: ROLine) color = Color blue ]).
	
	view treeLayout .	 
	"view open"
	
	self assert: (edges allSatisfy: [ :edge | (edge getShape: ROLine) color = Color blue ])! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'user defined edges' stamp: 'AlexandreBergel 9/9/2012 20:02'!
testUserDefinedEdges
	" to address: http://code.google.com/p/moose-technology/issues/detail?id=834 "

	| edges layout |
	view nodes: #(1 2 3).
	edges := view edgesFrom: [:each  | each - 1].
	view shape line color: Color red.
	view edges: #(3) from: [ :each | each - 2 ] to: #yourself.
	layout := view treeLayout userDefinedEdges: edges; yourself.
	
	"We check the user defined edges before doing the layout"
	self assert: (layout userDefinedEdges = edges).
	
	"We do the layout"
	view applyLayout.

	"We first check whether the edges have been well defined."
	self assert: edges size = 2.
	self assert: (edges first from model = 1).
	self assert: (edges first to model = 2).
	
	self assert: (edges second from model = 2).
	self assert: (edges second to model = 3).

	"We then checked if the edges are defined in the layout"
	self assert: (layout userDefinedEdges = edges).
	self assert: (layout edges = edges).
	
	""
 ! !

ROTest subclass: #ROMondrianViewBuilderTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianViewBuilderTest commentStamp: '<historical>' prior: 0!
A ROMondrianViewBuilderTest is a test class for testing the behavior of ROMondrianViewBuilder!

!ROMondrianViewBuilderTest methodsFor: 'running' stamp: ''!
setUp
	view := ROMondrianViewBuilder new! !

!ROMondrianViewBuilderTest methodsFor: 'running' stamp: ''!
tearDown
	super tearDown.
	window ifNotNil: [window delete. window := nil]! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testAbsolutePosition
	
	| inner2 outter inner |

	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.

	self assert: outter absolutePosition = outter position.
	self assert: outter absolutePosition = (5@5).
	
	self assert: inner absolutePosition = (inner position + outter position).
	self assert: inner absolutePosition = (10@10).

	self assert: inner2 absolutePosition = (inner2 position + outter position + inner position).
	self assert: inner2 absolutePosition = ( 15@15).! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testAbsolutePositionAfterTranslation
	
	| inner2 outter inner |

	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.
	outter translateBy: 10@3.

	self assert: outter absolutePosition = outter position.
	self assert: outter absolutePosition = (5@5 + (10@3)).
	
	self assert: inner absolutePosition = (inner position + outter position).
	self assert: inner absolutePosition = (10@10 + (10@3)).

	self assert: inner2 absolutePosition = (inner2 position + outter position + inner position).
	self assert: inner2 absolutePosition = ( 15@15 + (10@3)).! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'AlexandreBergel 6/9/2012 15:18'!
testAddingNode

	view node: 123.
	self assert: (view raw numberOfElements = 1)! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'AlexandreBergel 6/9/2012 15:18'!
testAddingNodes

	view nodes: (1 to: 20).
	self assert: (view raw numberOfElements = 20)! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/17/2012 12:18'!
testBorderColor

	| nodes b |
	view shape rectangle borderColor: (b := [ :model | model + 1]).
	nodes := view nodes: #(2 3 4).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderColorFor: n]) = #(3 4 5)! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/15/2012 13:11'!
testBorderColorWithNormalizer

	view shape rectangle borderColor: (RONIdentityNormalizer new).
	view nodes: (1 to: 10).
	self shouldnt: [view raw drawOn: RONullCanvas new]  raise: Error! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/17/2012 12:14'!
testBorderWidth

	| nodes b |
	view := ROMondrianViewBuilder new.
	view shape rectangle borderWidth: (b := [ :model | model + 1 ]).
	nodes := view nodes: #(2 3 4).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderWidthFor: n]) = #(3 4 5)! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testChangeInteraction

	
	| el |
	el := ROElement new.
	self deny: (el is: ROAbstractPopup).
	self deny: (el is: ROPopup).
	self deny: (el is: ROPopupView).

	el changeInteraction: ROPopup for: (ROPopupView new).
	self deny: (el is: ROPopup).
	self assert: (el is: ROPopupView).
	
	el changeInteraction: ROPopupView for: (ROPopup new).
	self assert: (el is: ROPopup).
	self deny: (el is: ROPopupView).

! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testChangeInteraction2

	
	| el |
	el := ROElement new.
	self deny: (el is: ROAbstractPopup).
	self deny: (el is: ROPopup).
	self deny: (el is: ROPopupView).

	el changeInteraction: ROAbstractPopup for: (ROPopupView new).
	self deny: (el is: ROPopup).
	self assert: (el is: ROPopupView).
	
	el changeInteraction: ROAbstractPopup for: (ROPopup new).
	self assert: (el is: ROPopup).
	self deny: (el is: ROPopupView).

! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/20/2012 14:49'!
testCircle

	| element |
	view shape circle.
	element := view node: 'hello'.
	self assert: (element isShapedAs: ROCircle).
	view raw bitmap.! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/20/2012 21:19'!
testCircleWithBorderedColor

	| element |
	view shape circle borderColor: [ :v | Color r: 255 g: 255 b: v].
	element := view node: 255.
	self assert: (element isShapedAs: ROCircle).
	view raw bitmap.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/23/2012 15:23'!
testColoredEdges

	| edge1 edge2 |
	view nodes: #(1 2 3).
	edge1 := view edgeFromAssociation: 1 -> 2.
	
	view shape line color: Color red.
	edge2 := view edgeFromAssociation: 2 -> 3.
	
	view treeLayout.
	self assert: (edge1 numberOfShapes = 2).
	self assert: (edge2 numberOfShapes = 2)! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/3/2012 00:03'!
testColoredEdges2

	| edges |
	view shape rectangle size: 50.
	view nodes: (1 to: 5).
	view shape line color: [:edge | (edge from model + edge to model) odd ifTrue: [ Color red ] ifFalse: [ Color black ]].

	edges := view edgesFromAssociations: (Array with: 1 -> 5 with: 1 -> 2 with: 3 -> 4).
	view treeLayout .	 

	self assert: ((edges first getShape: ROLine) color roValue: edges first) = Color black.
	self assert: ((edges second getShape: ROLine) color roValue: edges second) = Color red.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/23/2012 15:23'!
testColoredEdgesWithoutLayout

	| edge1 edge2 |
	view nodes: #(1 2 3).
	edge1 := view edgeFromAssociation: 1 -> 2.
	
	view shape line color: Color red.
	edge2 := view edgeFromAssociation: 2 -> 3.

	self assert: (edge1 numberOfShapes = 2).
	self assert: (edge2 numberOfShapes = 2)! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/7/2012 12:01'!
testDefaultShapeForEdge

	| edge |
	view nodes: #(1 2 3).
	edge := view edgeFromAssociation: 1 -> 2.	
	self assert: (edge isShapedAs: ROLine)
! !

!ROMondrianViewBuilderTest methodsFor: 'instantiating' stamp: 'AlexandreBergel 5/17/2012 20:52'!
testDefaultTitle
	| builder |
	builder := ROMondrianViewBuilder new.
	window := builder open.
	
	[
		self assert: window labelString = ROView defaultWindowTitle.
	] ensure: [ window delete ]! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 8/19/2012 21:52'!
testEdgeAndInteraction

	|  edge |
	view := ROMondrianViewBuilder new.
	view shape rectangle size: 30.
	view nodes: (1 to: 2).
	view interaction on: ROMouseEnter do: [:ann | Transcript show: ann printString ; cr ].
	edge := view edgeFromAssociation: 1 -> 2.

	self assert: edge numberOfInteractions = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 8/20/2012 09:16'!
testEdgeAndInteraction2LowLevel

	|  edge |
	view := ROMondrianViewBuilder new.
	view shape line.
	view interaction on: ROMouseEnter do: [:ann | Transcript show: ann printString ; cr ].
	edge := view buildEdgeFrom: (ROElement on: 1) to: (ROElement on: 2) for: 'zork'.

	self assert: edge numberOfInteractions = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:18'!
testEdgeFromAndToItself
	"
	self debug: #testEdgeFromAndToItself
	"
	
	view nodes: #(1 2).
	view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 2 with: 1 -> 1).

	self assert: (view raw elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view raw elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:18'!
testEdgeFromAndToItself2
	"
	self debug: #testEdgeFromAndToItself2
	"
	
	view nodes: #(1 2).
	view edges: #(1 2) from: #yourself toAll: [ :v | Array with: 1 ].

	self assert: (view raw elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view raw elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:40'!
testEdgeFromAssociation
	| nodes edges ass m |

	nodes := view nodes: #(1 2 3 4).
	 view edge: (1 -> 2) from: #key to:  #value.
	edges := view root edges.
	
	self assert: edges size = 1.
	self assert: edges first from = nodes first.
	self assert: edges first to = nodes second.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:42'!
testEdgeFromAssociation2
	| nodes edges ass m |

	nodes := view nodes: #(1 2 3 4).
	 view edge: (1 -> 20) from: #key to:  #value.
	edges := view root edges.
	
	self assert: edges isEmpty
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/17/2012 17:21'!
testEdgesAndInnerNodes
	"Node extremities should be looked up with the nesting"
	
	| outterNode1 edges innerNode1 innerNode2 innerNode3 |
	outterNode1 := view node: 'outter1' forIt: [ innerNode1 := view node: 1 ].
	view node: 'outter2' forIt: [ innerNode2 := view node: 2 ].
	view node: 'outter3' forIt: [ innerNode3 := view node: 3 ].
	
	view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3 with: 1 -> 3).

	self assert: (view nestedLookup: 1 in: outterNode1) = innerNode1.
	self assert: (view nestedLookup: 2 in: outterNode1) isNil.
		
	self assert: (view lookup: 1) == innerNode1.
	self assert: (view lookup: 2) == innerNode2.
	self assert: (view lookup: 3) == innerNode3.
	
	edges := view root edges.
	self assert: edges size = 3.
	self assert: (edges first from == innerNode1).
	self assert: (edges first to == innerNode2).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:42'!
testEdgesFromAssociation
	| nodes edges  m |

	nodes := view nodes: #(1 2 3 4).
	 view edges: (Array with: 1 -> 2 with: 2 -> 10 with: 10 -> 3) from: #key to:  #value.
	edges := view root edges.
	
	self assert: edges size = 1.
	self assert: edges first from = nodes first.
	self assert: edges first to = nodes second.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/17/2012 17:21'!
testEdgesFromTo
	| nodes edges ass m |

	nodes := view nodes: #(1 2 3 4).
	edges := view edges: (ass := (Array with: 1 -> 2 with: 1 -> 3 with: 3 -> 4)) from: #key to:  #value.
	
	self assert: edges size = 3.
	m := edges collect: [ :e | e from model -> e to model ].
	m with: ass do: [ :a :b | 
		self assert: a = b ]! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 23:07'!
testEdgesFromToHaveNonNilModel
	| edges |
	view nodes: #(4 2).
	edges := view edges: (Array with: 42) from: 4 to: 2.
	
	self assert: edges first model = 42! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 23:26'!
testEdgesFromToWithSameModelsAsTheNodes
	| edges |
	view nodes: (Array with: 4 with: 2).

	self shouldnt: [edges := view edges: (Array with: 4 with: 2) from: 4 to: 2] raise: Error.
	self assert: edges size = 2! !

!ROMondrianViewBuilderTest methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testElementsFromModels
	"
	self debug: #testElementsFromModels
	"

	| container node1To6 node7 nodeInner10To20 node8 nodeInner1To6 |
	node1To6 := view nodes: (1 to: 6).
	node7 := view node: 7 forIt: [ nodeInner10To20 := view nodes: (10 to: 20) ].
	node8 := view node: 8 forIt: [ nodeInner1To6 := view nodes: (1 to: 6) ].
	
	container := view raw.

	"Looking up individual nodes"
	self assert: (container elementFromModel: 1) == node1To6 first.
	self assert: (container elementFromModel: 7) == node7.
	self assert: (container elementFromModel: 8) == node8.

	self assert: (node7 elementFromModel: 7) == node7.
	self assert: (node7 elementFromModel: 70) isNil.
	
	"------"
	"Group of nodes"
	"Checking the outter nodes"
	self assert: (container elementsFromModels: (1 to: 6)) asArray = node1To6.
	self assert: (container elementsFromModels: (Array with: 7)) asArray first == node7.
	self assert: (container elementsFromModels: (Array with: 8)) asArray first == node8.

	"Looking up the inner nodes"
	self assert: (container elementsFromModels: (10 to: 20)) asArray = nodeInner10To20. 
	
	"Looking up unexisting nodes"
	self assert: (container elementsFromModels: (Array with: 2000)) isEmpty
	
! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/14/2012 19:41'!
testFillColor

	| nodes |
	view shape rectangle fillColor: [ :model | model + 1].
	nodes := view nodes: #(2 3 4).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) colorFor: n]) = #(3 4 5)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 6/2/2012 14:26'!
testFixedSize

	| variableNode fixedSizedNode |
	view shape rectangle width: 50; height: 50.
	variableNode := view node: 'Variable size' forIt: [ view nodes: (1 to: 100). view gridLayout ].

	view shape rectangle width: 50; height: 50; fixedSize.
	fixedSizedNode := view node: 'Fixed size' forIt: [ view nodes: (1 to: 100). view gridLayout ].


	self assert: fixedSizedNode resizeStrategy == ROFixedSizedParent instance.
	self assert: variableNode extent >= (50 @ 50).
	self assert: fixedSizedNode extent = (50 @ 50).! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testForItAndShape
	| node |
	
	view shape rectangle width: [ :v | v ].
	view node: 50.
	
	view shape withoutBorder.
	node := view node: Object new.
	
	self assert: node width = view defaultWidth.
	self assert: node height = view defaultHeight.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 6/9/2012 15:21'!
testForwarding

	| t outterNode innerNode |
	
	t := 0.
	"Only the outter node should be a forwarder"
	view interaction forwarder.
	outterNode := view node: 'outter' forIt: [ 
		innerNode := view node: 'inner'.
	].
	view raw on: ROEvent do: [ :e | t := t + 1 ].

	self assert: t = 0.
	outterNode announce: ROEvent.
	self assert: t = 1.

	"Since the inner node is not declared has a forwarder, it should not forward"
	innerNode announce: ROEvent.
	self assert: t = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: ''!
testGraph

	"No error should be raised"
	
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/17/2012 09:34'!
testHeight

	| nodes heightBlock secondNode |
	heightBlock := [ :model | model + 1].
	view shape rectangle height: heightBlock.
	"self assert: view height == heightBlock."
	nodes := view nodes: #(2 30 40).
	
	secondNode := nodes second.
	self assert: ((secondNode getShape: ROBox) height roValue: secondNode) = 31.
	self assert: (nodes collect: [ :n | n height ]) =  #(5 31 41)! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/14/2012 19:45'!
testIfBorderColor

	| nodes |
	view shape rectangle 
		if: #odd borderColor: [ :model | model + 1];
		if: #even borderColor: [ :model | model + 10].
	nodes := view nodes: #(2 3 4 5 6).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderColorFor: n]) = #(12 4 14 6 16)! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/15/2012 10:05'!
testIfFillColor

	| nodes |
	view shape rectangle 
		if: #odd fillColor: [ :model | model + 1];
		if: #even fillColor: [ :model | model + 10].
	nodes := view nodes: #(2 3 4 5 6).
	
	self assert: (nodes collect: [ :n | (n getShape: ROBox) colorFor: n]) = #(12 4 14 6 16)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:49'!
testIfborderColor

	| nodes result |
	view shape rectangle 
		if: #odd borderColor: Color red;
		if: #even borderColor: Color blue.
	nodes := view nodes: #(1 2 3 4).
	
	result :=  ((Array new: 4) at: 1 put: Color red; at: 2 put: Color blue; at: 3 put: Color red; at: 4 put: Color blue; yourself).
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderColorFor: n]) = result! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testInitialization

	| builder |
	builder := ROMondrianViewBuilder new.
	self assert: (builder raw class == ROView)! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testInitializationWithView

	| builder v |
	v := ROView new.
	builder := ROMondrianViewBuilder titled: 'hello' view: v .
	
	self assert: (builder raw == v).
	self assert: (builder raw class == ROView).! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 9/25/2012 15:56'!
testInnerNodesAndEvents

	| outter inner inner2 |
	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.

	self assert: (view raw elementAt: outter absolutePosition) == outter.
	self assert: (view raw elementAt: inner absolutePosition) == inner.
	self assert: (view raw elementAt: inner2 absolutePosition) == inner2.


	self assert: (view raw elementAtRealPosition: outter absolutePosition) == outter.
	self assert: (view raw elementAtRealPosition: inner absolutePosition) == inner.
	self assert: (view raw elementAtRealPosition: inner2 absolutePosition) == inner2.
	
	self assert: (view raw elementAtRealPosition: 18@18) == inner2.

	"We simulate a drag and drop"
	outter translateTo: 67@32.
	self assert: (view raw elementAtRealPosition: 80@45) == inner2.
	
	"What really happens underneath"
	self assert: (inner elementAt: (80@45 - outter topLeft - inner topLeft)) == inner2.
	self assert: (outter elementAt: (80@45 - outter topLeft)) == inner2.
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 4/17/2012 17:26'!
testInnerNodesAndLayout
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2) ].

	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 35@20) with: (45@5 corner: 75@20)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10))

! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 4/17/2012 17:25'!
testInnerNodesAndLayout2
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2).
		view verticalLineLayout ].

	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 20@35) with: (30@5 corner: 45@35)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (5@20 corner: 10@25)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (5@20 corner: 10@25))
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 4/17/2012 17:24'!
testInnerNodesAndLayout3
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v+ 1 with: v +2).
	 ].
	view verticalLineLayout.
	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 35@20) with: (5@30 corner: 35@45)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10))
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 8/19/2012 13:24'!
testInnerNodesAndLayout4
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2 with: v + 3).
		view shape line.
		view edgesFrom: [ :el | v + 1 ].
		view treeLayout ].

	view horizontalLineLayout.
	view applyLayout.
	
	"Sanity check begin"
	self deny: ((nodes second elementFromModel: 11) isShapedAs: ROLine).
	self assert: (nodes first elementsSuchThat: #isEdge) size = 2.
	"Sanity check end"
	
	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 28.0@45) with: (38.0@5 corner: 61.0@45)).
	
	self assert: (((Array new: 5) at: 1 put: (9.0@5 corner: 14.0@10); at: 2 put: (5.0@30 corner: 10.0@35); at: 3 put: (13.0@30 corner: 18.0@35); at: 4 put: (0@0 corner: 5@5); at: 5 put: (0@0 corner: 5@5); yourself) includesAllOf: (nodes first elementsNotEdge collect: #bounds) asArray).
	self assert: (((((Array new: 5) at: 1 put: (9.0@5 corner: 14.0@10); at: 2 put: (5.0@30 corner: 10.0@35); at: 3 put: (13.0@30 corner: 18.0@35); at: 4 put: (0@0 corner: 5@5); at: 5 put: (0@0 corner: 5@5); yourself))) includesAllOf: (nodes second elementsNotEdge collect: #bounds) asArray)! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testInteraction
	
	| t nodes |
	t := OrderedCollection new.
	view interaction 
		item: 'act' action: [ :v |  t add: t ].
	
	nodes := view nodes: #(1 2).
	! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 10/15/2012 10:01'!
testInteraction1
	"
	self debug: #testInteraction1
	"

	
	| nodes firstNode |
	view interaction highlightWhenOver: [ :e | (Array with: 123) ].
	view shape rectangle size: 60; fillColor: Color green.
	nodes := view nodes: #(123 456 789).

	firstNode := nodes first.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color green.
	nodes first announce: ROMouseEnter.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color red.
	nodes first announce: ROMouseLeave.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color green.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 10/15/2012 10:03'!
testInteraction2
	"
	self debug: #testInteraction2
	"

	
	| nodes firstNode |
	view node: 'foo' forIt: [
		view interaction highlightWhenOver: [ :e | (Array with: 123) ].
		view shape rectangle size: 60; fillColor: Color green.
		nodes := view nodes: #(123 456 789) ].

	firstNode := nodes first.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color green.
	nodes first announce: ROMouseEnter.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color red.
	nodes first announce: ROMouseLeave.
	self assert: ((firstNode getShape: ROShape) colorFor: firstNode) = Color green.
	! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'TudorGirba 10/18/2012 09:36'!
testInteraction2HighlightWhenOver
	"
	self debug: #testInteraction2HighlightWhenOver
	"
	| nodes shape1 shape2 t aNode node5 node2 |
	
	t := 0.
	view interaction highlightWhenOver: [ :v | t := t + 1. ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)].
	view interaction highlightWhenOver: [ :v | Array with: v ] color: Color blue.
	view shape rectangle 
		width: 40;
		height: 30.
	nodes := view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	
	aNode := nodes first.
	node5 := nodes fifth.
	node2 := nodes second.
	shape1 := aNode getShape: ROBox.
	self assert: (shape1 borderColor == Color black). 
	nodes first announce: (ROMouseEnter new).
	
	self assert: (aNode getShape: ROBox) == shape1.
	self assert: (shape1 color = Color blue).
	
	shape2 := aNode getShape: ROBox.
	self assert: (t = 1).
	self assert: (shape1 == shape2).
	self assert: ((node2 getShape: ROBox) color = Color red).
	self assert: ((node5 getShape: ROBox) color = Color red).

	nodes first announce: (ROMouseLeave new).
	self assert: ((Array with: aNode with: node2 with: node5) allSatisfy: [ :n | ((n getShape: ROBox) colorFor: n) = Color white ]).
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'TudorGirba 10/18/2012 09:36'!
testInteraction2HighlightWhenOverOnInnerNodes
	"
	self debug: #testInteraction2HighlightWhenOverOnInnerNodes
	"
	| nodes shape1 shape2 t aNode node5 node2 |
	
	t := 0.
	view node: 'outterNode' forIt: [
		view interaction highlightWhenOver: [ :v | t := t + 1. ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)].
		view interaction highlightWhenOver: [ :v | Array with: v ] color: Color blue.
		view shape rectangle 
			width: 40;
			height: 30.
		nodes := view nodes: (1 to: 16).
		view gridLayout gapSize: 2
	].
	
	aNode := nodes first.
	node5 := nodes fifth.
	node2 := nodes second.
	shape1 := aNode getShape: ROBox.
	self assert: (shape1 borderColor == Color black). 
	
	nodes first announce: (ROMouseEnter new).
	self assert: (aNode getShape: ROBox) == shape1.
	self assert: (shape1 color = Color blue).
	
	shape2 := aNode getShape: ROBox.
	self assert: (t = 1).
	self assert: (shape1 == shape2).
	self assert: ((node2 getShape: ROBox) color = Color red).
	self assert: ((node5 getShape: ROBox) color = Color red).

	nodes first announce: (ROMouseLeave new).
	self assert: ((Array with: aNode with: node2 with: node5) allSatisfy: [ :n | ((n getShape: ROBox) colorFor: n) == Color white ]).
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 7/4/2012 00:10'!
testInteraction3
	"
	self debug: #testInteraction2
	"

	
	| nodes firstNode shape secondNode |
	view node: 'foo' forIt: [
		view interaction highlightWhenOver: [ :e | (Array with: 123) ].
		view shape rectangle 
			size: 60;
			if: true fillColor: Color green.
		nodes := view nodes: #(123 456 789) ].

	firstNode := nodes first .
	secondNode := nodes second .
	shape := firstNode getShape: ROShape.
	
	self assert: (shape color roValue: firstNode) = Color green.
	firstNode announce: ROMouseEnter.
	self assert: (shape color roValue: firstNode) = Color red.
	firstNode announce: ROMouseLeave.
	self assert: (shape color roValue: firstNode) = Color green.

	"----"
	self assert: (shape color roValue: firstNode) = Color green.
	secondNode announce: ROMouseEnter.
	self assert: (shape color roValue: firstNode) = Color red.
	secondNode announce: ROMouseLeave.
	self assert: (shape color roValue: firstNode) = Color green.
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 7/3/2012 18:28'!
testInteraction4
	"
	self debug: #testInteraction4
	"

	
	| firstNode shape secondNode nodes1 nodes2 firstShape secondShape |
	view node: 'foo' forIt: [
		view interaction highlightWhenOver: [ :e | Array with: 123 with: 123  ].
		view shape rectangle 
			size: 60;
			if: true fillColor: Color green.
		nodes1 := view nodes: #(456 789) ].

	view node: 'bar' forIt: [
		view shape rectangle 
			size: 60;
			if: true fillColor: Color green.
		nodes2 := view nodes: #(123) ].
	
	firstNode := nodes1 first .
	secondNode := nodes2 first .
	firstShape := firstNode getShape: ROShape.
	secondShape := secondNode getShape: ROShape.
	
	"----"
	self assert: (secondShape color roValue: secondNode) = Color green.
	firstNode announce: ROMouseEnter.
	self assert: (secondShape color roValue: secondNode) = Color red.
	firstNode announce: ROMouseLeave.
	self assert: (secondShape color roValue: secondNode) = Color green.
! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 6/9/2012 15:22'!
testLabel

	| node builder element | 
	builder := ROMondrianViewBuilder titled: 'Finding nodes'.
	
	builder shape label.
	node := builder node: 'hello'.

	self assert: ((node getShape: ROLabel) textFor: node) = 'hello'.
	
	view := builder raw.
	self assert: view numberOfElements = 1.
	
	element := view elementDetect: [ :el | true ].
	self assert: (element isShapedAs: ROLabel).
	
	self assert: node bounds extent = (ROLabel new preferedExtentFor: node)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'TudorGirba 10/18/2012 09:34'!
testLabelText
	
	| node |
	view shape label text: [:o | o name, ' class'].
	node := view node: Object.

	self assert: ((node getShape: ROLabel) textFor: node) = 'Object class'.! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/25/2012 20:28'!
testLabelWithTwoNodes
	"Just to make sure that the view does not initialize a shape that later stays one"
	
	| node1 node2 |
	view shape label text: #printString.
	node1 := view node: Object.
	self assert: (node1 shapes size = 3).
	
	view shape label text: #printString.
	node2 := view node: Object.
	self assert: (node1 shapes size = 3).! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 7/25/2012 16:14'!
testLabeledRectangle

	| el1 el2 |
	view shape rectangle withText.
	el1 := view node: 'With rectangle'.
	
	view shape label.
	el2 := view node: 'Without rectangle'.
	
	self assert: (el2 width = (ROPlatform current fontOrganizerClass widthOfString: el2 model)).
	
	self assert: (el1 width >= (ROPlatform current fontOrganizerClass widthOfString: el1 model)).
	self assert: (el1 height = el2 height).! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/28/2012 11:24'!
testLinearFillColor

	self shouldnt:  
		[view shape rectangle 
			linearFillColor: #foo within: #().
		view nodes: #()]
	raise: Error.! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/18/2012 09:48'!
testLogHeight

	| nodes |
	view shape rectangle logHeight: [ :model | model + 1].
	nodes := view nodes: #(2 30 40).
	
	(nodes do: [ :n | self assert: n height class == Float ]) 
	 ! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/18/2012 09:49'!
testLogWidth

	| nodes |
	view shape rectangle logWidth: [ :model | model + 1].
	nodes := view nodes: #(2 30 40).
	
	(nodes do: [ :n | self assert: n width class == Float ]) 
	 ! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testMenu

	| nodes |
	
	view node: 30 forIt: [ 
		view interaction action: #inspect; action: #foo; action: #bar.
		nodes := view nodes: (1 to: 20) ].

	self assert: (nodes first getInteraction: ROMenuActivable) numberOfEntries = 3! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 9/10/2012 09:09'!
testNesting
	| firstNode |
	view nodes: (1 to: 20) forEach: [ :v | view nodes: (1 to: 2) ].	
	view applyLayout.
	firstNode := (view raw elementsSuchThat: [:el | el model = 1]) first.	
	self assert: firstNode extent = (30@15)
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 7/25/2012 10:08'!
testNestingForIt
	| firstNode |
	view node: 123 forIt: [ view nodes: (1 to: 2). ].
	view applyLayout.
	
	firstNode := (view raw elementsSuchThat: [:el | el model = 123]) first.	
	self assert: firstNode extent = ( 30@15)
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 7/25/2012 10:09'!
testNestingWithExplicitLayout
	| firstNode |
	view nodes: (1 to: 20) forEach: [ :v | view nodes: (1 to: 2) . view treeLayout ].
	view applyLayout.
	
	self assert: (view raw numberOfElements = 20).
	
	firstNode := (view raw elementsSuchThat: [:el | el model = 1]) first.
	self assert: firstNode numberOfElements = 2.
	
	self assert: firstNode extent = ( 23@15).
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testNilKeyOrValue

	"
	self debug: #testNilKeyOrValue
	"
	
	view nodes: #(1 2).
	view edgesFromAssociations: (Array with: 1 -> 2 with: nil -> 2 with: 1 -> nil).
	view edgeFromAssociation: nil -> nil.
	view edges: #(1 2) from: #yourself to: [ :v | nil ].
	view edges: #(1 2) from: [ :v | nil ] to: [ :v | nil ].
	view edges: #(1 2) from: [ :v | nil ] to: #yourself.

	self assert: (view root raw elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view root raw elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:58'!
testNoDraggable

	| el b |
	view interaction nodraggable.
	el := view node: 123.
	b := el position.
	
	self deny: (el is: RODraggable).
	
	el announce: (ROMouseDragging step: 40@50).
	self assert: el position = b! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 7/6/2012 14:15'!
testNoPopup

	| el1 el2 el3 |
	view interaction noPopup.
	el1 := view node: 1.
	
	el2 := view node: 2.

	view interaction noPopup.
	el3 := view node: 3.

	self deny: (el1 is: ROPopupView).
	self assert: (el2 is: ROPopupView).
	self deny: (el3 is: ROPopupView).! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 7/14/2012 09:47'!
testNumberOfDefinedInteractions

	
	self assert: view numberOfDefinedInteractions = 1! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 7/14/2012 09:47'!
testNumberOfDefinedInteractions2

	view nodes: (1 to: 20).
	self assert: view numberOfDefinedInteractions = 1.
! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 7/14/2012 09:47'!
testNumberOfDefinedInteractions3
	view interaction action: #inspect.
	self assert: view numberOfDefinedInteractions = 2.

	view nodes: (1 to: 20).
	self assert: view numberOfDefinedInteractions = 1.
! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 7/14/2012 09:48'!
testNumberOfDefinedInteractions4
	view interaction 
		if: #odd popupText: 'hello';
		if: #even popupText: 'world'.
	self assert: view numberOfDefinedInteractions = 3.

	view nodes: (1 to: 20).
	self assert: view numberOfDefinedInteractions = 1.
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testOddLine

	view node: 4.
	view edges: (Array with: 4) from: #yourself toAll: [ :m | #() ].

	self assert: view root raw numberOfElements = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 7/6/2012 14:15'!
testPopupOnInnerInnerNodes
	| node1 node2 node3 |
	node1 := view node: 1 forIt: [ node2 := view node: 2 forIt: [ node3 := view node: 3 forIt: [  ] ] ].
	
	self assert: (node1 is: ROPopupView).
	self assert: (node2 is: ROPopupView).
	self assert: (node3 is: ROPopupView).! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 6/2/2012 17:42'!
testPopupView
	| t el |
	t := false.

	view interaction popupView: [ :myView :ell |  t := true ] delay: 0. 
	el := view node: 'hello'.
	
	el announce: ROMouseEnter.
	self assert: t! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 09:49'!
testPopupViewSize
	| el popup elRef |
	

	view interaction popupView: [ :ell :myView | 
		
		myView shape rectangle fillColor: Color blue.
		myView node: '' forIt: [  myView node: 'world' ] ] delay: 0. 
	el := view node: 'hello'.
	
	elRef := view node: 'h' forIt: [ view node: 'w' ].
	
	view applyLayout.
	
	self assert: view stack numberOfElements = 0.
	el announce: ROMouseEnter.
	self assert: view stack numberOfElements = 1.
	
	popup := view stack elements first.
	self assert: popup extent = (21 @ 21).! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: 'AlexandreBergel 7/25/2012 10:09'!
testPositionRelativeTo

	| outterNode1 innerNode1 innerNode2 innerNode3 |
	outterNode1 := view node: 'outter1' forIt: 
		[ innerNode1 := view node: 1 forIt: [ innerNode2 := view node: 2] ].
	view applyLayout.
	
	self assert: innerNode2 bounds = ( (5@5) corner: (10@10) ).
	self assert: (innerNode2 positionRelativeTo: innerNode2) = (0 @ 0).
	self assert: (innerNode2 positionRelativeTo: innerNode1) = innerNode2 topLeft.
	self assert: (innerNode2 positionRelativeTo: outterNode1) = (innerNode2 topLeft + innerNode1 topLeft).! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 18:43'!
testRectangleWithText

	view shape rectangle withText: [ :v | v ].
	view node: Object.
	! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/17/2012 20:39'!
testShapeAndEdges

	| edges |
	view nodes: (1 to: 5).
	view shape line color: Color blue.
	edges := view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
		
	self assert: edges size = 5.
	edges do: [ :edge | 
		self assert: (edge getShape: ROLine) color = Color blue. 
	]
! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: ''!
testShapeAreProperlyInitialized
	| node1 node2 |
	
	view shape rectangle width: 20.
	node1 := view node: 123.
	self assert: node1 bounds width = 20.
	node2 := view node: 1234.
	
	self assert: node1 bounds width = 20.
	self assert: node2 bounds width = 5.! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 13:46'!
testSize

	| element |
	view shape rectangle size: 30.
	element := view node: 'hello'.
	
	self assert: element extent = (30 @ 30)! !

!ROMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 7/25/2012 10:09'!
testSugiyamaLayout 

	| nodes result |
	view node: 'foo' forIt: [
		view node: 'foo' forIt: [
			nodes := view nodes: (1 to: 5).
			view edgesFromAssociations: (Array with: 1 -> 2 with: 3 -> 5 with: 2-> 5).
			view sugiyamaLayout 
		]
	].
	view applyLayout.
	
	result := ((Array new: 5) at: 1 put: ((24.0@3.0) corner: (29.0@8.0)); at: 2 put: ((20.0@28.0) corner: (25.0@33.0)); at: 3 put: ((28.0@28.0) corner: (33.0@33.0)); at: 4 put: ((28.0@53.0) corner: (33.0@58.0)); at: 5 put: ((20.0@53.0) corner: (25.0@58.0)); yourself).
	self assert: (nodes collect: #bounds) = result.! !

!ROMondrianViewBuilderTest methodsFor: 'instantiating' stamp: 'AlexandreBergel 5/17/2012 20:53'!
testTitle
	| builder |
	builder := ROMondrianViewBuilder titled: 'hello world'.
	window := builder open.
	
	[
		self assert: window labelString = 'hello world'.
	] ensure: [ window delete ]! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/14/2012 19:43'!
testWidth

	| nodes |
	view shape rectangle width: [ :model | model + 1].
	nodes := view nodes: #(2 30 40).
	
	self assert: (nodes collect: [ :n | n width ]) =  #(5 31 41)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 10/23/2012 09:00'!
testWithBorderWidth
	"Related to http://code.google.com/p/objectprofile/issues/detail?id=198"
	| classesToDraw |
	
	classesToDraw := Collection withAllSubclasses.
	view shape rectangle 
		borderWidth: 1; 
		borderColor: Color blue.
	view nodes: classesToDraw.
	view gridLayout.
	self shouldnt: [ view raw drawOn: RONullCanvas new ]  raise: Error ! !

!ROMondrianViewBuilderTest methodsFor: 'using model' stamp: 'AlexandreBergel 10/15/2012 10:12'!
testWithText

	| nodes |
	view shape rectangle withText: [ :model | model + 1].
	nodes := view nodes: #(2 30 40).
	
	self assert: (nodes collect: [ :n | (n getShape: ROLabel) textFor: n]) =  #('3' '31' '41')! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: ''!
testlookup

	| nodes |
	nodes := view nodes: #(1 2 3 4).
	self assert: (view lookup: 1) == nodes first.
	self assert: (view lookup: 4) == nodes fourth.
	self assert: (view lookup: 6) == nil! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 6/9/2012 15:17'!
testrawEdgesFrom
	| nodes edges ass m assoc |

	nodes := view nodes: #(1 2 3 4).
	self assert: view raw numberOfElements = 4.
	assoc := 1 -> 2.

	edges := view rawEdges: (Array with: assoc) from: #key to: #value.
	self assert: edges size = 1.
	self assert: edges first from = nodes first.
	self assert: edges first to = nodes second.! !

ROTest subclass: #RONativeExampleUtilityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks-Tests'!

!RONativeExampleUtilityTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/16/2012 08:00'!
current
	^ RONativeExampleUtility current ! !

!RONativeExampleUtilityTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/16/2012 08:06'!
testGetMethods

	self assert: (self current getMethodsForClass: Object) isCollection! !

!RONativeExampleUtilityTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/16/2012 08:05'!
testSubstrings

	self assert: (self current substringsFor: 'ab cd ef') = #('ab' 'cd' 'ef')! !

ROTest subclass: #RONormalizerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers-Tests'!

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/14/2012 10:43'!
testBeginingAtBlue

	| n |
	n := RONIdentityNormalizer beginingAtBlue.
	self assert: n nextColor = Color blue! !

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/14/2012 10:40'!
testBeginingAtRed

	| n |
	n := RONIdentityNormalizer beginingAtRed.
	self assert: n nextColor = Color red! !

!RONormalizerTest methodsFor: 'explicit identity' stamp: 'AlexandreBergel 8/27/2012 00:12'!
testExplicitIdentity
	| normalizer colorOne colorTwo |
	
	normalizer := RONExplicitIdentityNormalizer 
						withCommand: #last 
						withColors: (Array with: Color blue with: Color white with: Color red) 
						withDefaultColor: Color orange.
						
	colorOne := normalizer roValue: 'alex'.
	colorTwo := normalizer roValue: 'suffix'.
	self assert: (colorOne = colorTwo)

! !

!RONormalizerTest methodsFor: 'explicit identity' stamp: 'AlexandreBergel 8/27/2012 00:12'!
testExplicitIdentity2
	| normalizer colorOne colorTwo |
	
	normalizer := RONExplicitIdentityNormalizer
					withCommand: #yourself
					withColors: (Array with: Color blue with: Color white with: Color red) 
					withDefaultColor: Color orange.						

	self assert: (normalizer roValue: 1) = Color blue.
	self assert: (normalizer roValue: 2) = Color white.
	self assert: (normalizer roValue: 3) = Color red.
	self assert: (normalizer roValue: -1) = Color orange.
	self assert: (normalizer roValue: 1000) = Color orange.! !

!RONormalizerTest methodsFor: 'explicit identity' stamp: 'AlexandreBergel 8/27/2012 00:13'!
testExplicitIdentity3Initialization
	| normalizer colorOne colorTwo colors |
	
	colors := Array with: Color blue with: Color white with: Color red.
	normalizer := RONExplicitIdentityNormalizer
					withCommand: #yourself
					withColors: colors
					withDefaultColor: Color orange.						
											
	self assert: (normalizer roValue: 1) = Color blue.
	self assert: (normalizer roValue: 2) = Color white.
	self assert: (normalizer roValue: 3) = Color red.
	self assert: (normalizer roValue: 4) = Color orange.! !

!RONormalizerTest methodsFor: 'linear' stamp: 'AlexandreBergel 7/4/2012 00:49'!
testGradient
	| normalizer |

	normalizer := RONColorLinearNormalizer inContext: #(0 1 2 3 4 5 6 7 8 9 10) lowColor: Color yellow highColor: Color red.
	self assert: (normalizer maximumValue: nil) = 10.
	self assert: (normalizer roValue: 10) =  (Color r: 1.0 g: 0.0 b: 0.0). 
	self assert: (normalizer roValue: 1) = (Color r: 1.0 g: 0.900012 b: 0.0).
	self assert: (normalizer roValue: 0) =  (Color r: 1.0 g: 1.0 b: 0.0)! !

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/2/2012 16:15'!
testIdentity
	| colorOne colorTwo normalizer |
	
	normalizer := RONIdentityNormalizer new.
	colorOne := normalizer roValue: 1.
	colorTwo := normalizer roValue: 2.
	self deny: colorOne = colorTwo.

	colorOne := normalizer roValue: 12.
	colorTwo := normalizer roValue: 12.
	self assert: colorOne = colorTwo.! !

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/2/2012 16:15'!
testIdentityModulo
	"This checks that there is no exception if there are more identities than colors"

	1 to: 150 do: [:index | RONIdentityNormalizer new roValue: index]! !

!RONormalizerTest methodsFor: 'identity' stamp: 'AlexandreBergel 7/2/2012 16:15'!
testIdentityWithCommand
	| colorOne colorTwo normalizer |
	
	normalizer := RONIdentityNormalizer withCommand: #last.
	colorOne := normalizer roValue: 'bob'.
	colorTwo := normalizer roValue: 'tom'.
	self deny: colorOne = colorTwo.

	colorOne := normalizer roValue: 'anna'.
	colorTwo := normalizer roValue: 'maria'.
	self assert: colorOne = colorTwo.! !

!RONormalizerTest methodsFor: 'multiple' stamp: 'AlexandreBergel 7/4/2012 00:54'!
testMultipleLinearNormalizer
	| normalizer |

	normalizer := ROMultipleColorLinearNormalizer 
					valueRange: #(5 10 15) colorRange: (Array with: Color blue with: Color white with: Color red) .
	
	self assert: (normalizer roValue: 5) =   (Color r: 0.0 g: 0.0 b: 1.0).
	self assert: (normalizer roValue: 6) =  ( (Color r: 0.2 g: 0.2 b: 1.0)). 
	self assert: (normalizer roValue: 15) =  (Color r: 1.0 g: 0.0 b: 0.0)! !

!RONormalizerTest methodsFor: 'linear' stamp: 'AlexandreBergel 7/2/2012 16:16'!
testNumberLinearNormalizer
	| normalizer |
	normalizer := RONumberLinearNormalizer inContext: (1 to: 10) withCommand: [:entity | entity * 1000 ].
	self assert: (normalizer roValue: 100) = 10.
	
	normalizer := RONumberLinearNormalizer inContext: (1 to: 100) withCommand: [:entity | entity * 1000 ].
	self assert: (normalizer roValue: 100) = 1.
	
	normalizer := RONumberLinearNormalizer inContext: (1 to: 100) withCommand: [:entity | entity ].
	self assert: (normalizer roValue: 100) = 1.
! !

ROTest subclass: #ROOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROOrderedCollection methodsFor: 'tests' stamp: ''!
testBasic

	self assert: ((#(5 4 1 5 2) asSorted: #squared) =  #(1 2 4 5 5) )! !

ROTest subclass: #ROParentElementResizeStrategyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROParentElementResizeStrategyTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/2/2012 14:27'!
testFixedSized

	| view el1 el2 |
	view := ROView new.
	el1 := ROElement new.
	el1 resizeStrategy: ROFixedSizedParent instance.
	el1 addAll: (ROGridLayout on: ((1 to: 5) collect: [ :i | ROElement new ])).
	
	el2 := ROElement new.
	el2 resizeStrategy: ROExtensibleParent instance.
	el2 addAll: (ROGridLayout on: ((1 to: 5) collect: [ :i | ROElement new ])).
	
	self assert: el1 bounds = ( (0@0) corner: (5@5)).
	self assert: el2 bounds = ( (0@0) corner: (45@30)).! !

ROTest subclass: #ROPlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-PlatformIndependent'!

!ROPlatformTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 18:01'!
testAddingAPlatform

	| platform s |
	platform := ROPlatform new.
	platform name: 'test'.
	platform canvasClass: ROAbstractCanvas subclasses anyOne.
	platform fontOrganizerClass: ROFontOrganizer subclasses anyOne.
	platform widgetFactory: RONativeWidgetFactory subclasses anyOne.
	platform timeOrganizerClass: ROTimeOrganizer subclasses anyOne.
	platform hostVisualElement: Object. "We pick any class"

	ROPlatform removeNamed: 'test' ifAbsent: [].
	s := ROPlatform numberOfPlatforms.
	ROPlatform add: platform.
	self assert: (s + 1) = ROPlatform numberOfPlatforms.

	platform remove.
	self assert: s = ROPlatform numberOfPlatforms.! !

!ROPlatformTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 15:19'!
testCurrent
	self assert: ROPlatform current notNil.
	self assert: (ROPlatform current isKindOf: ROPlatform).! !

ROTest subclass: #ROPopupMondrianTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROPopupMondrianTest methodsFor: 'running' stamp: 'AlexandreBergel 7/3/2012 13:28'!
setUp

	view := ROMondrianViewBuilder new.! !

!ROPopupMondrianTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/9/2012 07:57'!
testIfPopupText

	| nodes targetView |
	view interaction 
		if: #odd popupText: 'hello';
		if: #even popupText: 'world'.
	nodes := view nodes: #(1 2 3).
	
	targetView := view stack.
	
	self assert: (nodes allSatisfy: [ :node | node is: ROPopupView ]).
	
	self assert: targetView numberOfElements isZero.
	 
	nodes first announce: ROMouseEnter.
	self assert: targetView numberOfElements = 1.
	nodes first announce: ROMouseLeave.
	self assert: targetView numberOfElements isZero.

	nodes third announce: ROMouseEnter.
	self assert: targetView numberOfElements = 1.
	nodes third announce: ROMouseLeave.
	self assert: targetView numberOfElements isZero.
	
	
	nodes second announce: ROMouseEnter.
	self assert: targetView numberOfElements = 1.
	nodes second announce: ROMouseLeave.
	self assert: targetView numberOfElements isZero.! !

!ROPopupMondrianTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/14/2012 09:36'!
testInteractionAndPopup

	| nodes node |
	view interaction action: #browse.
	view shape rectangle size: 15.
	nodes := view nodes: (Array with: 10).
	
	node := nodes first.
	self assert: (node is: RODraggable).
	self assert: (node is: ROMenuActivable).
	self assert: (node is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'popupText per default' stamp: 'AlexandreBergel 7/14/2012 09:37'!
testInteractionAndPopup2

	| nodes node |
	view shape rectangle size: 15.
	nodes := view nodes: (Array with: 10).
	
	node := nodes first.
	self assert: (node is: RODraggable).
	self deny: (node is: ROMenuActivable).
	self assert: (node is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'popupText per default' stamp: 'AlexandreBergel 7/14/2012 09:38'!
testInteractionAndPopup3

	| nodes node |
	view interaction action: #browse; noPopup.
	view shape rectangle size: 15.
	nodes := view nodes: (Array with: 10).
	
	node := nodes first.
	self assert: (node is: RODraggable).
	self assert: (node is: ROMenuActivable).
	self deny: (node is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'popupText per default' stamp: 'AlexandreBergel 7/14/2012 09:46'!
testInteractionAndPopup4

	| nodes node node1 node2 |
	view interaction action: #browse; noPopup.
	view shape rectangle size: 15.
	node1 := view node: 10.
	node2 := view node: 20.
	
	self assert: (node1 is: RODraggable).
	self assert: (node1 is: ROMenuActivable).
	self deny: (node1 is: ROPopupView).

	self assert: (node2 is: RODraggable).
	self deny: (node2 is: ROMenuActivable).
	self assert: (node2 is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'popupText per default' stamp: 'AlexandreBergel 7/16/2012 20:03'!
testInteractionAndPopup5

	| node1 node2 |
	view interaction action: #browse; noPopup.
	view shape rectangle size: 15.
	node1 := view node: 10 forIt: [
		node2 := view node: 20 ].
	
	self assert: (node1 is: RODraggable).
	self assert: (node1 is: ROMenuActivable).
	self deny: (node1 is: ROPopupView).

	self assert: (node2 is: RODraggable).
	self deny: (node2 is: ROMenuActivable).
	self assert: (node2 is: ROPopupView)
	! !

!ROPopupMondrianTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/3/2012 13:28'!
testNoTwoPopupAtTheSameTime

	| nodes |
	nodes := view nodes: #(1 2).
	
	"We have done nothing so far, so there is only two nodes"
	self assert:  view raw numberOfElements = 2.
	self assert:  view stack numberOfElements = 0.

	
	"We enter one node, a popup appears in the stack"
	nodes first announce: ROMouseEnter.
	self assert:  view raw numberOfElements = 2.
	self assert:  view stack numberOfElements = 1.
	
	"We enter the second node, a popup appears, but the first popup should diseapear"
	nodes second announce: ROMouseEnter.
	self assert:  view raw numberOfElements = 2.
	self assert:  view stack numberOfElements = 1.
! !

ROTest subclass: #ROPopupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/2/2012 18:06'!
testMouseEnteringAndDragNode

	| view el popupElement |
	view := ROView new.
	el  := ROElement new.
	el @ ROPopup.
	view add: el.

	el announce: ROMouseEnter.
	self assert: view elements size = 2.
	popupElement := (view elements copyWithout: el) first.
	
	el announce: (ROMouseDragging step: 10 @ 10).
	self assert: view elements size = 1.! !

!ROPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/11/2012 12:50'!
testPositionInAStack
	| view stack element popup |
	element := (ROElement on: 'an element').
	element + (ROLabel new color: Color gray) @ ROPopup.
	view := ROView new.
	view
		add: element.
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	element translateBy: 40@60.
	element announce: (ROMouseEnter new position: 45 @ 65; realPosition: 45 @ 65).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = ((45 @ 65) + ROPopup defaultPopupOffset).! !

!ROPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/11/2012 12:50'!
testPositionInAStack2
	| view stack element popup |
	element := (ROElement on: 'an element').
	element + (ROLabel new color: Color gray) @ ROPopup.

	view := ROView new.
	view add: element.
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	view translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40@60).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).! !

ROTest subclass: #ROPopupViewTest
	instanceVariableNames: 'popup popupView view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROPopupViewTest methodsFor: 'running' stamp: 'AlexandreBergel 6/1/2012 18:19'!
setUp
	| el |
	view := ROView new.
	
	popupView := ROView new.
	el := (ROElement new extent: 50@60)+ (ROBox new color: Color blue).
	popupView add: el.
	
! !

!ROPopupViewTest methodsFor: 'position in a stack' stamp: 'AlexandreBergel 6/11/2012 12:51'!
testPositionInAStack
	| stack element |
	element := (ROElement on: 'an element').
	element + (ROLabel new color: Color gray) @ ROPopup.

	view := ROView new.
	view add: element.
	view @ RODraggable.
	
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	element translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40 @ 60).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = ((40 @ 60) + ROPopup defaultPopupOffset).! !

!ROPopupViewTest methodsFor: 'position in a stack' stamp: 'AlexandreBergel 6/11/2012 12:51'!
testPositionInAStack2
	| stack element |
	element := (ROElement on: 'an element').
	element + (ROLabel new color: Color gray) @ ROPopup.

	view := ROView new.
	view add: element.
	view @ RODraggable.
	
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	view translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40@60).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 6/2/2012 09:59'!
testPositionWithReceivingView

	| el receivingView |
	receivingView := ROView new.
	view := ROView new.
	el := ROElement sprite.
	el translateTo: 50@25.
	el @ (ROPopup new receivingView: receivingView).
	view add: el.
	
	el announce: ROMouseEnter.
	popup := receivingView elements first.
	self assert: popup position =  (10@10).! !

!ROPopupViewTest methodsFor: 'size' stamp: 'AlexandreBergel 7/7/2012 07:48'!
testSize

	| v2 raw el |
	v2 := ROView new.
	v2 add: ((ROElement new extent: 90@20) + ROBox green).

	raw := ROView new.
	el := ROElement new extent: 150@ 60.
	el + (ROBox new).
	el @ RODraggable.
	el @ (ROPopupView view: v2). 
	raw add: el.
	
	self assert: v2 encompassingRectangle = ( (0@0) corner: (90@20))! !

!ROPopupViewTest methodsFor: 'subview' stamp: 'AlexandreBergel 8/19/2012 09:53'!
testSubview

	| canvas oldCamera viewDisplayerShape element |
	view := ROMondrianViewBuilder new.
	
	canvas := RONullCanvas new.
	oldCamera := canvas camera.

	viewDisplayerShape := ROViewDisplayer new view: view raw; yourself.
	element := ROElement new.
	element + viewDisplayerShape.
	
	element drawOn: canvas.
	
	self assert: canvas camera == view raw camera.
	
	
	
! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 6/1/2012 18:26'!
testWithReceivingView

	| el receivingView |
	receivingView := ROView new.
	view := ROView new.
	el := ROElement sprite.
	el @ (ROPopup new receivingView: receivingView).
	view add: el.
	
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.
	
	el announce: ROMouseEnter.
	self assert: view elements size = 1.
	self assert: receivingView elements size = 1.
	
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.
	
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 6/1/2012 18:21'!
testWithoutReceivingView

	| el |
	view := ROView new.
	el := ROElement sprite.
	el @ ROPopup.
	view add: el.
	
	self assert: view elements size = 1.
	el announce: ROMouseEnter.
	self assert: view elements size = 2.
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	el announce: ROMouseLeave.
	self assert: view elements size = 1.! !

ROTest subclass: #RORemoveNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!RORemoveNodeTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/18/2012 15:55'!
testBasic

	| view el1 el2 el3 el4 el | 
	view := ROView new.
	view add: (el1 := ROElement on: 1).
	view add: (el2 := ROElement on: 2).
	view add: (el3 := ROElement on: 3).
	view add: (el4 := ROElement on: 4).
	
	view addAll: (ROEdge linesFor: (Array with: el1 -> el2 with: el1 -> el1 with: el3 -> el1)).
	self assert: view numberOfElements = 7.
	RORemoveNode suchThat: [ :e | e == el1 ] in: view.
	self assert: view numberOfElements = 3.! !

ROTest subclass: #ROScrollbableTest
	instanceVariableNames: 'view stack horizontalScrollbar verticalScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROScrollbableTest methodsFor: 'running' stamp: 'AlexandreBergel 6/9/2012 18:42'!
setUp

	view := ROView new.
	view add: ROElement sprite.

	view addAll: (ROHorizontalLineLayout on: (ROElement spritesOn: (1 to: 50))).
	"view @ RODraggable ."

	stack := ROViewStack new.
	stack addView: view.
	stack @ ROScrollbable.
	"stack open."

	"Get the scrollbars"	
	horizontalScrollbar := stack elements first.
	verticalScrollbar := stack elements second.
! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 23:22'!
testMovingScrollbar

	ROGridLayout on: view elements .

	verticalScrollbar announce: (ROMouseDragging step: 0 @ 250).
	self assert: verticalScrollbar position = (0 @ 250).
	
	self assert: view encompassingRectangle height =  350.
	self assert: view camera position =  (0 @ 175) " ((2995-  view camera width) @0).".
	
	
	horizontalScrollbar announce: (ROMouseDragging step: 250 @ 0).
	self assert: horizontalScrollbar position = (250 @ 0).
	
	self assert: view encompassingRectangle width =   530.
	self assert: view camera position =  (265 @ 175) " ((2995-  view camera width) @0)."! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 18:02'!
testScrollbar

	self assert: horizontalScrollbar position = (0 @ 0).
	self assert: view camera position = (0 @ 0)! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 23:22'!
testScrollbarBottomMost

	verticalScrollbar announce: (ROMouseDragging step: 0 @ 10000).
	self assert: verticalScrollbar position = (0 @ 420).
	
	self assert: view encompassingRectangle height =  55.
	self assert: view camera position =   (0@46) " ((2995-  view camera width) @0)."! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 18:02'!
testScrollbarRightMost

	horizontalScrollbar announce: (ROMouseDragging step: 10000 @ 0).
	self assert: horizontalScrollbar position = (420 @ 0).
	
	self assert: view encompassingRectangle width = 2995.
	self assert: view camera position =  (2515@0) " ((2995-  view camera width) @0)."! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 17:59'!
testStack
	"Only one element in the stack so far. Soon we will have two!!"
	self assert: stack numberOfElements = 2.
! !

ROTest subclass: #ROSequenceOfInteractionTest
	instanceVariableNames: 'emptySequence sequence incr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROSequenceOfInteractionTest methodsFor: 'running' stamp: 'AlexandreBergel 5/4/2012 11:29'!
setUp
	emptySequence := ROSequenceOfInteraction new.
	sequence := ROSequenceOfInteraction new.
	incr := 0.
	sequence after: 2 do: [ incr := 0 ].
	sequence after: 5 do: [ incr := incr + 1 ].
	sequence after: 5 do: [ incr := incr + 2 ]! !

!ROSequenceOfInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/19/2012 10:07'!
testExecute
	self assert: incr = 0.
	sequence execute.
	sequence waitUntilDone.
	self assert: incr = 3.
	self assert: sequence isComplete! !

!ROSequenceOfInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/19/2012 10:07'!
testExecuteEmpty
	emptySequence execute.
	self assert: emptySequence isComplete! !

!ROSequenceOfInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/19/2012 10:07'!
testIsOver
	self deny: sequence isComplete.
	self assert: emptySequence isComplete.! !

ROTest subclass: #ROShapeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROShapeTest methodsFor: 'extent on chain' stamp: 'AlexandreBergel 10/17/2012 09:42'!
testAddingShape
	| el shape b |
	el := ROElement on: 30.
	shape := ROBox new.
	shape height: (b := [ :e | e model + 1 ]).
	self assert: (shape extentFor: el) = (5 @ 31).
	
	el + shape.
	self assert: (shape extentFor: el) = (5 @ 31).
	
	self assert: shape height == b! !

!ROShapeTest methodsFor: 'extent on chain' stamp: 'AlexandreBergel 9/27/2012 19:00'!
testAdjustingShapeChain

	| shape1 shape2 el |
	shape1 := ROBox blue.
	shape2 := ROBox green.
	el := ROElement new.
	el + shape1 + shape2.
	
	el extent: 50 @ 50.
	
	self assert: el extent = (50 @ 50).
	self assert: shape1 extent = (50 @ 50).	
	self assert: shape2 extent = (50 @ 50).! !

!ROShapeTest methodsFor: 'extent on chain' stamp: 'AlexandreBergel 9/27/2012 19:12'!
testAdjustingShapeChain4

	| shape1 shape2 el |
	shape1 := ROBox blue.
	shape2 := ROBox green.
	el := ROElement new.
	el + shape1 + shape2.
	
	el extent: 50 @ 50.
	shape1 extent: 70 @ 70.
	
	self assert: el extent = (70 @ 70).
	self assert: shape1 extent = (70 @ 70).	
	self assert: shape2 extent = (50 @ 50).! !

!ROShapeTest methodsFor: 'children shape' stamp: 'AlexandreBergel 9/25/2012 18:49'!
testChildrenShape

	| outter inner |
	outter := ROElement on: 'outter'.
	outter + ROBox new.
	outter extent: 50 @ 50.
	
	inner := ROElement on: 'inner'.
	inner + ROBox new.
	inner extent: 20 @ 20.

	outter add: inner.
	inner translateBy: 5 @ 5.
	
	self assert: ((outter getShape: ROBox) boundsFor: outter) = ((0@0) corner: (50@50)). 
	self assert: ((outter getShape: ROBox) boundsFor: inner) = ((0 @ 0) corner: (20@20)).
	
	self assert: ((outter getShape: ROAbstractChildrenShape) boundsFor: outter) = ((0@0) corner: (50@50)). 
	self assert: ((outter getShape: ROAbstractChildrenShape) boundsFor: inner) = ((0 @ 0) corner: (20@20)).! !

!ROShapeTest methodsFor: 'remove shape' stamp: 'AlexandreBergel 10/17/2012 08:48'!
testRemoveShape
	| b c removedElement |
	b := ROBox new.
	c := ROCircle new.
	b addLast: c.

	self assert: b next == c.
	removedElement := b removeShape: ROCircle.
	
	self assert: removedElement == c.
	self assert: (b next isKindOf: RONullShape) ! !

!ROShapeTest methodsFor: 'remove shape' stamp: 'AlexandreBergel 10/17/2012 08:48'!
testRemoveShape2
	| b c b2 |
	b := ROBox new.
	c := ROCircle new.
	b addLast: c.
	b2 := b removeShape: ROBox.
	
	self assert: b2 == c.
	self assert: (b2 next isKindOf: RONullShape)! !

ROTest subclass: #ROTranslationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROTranslationTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/15/2012 22:39'!
testDraggingOnTheTopLeftCorner
	| view outterNode innerNode1 innerNode2 |
	view := ROView new.
	view @ RODraggable.
	
	outterNode := ROElement new.
	outterNode + (ROBox new extent: 50 @ 50).
	
	innerNode1 := ROElement new.
	innerNode1 + (ROBox blue extent: 10 @ 10).
	
	innerNode2 := ROElement new.
	innerNode2 + (ROBox green extent: 10 @ 10).

	outterNode add: innerNode1.
	outterNode add: innerNode2.
	
	view add: outterNode.
	" view open "	

	"Witout dragging"
	self assert: innerNode1 position = (0 @ 0).
	self assert: innerNode2 position = (0 @ 0).

	"Dragging innerNode"
	innerNode1 translateBy: -10 @ -10.
	self assert: innerNode1 position = (0 @ 0).
	self assert: innerNode2 position = (10 @ 10).! !

ROTest subclass: #ROViewStructureTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROViewStructureTest methodsFor: 'running' stamp: 'AlexandreBergel 7/24/2012 17:35'!
setUp

	view := ROMondrianViewBuilder new.! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 09:37'!
testBasic

	view nodes: (1 to: 4).
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 4.
	
	view nodes: (5 to: 10).
	self assert: view numberOfFrames = 1.
	self assert: view currentFrame numberOfElements = 10.! !

!ROViewStructureTest methodsFor: 'looking up' stamp: 'AlexandreBergel 7/25/2012 10:29'!
testFrameOfElement

	| outterNodes outterFrame firstInnerFrame secondInnerFrame |
	outterNodes := view nodes: #(10 11) forEach: [ :e | view nodes: (1 to: 5) ].
	
	outterFrame := view structureTree.
	outterNodes do: [ :n | 
		self assert: (outterFrame frameOfElement: n) == outterFrame ].
	
	firstInnerFrame := outterFrame children first.
	firstInnerFrame nodes do: [ :n | 
		self assert: (outterFrame frameOfElement: n) == firstInnerFrame ].

	secondInnerFrame := outterFrame children second.
	secondInnerFrame nodes do: [ :n | 
		self assert: (outterFrame frameOfElement: n) == secondInnerFrame ].
! !

!ROViewStructureTest methodsFor: 'looking up' stamp: 'AlexandreBergel 7/25/2012 16:44'!
testFrameOfElementNotFound

	self assert: (view structureTree frameOfElement: ROElement new) == view structureTree
! !

!ROViewStructureTest methodsFor: 'initialization' stamp: 'AlexandreBergel 7/24/2012 17:54'!
testInitialization

	self assert: view numberOfFrames = 1.
	! !

!ROViewStructureTest methodsFor: 'initialization' stamp: 'AlexandreBergel 7/24/2012 17:44'!
testInitializationFrame

	self assert:  ROMondrianFrame new parent isNil! !

!ROViewStructureTest methodsFor: 'layout' stamp: 'AlexandreBergel 7/25/2012 10:06'!
testLayout

	| node innerNodes outerFrame innerFrame |
	view nodes: #(10 11) forEach: [ :each | view nodes: (1 to: 5) ].
	view treeLayout.
	
	outerFrame := view structureTree.
	self assert: outerFrame layout class == ROTreeLayout.
	
	innerFrame := outerFrame children anyOne.
	self assert: innerFrame layout class == ROHorizontalLineLayout ! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 09:46'!
testNesting

	view node: 10 forIt: [ view nodes: (1 to: 5) ].

	self assert: view numberOfFrames = 2.
	self assert: view structureTree numberOfElements = 1.
	
	self assert: (view structureTree numberOfChildren = 1).
	self assert: (view structureTree children first numberOfElements = 5).
! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 09:48'!
testNesting2

	| node innerNodes |
	node := view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5) ].

	self assert: view structureTree elements first == node.
	self assert: (view structureTree children first elements = innerNodes).
! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 10:07'!
testNesting3

	view nodes: #(1 2) forEach: [ :e | view nodes: (1to: 3)].
	
	self assert: view structureTree numberOfElements = 2.
	self assert: view structureTree numberOfFrames = 3.! !

!ROViewStructureTest methodsFor: 'nesting' stamp: 'AlexandreBergel 7/25/2012 10:45'!
testNestingWithEdges

	| innerNodes edge innerFrame |
	view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5). edge := view edgeFromAssociation: 1->3  ].

	innerFrame := view structureTree children first.
	self assert: (innerFrame numberOfElements = 6).
	self assert: (innerFrame edges size = 1).
	self assert: (innerFrame edges anyOne == edge).
	
	self assert: (innerFrame nodes = innerNodes).
	self assert: (innerFrame edges first == edge).! !

!ROViewStructureTest methodsFor: 'layout' stamp: 'AlexandreBergel 7/25/2012 09:51'!
testNoLayout

	| innerNodes |
	view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5). view horizontalLineLayout ].
	
	"We haven't done a layout still"
	self assert: (view structureTree children first layout class == ROHorizontalLineLayout).
	self assert: (innerNodes allSatisfy: [ :n | n position = (0 @ 0)]) ! !

!ROViewStructureTest methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 09:36'!
testPoping

	view push.
	view pop.
	self assert: view currentFrame == view structureTree.
	! !

!ROViewStructureTest methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 09:36'!
testPushing

	self assert: view currentFrame == view structureTree. 
	
	view push.
	self assert: view currentFrame ~~ view structureTree.
	self assert: view currentFrame parent == view structureTree.! !

!ROViewStructureTest methodsFor: 'layout' stamp: 'AlexandreBergel 7/25/2012 09:53'!
testRecursiveLayout

	| innerNodes positions |
	view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5). view horizontalLineLayout ].
	
	view applyLayout.
	 
	positions := OrderedCollection new.
	positions add: (5@5); add: (20@5); add: (35@5); add: (50@5); add: (65@5).
	self assert: (innerNodes collect: #position) = positions asArray.! !

ROTest subclass: #ROViewTest
	instanceVariableNames: 'node1 view emptyView node2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROViewTest subclass: #ROViewStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROViewStackTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/30/2012 16:43'!
testNestingView

	| newView el mouseClickPosition |
	newView := ROView new.
	newView add: (el := ROElement sprite translateTo: 0@60).

	view := ROViewStack new.
	view addFirst: newView.
	
	self assert: (view elementAtRealPosition: 23@85) == el.
	self assert: (newView elementAtRealPosition: 23@85) == el.

	(ROZoomOutMove new on: newView) waitUntilDone.

	self assert: (view elementAtRealPosition: (53@103)) == el.
	self assert: (newView elementAtRealPosition: (53@103)) == el.
	
	(ROZoomOutMove new on: newView) waitUntilDone.
	(ROZoomOutMove new on: newView) waitUntilDone.	

	self assert: (view elementAtRealPosition: (109@131)) == el.

"	view openInWindow"! !

!ROViewStackTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/30/2012 23:18'!
testOpening

	|  window |
	view := ROViewStack new.
	view add: (ROElement on: 'hello').
	window := view open.
	window delete! !

!ROViewStackTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 17:17'!
testZoomInAndDragAndDrop

	| newView el originalCameraBounds step |
	newView := ROView new.
	el := ROElement new extent: (5 @ 5).
	el + (ROBox new color: Color red).
	el @ RODraggable.
	newView add: el.
	el translateTo: 150 @ 100.

	view := ROViewStack new.
	view addFirst: newView.


	self assert: (el bounds = ( (150@100) corner: (155@105))).
	self assert: newView camera bounds = ( (0@0) corner: (500@500)).
	self assert: (newView camera virtualToRealPointNoTrunc: el position ) = (150 @ 100).
	
	
	"We simulate the zoom in"
	originalCameraBounds := newView camera bounds.
	step := 100 @ 100.
	newView camera bounds: ((originalCameraBounds topLeft + step) corner: (originalCameraBounds bottomRight - step)).
	newView signalUpdate.
	self assert: (el bounds = ( (150@100) corner: (155@105))).
	
	self assert: (((newView camera virtualToRealPointNoTrunc: el position ) -  (83.33333333333333@0.0)) < (0.1 @ 0.1)).
	self assert: newView camera bounds = ( (100@100) corner: (400@400)).
	
	
	el announce: (ROMouseDragging step: 20 @ 20 ).
	self assert: (el bounds = ( (162.0@112.0) corner: (167.0@117.0))).
	self assert: ((newView camera virtualToRealPointNoTrunc: el position ) - (103.33333333333333@20.0)) < (0.1 @ 0.1)! !

!ROViewTest methodsFor: 'running' stamp: 'AlexandreBergel 9/25/2012 15:01'!
setUp

	node1 := ROElement on: 'hello'.
	node1 extent: 40 @ 30.
	node1
		addShape: (ROBox new color: Color yellow);
		addShape: ROBorder new.
	node1 addInteraction: RODraggable.

	node2 := ROElement on: 'world'.
	node2 extent: 40 @ 30.
	node2
		addShape: (ROBox new color: Color green).
	node2 translateBy: 100@30.
	
	view := self viewClass new.
	view add: node1.
	view add: node2.
	
	emptyView := ROView new.! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testAddingNode

	self assert: emptyView numberOfNodes isZero.
	emptyView add: ROElement new.
	self assert: emptyView numberOfNodes = 1.
	
	emptyView add: ROElement new.
	self assert: emptyView numberOfNodes = 2! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/4/2012 15:21'!
testAddingNodes

	| element |
	element := ROElement new.
	self assert: emptyView elements isEmpty.
	3 timesRepeat: [ emptyView add: element ].
	self assert: emptyView elements size = 1.
! !

!ROViewTest methodsFor: 'events' stamp: 'AlexandreBergel 6/9/2012 15:15'!
testAnnouncerInView

	self assert: (view instVarNamed: 'eventHandler') class == ROAnnouncer! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testCamera
	self assert: (view camera class == ROCamera)! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testCameraHeight
	| camera |
	camera := view camera.
	self assert: camera position = (0@0).
	self assert: camera height asInteger = 229.
	
	"Due to the rounding"
	camera height: 230.
	self assert: camera height asInteger = 229.
	
	
	! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/30/2012 15:25'!
testDefaultWindowSize

	self assert: (self viewClass new defaultWindowSize class == Point)! !

!ROViewTest methodsFor: 'dragging' stamp: ''!
testDraggingElement
	| el t |
	el := ROElement sprite.
	node1 add: el.

	t := false.
	view on: RORefreshNeeded do: [ :event | t := true. ].
	self deny: t.
	
	el announce: (ROMouseDragging step: 5 @ 3).
	self assert: t! !

!ROViewTest methodsFor: 'dragging' stamp: 'AlexandreBergel 9/4/2012 15:30'!
testDraggingElement2
	| el t |
	el := ROElement sprite.
	node1 add: el.

	t := false.
	"view := self viewClass new.
	view add: node1; add: node2."
	view on: RORefreshNeeded do: [ :event | t := true ].
	self deny: t.
	
	"Check signalUpdate, since this is what is used to update the view"
	self assert: el view == node1 view.
	el signalUpdate.
	self assert: t.
	t := false.
	
	el announce: (ROMouseDragging step: 5 @ 3).
	self assert: t! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testDraggingView
	| camera |
	camera := view camera.
	
	self assert: camera bounds = ( 0@0 corner: 500@500).
	
	camera translateByRealStep: 15 @ 10.
	self assert: camera bounds = ( 15@10 corner: 515@510).

	"camera translateByRealStep: -15 @ -10.
	self assert: camera bounds = ( 0@0 corner: 500@500)."! !

!ROViewTest methodsFor: 'dragging' stamp: 'AlexandreBergel 6/2/2012 10:02'!
testDraggingViewAndPopupOnElement
	"
	self debug: #testDraggingViewAndPopupOnElement
	"
	
	| el popup |
	view := ROView new.
	el := ROElement spriteOn: 12.
	el @ ROPopup.
	view add: el.
	view 
			@ RODraggable;
			@ RODraggableWithVelocity.

	el announce: (ROMouseEnter new position: 0@0).
	self assert: view elements size = 2.
	popup := view elements second.
	self assert: popup position =  (10@10).
	el announce: ROMouseLeave.
	
	"We do a drag and drop of the view, and we mouse enter again"
	view translateBy: 50@60.
	el announce: (ROMouseEnter new realPosition: 50@60).
	popup := view elements second.
	self assert: popup position =  (10@10).
	el announce: ROMouseLeave.
	
	
	"
	view open
	"! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testElementAt

	self assert: (view elementAt: node1 bounds center) == node1.
	self assert: (view elementAt: node2 bounds center) == node2.
	self assert: (view elementAt: node2 bounds bottomRight + (1 @ 1)) == view ! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testElementAt2

	node1 translateBy: (-20 @ -20).
	self assert: (view elementAt: (node1 bottomRight - (5@5))) == node1.
	

"
self halt.
view openInWindow 
"! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testElementAt3

	| node aPoint |
	node := ROElement sprite 
				extent: (100@100);
				add: (ROElement sprite).
	view add: node.
	self assert: (view elementAt: (node bottomRight - (5@5))) == node.
	
	node translateBy: -20 @ -20.
	aPoint := node bottomRight - (5@5).
	self assert: (node contains: aPoint).
	self assert: (view elementAt: aPoint) == node.

"
self halt.
view openInWindow 
"! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/3/2012 15:13'!
testEncompassingRectangle

	self assert: view encompassingRectangle = ((0@0) corner: (140@60)).
	
	node1 translateBy: 6@9.
	self assert: view encompassingRectangle = ((6@9) corner: (140@60)).! !

!ROViewTest methodsFor: 'events' stamp: ''!
testEvents

	| t |
	t := 0.
	view announce: RORefreshNeeded.
	self assert: t isZero.
	
	view on: RORefreshNeeded do: [ :event | t := t + 1 ].
	view announce: RORefreshNeeded.
	self assert: t = 1.
! !

!ROViewTest methodsFor: 'opening' stamp: ''!
testOpenInWindow
	| window |
	window := view openInWindow.
	window delete! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 5/10/2012 16:41'!
testOpenInWindowSized
	| window |
	[ window := view openInWindowSized: 400@30.
	 self assert: window extent >= (400@30).]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'overlapping' stamp: 'AlexandreBergel 9/28/2012 08:30'!
testOverlapping
	| greenNode |

	"greenNode is overlapping node1"
	greenNode := ROElement spriteOn: 'green node'.
	greenNode setBounds: (node1 bounds translateBy: 5@6 ).

	view add: greenNode.
	 
	"-----"
	self assert: (view elementAt: node1 bounds topLeft) == node1. 
	self assert: (view elementAt: greenNode bounds topLeft) == greenNode

	! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/22/2012 13:55'!
testSortingElements

	| nodes nodes2 |
	
	nodes := ROElement forCollection: #(1 2 3).
	emptyView addAll: nodes.
	
	nodes2 := emptyView elementsSuchThat: [ :v | true ].
	self assert: (nodes2 collect: #model) asArray = #(1 2 3).
	
	emptyView sortElementsWith: [ :a :b | a model > b model ].
	nodes2 := emptyView elementsSuchThat: [ :v | true ].
	self assert: (nodes2 collect: #model) asArray = #(3 2 1).
! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testTranslatingCamera
	| camera |
	camera := view camera.
	
	self assert: camera bounds = ( 0@0 corner: 500@500).
	
	camera translateBy: 15 @ 10.
	self assert: camera bounds = ( 15@10 corner: 515@510).

	camera translateBy: -15 @ -10.
	self assert: camera bounds = ( 0@0 corner: 500@500).! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testVisibleBounds
	| window |
	self assert: view camera bounds = ( 0@0 corner: 500@500).
	window := view open.
	window delete.
	self assert: view camera bounds = ( 0@0 corner: 500@500).

	! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 4/30/2012 15:26'!
testWindowTitle

	| window |
	window := (view := self viewClass titled: 'Hello World') open.
	[ self assert: window labelString = 'Hello World'.
	  self assert: view title = 'Hello World' ]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 5/22/2012 21:01'!
testWindowTitleDefault

	| window |
	window := self viewClass new open.
	[ self assert: window labelString = ROView defaultWindowTitle ]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'running' stamp: 'AlexandreBergel 4/30/2012 15:25'!
viewClass
	^ ROView! !

ROTest subclass: #ROVisitorTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor-Tests'!

ROVisitorTest subclass: #ROCountingVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor-Tests'!

!ROCountingVisitorTest methodsFor: 'tests' stamp: ''!
test

	| visitor |
	visitor := ROCountingVisitor new.
	self assert: visitor nbOfEdges isZero.
	self assert: visitor nbOfNodes isZero.
	
	visitor runOn: view.
	
	self assert: visitor nbOfEdges = 3.
	self assert: visitor nbOfNodes = 5.
! !

ROVisitorTest subclass: #ROHighlighterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor-Tests'!

!ROHighlighterTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2012 17:15'!
test

	| b |
	b := [ :n | n model = 5].
	self assert: ((view elementsSuchThat: b) first shapes first borderColor)
					= Color black.
					
	ROHighlighter for: b in: view.
	
	self assert: ((view elementsSuchThat: b)first shapes first borderColor)
					= Color red.

	self assert: ((view elementsSuchThat: [ :n | (b value: n) not ]) first shapes first borderColor)
					=  Color black.
! !

!ROVisitorTest classSide methodsFor: 'as yet unclassified' stamp: ''!
isAbstract
	^ self name == #ROVisitorTest! !

!ROVisitorTest methodsFor: 'running' stamp: 'AlexandreBergel 4/17/2012 17:02'!
setUp

	| elements |
	view := ROView new.
	elements := ROElement forCollection: (1 to: 5).
	elements do: [ :el | el + ROBox ].
	view addAll: elements.
	view addAll: (ROEdge linesFor: 
		(Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third ))! !

ROTest subclass: #ROZoomOnClickTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROZoomOnClickTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/16/2012 08:11'!
testZoomOnClick

	| view |
	view := ROView new.
	view add: (ROElement sprite @ ROZoomOnClick ).
	
	view elements first announce: ROMouseClick! !

TestCase subclass: #ROTreeMapLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/4/2012 15:23'!
testBasicNodePositioning
	| layout view nodes edges root |
	
	"Setting up..."
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 400; height: 400.
	view nodes: (0 to: 76).
	edges := view edgesFrom: [ :each | each // 10 ].
	view layout: layout.	
	nodes := view nodes.
	root := nodes first.
	view applyLayout.
	nodes := layout recursiveChildrenSortedFor: root.
	
	"Check dimensions and position of root node."
      self assert: root extent = (400 @ 400).
	self assert: root bounds = ((5@5) corner: (405@405)).
	
	"These are relative bounds (to containment nodes bounds)."
	self assert: (nodes at: 1) bounds = ((5@5) corner: (44@91)).
	self assert: (nodes at: 2) bounds = ((43@5) corner: (122@91)).
	self assert: (nodes at: 3) bounds = ((121@5) corner: (238@91)).
	self assert: (nodes at: 8) bounds = ((126@177) corner: (252@395)).
	self assert: (nodes at: 33) bounds = ((5@46) corner: (29@81)).
	self assert: (nodes at: 49) bounds = ((102@53) corner: (153@81)).
	self assert: (nodes at: 67) bounds = ((47@79) corner: (117@106)).
	self assert: (nodes at: 76) bounds = ((223@5) corner: (264@83)).! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/12/2012 10:53'!
testDeepNesting
	| layout view nodes interval o |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	layout inset: 5.
	layout minInset: 3.
	interval := 1 to: 30.
	view := ROMondrianViewBuilder new.
	view shape size: 240.
	view nodes: interval.
	o := OrderedCollection new.
	interval do: [ :each | o add: each -> (each+1)].
	view edgesFromAssociations: o.
	view layout: layout.	
	nodes := view nodes.
	view applyLayout.
	
	self assert: (nodes at: 1) extent = (240@240).
	self assert: (nodes at: 1) position = (5@5).
	self assert: (nodes at: 2) extent = (230@230).
	self assert: (nodes at: 2) position = (5@5).
	self assert: (nodes at: 4) extent = (210@210).
	self assert: (nodes at: 4) position = (5@5).
	self assert: (nodes at: 7) extent = (182@182).
	self assert: (nodes at: 7) position = (4@4).
	self assert: (nodes at: 11) extent = (150@150).
	self assert: (nodes at: 11) position = (4@4).
	self assert: (nodes at: 16) extent = (120@120).
	self assert: (nodes at: 16) position = (3@3).
	self assert: (nodes at: 22) extent = (84@84).
	self assert: (nodes at: 22) position = (3@3).
	self assert: (nodes at: 29) extent = (42@42).
	self assert: (nodes at: 29) position = (3@3).
	self assert: (nodes at: 30) extent = (36@36).
	self assert: (nodes at: 30) position = (3@3).! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/19/2012 12:16'!
testLayoutEmbedding
	| layout view outerModel outerNodes innerNodes node1 node2 node3 |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	outerModel := (OrderedCollection with: 1).
	outerNodes := view nodes: outerModel forEach: [ :node |
		
		"Testing setting the size of the node that has the treemap layout."
		view shape rectangle size: 150.
		
		innerNodes := view nodes: (2 to: 3).
		view edgesFromAssociations: (Array with: 2 -> 3).
		view layout: layout.
	].

	view applyLayout.

	node1 := outerNodes at: 1.
	node2 := node1 elements at: 1.
	node3 := node2 elements at: 1.

	"Make sure outer node has grown corecctly."
	self assert: node1 extent = (160@160).
	
	"Make sure the inner nodes have according sizes."
	self assert: node2 extent = (150@150).
	self assert: node3 extent = (140@140).
	! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/19/2012 12:16'!
testLayoutEmbedding2
	| layout view outerModel outerNodes innerNodes node1 node2 node3 |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	outerModel := (OrderedCollection with: 1).
	
	"Testing setting the size of the node that is outside of the treemap layout."
	view shape rectangle size: 160.
	
	outerNodes := view nodes: outerModel forEach: [ :node |
		innerNodes := view nodes: (2 to: 3).
		view edgesFromAssociations: (Array with: 2 -> 3).
		view layout: layout.
	].

	view applyLayout.

	node1 := outerNodes at: 1.
	node2 := node1 elements at: 1.
	node3 := node2 elements at: 1.

	self assert: node1 extent = (160@160).
	self assert: node2 extent = (150@150).
	self assert: node3 extent = (140@140).
	! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/11/2012 10:56'!
testMinAreaOptimizations
	| layout view nodes node1 |

	layout := ROTreeMapLayout withWeightBlock: [ :e | e model ].
	layout minAreaPerNode: 25.
	
	view := ROMondrianViewBuilder new.
	view shape rectangle size: 15.
	view nodes: (1 to: 3).
	view edgesFromAssociations: (Array with: 1 -> 2 with: 1 -> 3).
	view layout: layout.

	view applyLayout.
	
	nodes := view nodes.
	node1 := (nodes at: 1).
	
	self assert: node1 elements isEmpty.
	self assert: node1 extent = (15@15).
	self assert: node1 bounds = ((5@5) corner: (20@20)).

! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/11/2012 15:58'!
testMinAreaOptimizations2
	| layout view minAreaPerNode minAreaBreakPoint sizeBreakpoint inset numberOfNodes nodes node1 o |

	minAreaPerNode := 25.
	inset := 3.
	numberOfNodes := 6.
	
	layout := ROTreeMapLayout withWeightBlock: [ :e | e model ].
	layout inset: inset.
	layout minAreaPerNode: minAreaPerNode.
	
	minAreaBreakPoint := layout minAreaNeededFor: (2 to: (numberOfNodes - 1)).
	sizeBreakpoint := minAreaBreakPoint sqrt.

	view := ROMondrianViewBuilder new.
	view shape rectangle size: sizeBreakpoint.
	
	view nodes: (1 to: numberOfNodes).
	
	o := OrderedCollection new.
	o add: 1->2; add: 1->3; add: 1->4; add: 1->5; add: 1->6.
	view edgesFromAssociations: o.
	
	view layout: layout.

	view applyLayout.
	
	nodes := view nodes.
	node1 := (nodes at: 1).
	
	self assert: node1 elements isEmpty.
	self assert: node1 extent = (sizeBreakpoint@sizeBreakpoint).
	self assert: node1 bounds = ((inset@inset) corner: ((sizeBreakpoint + inset)@(sizeBreakpoint + inset))).
! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/5/2012 09:53'!
testNestedNodePositioning
	| layout view nodes edges root |

	view := ROMondrianViewBuilder new.
	view shape rectangle size: 100.
	view nodes: (1 to: 4) forEach: [ :each |
		| innerNodes innerEdges |
		innerNodes := view nodes: (each*10 to: each*40 by: each*5) asOrderedCollection.
		innerEdges := view edgesFromAssociations: 
			((Array new: 6)
				at: 1 put: (each*10) -> (each*10+each*5*1);
				at: 2 put: (each*10) -> (each*10+each*5*2);
				at: 3 put: (each*10) -> (each*10+each*5*3);
				at: 4 put: (each*10) -> (each*10+each*5*4);
				at: 5 put: (each*10) -> (each*10+each*5*5);
				at: 6 put: (each*10) -> (each*10+each*5*6);
			 	yourself).
		view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	].	
	nodes := view nodes.

	view applyLayout.
	
	"Make sure outer nodes have the size we specified."
	self assert: (nodes at: 1) extent = (100 @ 100).
	self assert: (nodes at: 2) extent = (100 @ 100).
	self assert: (nodes at: 3) extent = (100 @ 100).
	self assert: (nodes at: 4) extent = (100 @ 100).

	"Make sure the standard layout, because we have none set for the outer nodes, positions them corectly."
	self assert: (nodes at: 1) bounds = ((5@5) corner: (105@105)).
	self assert: (nodes at: 2) bounds = ((115@5) corner: (215@105)).
	self assert: (nodes at: 3) bounds = ((225@5) corner: (325@105)).
	self assert: (nodes at: 4) bounds = ((335@5) corner: (435@105)).
	
	"Test first (inner) nodes..."
	self assert: ((nodes at: 1) elements at: 1) bounds = ((5@5) corner: (25@28)).
	self assert: ((nodes at: 1) elements at: 3) bounds = ((53@5) corner: (95@28)).
	self assert: ((nodes at: 1) elements at: 5) bounds = ((5@56) corner: (43@95)).
	self assert: ((nodes at: 1) elements at: 6) bounds = ((42@27) corner: (95@58)).
	
	"Test third (inner) nodes..."
	self assert: ((nodes at: 3) elements at: 2) bounds = ((24@5) corner: (54@28)).
	self assert: ((nodes at: 3) elements at: 4) bounds = ((5@27) corner: (43@57)).
	self assert: ((nodes at: 3) elements at: 5) bounds = ((5@56) corner: (43@95)).
	self assert: ((nodes at: 3) elements at: 7) bounds = ((42@57) corner: (95@95)).! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/11/2012 11:44'!
testSimpleEdgeDrivenLayouting
	| layout view nodes edges node1 node2 node3 mergedBounds |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 100; height: 100.
	view nodes: (1 to: 3).
	view edgesFromAssociations: (Array with: 1 -> 2 with: 1 -> 3).
	view layout: layout.	
	nodes := view nodes.
	view applyLayout.
	
	node1 := (nodes at: 1).
	node2 := (nodes at: 2).
	node3 := (nodes at: 3).
	mergedBounds := node1 bounds merge: (node2 bounds merge: node3 bounds).

	"Make sure the whole 'canvas' is as specified"
	self assert: mergedBounds extent = (100@100).
	self assert: mergedBounds = ((5@5) corner: (105@105)).
	
	"Lets also make sure the nodes are correctly positioned"
	self assert: (node1 bounds = ((5@5) corner: (105@105))).
	self assert: (node2 bounds = ((5@5) corner: (95@41))).
	self assert: (node3 bounds = ((5@40) corner: (95@95))).
	

	
! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/5/2012 09:45'!
testSimpleNestedDrivenLayouting
	| layout view nodes root mergedBounds node1 node2 node3 |

	view := ROMondrianViewBuilder new.
	view shape rectangle size: 100.
	view nodes: (OrderedCollection with: 1) forEach: [ :each |
		| innerNodes innerEdges |
		innerNodes := view nodes: (2 to: 3).
		view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	].
	nodes := view nodes.

	view applyLayout.
	node1 := (nodes at: 1).
	node2 := ((nodes at: 1) elements at: 1).
	node3 := ((nodes at: 1) elements at: 2).
	mergedBounds := node1 bounds merge: (node2 bounds merge: node3 bounds).

	"Make sure the whole 'canvas' is as specified"
	self assert: mergedBounds extent = (100@100).
	self assert: mergedBounds = ((5@5) corner: (105@105)).
	
	"Lets also make sure the nodes are correctly positioned"
	self assert: (node1 bounds = ((5@5) corner: (105@105))).
	self assert: (node2 bounds = ((5@5) corner: (95@41))).
	self assert: (node3 bounds = ((5@40) corner: (95@95))).
	! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/4/2012 16:47'!
testSingleNodeLayouting
	| layout view nodes edges root |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 100; height: 100.
	view nodes: (OrderedCollection with: 1).
	view layout: layout.	
	nodes := view nodes.
	root := nodes first.	
	"view open."	
	view applyLayout.

	"Make sure the node has the dimension we specified."
	self assert: (nodes at: 1) extent = (100 @ 100).

	! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/5/2012 11:26'!
testThreeNodesLayouting
	| layout view nodes node1 node2 node3 mergedBounds |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 100; height: 100.
	view nodes: (1 to: 3).
	view layout: layout.	
	nodes := view nodes.

	view applyLayout.
	node1 := (nodes at: 1).
	node2 := (nodes at: 2).
	node3 := (nodes at: 3).
	mergedBounds := node1 bounds merge: (node2 bounds merge: node3 bounds).

	"Make sure the whole 'canvas' is as specified"
	self assert: mergedBounds extent = (100@100).
	self assert: mergedBounds = ((5@5) corner: (105@105)).
	
	"Lets also make sure the nodes are correctly positioned"
	self assert: (node1 bounds = ((5@5) corner: (105@21))).
	self assert: (node2 bounds = ((5@20) corner: (45@105))).
	self assert: (node3 bounds = ((44@20) corner: (105@105))).! !

!ROTreeMapLayoutTest methodsFor: 'tests' stamp: 'DennisSchenk 9/4/2012 16:48'!
testTwoNodeslayouting
	| layout view nodes node1 node2 mergedBounds |
	
	layout := (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	view := ROMondrianViewBuilder new.
	view shape width: 100; height: 100.
	view nodes: (1 to: 2).
	view layout: layout.	
	nodes := view nodes.
	view applyLayout.
	node1 := (nodes at: 1).
	node2 := (nodes at: 2).
	mergedBounds := node1 bounds merge: node2 bounds.

	"Make sure the whole 'canvas' is as specified"
	self assert: mergedBounds extent = (100@100).
	self assert: mergedBounds = ((5@5) corner: (105@105)).

	"Make sure the nodes have the right dimensions based on their weight: node2 should be double the size as node1."
	"We have to substract the area that node2 has additionally because of the border overlapping. See the splitRectangle 
	methods in ROTreeMapLayout"
	self assert: (node1 bounds area) * 2 = (node2 bounds area - (2 * node2 bounds width)).

	"Lets also make sure the nodes are correctly positioned"
	self assert: (node1 bounds = ((5@5) corner: (105@38))).
	self assert: (node2 bounds = ((5@37) corner: (105@105))).
! !

!Array methodsFor: '*roassal-core' stamp: ''!
@ interactionClassOrObject
	| obj |
	obj := interactionClassOrObject elementToBeAdded.
	self do: [ :el | el addInteraction: obj ].
	^ self! !

!Point class methodsFor: '*roassal-core' stamp: ''!
radius: radius theta: angle
	^ (radius * angle cos) @ (radius * angle sin)! !

Announcement subclass: #ROEvent
	instanceVariableNames: 'position element realPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROAbstractMouseDragging
	instanceVariableNames: 'step'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: ''!
step
	^ step! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: ''!
step: anObject
	step := anObject! !

ROAbstractMouseDragging subclass: #ROMouseDragged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROAbstractMouseDragging subclass: #ROMouseDragging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROMouseDragging classSide methodsFor: 'as yet unclassified' stamp: ''!
step: value
	^ self new step: value! !

ROEvent subclass: #ROBeginingAnimation
	instanceVariableNames: 'animation nbCycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
animation
	^ animation! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
animation: anim
	animation := anim! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
incrementStep
	nbCycles isZero ifTrue: [ ^ self ].
	nbCycles := nbCycles - 1.
	animation value! !

!ROBeginingAnimation methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	nbCycles := 0.! !

!ROBeginingAnimation methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 8/19/2012 10:07'!
isComplete
	^ nbCycles <= 0! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
nbCycles
	^ nbCycles
	! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
nbCycles: integer
	nbCycles := integer! !

!ROBeginingAnimation methodsFor: 'actions' stamp: 'AlexandreBergel 8/19/2012 10:07'!
waitUntilDone
	[ self isComplete ] whileFalse: [ self incrementStep ] ! !

ROEvent subclass: #ROElementEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROElementEvent subclass: #ROElementResized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROElementEvent subclass: #ROElementTranslated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROEvent classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/17/2012 20:19'!
new
	^ self basicNew initialize! !

!ROEvent methodsFor: 'accessing' stamp: ''!
element
	^ element! !

!ROEvent methodsFor: 'accessing' stamp: ''!
element: anObject
	element := anObject! !

!ROEvent methodsFor: 'testing' stamp: ''!
hasElement
	^ element notNil! !

!ROEvent methodsFor: 'initialize-release' stamp: 'AlexandreBergel 6/1/2012 18:47'!
initialize
	position := 0 @ 0.
	realPosition := 0 @ 0! !

!ROEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 10/3/2012 19:14'!
model 
	^ element isNil
		ifTrue: [ nil ]
		ifFalse: [ self element model ]
 ! !

!ROEvent methodsFor: 'accessing' stamp: ''!
position
	^ position! !

!ROEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 12:17'!
position: aPoint
	"Set the position of the even in the view.  The position does not necessary correspond to the position on the screen"
	position := aPoint
	! !

!ROEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 18:45'!
realPosition
	^ realPosition! !

!ROEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 12:19'!
realPosition: aPoint
	"aPoint corresponds to the position on the screen. This is useful to process later on"
	realPosition := aPoint! !

ROEvent subclass: #ROKeyDown
	instanceVariableNames: 'keyValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROKeyDown methodsFor: 'as yet unclassified' stamp: 'VanessaPena 8/26/2012 12:26'!
keyValue 
	^keyValue ! !

!ROKeyDown methodsFor: 'as yet unclassified' stamp: 'VanessaPena 8/26/2012 12:26'!
keyValue: aValue
	
		keyValue := aValue ! !

ROEvent subclass: #ROMouseClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROMouseClick subclass: #ROMouseLeftClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROMouseClick subclass: #ROMouseRightClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROMouseEnter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROMouseLeave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROMouseMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #RORefreshNeeded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROViewChanged
	instanceVariableNames: 'newView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROViewChanged methodsFor: 'accessing' stamp: ''!
newView 
	^ newView! !

!ROViewChanged methodsFor: 'accessing' stamp: ''!
newView: aView
	newView := aView! !

Announcer subclass: #ROAnnouncer
	instanceVariableNames: 'forwarding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAnnouncer commentStamp: '<historical>' prior: 0!
A ROAnnouncer is an object that receive and emit events. Each roassal element has an roannouncer. !

!ROAnnouncer methodsFor: 'announce' stamp: 'AlexandreBergel 9/2/2012 20:25'!
announce: event
	(self isForwarded: event) 
		ifTrue: [ self sendToParent: event ]
		ifFalse: [ super announce: event ]
! !

!ROAnnouncer methodsFor: 'forwarding' stamp: ''!
forward
	self forward: ROEvent! !

!ROAnnouncer methodsFor: 'forwarding' stamp: ''!
forward: anEventClass

	forwarding ifNil: [ forwarding := IdentitySet new ].
	forwarding add: anEventClass! !

!ROAnnouncer methodsFor: 'testing' stamp: 'AlexandreBergel 9/2/2012 20:24'!
isForwarded: anEventClass
	anEventClass isBehavior ifFalse: [ ^ self isForwarded: anEventClass class ].
	 
	forwarding ifNil: [ ^ false ].
	^ forwarding anySatisfy: [ :c | (c == anEventClass) or: [ anEventClass inheritsFrom: c ] ] ! !

!ROAnnouncer methodsFor: 'testing' stamp: ''!
isForwarder
	^ forwarding notNil and: [ forwarding notEmpty ]! !

!ROAnnouncer methodsFor: 'announce' stamp: ''!
sendToParent: event
	"Do nothing if an event class"
	event isBehavior ifTrue: [ ^ self ].
	
	event hasElement ifTrue: [ event element parentAnnounce: event ]! !

!BlockClosure methodsFor: '*roassal-core' stamp: ''!
roValue: valueOrArray
	self numArgs = 0 ifTrue: [ ^ self value ].  
	self numArgs = 1 ifTrue: [ ^ self value: valueOrArray ].
	
	"if I have more than 1 argument, then the valueOrArray is a collection"
	valueOrArray isCollection ifFalse: [ self error: 'A block with more than one argument can only be evaluated with a collection ' ].
	
	self numArgs = valueOrArray size ifTrue: [ ^ self valueWithArguments: valueOrArray ]. 
	
	self error: 'Incorrect number of arguments'

! !

!ClassDescription methodsFor: '*roassal-core' stamp: 'AlexandreBergel 7/16/2012 07:56'!
numberOfLinesOfCode 
	"Return the amount of lines of code"
	
	^ 5 + ((RONativeExampleUtility current getMethodsForClass: self)  inject: 0 into: [:sum :el | sum + el linesOfCode ])! !

!Object methodsFor: '*roassal-core' stamp: ''!
roValue: anArgument 
	^ self! !

Object subclass: #ROAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

ROAction subclass: #ROAbstractAdjustSize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROAbstractAdjustSize classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/15/2012 10:42'!
getNewRectangleFor: element
	self subclassResponsibility ! !

!ROAbstractAdjustSize classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/15/2012 10:57'!
on: element
	| rec topLeft border |
	self assert: [ element isKindOf: ROElement ].
	topLeft := element bounds topLeft.
	rec := self getNewRectangleFor: element.
	element extent: rec extent.
	element translateTo: (rec topLeft).	"Check if I was extended on the topLeft corner"
	element elementsNotEdge do: [ :el | el translateWithoutUpdatingContainedElementsBy: topLeft - rec topLeft ]! !

ROAbstractAdjustSize subclass: #ROAdjustSizeOfNesting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROAdjustSizeOfNesting classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/15/2012 10:31'!
getNewRectangleFor: element
	^ element encompassingRectangle! !

ROAbstractAdjustSize subclass: #ROShrikingSize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROShrikingSize classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 9/15/2012 10:33'!
getNewRectangleFor: element
	^ element encompassingNestedRectangle! !

!ROAction classSide methodsFor: 'public' stamp: ''!
on: element
	self subclassResponsibility! !

ROAction subclass: #ROGrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROGrow classSide methodsFor: 'public' stamp: ''!
on: element by: integer
	element setBounds: (element bounds extendBy: ((integer * 2) @ (integer * 2))).
	element translateBy: integer @ integer! !

ROAction subclass: #ROHighlightElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROHighlightElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 7/4/2012 16:17'!
defaultColor
	^ Color red! !

!ROHighlightElement classSide methodsFor: 'testing' stamp: 'AlexandreBergel 7/4/2012 16:16'!
isHighlighted: element
	^ element attributes includesKey: #oldColor! !

!ROHighlightElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 7/4/2012 16:17'!
on: element
	self on: element color: self defaultColor! !

!ROHighlightElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 7/4/2012 16:19'!
on: element color: aColor
	element forShape: ROShape do: [ :d | 
		
		(element attributes includesKey: #oldColor)
			ifFalse: 
				[ element attributes at: #oldColor put: d color.
				d color: aColor.
				element signalUpdate ]]. 
	! !

ROAction subclass: #ROHighlightElements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROHighlightElements classSide methodsFor: 'public' stamp: ''!
on: elements
	elements do: [ :el | ROHighlightElement on: el ]! !

!ROHighlightElements classSide methodsFor: 'public' stamp: ''!
on: elements color: aColor
	elements do: [ :el | ROHighlightElement on: el color: aColor ]! !

ROAction subclass: #RORemoveEdge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!RORemoveEdge classSide methodsFor: 'as yet unclassified' stamp: 'BenComan 10/10/2012 21:41'!
edgesFrom: anElement 
	anElement view elementsDo: 
	[ 	:el |
		el isEdge ifTrue: 
		[ 	(el from == anElement) ifTrue: 
			[ 	el remove
			] 
		]
	].
	anElement view signalUpdate ! !

!RORemoveEdge classSide methodsFor: 'as yet unclassified' stamp: 'BenComan 10/10/2012 21:41'!
edgesTo: anElement 
	anElement view elementsDo: 
	[ 	:el |
		el isEdge ifTrue: 
		[ 	(el to == anElement) ifTrue: 
			[ 	el remove
			] 
		]
	].
	anElement view signalUpdate ! !

ROAction subclass: #RORemoveNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!RORemoveNode classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/18/2012 15:49'!
suchThat: aBlock in: view
	view elementsDo: [ :el | 
		el isEdge
			ifTrue: [ ((aBlock value: el from) or: [ (aBlock value: el to) ]) ifTrue: [ el remove ] ] 
			ifFalse: [ (aBlock value: el) ifTrue: [ el remove ] ] ].
	view signalUpdate ! !

ROAction subclass: #ROUnhighlightElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROUnhighlightElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/29/2012 14:58'!
on: element

	(ROHighlightElement isHighlighted: element) ifFalse: [ ^ self ].
	
	element forShape: ROShape do: [ :d | 
		d color: (element attributes at: #oldColor).
		element attributes removeKey: #oldColor ]. 
	element signalUpdate ! !

ROAction subclass: #ROUnhighlightElements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROUnhighlightElements classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/14/2012 18:36'!
on: elements
	elements do: [ :el | ROUnhighlightElement on: el ]! !

Object subclass: #ROBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Benchmarks'!

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:31'!
cleanMemory

	10 timesRepeat: [ Smalltalk garbageCollect ].
	Object new; new; new.
	10 timesRepeat: [ Smalltalk garbageCollect ].! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:33'!
elementAtFor: nbIterations
	"
	self new elementAtFor: 50000 
	=> 320 (AlexandreBergel 9/28/2012 08:33)
	=> 329 (Macbook air AlexandreBergel 9/27/2012 17:09)
	"


	| view node center |
	self cleanMemory.
	view := ROMondrianViewBuilder new.
	view node: #a forIt: [ view node: #a forIt: [ view node: #a forIt: [ view node: #a forIt: [ node := view node: #a ] ] ] ].
	"
	view open.
	"
	
	center := node bounds center.
	^ [ nbIterations timesRepeat: [(view raw elementAt: center )] ] timeToRun! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:33'!
interaction1
	"
	self new interaction1 
	331 (AlexandreBergel 9/28/2012 08:33)
	518 AlexandreBergel 9/26/2012 09:21 
	920 AlexandreBergel 2/11/2012 17:02
	"
	| element |
	self cleanMemory.
	element := ROElement new.
	^ [20000 timesRepeat: [element @ RODraggable @ ROGrowable @ ROPopup]] timeToRun! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:32'!
interaction2WithMenuActivable
	"
	self new interaction2WithMenuActivable
	
	=> 77 (AlexandreBergel 9/28/2012 08:32)
	79 AlexandreBergel 9/26/2012 09:21
	 793 AlexandreBergel 2/11/2012 17:04
	"
	| element |
	self cleanMemory.
	element := ROElement new.
	^ [100000 timesRepeat: [element @ ROMenuActivable ]] timeToRun! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/28/2012 08:32'!
layout

"
[self new layout ] timeToRun 

=> 8177 (AlexandreBergel 9/28/2012 08:32)
=> 7309 
=> 6845  (Pharo)
"

| view |
self cleanMemory.
view := ROMondrianViewBuilder new.
view nodes: (1 to: 800).
view edgesFrom: [ :v | v // 5].
"==="
view treeLayout.
view applyLayout.
"==="
view sugiyamaLayout.
view applyLayout
! !

Object subclass: #RODummyNode
	instanceVariableNames: 'edge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RODummyNode classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 5/3/2012 19:18'!
on: anEdge slot: anIndex
	
	^(self new)
		edge: anEdge;
		slot: anIndex;
		yourself! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
edge
	
	^edge! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
edge: anEdge
	
	edge := anEdge! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
height
	
	^0! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:15'!
position
	^ 0 @ 0! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:16'!
signalUpdate
	"do nothing"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
slot: anIndex
	! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:16'!
translateBy: apoint
	"do nothing"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
translateTo: aPoint
	
	"edge index: index point: aPoint"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
width
	
	^0! !

Object subclass: #ROExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Example'!

!ROExample commentStamp: '<historical>' prior: 0!
A ROExample contains a list of example of Roassal. It does not contains examples on the builder. !

!ROExample classSide methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:48'!
postScript
	^ '
"-------------"
"-------------"
"Below is the initiation of the menu and opening the visualization"
ROEaselMorphic new populateMenuOn: view.
view noLayout.
view open'! !

!ROExample classSide methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:43'!
preamble
	^ 'rawView := ROView new.
view := ROMondrianViewBuilder view: rawView.'! !

!ROExample classSide methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:43'!
preambleVariables
	^ #('view' 'rawView')! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 15:05'!
arrowedLine

	"
	self new arrowedLine
	"
	| view n1 n2|
	view := ROView new.
	self arrowedLineOn: view.
	view open! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:12'!
arrowedLineOn: rawView 
	| n1 n2 |
	
	n1 := ROElement sprite.
	n2 := ROElement sprite.
	n2 translateBy: 20@60.

	rawView 
		add: n1; 
		add: n2; 
		add: (ROEdge arrowedLineFrom: n1 to: n2).
	! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:48'!
bouncingBall

"
	self new bouncingBall

"

	| rawView |
	rawView := ROView new.
	self bouncingBallOn: rawView.
	rawView open.! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:51'!
bouncingBallOn: rawView
| x y dy ball b |

x := 0.
y := 50.
dy := 0.

ball := ROElement new + ROCircle.
ball extent: 30 @ 30.
rawView add: ball. 

b := [ 
	x := x + 4.
	y := y + dy.
	( y > 185) 
		ifTrue: [ 
			dy := dy negated. 
			ball extent: 30 @ 25.
			ball translateTo: x @ 190 ]
		ifFalse: [
			dy := dy * 0.98 + 3.
			ball extent: 30 @ 30.
			ball translateTo: x @ y ].
].

[ 100 timesRepeat: [ b value. rawView signalUpdate. (Delay forMilliseconds: 30 ) wait ] ] fork.! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 9/11/2012 17:19'!
brightness 
"
	Brightness 
	by Rusty Robison. 
	from Processing
	
	self new brightness 	
	
"
	
	| view barWidth elements windowExtent cantBars layout |
	
	view := ROView new.
	windowExtent := 500.
	self brightnessOn: view.	
	view openInWindowSized: windowExtent @windowExtent .
	
! !

!ROExample methodsFor: 'colors' stamp: 'VanessaPena 8/22/2012 21:17'!
brightnessOn: rawView
	|barWidth elements windowExtent cantBars layout|
	windowExtent := 250.
	barWidth := 5.	
	cantBars := windowExtent / barWidth .
	elements := ROElement forCollection: (1 to: cantBars).
	elements do:[:e |
			e extent: barWidth@windowExtent.
			e + (ROBox new color: Color black).
			e on: ROMouseMove do:[:event | 
				(e getShape: ROBox) color: (Color h: e position x s: 100 v: (event position y / 250) ).
				e signalUpdate.
			].
			
		].
	layout := ROHorizontalLineLayout  withGap: 0.
	layout applyOn: elements .
	rawView addAll: elements .
	
! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 9/20/2012 11:54'!
centeredLabel

	"
	self new centeredLabel
	"
	
	| rawView |
	rawView := ROView new.
	self centeredLabelOn: rawView.
	rawView openInWindow .
	! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 9/20/2012 11:55'!
centeredLabelOn: rawView
	| el |
	
el := (ROElement spriteOn: 
'x
x
x
x
x
x x x x x x x x x x x x x x x x x x
x
x
x
x
x' ) width: 200; height:200.

el + ROCenteredLabel + (ROCircle color: Color lightGreen).
rawView add: el.! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 6/11/2012 12:40'!
choice
	"
	self new choice
	"

	| view circle grid options choice container elementsToLayout |
	view := ROView new.
	circle := ROButtonElement named: 'circle' do: [:e | ROCircleLayout on: elementsToLayout. view signalUpdate  ].

	grid := ROButtonElement named: 'grid' do:  [:e | ROGridLayout on: elementsToLayout. view signalUpdate  ].
	
	options := Array with: circle with: grid.

	choice := ROElement new.
	choice addAll: (ROHorizontalLineLayout on: options).
	
	container := ROElement new.
	elementsToLayout := ROElement labelsOn: (1 to: 20).
	elementsToLayout do: [ :v | 
		v + ROBorder red @RODraggable.
		v extent: 50@50 ].
	container addAll: (ROCircleLayout on: elementsToLayout).
	elementsToLayout do: [:l | l addShape: ROLabel].

	view addAll: (ROVerticalLineLayout on: (Array with: choice with: container)).
	view openInWindow.
	! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 7/14/2012 18:40'!
choiceOn: rawView
	| circle grid options choice container elementsToLayout |
	circle := ROButtonElement named: 'circle' do: [:e | ROCircleLayout on: elementsToLayout. rawView signalUpdate  ].
	grid := ROButtonElement named: 'grid' do:  [:e | ROGridLayout on: elementsToLayout. rawView signalUpdate  ].
	options := Array with: circle with: grid.
	choice := ROElement new.
	choice addAll: (ROHorizontalLineLayout on: options).
	
	container := ROElement new.
	elementsToLayout := ROElement labelsOn: (1 to: 20).
	elementsToLayout do: [ :v | 
		v + ROBorder red @RODraggable.
		v extent: 50@50 ].
	container addAll: (ROCircleLayout on: elementsToLayout).
	elementsToLayout do: [:l | l addShape: ROLabel].

	rawView addAll: (ROVerticalLineLayout on: (Array with: choice with: container)).
	
	! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 6/9/2012 18:42'!
circle
	"
	self new circle
	"

	| view elements |
	view := ROView new.
	view addAll: ((elements := ROElement spritesOn: (1 to: 20)) do: [:n | n addShape: ROLabel]).
	ROCircleLayout on: elements.
	view openInWindow ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 15:19'!
clickAndMove
	"
	self new clickAndMove
	
	Click to make the element go to where you have clicked
	"

	| rawView |
	rawView := ROView new.
	self clickAndMoveOn: rawView.
	rawView open.
	
! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:13'!
clickAndMoveOn: rawView
	| el |
	"
	Click to make the element go to where you have clicked
	"
	el := ROElement sprite.
	rawView add: el.
	rawView on: ROMouseLeftClick do: [ :event | 
		ROLinearMove new
			nbCycles: 180;
			for: el until: event position.
	].
	! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 7/14/2012 18:24'!
colors
	"
	self new colors
	"
	| view els |
	view := ROView new.
	self colorsOn: view.
	view open.! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 7/14/2012 18:25'!
colorsOn: rawView
	| els |
	
	els := ROElement forCollection: (1 to: 20). 
	els with: (Color red mix: Color green shades: 20) do: [:el :c | (el size: 20) + (ROCircle color: c )].
	
	"We make the circle draggable"
	els do: [ :e | e @ RODraggable ].
	
	rawView addAll: els.
	ROCircleLayout new scaleBy: 4; on: els.
! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 9/26/2012 19:11'!
composingOn: rawView 
| outter inner innerLabel |

outter := ROElement new + ROBorder white.
outter @ RODraggable.

inner := ROElement sprite.
innerLabel := ROElement labelOn: 'My sprite'.

outter add: inner; add: innerLabel.

"We make the inner and innerLabel forwarder of events"
inner forward.
innerLabel forward.

"We layout the things"
ROVerticalLineLayout on: outter elements.

rawView add: outter.


! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 10/1/2012 10:01'!
constraintsOn: rawView
| outer inner innerLabel |

outer := ROElement sprite.
outer @ ROLightlyHighlightable .

inner := ROElement sprite .
innerLabel := ROElement labelOn: 'My sprite'.
outer add: inner; add: innerLabel.
inner add: ROElement sprite.

rawView add: outer.

ROConstraint stick: innerLabel onTheRightOf: inner.
"ROConstraint stick: innerLabel below: inner."
"ROConstraint stick: innerLabel above: inner."
"ROConstraint stick: innerLabel onTheLeftOf: inner."! !

!ROExample methodsFor: 'interaction' stamp: 'VanessaPena 8/22/2012 21:38'!
continuousLinearMove

"
	From Processing
	
	self new continuousLinearMove

"

	|view line1 line2|
	view := ROView new.
	line1 := (ROElement new model: 'line1') extent:1@100; yourself.
	line1 + (ROBorder new color: Color red).
	line2 := (ROElement new model: 'line1') extent:1@100; yourself.
	line2 + (ROBorder new color: Color green).
	line2 translateBy: 0@100.
	view add: line1.
	view add: line2.
	ROMotionMove new for: line1 initialSpeed: 60@0.
	ROMotionMove new for: line2 initialSpeed: 30@0.
	view openInWindowSized: 200@200.
	! !

!ROExample methodsFor: 'free style' stamp: 'AlexandreBergel 5/7/2012 11:54'!
drawCircle: view x: x radius: radius level: level
	| tt |
	tt := 126 * level / 4.
	view  add: ((ROElement new center: x asInteger @100 radius: radius asInteger )
						addShape: (ROCircle new color: (Color gray256: tt) )).
	(level > 1) ifTrue: 
		[
			self drawCircle: view x: (x - (radius / 2)) radius: radius / 2 level: level - 1.
			self drawCircle: view x: (x + (radius / 2)) radius: radius / 2 level: level - 1.
		]
! !

!ROExample methodsFor: 'free style' stamp: 'AlexandreBergel 9/11/2012 15:48'!
embeddedIteration

"
	From Processing

	self new embeddedIteration

"

	| view boxSize elements tmpEltos windowExtent cantBoxes layout height gap originalBoxSize |
	originalBoxSize := 10.
	boxSize := 10.
	windowExtent := 200.
	view := ROView new.
	elements := OrderedCollection new.
	cantBoxes := windowExtent / boxSize .
	height  := 0.
	[ boxSize > 0 ] whileTrue: [
		gap := (originalBoxSize - boxSize) / 2.	
		tmpEltos := ROElement forCollection: (1 to: cantBoxes).
		tmpEltos do: [ :e |
			e + ROBox .
			e size: boxSize ].
		
		layout := ROHorizontalLineLayout withGap: gap.
		layout applyOn: tmpEltos.
		tmpEltos do: [ :e | e translateBy: 0 @ height ].

		elements addAll: tmpEltos .
		height := height + boxSize + 1.
		boxSize := boxSize - 0.5.	

	].

	view addAll: elements .	
	view openInWindowSized: windowExtent @ windowExtent .! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:28'!
expandableNodes

	"
	ROExample new expandableNodes
	"
	
	| view initialNodes |
	view := ROView new.
	self expandableNodesOn: view.
	view @RODraggable @ RODraggableWithVelocity.
	view open! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:28'!
expandableNodesOn: rawView
	| initialNodes |
	
	initialNodes := (ROElement labelsOn: (Array with: Integer)) asOrderedCollection.
	initialNodes do: [:n |
		n + ROLabel + ROBorder red.
		n @ (RORecursiveExpandOnClick childrenForModel: [ :model | model subclasses])].
	rawView addAll: initialNodes.
	ROTreeLayout new 
		translator: (ROSmoothLayoutTranslator new);
		applyOn: initialNodes.
! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 6/9/2012 18:42'!
grid
	"
	self new grid
	"

	| view elements |
	view := ROView new.
	view addAll: ((elements := ROElement spritesOn: (1 to: 20)) do: [:n | n addShape: ROLabel]).
	ROGridLayout on: elements.
	view openInWindow ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:30'!
growOnClick

	"
	self new growOnClick
	"
	| view greenNode blueNode |
	view := ROView new.
	self growOnClickOn: view.
	view openInWindow ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:31'!
growOnClickOn: rawView 
	| greenNode blueNode |
	
	greenNode := ROElement on: 'green node'.
	greenNode addShape: (ROBox new color: Color green).
	greenNode setBounds: (5 @ 10 corner: (180 @ 170)).
	greenNode @ RODraggable.
	greenNode @ ROGrowable.

	blueNode := ROElement on: 'blue node'.
	blueNode addShape: (ROBox new color: Color blue).
	blueNode setBounds: (5 @ 10 corner: (180 @ 170)).
	blueNode translateBy: 50@30.
	blueNode @ RODraggable.
	blueNode @ ROGrowable.

	rawView add: greenNode; add: blueNode.
	! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 5/22/2012 21:01'!
innerNodeAndZoom


	"
	self new innerNodeAndZoom
	"
	| view els |
	view := ROView new.
	els := ROElement forCollection: (1 to: 200).
	els do: [:spr |
		| innerNodes |
		spr extent: 50@50. 
		spr + ROBorder red.
		spr @ ROZoomOnClick @ RODraggable.
		
		innerNodes := ROElement forCollection: (1 to: 10).
		innerNodes do: [:s | s + ROBox green @ RODraggable ].
		spr addAll: (ROGridLayout on: innerNodes).
		].
	view addAll: els.
	view @ RODraggable.
	ROGridLayout on: els.
	view open.
	! !

!ROExample methodsFor: 'keypressing' stamp: 'VanessaPena 8/27/2012 10:06'!
keyPressing

"

	self new keyPressing

"

	|view elto elements|
	view := ROView new.
	view on: ROKeyDown  do: [:evt |
		|keyValue|
		keyValue  := evt keyValue.
		keyValue = 30 "up arrow"
			ifTrue: [view  translateBy: 0@1].
		keyValue = 31 "down arrow"
			ifTrue: [view  translateBy: 0@(-1)].
		keyValue = 29 "right arrow"
			ifTrue: [view  translateBy: (-1)@0].
		keyValue = 28 "left arrow"
			ifTrue: [view  translateBy: 1@0]
	].
	elements := ROElement spritesOn: (1 to: 100).
	ROGridLayout new applyOn: elements.
	view  addAll: elements .
	view open.! !

!ROExample methodsFor: 'keypressing' stamp: 'VanessaPena 8/26/2012 12:33'!
keyPressing2

"

	self new keyPressing2

"

	|view elto element|
	view := ROView new.
	element := ROElement spriteOn: 'me'.
	view on: ROKeyDown  do: [:evt |
		|keyValue|
		keyValue  := evt keyValue.
		keyValue = 30 "up arrow"
			ifTrue: [element  translateBy: 0@(-2)].
		keyValue = 31 "down arrow"
			ifTrue: [element  translateBy: 0@(2)].
		keyValue = 29 "right arrow"
			ifTrue: [element  translateBy: (2)@0].
		keyValue = 28 "left arrow"
			ifTrue: [element  translateBy: (-2)@0].
		element signalUpdate.
	].
	view add: element.
	view open.! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 15:06'!
label

	"
	self new label
	"
	
	| rawView |
	rawView := ROView new.
	self labelOn: rawView.
	rawView openInWindow .
	! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:13'!
labelOn: rawView

	rawView add: (ROLabel elementOn: 'hello world').
	! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 6/10/2012 15:57'!
labelWithCRCharacter

	"
	self new labelWithCRCharacter
	"
	
	| view |
	view := ROView new.
	view add: (ROLabel elementOn: 
'hello 
world').
	view openInWindow .
	! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:21'!
labelWithCRCharacterOn: rawView
	rawView add: (ROLabel elementOn: 
'hello 
world').
	
	! !

!ROExample methodsFor: 'software' stamp: 'AlexandreBergel 6/19/2012 10:16'!
latentSemanticIndexing
	"
	self new latentSemanticIndexing
	"

	| documentsToProcess matrix words v elements view tIndexing elementsGraphical nativeUtil stack miniView |
	documentsToProcess := OrderedCollection new.
	nativeUtil := RONativeExampleUtility current.
	ROElement withAllSubclasses do: [ :cls | documentsToProcess addAll: ((nativeUtil getMethodsForClass: cls) collect: #getSource) ].
	
	"Matrix is a dictionary of dictionaries. The outter key is a word of the documents. The value is a dictionary is a method source code. In this dictionary of method source code, the value is the number of occurence of the word in the source code.
    | w1 | w2 | w3 | w4|
s0| 
s1|
s2|

(w1, s0) occurence of the word w1 in the source code s0.
...
	"
	matrix := Dictionary new.
	documentsToProcess do: [ :source | 
		words := nativeUtil substringsFor: source .
		words do: [ :w |  
			matrix at: w ifAbsentPut: [ Dictionary new ].
			v := (matrix at: w) at: source ifAbsentPut: [ 0 ].
			(matrix at: w) at: source put: (v + 1) ] ].
	elements := OrderedCollection new.
	matrix associationsDo: [ :assoc|
		| wordToConsider sourceAndOccurrences |
		wordToConsider := assoc key.
		sourceAndOccurrences := assoc value.
		
		sourceAndOccurrences associationsDo: [ :assoc2|
			| sourceCodeForWord wordOccurrence|
			sourceCodeForWord := assoc2 key.
			wordOccurrence := assoc2 value.
			elements add: (Array 
							with: wordToConsider
							with: (documentsToProcess indexOf: sourceCodeForWord) 
							with: wordOccurrence
							with: sourceCodeForWord) ] ].

	tIndexing := (elements collect: #first) asSet asSortedCollection.
	elements := elements collect: [ :tupple |
			Array 
				with: (tIndexing indexOf: tupple first) 
				with: tupple second 
				with: tupple third
				with: tupple fourth
				with: tupple first ].
	

	"We build the view"	
	stack := ROViewStack new.
	view := ROView new backgroundColor: Color black.
	elementsGraphical := ROElement forCollection: elements.
	elementsGraphical do: [:el | 
					
					el 
						addShape: (ROCircle green);
						addInteraction: (ROPopup new 
											text:  [:e | 
												'Word: ', e fifth, String cr,
												'Occurrence: ', e third printString, String cr,
												'Source Code: ', String cr, e fourth printString] ;
											receivingView: stack);
						size: (el model third) ].
						
	view addAll: elementsGraphical.
	ROScatterplotLayout new 
		x: #first ; y: #second;
		applyOn: elementsGraphical.
	

	view 
		on: ROMouseLeftClick
		do: [ :event | 
			ROZoomInMove new on: view ].
	view 
		on: ROMouseRightClick
		do: [ :event | 
			ROZoomOutMove new on: view ].
		
	view @ RODraggable @ RODraggableWithVelocity.
	
	stack addView: view.
	stack open.! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:33'!
leftAndRightClick
	" 
	self new leftAndRightClick
	"
	| view |
	view := ROView new.
	self leftAndRightClickOn: view.
	view openInWindow  ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/29/2012 09:40'!
leftAndRightClickOn: rawView
	| counter add sub els |
	
	els := OrderedCollection new.
	
	add := ROElement sprite 
				addShape: (ROLabel new text: '+ / --');
				addShape: (ROBorder yellow).

	add on: ROMouseLeftClick do: [ :ev | 
		| el |
		el := ROElement sprite translateTo: (200 atRandom @ 200 atRandom ).
		els add: el.
		rawView add: el.
		rawView signalUpdate ].

	add on: ROMouseRightClick do: [ :ev | 
		| el |
		els ifNotEmpty: [
			rawView remove: els removeLast.
			rawView signalUpdate ] ].

	rawView add: add.
	! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:22'!
lines

	"
	self new lines
	"
	
	| view node1 node2 edge |
	view := ROView new.
	self linesOn: view.
	view open! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 10/3/2012 09:02'!
linesOn: rawView
	| node1 node2 edge |
	node1 := ROLabel elementOn: 'node1'. 
	node2 := ROLabel elementOn: 'node2'.
	node1 @ RODraggable.
	node2 @ RODraggable.
	edge := ROEdge from: node1 to: node2.
	edge + (ROLine red).
	rawView add: edge; add: node1; add: node2.
	ROHorizontalLineLayout on: (Array with: node1 with: node2).
	! !

!ROExample methodsFor: 'software' stamp: ''!
memoryProfiling
	"
	self new memoryProfiling
	"
	"| spaceItems builder |
	spaceItems := SpaceTally new spaceTally: (Array with: ByteString with: Process with: RPackage with: Bitmap).
	
	builder := ROMondrianViewBuilder new.
	builder shape rectangle logWidth: #instanceCount; logHeight: #spaceForInstances.
	builder nodes: (spaceItems asSorted: #spaceForInstances).
	builder open	.
	"! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:34'!
motion

	"
	self new motion
	"
	|view sprs |
	view := ROView new.
	self motionOn: view.
	view open.
! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:34'!
motionOn: rawView
	| sprs |
	
	sprs := (ROElement forCollection: (1 to: 20)).
	sprs do: [:s | 
		s extent: 20@20.
		s + ROCircle blue.
		s @ RODraggable.
		s @ RODraggableWithVelocity ].
	rawView addAll: sprs.

	sprs do: [ :spr | ROMotionMove new for: spr initialSpeed: 60 atRandom @ 60 atRandom ].
	! !

!ROExample methodsFor: 'interaction' stamp: 'VanessaPena 8/28/2012 09:52'!
mouse1D

"
	From Processing

	self new mouse1D
"

	|view lElto rElto w h|
	w := 200.
	h := 200.
	view := ROView new.
	lElto := ROElement new model: 'left element'.
	lElto width: 100; height: 200.
	lElto + (ROBox new color: Color green).
	rElto := ROElement new model: 'right element'.
	rElto width: 100; height: 200.
	rElto + (ROBox new color: Color blue).
	
	rElto translateBy: 100@0.
	
	view add: lElto ; add: rElto .
	
	view openInWindowSized: w@h.! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:48'!
moveLikeCircle

"
	self new moveLikeCircle

"

	| rawView |
	rawView := ROView new.
	self moveLikeCircleOn: rawView.
	rawView open.! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:45'!
moveLikeCircleOn: rawView
	| elto mov |
	
	elto := ROElement new.
	elto size: 10.
	elto + (ROCircle color: Color green).
	rawView add: elto.
	elto translateBy: 250@250.
	
	mov := ROFunctionMove new nbCycles: 200.
	mov for: elto functionX: [:t | 10* (t cos)] Y: [:t | 10* (t sin)] intervalIni: 0 IntervalEnd: 2 * Float pi.
	! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:47'!
moveLikeCurve

"
	self new moveLikeCurve

"
	| rawView |
	rawView := ROView new.
	self moveLikeCurveOn: rawView.
	rawView open.! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:46'!
moveLikeCurveOn: rawView
	| elto mov |
	
	elto := ROElement new.
	elto size: 10.
	elto + (ROCircle color: Color green).
	rawView add: elto.
	elto translateBy: 30@20.
	
	mov := ROFunctionMove new nbCycles: 100.
	mov for: elto function: [:x | x ] intervalIni: 0 IntervalEnd: 100.
! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:46'!
moveLikeSin

"
	self new moveLikeSin

"


	| rawView |
	rawView := ROView new.
	self moveLikeSinOn: rawView.
	rawView open.! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/3/2012 08:46'!
moveLikeSinOn: rawView
	| elto mov |
	
	elto := ROElement new.
	elto size: 10.
	elto + (ROCircle color: Color green).
	rawView add: elto.
	elto translateBy: 30@100.
	
	mov := ROFunctionMove new nbCycles: 100.
	mov for: elto function: [:x | x sin * 10] intervalIni: 0 IntervalEnd: 4 * Float pi XFactor: 10.
! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 6/13/2012 00:25'!
multipleArrow

	| view el1 el2 edge line  |
	view := ROView new.
	el1 := ROElement new.
	el1 @RODraggable.
	el1 extent: 50@50.
	el1 + ROBox blue.

	el2 := ROElement new.
	el2 @RODraggable.
	el2 extent: 50@50.
	el2 + ROBox green.

	el1 translateTo: 0 @ 100.
	 
	edge := ROEdge from: el1 to: el2.
	line := ROLine new.
	line add: ROArrow new offset: 0.1.
	line add: ROArrow new offset: 0.5.
	edge + line.

	view add: el1; add: el2; add: edge.
	view open 
	 ! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 7/14/2012 18:23'!
multipleArrowOn: rawView
	| el1 el2 edge line  |
	
	"A line shape can have several arrows on it."
	el1 := ROElement new.
	el1 @RODraggable.
	el1 extent: 50@50.
	el1 + ROBox blue.

	el2 := ROElement new.
	el2 @RODraggable.
	el2 extent: 50@50.
	el2 + ROBox green.

	el1 translateTo: 0 @ 100.
	 
	edge := ROEdge from: el1 to: el2.
	line := ROLine new.
	line add: ROArrow new offset: 0.1.
	line add: ROArrow new offset: 0.5.
	edge + line.

	rawView add: el1; add: el2; add: edge.
	 
	 ! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 10/7/2012 13:46'!
nestedLayoutOn: rawView
	| elements edges outterNode |
	
	outterNode := ROElement new + ROBorder blue.
	elements := ROElement spritesOn: (1 to: 5).
	outterNode addAll: elements.
	
	rawView add: outterNode.
	rawView addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	
	ROTreeLayout on: elements.
! !

!ROExample methodsFor: 'nesting' stamp: 'VanessaPena 8/26/2012 10:51'!
nesting
	"
	self new nesting
	"

	| view innerNode outterNode |
	view := ROView new.
	
	innerNode := ROElement new 
					extent: 40@30; 
					+ (ROBox new color: Color green);
					@ RODraggable.
	
	outterNode := 
		ROElement new 
			addInteraction: RODraggable;
			extent: 190@190;
			translateBy: 20@20;
			+ (ROBorder new color: Color red).

	view add: outterNode.
	outterNode add: innerNode.	
	
	view openInWindow.
	! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 6/9/2012 18:42'!
nesting2
	"
	self new nesting2
	"

	| view nodes |
	view := ROView new.
	view add: (ROElement sprite
				addAll: (nodes := ROElement spritesOn: (1 to: 20))).
	nodes do: [:n | n addShape: ROLabel].
	ROCircleLayout on: nodes. 
	view openInWindow.
	! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 6/9/2012 18:42'!
nesting3
	"
	self new nesting3
	"
	
	| view elements edges outterElement |
	view := ROView new.
		
	elements := ROElement spritesOn: (1 to: 5).

	outterElement := ROElement new.
	outterElement addAll: elements.
	outterElement addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).

	ROTreeLayout on: elements edges: edges.

	view add: outterElement.
	
	view open.! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 7/29/2012 10:14'!
normalizer
	"
	self new normalizer
	"
	| view el |
	view := ROView new.
	self normalizerOn: view.
	view open! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 7/29/2012 10:14'!
normalizerOn: rawView
	| el normalizer nodes|
	
	normalizer := RONIdentityNormalizer beginingAtBlue.
	
	nodes := (1 to: 30) collect: [ :i | 
		el := ROElement on: i.
		el @ RODraggable.
		el @ ROPopup.
		el extent: 60 @ 30.
		el + (ROBox new color: normalizer) + ROBorder.
		el ].	
	rawView addAll: nodes.
	ROGridLayout on: nodes.

"-------------"
! !

!ROExample methodsFor: 'animation' stamp: 'AlexandreBergel 10/16/2012 14:18'!
omgParticulesOn: rawView
	| particules |
	
	"Inspired from http://bl.ocks.org/1062544"
	particules := OrderedCollection new.
	rawView on: ROMouseMove do: [ :event | 
		| newElem |
		newElem := ROElement new + ROCircle.
		newElem extent: 10 @ 10.
		newElem translateTo: (rawView camera realToVirtualPoint: event position).
		particules addFirst: newElem.
		rawView add: newElem.
		rawView signalUpdate.
		(particules size = 70) ifTrue: [ particules last remove.  particules removeLast ].
		].
	
	[ 300 timesRepeat: [ particules do: [ :el | (el extent: (el extent + (3 @ 3))) ]. rawView signalUpdate. (Delay forMilliseconds: 30 ) wait ] ] fork.! !

!ROExample methodsFor: 'free style' stamp: 'VanessaPena 8/23/2012 16:11'!
pointillism

"
	Idea from  Pointillism
	by Daniel Shiffman
	at Prossesing

	self new pointillism
 
"

	|view elto|
	view := ROView new.
	self pointillismOn: view.	
	view open.! !

!ROExample methodsFor: 'free style' stamp: 'VanessaPena 8/23/2012 16:10'!
pointillismOn: rawView
	|elto|
	rawView on: ROMouseMove do:[:event | 
		(1 to: 5) do:[:i |
			elto := ROElement new.
			elto size: (event position x / 10).
			elto + (ROCircle color: (Color r: (155 atRandom / 255) g: (155 atRandom / 255) b: (155 atRandom / 255) alpha: 0.5)).
			elto translateTo: (500 atRandom @ 500 atRandom).
			rawView add: elto.
			rawView signalUpdate.
		]
	].! !

!ROExample methodsFor: 'interaction' stamp: ''!
popup

	"
	self new popup
	"
	
	| view |
	view := ROView new.
	view add: ((ROElement spriteOn: 'world')
				+ (ROLabel text: 'hello')
				@ (ROPopup)).
	view open.! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:37'!
popupOn: rawView
	rawView add: ((ROElement spriteOn: 'world')
				+ (ROLabel text: 'hello')
				@ (ROPopup)).
! !

!ROExample methodsFor: 'interaction' stamp: ''!
popupView

	"
	self new popupView 
	"

	| element view popupView |
	
	popupView := ROView new.
	popupView add: ((ROElement new extent: 50@60)+ (ROBox new color: Color blue)).
	
	view := ROView new.
	element := ROElement sprite.
	element @ (ROPopupView new view: popupView).
	view add: element.
	view open! !

!ROExample methodsFor: 'software' stamp: 'AlexandreBergel 7/14/2012 15:21'!
punchChart
	"inspired from http://raphaeljs.com/github/dots.html
	self new punchChart
	"

	| rawView |
	rawView := ROView new.
	self punchChartOn: rawView.
	rawView @ RODraggable.
	rawView open! !

!ROExample methodsFor: 'software' stamp: 'AlexandreBergel 7/14/2012 18:15'!
punchChartOn: rawView
	| classes metrics maxMetrics rx ry elements initialX initialY spaceX spaceY spaceYFromAxis spaceXFromAxis |

	"inspired from http://raphaeljs.com/github/dots.html"

	"Gathering the data"
	classes := OrderedCollection new.
	classes add: Object; add: Behavior; add: Metaclass; add: Collection; add: OrderedCollection.
	metrics :=  #(#numberOfMethods #numberOfVariables #numberOfSubclasses).
	
	"Visualzing the data"
	maxMetrics := metrics collect: [ :m | classes inject: 0 into: [:max :el | max max: (m roValue: el) ] ].
	initialX := 30.
	initialY := 60.
	spaceX := 100.
	spaceY := 30.
	spaceYFromAxis := 20.
	spaceXFromAxis := 20.
	rx := initialX.
	ry := initialY.
	elements := OrderedCollection new.
	
	classes do: [:cls | 
		ry := initialY.
		rx := rx + spaceX.
		
		metrics with: maxMetrics do: [ :m :mMax |
						| v |
						ry := ry + spaceX.
						v := m roValue: cls.
						elements add: 
							((ROElement on: cls)
							
								translateTo: rx @ ry;
								+ (ROCircle color: ((Color green mix: Color red shades: 30) at: (v max: mMax in: (1 to: 30))));
								@ (ROPopup text: v printString);
								 radius: ((m roValue: cls) max: mMax in: (5 to: 10))) ].
		ry := ry + spaceYFromAxis.
		elements add: ((ROLabel elementOn: cls name) center: rx @ ry). ].
	
	ry := initialY.
	rx := rx + spaceX.
	rx := rx + spaceXFromAxis.
	metrics do: [ :m | 
		ry := ry + spaceX.
		elements add: ((ROElement labelOn: m) center: rx @ ry) ].
				
	rawView addAll: elements.
! !

!ROExample methodsFor: 'free style' stamp: 'AlexandreBergel 5/7/2012 11:54'!
recursionProcessing
	"
	self new recursionProcessing
	"
	| view b |
	view := ROView new.

	b := [:x :radius :level | 
		| tt |
		tt := 126 * level / 4.0.
		view  add: ((ROElement new center: x@100 radius: radius)
							addShape: (ROCircle new color: (Color gray256: tt) )).
		(level > 1) ifTrue: 
			[
				b value: (x - (radius / 2)) value: radius / 2 value: (level - 1).
				b value: (x + (radius / 2)) value: radius / 2 value: (level - 1).
			]
	].
	b value: 126 value: 170 value: 6.
	view openInWindow ! !

!ROExample methodsFor: 'free style' stamp: 'AlexandreBergel 4/17/2012 17:14'!
recursionProcessing2
	"
	self new recursionProcessing2
	"
	| view b |
	view := ROView new.

	self drawCircle: view x: 126 radius: 170 level: 6.
	view open
! !

!ROExample methodsFor: 'free style' stamp: 'AlexandreBergel 7/14/2012 18:15'!
recursionProcessingOn: rawView
	| b |

	b := [ :x :radius :level | 
		| tt |
		tt := 126 * level / 4.0.
		rawView  add: ((ROElement new center: x@100 radius: radius)
							addShape: (ROCircle new color: (Color gray256: tt) )).
		(level > 1) ifTrue: 
			[
				b value: (x - (radius / 2)) value: radius / 2 value: (level - 1).
				b value: (x + (radius / 2)) value: radius / 2 value: (level - 1).
			]
	].
	b value: 126 value: 170 value: 6.
! !

!ROExample methodsFor: 'interaction' stamp: ''!
resizableCircle
	"
	self new resizableCircle
	"

	| view circles colors |
	view := ROView new.
	colors := Color wheel: 6 alpha: 0.7.
 
	circles := (1 to: 6) with: colors collect: [:i :c | 
		ROElement new
			@ RODraggable;
			+ (ROCircle color: c);
			translateTo: (i * 60) @ (i \\ 3 * 50 + 50);
			extent: 50@50.
	].
	view on: ROMouseMove do: [:event | 
		circles do: [:c | | t |
			t := ((c bounds center - event position ) r / 2) max: 40.
			c size: t ].
		view signalUpdate  ].
	
	view addAll: circles.
	view open.

! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:19'!
resizableCircleOn: rawView
	| circles colors |
	
	colors := Color wheel: 6 alpha: 0.7.
 
	circles := (1 to: 6) with: colors collect: [:i :c | 
		ROElement new
			@ RODraggable;
			+ (ROCircle color: c);
			translateTo: (i * 60) @ (i \\ 3 * 50 + 50);
			extent: 50@50.
	].
	rawView on: ROMouseMove do: [:event | 
		circles do: [:c | | t |
			t := ((c bounds center - event position ) r / 2) max: 40.
			c size: t ].
		rawView signalUpdate  ].
	
	rawView addAll: circles.
! !

!ROExample methodsFor: 'interaction' stamp: 'BenComan 10/14/2012 23:20'!
rubberBand
	"
	self new rubberBand
	"
	| view |
	view := ROView new.
	self rubberBandOn: view.
	view open! !

!ROExample methodsFor: 'interaction' stamp: 'BenComan 10/15/2012 22:24'!
rubberBandOn: rawView
	| rubberband |
	"Drag edges from '1x' to '2x' then from '2x' to '3x' etc..."
   	rubberband := RORubberBand new
		targeting:   
		( 	ROSelection new 
				for: [ :source :target | source model first asInteger + 1 = target model first asInteger ];
				onInclusion: [ :element | ROHighlightElement on: element color: Color blue ];
				onExclusion: [ :element | ROUnhighlightElement on: element ]
  		);                         
		onDrop: 
		[	:newEdgeRaw |
                   RORemoveEdge edgesTo: (newEdgeRaw to). 
                   rawView add: (newEdgeRaw + ROLine).
                   ROTreeLayout on: rawView elements. 
		]. 

	1 to: 4 do: 
	[	:num | 
		$a asInteger to: $d asInteger do: 
		[	:charInt | | element |
			element := (ROElement on: num asString , charInt asCharacter asString) + ROBorder red + ROLabel.
			element extent: 40 @ 40.
			element @ rubberband.
			rawView add: element.
		]
	].
	ROTreeLayout on: rawView elements.! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/7/2012 11:54'!
scatterPlot
	"
	self new scatterPlot
	"

	| view elements |
	view := ROView new.
	elements := ROElement forCollection:  #(#(1 2) #(100 50) #(60 20)).
	elements do: [:el | el 
						addShape: (ROCircle);
						size: 30 ].
	view addAll: elements.
	ROScatterplotLayout new 
		x: #first ; y: #second;
		applyOn: elements.
	view open.! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 7/14/2012 18:41'!
scatterPlotOn: rawView
	| elements |
	elements := ROElement forCollection:  #(#(1 2) #(100 50) #(60 20)).
	elements do: [:el | el 
						addShape: (ROCircle);
						size: 30 ].
	rawView addAll: elements.
	ROScatterplotLayout new 
		x: #first ; y: #second;
		applyOn: elements.
	! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 6/9/2012 18:42'!
scrollbar

	| view els stack |
	view := ROView new.
	view add: ROElement sprite.

	els := ROElement spritesOn: (1 to: 500).
	els do: [ :el | el + ROLabel @ ROPopup ].
	view addAll: (ROGridLayout  on: els).
	view @ RODraggable .

	stack := ROViewStack new.
	stack addView: view.
	stack @ ROScrollbable.
	stack open.! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 6/10/2012 15:59'!
stack
	"
	self new stack
	"
	
	| view1 label1 stack view2 label2 view3 label3 |
	view1 := ROView new.
	label1 := (ROElement on: 'view 2') + ROLabel @ ROLightlyHighlightable.
	label1 on: ROMouseClick do: [ :event | stack replaceFirstBy: view2 ].
	view1 add: label1.
	view1 addAll: (ROGridLayout on: (ROElement spritesOn: (1 to: 20))).
	
	view2 := ROView new.
	label2 := (ROElement on: 'view 3') +ROLabel @ ROLightlyHighlightable.
	label2 on: ROMouseClick do: [ :event | stack replaceFirstBy: view3 ].
	view2 add: label2.
	view2 addAll: (ROCircleLayout on: (ROElement spritesOn: (1 to: 20))).

	view3 := ROView new.
	label3 := (ROElement on: 'view 1') +ROLabel @ ROLightlyHighlightable.
	label3 on: ROMouseClick do: [ :event | stack replaceFirstBy: view1 ].
	view3 add: label3.
	view3 addAll: (ROHorizontalLineLayout on: (ROElement spritesOn: (1 to: 20))).

	stack := ROViewStack new addFirst: view1.
	stack open! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 6/9/2012 18:42'!
treeLayout 
	"
	self new treeLayout
	"
	
	| view elements edges |
	view := ROView new.
	elements := ROElement spritesOn: (1 to: 5).
	view addAll: elements.
	view addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	
	ROTreeLayout on: elements.

	view open.! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 7/14/2012 18:42'!
treeLayoutOn: rawView
	| elements edges |
	elements := ROElement spritesOn: (1 to: 5).
	rawView addAll: elements.
	rawView addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	
	ROTreeLayout on: elements.
! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:39'!
zooming

	"
	self new zooming
	"
	| view els classes stack |
	view := ROView new.
	self zoomingOn: view.
	view open! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 7/14/2012 18:39'!
zoomingOn: rawView
	| els classes stack |
	
	"We gather what we want to visualize"
	classes := Smalltalk globals allClasses select: [ :c | c name beginsWith: 'RO' ].
	
	"We build the visualization"
	els := ROElement forCollection: classes.
	els do: [:spr |
		spr extent: 50@50. 
		spr + ROBorder red.
		spr @ ROZoomOnClick @ RODraggable 
		].
	rawView addAll: els.
	ROGridLayout on: els.
! !

Object subclass: #ROLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROLayoutTranslator class
	instanceVariableNames: 'defaultTranslator'!

!ROLayoutTranslator commentStamp: 'AlexandreBergel 11/28/2011 10:48' prior: 0!
ROLayoutTranslator is used by the layout to translate object. Each layout can be parametrized with a translator to produce a visual effect.

I am an abstract class!

ROLayoutTranslator class
	instanceVariableNames: 'defaultTranslator'!

ROLayoutTranslator subclass: #ROAbsorbLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbsorbLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	"Does not perform the translation. Used in testing essentially"! !

ROLayoutTranslator subclass: #RODirectLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RODirectLayoutTranslator classSide methodsFor: 'testing' stamp: ''!
isDefault
	^ true! !

!RODirectLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	element translateTo: newPosition! !

!ROLayoutTranslator classSide methodsFor: 'accessing' stamp: ''!
default
	"Return the default translator, the one used in the layouts"

	defaultTranslator ifNotNil: [ ^ defaultTranslator ].
	^ defaultTranslator := self defaultClass new! !

!ROLayoutTranslator classSide methodsFor: 'accessing' stamp: ''!
defaultClass
	^ self withAllSubclasses detect: #isDefault! !

!ROLayoutTranslator classSide methodsFor: 'testing' stamp: ''!
isDefault
	^ false! !

!ROLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	self subclassResponsibility ! !

ROLayoutTranslator subclass: #ROSmoothLayoutTranslator
	instanceVariableNames: 'move'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSmoothLayoutTranslator methodsFor: 'testing' stamp: ''!
hasCompleted
	"Return true if all the translation has completed"
	^ move hasCompleted! !

!ROSmoothLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	move := ROLinearMove new
			nbCycles: 180;
			for: element until: newPosition! !

Object subclass: #ROMondrianExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Example'!

!ROMondrianExample commentStamp: '<historical>' prior: 0!
Example for the Mondrian builder!

!ROMondrianExample classSide methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:48'!
postScript
	^ '
"-------------"
"-------------"
"Below is the initiation of the menu and opening the visualization"
ROEaselMorphic new populateMenuOn: view.
view open'! !

!ROMondrianExample classSide methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:34'!
preamble
	^ 'rawView := ROView new.
view := ROMondrianViewBuilder view: rawView.'! !

!ROMondrianExample classSide methodsFor: 'easel' stamp: 'AlexandreBergel 7/14/2012 15:34'!
preambleVariables
	^ #('view' 'rawView')! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 10/3/2012 18:26'!
addingNameOn: view

"Hovering the mouse on a class give a name to its superclass"
view shape rectangle size: 10. 
view interaction on: ROMouseEnter do: [ :event |  
	| elSuperclass |
	elSuperclass := view raw elementFromModel: event model superclass.
	elSuperclass notNil 
		ifTrue: [ ROAddName toElement: elSuperclass ] ].
 
view interaction on: ROMouseLeave do: [ :event | 
	| elSuperclass |
	elSuperclass := view raw elementFromModel: event model superclass.
	elSuperclass notNil 
		ifTrue: [ ROAddName removeFrom: elSuperclass ] ].
 
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.
! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/28/2012 21:42'!
attachPoint
	"
	self new attachPoint
	"
	| view |
	view := ROMondrianViewBuilder new.
	self attachPointOn: view.
	view open! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/28/2012 21:41'!
attachPointOn: view
	view nodes: (ROAttachPoint subclasses) forEach: [ :cls |
		view shape rectangle size: 20.
		view nodes: #(1 2 3).
		view shape line attachPoint: cls new.
		view edgesFromAssociations: (Array with: 1-> 2 with: 2 -> 3 with: 1 -> 3).
		view circleLayout
	].! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:01'!
bottomFlowLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view bottomFlowLayout.
	 ! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 9/20/2012 12:09'!
centeredTextOn: view

	view shape rectangle; withCenteredText;  width: 180.
	view node: 'centered text'.

	view shape rectangle; withText;  width: 180.
	view node: 'left text'.
! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 8/3/2012 11:49'!
chooseLayoutOn: view

	(ROGridLayout on: (
	 ((OrderedCollection new) 
		add: ROTreeLayout; 
		add: ROGridLayout; 
		add: ROForceBasedLayout; 
		add: ROCircleLayout; 
		add: ROHorizontalTreeLayout;
		add: ROVerticalLineLayout; 
		add: ROHorizontalLineLayout; 
		add: ROSugiyamaLayout; 
		add: ROBottomFlowLayout; 
		add: ROFlowLayout; 
		add: RORadialTreeLayout; 
		add: ROScatterplotLayout;
		yourself) collect: [ :layoutClass | 
			| button |
			button := ((ROElement on: layoutClass name)  + ROLabel @ ROLightlyHighlightable + ROBorder).
			button on: ROMouseLeftClick do: [ :event | 
				layoutClass new 
					translator: (ROSmoothLayoutTranslator new);
					applyOn: (view raw elementsFromModels: (1 to: 5)) ].
			view stack firstView add: button.
			button ])) do: [ :button | button translateBy: 0 @ 380 ].

	
	"We start with a very simple graph"
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edgesFromAssociations:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself).
	"We use circle layout as default layout"
	view circleLayout executeOnElements: (view raw elementsFromModels: (1 to: 5)).
	! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:02'!
circleLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view circleLayout.
	 ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:28'!
clickToFocus
	"
	self new clickToFocus
	"
	
	| builder | 
	builder := ROMondrianViewBuilder titled: 'Finding nodes'.
	self clickToFocusOn: builder.	
	builder open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 9/29/2012 14:50'!
clickToFocusOn: view
		
	view interaction 
		on: ROMouseClick do:  [ :event |  
			ROFocusView on: event element ].
	view shape rectangle size: 30.
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 9/26/2012 19:44'!
coloredSystemComplexity
	"
	self new systemComplexity
	"

	| view elements  edge |	
		
	view := ROMondrianViewBuilder new.
	self coloredSystemComplexityOn: view.
	view open.
	^ view! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 9/26/2012 19:44'!
coloredSystemComplexityOn: view
	view shape rectangle 
		width:  [ :cls | cls numberOfVariables * 7 ];  
		height: #numberOfMethods;
		fillColor: (RONColorLinearNormalizer 
					inContext: (Collection withAllSubclasses) 
					withCommand: #numberOfLinesOfCode 
					lowColor: Color green  highColor: Color red).
		
	view interaction popupText: [ :cls | 
		cls name, (String with: Character cr), 
		cls methods size printString, ' methods', (String with: Character cr), 
		cls instVarNames size printString, ' variables', (String with: Character cr),
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:49'!
command

	"
	self new command
	
	An example that shows the commands that can be defined on the builder. Useful to add menus.
	"

	| view |
	view := ROMondrianViewBuilder new.
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
	
	view addMenu: 'Inspect stack' callBack: [ :stack | stack inspect.  ].

	view addMenu: '+Node Background' callBack: [ :stack | 
		stack firstView add: (ROElement sprite translateTo: 200 atRandom @ 200 atRandom).
		stack signalUpdate ].

	view addMenu: '+Node Foreground' callBack: [ :stack | 
		| el |
		el := ROElement sprite translateTo: 200 atRandom @ 200 atRandom.
		(el getShape: ROBorder) color: Color blue. 
		stack add:  el.
		stack signalUpdate ].
	
	view addMenu: 'Zoom in' callBack: [ :stack | ROZoomInMove new on: stack firstView ].
	view addMenu: 'Zoom out' callBack: [ :stack | ROZoomOutMove new on: stack firstView ].

	view open.! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/25/2012 17:01'!
edgesDefinedOutsideOn: view
	
	"The edges is defined outside the inner nodes. The layout takes those edges into account"
	view nodes: #(1 2) forEach: [ :each |
		view shape label.
		view nodes: (Array with: each * 10 with: (each * 100)). 
		view treeLayout.
		].
	view edgesFromAssociations: (Array with: 10 -> 100 with: 20 -> 200).! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 23:53'!
explicitIdentityNormalizer2On: view

	 		
	view shape rectangle size: 30; fillColor: 
		(RONExplicitIdentityNormalizer 
						withCommand: #yourself 
						withColors: (Array with: Color blue with: Color white with: Color red)
						withDefaultColor: Color pink).
	view nodes: #(foo bar zork foo bar zork).! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 23:53'!
explicitIdentityNormalizerOn: view

	 		
	view shape rectangle size: 30; fillColor: ( RONExplicitIdentityNormalizer
						withCommand: #yourself
						withColors:  (Array with: Color blue with: Color white with: Color red)
						withDefaultColor: Color pink).
	view nodes: (5 to: 10).! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:01'!
flowLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view flowLayout.
	 ! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/17/2012 20:36'!
forceBasedLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view forceBasedLayout.
	 ! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 08:49'!
gridLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view gridLayout.
	 ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:13'!
highlight
	"
	self new highlight
	"
	| view |

	view := ROMondrianViewBuilder new.
	self highlightOn: view.
	view open. ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:29'!
highlightInnerNodes
	" 
	self new highlightInnerNodes
	"

	| view |
	view := ROMondrianViewBuilder new.
	self highlightInnerNodesOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/3/2012 09:38'!
highlightInnerNodesOn: view

	view nodes: (1 to: 5) forEach: [:each |    
		view interaction highlightNodesWhenOver: [ :node | Array with: node ].    
		view shape rectangle withText; size: 20.    
		view nodes: (1 to: each).    
		view gridLayout ].
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 6/9/2012 15:19'!
highlightOn: view
	view interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := view raw elementsFromModels: n element model allSubclasses.
		ROHighlighter new on: nodes in: view raw  ].

	view interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := view raw elementsFromModels: n element model allSubclasses.
		ROHighlighter new
			color: Color black;
			on: nodes in: view raw  ].
	
	(view nodes: (Collection withAllSubclasses)).
	view edgesFrom: #superclass.
	
	view treeLayout. ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 4/18/2012 16:35'!
highlightSeveralNodes
	"
	self new highlightSeveralNodes
	"

	| view nodes |
	view := ROMondrianViewBuilder new.
	view interaction highlightWhenOver: [:v | ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)  ].
	view shape rectangle 
		width: 40;
		height: 30;
		borderColor: Color black; borderWidth: 2.
	nodes := view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	
	
	view open.
	! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 10/1/2012 09:42'!
horizontalTreeLayoutLayeredOn: view

view shape rectangle width: #yourself.
view nodes: (1 to: 100).
view edgesFrom: [:x | x // 2  ].
view horizontalTreeLayout layered.
! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 10/1/2012 09:42'!
horizontalTreeLayoutNoLayeredOn: view

view shape rectangle width: #yourself.
view nodes: (1 to: 100).
view edgesFrom: [:x | x // 2  ].
view horizontalTreeLayout.
! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/14/2012 10:43'!
identityNormalizer2On: view

	view shape rectangle size: 30; fillColor: RONIdentityNormalizer beginingAtRed.
	view nodes: #(foo bar zork).
! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 16:23'!
identityNormalizerOn: view

	view shape rectangle size: 30; fillColor: RONIdentityNormalizer new.
	view nodes: (1 to: 30) , (30 to: 1).
! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/2/2012 18:30'!
labeledRectangle
	"
	self new labeledRectangle
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	self labeledRectangleOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/3/2012 09:38'!
labeledRectangleOn: view
	
	view shape rectangle withText.
	view node: 'With rectangle'.
	
	view shape label.
	view node: 'Without rectangle'.
! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 9/25/2012 15:27'!
lineWidthOn: view

	view shape rectangle size: 50.
	view nodes: #( 1 2 ).
	view shape line width: 4.
	
	view interaction popupText: 'edge!!'.
	view edgeFromAssociation: 1 -> 2.
! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 23:54'!
linearNumberOn: view

	view shape rectangle size: ((RONumberLinearNormalizer inContext: #(1 2 3 4 3 2 1)) scale: 50).
	view nodes: #(1 2 3 4 3 2 1).

"The script above has the same effect than:
| maxPixel maxValue |
maxPixel := 50.
maxValue := 4.
view shape rectangle size: [:v | (v * maxPixel / maxValue) asInteger ].
view nodes: {1 . 2 . 3 . 4 . 3 . 2 . 1}
"! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 5/2/2012 18:31'!
lines
	"
	self new lines
	"
	| view |
	view := ROMondrianViewBuilder new.
	self linesOn: view.
	view open! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 5/3/2012 09:38'!
linesOn: view
	view shape label.
	view nodes: #(1 2 3 4 5 6 7 8 9 10).
	view edges: #(1 2 3 4 5 6 7 8 9 10) from: #yourself toAll: (#(1 2 3 4 5 6 7 8 9 10) select: #odd).
	view circleLayout.! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/2/2012 16:24'!
lowerBoundNormalizerOn: view

	"Color normalizer use white as the lower bound. But it could be any color"
	view shape rectangle size: 30;
		fillColor: (RONColorLinearNormalizer 
					inContext: (1 to: 10) lowColor: Color gray highColor: Color black).
		
	view nodes: (1 to: 10).! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/28/2012 22:44'!
makingInvisibleEdgesOn: view

	"The mondrian builder adds a shape per default. But this can be easily bypassed by using the low level facilities of Roassal"
	view nodes: Collection withAllSubclasses.
	(view edgesFrom: #superclass) do: [ :edge | edge - ROEdge ].
	view treeLayout.
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:31'!
menuOnNodes

	"
	self new menuOnNodes
	Right click on a node gives a menu
	"

	| view |
	
	view := ROMondrianViewBuilder new.
	self menuOnNodesOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 10/2/2012 20:31'!
menuOnNodesOn: view
	view shape rectangle size: 15.
	view interaction 
		item: 'inspect element' action: #inspect;
		item: 'inspect model' action: [ :el | el model inspect ];
		item: 'browse element class' action: [ :el | el model browse ].
	view nodes: (1 to: 5).
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/3/2012 19:21'!
methodComplexity

	"
	self new methodComplexity 
	"
	| view d connectedMethods disconnectedMethods methodShape |
	view := ROMondrianViewBuilder titled: 'Method Complexity'.
	self methodComplexityOn: view.
	view open! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/3/2012 19:15'!
methodComplexityFor: classes on: view

	| d connectedMethods disconnectedMethods methodShape |
	
	
	view nodes: classes forEach: [ :cls |
		d := IdentityDictionary new.
		cls methods do: [ :cm | d at: cm selector put: cm messages ].
		d copy keysAndValuesDo: [ :key :messages | d at: key put: (messages intersection: d keys) ].
		
		connectedMethods := d keys select: [ :k | (d at: k) notEmpty ].
		disconnectedMethods := d keys select: [ :k | (d at: k) isEmpty ].
	
		"Connected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: connectedMethods.
			view edges: connectedMethods from: #yourself toAll: [ :cm | d at: cm ].
			view sugiyamaLayout. 
		].
	
		"Disconnected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: disconnectedMethods.
			view gridLayout.
		].

	].
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 10/1/2012 12:30'!
methodComplexityOn: view
	| classesToAnalyze |
	
	"We analyze only the classes of Roassal"
	classesToAnalyze := (Object allSubclasses select: [ :cls | cls name beginsWith: 'RO' ]).
	view nodes: classesToAnalyze forEach: [ :cls |
		| d connectedMethods disconnectedMethods methodShape nativeUtil |
		d := IdentityDictionary new.
		nativeUtil := RONativeExampleUtility current .
		(nativeUtil getMethodsForClass: cls) do: [ :cm | d at: cm selector put: cm messages ].
		d copy keysAndValuesDo: [ :key :messages | d at: key put: (messages intersection: d keys) ].
		
		connectedMethods := d keys select: [ :k | (d at: k) notEmpty ].
		disconnectedMethods := d keys select: [ :k | (d at: k) isEmpty ].
	
		"Connected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: connectedMethods.
			view edges: connectedMethods from: #yourself toAll: [ :cm | d at: cm ].
			view sugiyamaLayout. 
		].
	
		"Disconnected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: disconnectedMethods.
			view gridLayout.
		].

	].
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 7/30/2012 00:01'!
middleArrowOnEdgesOn: view
	view shape label.
	view nodes: #(1 2 3 ). 
	
	view shape arrowedLineWithOffset: 0.5.
	view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3 with: 3 -> 1).
	view circleLayout.
! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:34'!
multilineLabel
	"
	self new multilineLabel
	"

	| view |
	view := ROMondrianViewBuilder new.
	self multilineLabelOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:34'!
multilineLabelOn: view
	view shape label text: [:m | 'line1
	  line2
		line3    ']; color: Color blue.
	view node: $a.! !

!ROMondrianExample methodsFor: 'normalizers' stamp: 'AlexandreBergel 7/4/2012 00:04'!
multipleColorLinearOn: view
	view shape rectangle size: 60; fillColor: (ROMultipleColorLinearNormalizer 
					valueRange: #(5 10 15) colorRange: (Array with: Color blue with: Color white with: Color red)).
	view nodes: (5 to: 15).		! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:35'!
nodraggable 
	"
	self new nodraggable
	"

	| view |
	view := ROMondrianViewBuilder new.
	self nodraggableOn: view.
	
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:35'!
nodraggableOn: view
	view interaction nodraggable.
	view shape label.
	view node: 'Cannot be dragged'.
	
	view shape label.
	view node: 'Can be dragged'.! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 8/22/2012 18:58'!
orthoHorizontalWithArrowLineOn: view

	view nodes: 
	( Array 
		with: [ROHorizontalArrow new offset: 0]
		with: [ROReversedHorizontalArrow new offset: 0]
		with: [ROHorizontalArrow new offset: 1] 
		with:  [ROReversedHorizontalArrow new offset: 1]
	)
	forEach: 
	[ 	:exampleBlock | 
		view shape rectangle size: 20.
		view nodes: (1 to: 16). 
		view shape: (ROOrthoHorizontalLineShape new add: exampleBlock value ).
		view edgesFrom: [ :i | (i / 4) ceiling ].
		view horizontalTreeLayout verticalGap: 10. 
	].
	view horizontalLineLayout.
! !

!ROMondrianExample methodsFor: 'edges' stamp: 'AlexandreBergel 7/30/2012 00:02'!
orthoVerticalLineOn: view

	view shape rectangle size: 20.
	view nodes: (1 to: 20). 
	view shape: (ROOrthoVerticalLineShape new).
	view edgesFrom: [ :i | i \\ 3 ].
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 8/22/2012 18:59'!
orthoVerticalWithArrowLineOn: view

	view nodes: 
	(Array 
		with:  [ROVerticalArrow new offset: 0]
		with: [ROReversedVerticalArrow new offset: 0]
		with: [ROVerticalArrow new offset: 1]
		with: [ROReversedVerticalArrow new offset: 1]
	) 
	forEach: 
	[ 	:exampleBlock | 
		view shape rectangle size: 20.
		view nodes: (1 to: 16). 
		view shape: (ROOrthoVerticalLineShape new add: exampleBlock value ).
		view edgesFrom: [ :i | (i / 4) ceiling ].
		view treeLayout horizontalGap: 10. 
	].
	view verticalLineLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: ''!
polymetricViewWithMethods
	"
	self new polymetricViewWithMethods
	"

	| view classes elements  edge nodes |
	"Gathering the data"
	classes := ROTest withAllSubclasses.
	
	"Visualzing the data"
	view := ROMondrianViewBuilder new.
	view shape rectangle 
		width: #numberOfVariables; 
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within: classes.
	nodes := view nodes: classes.
	nodes do: [:n | n @ ROZoomOnClick ].
	
	view edgesFrom: #superclass.
	view treeLayout.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 4/30/2012 17:29'!
popupAndNoPopup
	"
	self new popupAndNoPopup
	"
	
	| view |
	view := ROMondrianViewBuilder titled: 'Popup and No popup'.
	view interaction noPopup.
	view shape label.
	view node: 'I have _no_ popup'.
	
	view shape label.
	view node: 'I have a popup'.

	view interaction noPopup.
	view shape label.
	view node: 'I have _no_ popup'.

	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: ''!
popupView
	"
	self new popupView
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	view shape label.
	view interaction popupView: [ :entity :myView | 
		myView nodes: entity withAllSuperclasses.
		myView nodes: entity allSubclasses.
		myView edgesFrom: #superclass.
		myView treeLayout.
	].
	(view nodes: (Array with: ROEvent with: Collection)).
	view open
! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/3/2012 09:43'!
popupViewOn: view

	view shape label.
	view interaction popupView: [ :entity :myView | 
		myView nodes: entity withAllSuperclasses.
		myView nodes: entity allSubclasses.
		myView edgesFrom: #superclass.
		myView treeLayout.
	].
	(view nodes: (Array with: ROEvent with: Collection)).
	
! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/21/2012 23:42'!
scatterLayoutOn: view

	view node: 'scatter layout' forIt: [
		view nodes: #((10 5) (20 50) (2 4) (60 20)).
		view layout: (ROScatterplotLayout new
						upSideDown;
						scaleFactor: 2;
						x: #first;
						y: #second) ].! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 10/18/2012 16:56'!
shrikingSizeOn: view
	| outterNode |
	
	outterNode := view node: 'hello' forIt: [ 
	view shape rectangle withText.
	view interaction on: ROMouseClick do: [ :event | 
		outterNode remove: event element. 
		ROHorizontalLineLayout on: outterNode elements.
		
		ROShrikingSize on: outterNode. 
		event element signalUpdate  ].
	 
	view nodes: (1 to: 20).
	].
	
	"Make the outter node shrink when it can"
	outterNode resizeStrategy:  ROShrinkingParent new.! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:16'!
simpleHierarchy
	"
	self new simpleHierarchy 
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	self simpleHierarchyOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:15'!
simpleHierarchyOn: view
	
	view shape rectangle size: 20.
	view nodes: (1 to: 20).
	view shape line.
	view edgesFrom: [ :i | i \\ 3 ].
	view treeLayout.
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 10/3/2012 19:08'!
statusBarOn: view
| statusBar |

statusBar := ROElement new + ROLabel + ROBox white.
view stack add: statusBar.
statusBar translateTo: 0 @ 480.

view interaction on: ROMouseEnter do: [ :event | 
	statusBar model: event element model.
].
view shape rectangle size: 10.
view nodes: (Collection withAllSubclasses).
view edgesFrom: #superclass.
view treeLayout.! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/4/2012 09:27'!
step1CreatingNodesOn: view

	"A mondrian view is composed of nodes and egdes. 
	In this first step, we will have the simplest visualization possible. 
	A list of nodes representing each subclass of the class Collection."
	view nodes: Collection withAllSubclasses.
	"Since no shape is defined, each node is represented as a small white square, with a black border.
	The size of the square is 5 pixels wide.
	
	No layout is specified, therefore the horizontal line layout is used per default.
	All the nodes are lined up horizontally.
	
	Wave the mouse over a node, a popup will tell you which node you are pointing to.
	You can individually drag and drop each node.
	The whole view may be move around by dragging and dropping where there is no node, in the background."! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/4/2012 10:23'!
step2AddingEdgesOn: view

	"We will now add edges to represent the superclass hierarchy of the collection classes."
	view nodes: Collection withAllSubclasses.
	
	"The message #edgesFrom: tells Roassal to draw edges between each node. The message #superclass is sent to each nodes (i.e., each subclass of Collection). A line is draw for each couple (subclassOfCollection -> subclassOfCollection superclass)."
	view edgesFrom: #superclass.
	
	"We need to provide a layout to structure the visualization. A tree layout is appropriate in Smalltalk since a class has only one superclass."
	view treeLayout.
	"The tree layout places a superclass aboves its subclasses.
	
	The Easel offers a number of actions. Zoom in, zoom out and find objects. Really handy and you have many nodes and you are looking for a specific node.
	"! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/12/2012 21:56'!
step3DefiningShapeOn: view

	"Up to now, all the boxes have the same graphical aspect (i.e., a 5 pixels white square). 
	Each node may particularize its shape depending on the object that is rendered."
	
	"We will now define a new shape in which the height represents the amount of mehtods the class has,
	Its width is the amount of variables the class defines."
	view shape rectangle 
		width: [ :cls | cls instVarNames size ]; 
		height: [ :cls | cls methods size ].
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:01'!
step4ColoringShapeOn: view

	"Shapes may be colored in many different ways. "
	
	"Let's paint with a blue border the classes for which the word Array appear in their name.
	Classes with Hash in their name will have a green border."
	
	"Classes are painted in veryLightGray. Classes with more than 20 methods are in gray.
	 The one with more than 30 methods are in back"
	view shape rectangle 
		width: [ :cls | cls instVarNames size * 5 ]; 
		height: [ :cls | cls methods size ];
		if: [ :cls | '*Array*' match: cls name ] borderColor: Color blue;
		if: [ :cls | '*Hash*' match: cls name ] borderColor: Color green;
		
		fillColor: Color veryLightGray;
		if: [ :cls | cls methods size > 20 ] fillColor: Color gray;
		if: [ :cls | cls methods size > 30 ] fillColor: Color black.
		
		
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:38'!
step5LinearFillColorOn: view

	"In the previous step, we have related the amount of methods a class may have with the darkness of its color:
	many methods is associated to black and few methods with light gray. In chromatography, the lightness (or darkness) of a color is called its 'value'.
	Relating a metric (e.g., the number of methods) with the color value is a common behavior that deserves its own facilities. "

	"In this example, we relate the number of lines of code a class has with its color value."
	view shape rectangle 
		width: [ :cls | cls instVarNames size * 5 ]; 
		height: [ :cls | cls methods size ];
		linearFillColor: #linesOfCode within: Collection withAllSubclasses.
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
	
	"linearFillColor: aBlock within: aCollection computes for each node a numerical value using aBlock and associates a gray value.
	The visualization we have obtained is well know in the field of software visualization. It is called 'System Complexity'. More description of this fantastic visualization may be found in the publication 'Polymetric Views -- A Lightweight Visual Approach to Reverse Engineering', TSE 29(9), 2003."
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:43'!
step6NestingNodesOn: view

	"Until now, the only relation between nodes that we have expressed is linking them with an edge. Another way to relate nodes is to nest them. A node acts as a view in which nodes and edges may be added."

	"Methods may be added within a class using nodes:forEach:"
	view nodes: Collection withAllSubclasses forEach: [ :aClass |
		view nodes: aClass methods.
	].
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 7/14/2012 19:00'!
step7GridLayoutOn: view

	"Having a long horizontal list of methods is not that exciting. They can be ordered a little bit by using a grid layout"
	view nodes: Collection withAllSubclasses forEach: [ :aClass |
		view nodes: aClass methods.
		
		
		"The amount of space between each nodes may be specified using gapSize:. "
		view gridLayout gapSize: 2.
	].
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 7/14/2012 19:00'!
step8PaintingMethodsOn: view


	"We will now paint the methods according to their amount of lines of code "
	
	view nodes: Collection withAllSubclasses forEach: [ :aClass |
		
		"The color of an element may be conditionally picked. "
		view shape rectangle
				if: [ :cm | cm numberOfLinesOfCode > 5 ] fillColor: Color orange;
				if: [ :cm | cm numberOfLinesOfCode > 10 ] fillColor: Color red.
				
		view nodes: (aClass methods 
						asSortedCollection: [ :m1 :m2 | m1 numberOfLinesOfCode > m2 numberOfLinesOfCode]).
		view gridLayout gapSize: 2.
	].
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/3/2012 09:46'!
systemComplexity
	"
	self new systemComplexity
	"

	| view elements  edge |	
		
	view := ROMondrianViewBuilder new.
	self systemComplexityOn: view.
	view open.
	^ view! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 4/29/2012 10:29'!
systemComplexityFor: classes
	"
	self new systemComplexityFor: Morph withAllSubclasses
	"

	| view elements  edge |	
		
	view := ROMondrianViewBuilder new.
	view shape rectangle 
		width: #numberOfVariables; 
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within: classes.
		
	view interaction popupText: [ :cls | 
		cls name, String cr, 
		cls methods size printString, ' methods', String cr, 
		cls instVarNames size printString, ' variables', String cr,
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: classes.
	view edgesFrom: #superclass.
	view treeLayout.
	view open.
	^ view! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 7/14/2012 14:15'!
systemComplexityOn: view
	view shape rectangle 
		width:  [ :cls | cls numberOfVariables * 5 ];  
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within:  Collection withAllSubclasses.
		
	view interaction popupText: [ :cls | 
		cls name, (String with: Character cr), 
		cls methods size printString, ' methods', (String with: Character cr), 
		cls instVarNames size printString, ' variables', (String with: Character cr),
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/17/2012 19:59'!
treeLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view treeLayout.
	 ! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 7/30/2012 00:04'!
umlLikeOn: view

	view shape rectangle withText.
	view nodes: (ROShape withAllSubclasses). 
	view shape: (ROOrthoVerticalLineShape new add: (ROReversedVerticalArrow new offset: 1 )).
	view edgesFrom: #superclass.
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 7/30/2012 00:05'!
umlReallyUpSideDownLikeOn: view

	view shape rectangle withText.
	view nodes: (ROShape withAllSubclasses). 
	view shape: (ROOrthoVerticalLineShape new add: (ROVerticalArrow new offset: 1 )).
	view edgesFrom: #superclass.
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'arrowed edges' stamp: 'AlexandreBergel 7/30/2012 00:05'!
umlUpSideDownLikeOn: view

	view shape rectangle withText.
	view nodes: (ROShape withAllSubclasses). 
	view shape: (ROOrthoVerticalLineShape new add: (ROVerticalArrow new offset: 0 )).
	view edgesFrom: #superclass.
	view treeLayout. 
! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 12:10'!
viewCollectionSubclassesTreeMapsOn: view			
	view interaction 
			item: 'Explore Class' action: #explore;
			item: 'Browse Class' action: #browse;
			popupText: [ :node | node ].
			
	"Set size of all treemaps to 100 by 100."		
	view shape size: 100.
	
	view nodes: Collection subclasses forEach: [ :each |
			| subClasses |
			subClasses := each allSubclasses.
			subClasses notEmpty ifTrue: [
				
				view nodes: subClasses.
				view edgesFrom: #superclass.			
				view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model numberOfLinesOfCode ]).	
			].
	].
	
	view gridLayout. ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 12:34'!
viewCollectionSubclassesTreesOn: view
	view interaction 
			item: 'Explore Class' action: #explore;
			item: 'Browse Class' action: #browse;
			popupText: [ :node | node ].
	
	view shape size: 100.
	
	view nodes: Collection subclasses forEach: [ :each |
			| subClasses |
			subClasses := each allSubclasses.
			subClasses notEmpty ifTrue: [
				view nodes: subClasses.
				view edgesFrom: #superclass.			
				view treeLayout.	
			].
	].
	
	view gridLayout. ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'AlexandreBergel 8/21/2012 10:34'!
viewCollectionTreeMapOn: view
	
	"Adding basic interaction capabilities to nodes: 
	 - Add a menu item which lets one explore the model of the node.
	 - Another menu item which lets one browse the class represented by the node.
	 - Show the node name on hover."
	view interaction 
			item: 'Explore Class' action: #explore;
			item: 'Browse Class' action: #browse;
			popupText: [ :node | node ].
	
	"The treemap should have a dimension of 400 by 400."	
	view shape width: 400; height: 400.

	"Our nodes are all subclasses of Collection."
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	
	"The weights we use to draw the treemap are the classes lines of code (LOC)."
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model numberOfLinesOfCode ]).
	 ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 11:16'!
viewMultipleTreeMapsOn: view
	
	"Make every treemap have a size of 100x100."
	view shape rectangle size: 100.

	view nodes: (1 to: 4) forEach: [ :each |
		| innerNodes innerEdges |
			
		innerNodes := view nodes: (each*10 to: each*40 by: each*5) asOrderedCollection.
		innerEdges := view edgesFromAssociations: 
			(Array with: (each*10) -> (each*10+each*5*1) 
				    with: (each*10) -> (each*10+each*5*2)
				    with: (each*10) -> (each*10+each*5*3)
				    with: (each*10) -> (each*10+each*5*4)
				    with: (each*10) -> (each*10+each*5*5)
				    with: (each*10) -> (each*10+each*5*6)
			).
		view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	].
	view edgesFromAssociations: 
		(Array with: 1 -> 2 with: 1 -> 3 with: 1 -> 4).	

	view treeLayout.
	 ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 11:15'!
viewMultipleTreesOn: view
	
	"Displays the same tree as displayed in viewMultipleTreeMapsOn but as normal tree."
	view nodes: (1 to: 4) forEach: [ :each |
		| innerNodes innerEdges |
			
		innerNodes := view nodes: (each*10 to: each*40 by: each*5) asOrderedCollection.
		innerEdges := view edgesFromAssociations: 
			(Array with: (each*10) -> (each*10+each*5*1) 
				    with: (each*10) -> (each*10+each*5*2)
				    with: (each*10) -> (each*10+each*5*3)
				    with: (each*10) -> (each*10+each*5*4)
				    with: (each*10) -> (each*10+each*5*5)
				    with: (each*10) -> (each*10+each*5*6)
			).
		view treeLayout.
	].

	view edgesFromAssociations: 
		(Array with: 1 -> 2 with: 1 -> 3 with: 1 -> 4).	

	view treeLayout.
! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'AlexandreBergel 8/21/2012 10:35'!
viewSimpleTreeMapOn: view
	
	"Adding basic interaction capabilities: 
	 - Add a menu item which lets one explore the model of a node
	 - Show the node name on hover"	
	view interaction 
		item: 'Explore Element' action: #explore;
		popupText: [ :node | node ].
	
	"The treemap should have a dimension of 400 by 400."
	view shape width: 400; height: 400.
	
	"The nodes we draw are simply the numbers from 0 to 76."
	view nodes: (0 to: 76).
	view edgesFrom: [ :each | each // 10 ].
	
	"The weights we use to draw the treemap are the models itself: the numbers."
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	 ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'DennisSchenk 9/19/2012 11:15'!
viewSimpleTreeOn: view

	"Displays the same tree as displayed in viewSimpleTreeMap but as normal tree."
	view shape rectangle.
	view nodes: (0 to: 76).
	view edgesFrom: [ :each | each // 10 ].
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'AlexandreBergel 8/21/2012 10:35'!
viewTreeMapOn: view
		
	"Adding basic interaction capabilities: 
	 - Add a menu item which lets one explore the model of a node
	 - Show the node name on hover"
	view interaction 
		item: 'Explore Element' action: #explore;
		popupText: [ :node | node ].
	
	"The treemap should have a dimension of 500 by 500."
	view shape width: 500; height: 500.

	"The nodes we draw are simply the numbers from 0 to 999."
	view nodes: (0 to: 999).
	view edgesFrom: [ :each | each // 10 ].
		
	"The weights we use to draw the treemap are the models itself: the numbers."
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	 ! !

!ROMondrianExample methodsFor: 'layout tree map' stamp: 'AlexandreBergel 9/23/2012 12:48'!
viewVerySimpleTreeMapOn: view
	
	"Draw a Treemap that ihas a size of 100x100."
	view shape size: 100.
	
	"The nodes we draw are simply the numbers from 0 to 6."
	view nodes: 
		(OrderedCollection new add: 1;  add: 2; add: 3; add: 4; add: 5; add: 6; yourself).
	
	view edgesFromAssociations: 
		(OrderedCollection new add: 1 -> 2; add: 1 -> 3; add: 3 -> 4; add: 3 -> 5; add: 4 -> 6; yourself).
	
	"The weights we use to draw the treemap are the models itself: the numbers."
	view layout: (ROTreeMapLayout withWeightBlock: [ :e | e model ]).
	 ! !

Object subclass: #ROObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROObject commentStamp: '<historical>' prior: 0!
A ROObject is the root of the roassal class hierarchy. The idea to have ROObject is to have an empty initialize and a new on the class side that calls the initialize. This class is particuarly useful in VisualWorks since Object does not has an initialize!

ROObject subclass: #ROAbstractArrow
	instanceVariableNames: 'color offset size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractArrow methodsFor: 'configuration' stamp: 'DennisSchenk 9/18/2012 10:20'!
defaultSize
	^ 10! !

!ROAbstractArrow methodsFor: 'as yet unclassified' stamp: 'DennisSchenk 9/18/2012 10:15'!
drawOn: aCanvas for: anEdge fromPoint: fromPoint toPoint: toPoint line: line
	"Draw the arrow on the canvas and return the begining and ending of the arrow"
	
	| vector u unit arrowMiddle arrowLeft arrowRight w c toPointWithOffset r |

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
	toPointWithOffset := toPoint - (offset * (vector r - size) * unit).
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowLeft :=  arrowMiddle- (u * size).
	arrowRight := arrowMiddle + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: toPointWithOffset to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: toPointWithOffset width: w color: c.
	
	^ Array with: toPointWithOffset with: arrowMiddle! !

!ROAbstractArrow methodsFor: 'drawing' stamp: 'DennisSchenk 9/18/2012 10:15'!
drawOn: aCanvas for: anEdge line: line
	"Draw the arrow on the canvas and return the begining and ending of the arrow"

	^ self drawOn: aCanvas for: anEdge fromPoint: (line startingPointOf: anEdge) toPoint: (line endingPointOf: anEdge) line: line.! !

!ROAbstractArrow methodsFor: 'hooks' stamp: 'AlexandreBergel 7/29/2012 21:26'!
getDirectionVectorFrom: fromPoint to: toPoint
	self subclassResponsibility! !

!ROAbstractArrow methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/29/2012 21:25'!
initialize
	super initialize.
	offset := 0.
	size := self defaultSize! !

!ROAbstractArrow methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 21:25'!
offset
	^ offset! !

!ROAbstractArrow methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 21:25'!
offset: aFloat 
	offset := aFloat! !

!ROAbstractArrow methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 21:25'!
size

	^ size! !

!ROAbstractArrow methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 21:25'!
size: anInteger

	size := anInteger! !

ROAbstractArrow subclass: #ROArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROArrow commentStamp: '<historical>' prior: 0!
A ROArrow represent an arrow. A ROLine may receive arrows.

Instance Variables
	color:		<Object>
	offset:		<Object>
	size:		<Object>

color
	- Color of the arrow

offset
	- float that represent where to put the arrow on a line

size
	- size of the arrow
!

!ROArrow methodsFor: 'hooks' stamp: 'AlexandreBergel 7/29/2012 21:18'!
getDirectionVectorFrom: fromPoint to: toPoint
	^ toPoint - fromPoint! !

ROArrow subclass: #ROReversedArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROReversedArrow methodsFor: 'drawing' stamp: 'AlexandreBergel 7/29/2012 22:48'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowLeft arrowRight w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
	toPointWithOffset := toPoint - (offset * (vector r - size) * unit).
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowLeft :=  toPointWithOffset - (u * size).
	arrowRight := toPointWithOffset + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: arrowMiddle to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: arrowMiddle width: w color: c.
	
	^ Array with: toPointWithOffset with: arrowMiddle! !

ROAbstractArrow subclass: #ROHorizontalArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROHorizontalArrow methodsFor: 'as yet unclassified' stamp: 'BenComan 8/5/2012 20:33'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowTop arrowBottom w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
"	toPointWithOffset := toPoint - (offset * (vector r - size) * unit)."
	(offset = 0)
		ifTrue: [ toPointWithOffset := toPoint - (offset * (vector r - size) * unit) ]
		ifFalse: [ toPointWithOffset := fromPoint + (unit * (size @ 0))  ].

	
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowTop :=  arrowMiddle - (u * size).
	arrowBottom := arrowMiddle + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: toPointWithOffset to: arrowTop width: w color: c.
	aCanvas line: arrowTop to: arrowBottom width: w color: c.
	aCanvas line: arrowBottom to: toPointWithOffset width: w color: c.
	
	^ Array with: toPointWithOffset with: arrowMiddle! !

!ROHorizontalArrow methodsFor: 'as yet unclassified' stamp: 'BenComan 8/5/2012 14:52'!
getDirectionVectorFrom: fromPoint to: toPoint
	^ (toPoint - fromPoint) x @  0! !

ROHorizontalArrow subclass: #ROReversedHorizontalArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROReversedHorizontalArrow methodsFor: 'as yet unclassified' stamp: 'BenComan 8/5/2012 20:31'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowTop arrowBottom w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
	
	(offset = 0)
		ifTrue: [ toPointWithOffset := toPoint - (offset * (vector r - size) * unit) ]
		ifFalse: [ toPointWithOffset := fromPoint + (unit * (size @ 0))  ].
	
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowTop :=  toPointWithOffset - (u * size).
	arrowBottom := toPointWithOffset + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: arrowMiddle to: arrowTop width: w color: c.
	aCanvas line: arrowTop to: arrowBottom width: w color: c.
	aCanvas line: arrowBottom to: arrowMiddle width: w color: c.
	
	^ Array with: (fromPoint + (unit * (size @ 0))) with: (toPoint - (unit * (size @ 0)))! !

ROAbstractArrow subclass: #ROVerticalArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROVerticalArrow subclass: #ROReversedVerticalArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROReversedVerticalArrow methodsFor: 'drawing' stamp: 'AlexandreBergel 7/29/2012 23:58'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowLeft arrowRight w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
	
	(offset = 0)
		ifTrue: [ toPointWithOffset := toPoint - (offset * (vector r - size) * unit) ]
		ifFalse: [ toPointWithOffset := fromPoint + (unit * (0 @ size))  ].
	
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowLeft :=  toPointWithOffset - (u * size).
	arrowRight := toPointWithOffset + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: arrowMiddle to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: arrowMiddle width: w color: c.
	
	^ Array with: (fromPoint + (unit * (0 @ size))) with: (toPoint - (unit * (0 @ size)))! !

!ROVerticalArrow methodsFor: 'drawing' stamp: 'AlexandreBergel 7/29/2012 23:47'!
drawOn: aCanvas for: anEdge line: line
	"Return the begining and ending of the arrow"
	
	| fromPoint toPoint vector u unit arrowMiddle arrowLeft arrowRight w c toPointWithOffset r |
	fromPoint := line startingPointOf: anEdge.
	toPoint := line endingPointOf: anEdge.

	"Draw head"
	vector := self getDirectionVectorFrom: fromPoint to: toPoint.
	r := vector r.
	r = 0 ifTrue: [ ^ Array with: fromPoint with: fromPoint ].
	
	u := vector normal.
	unit := vector / r.
"	toPointWithOffset := toPoint - (offset * (vector r - size) * unit)."
	(offset = 0)
		ifTrue: [ toPointWithOffset := toPoint - (offset * (vector r - size) * unit) ]
		ifFalse: [ toPointWithOffset := fromPoint + (unit * (0 @ size))  ].

	
	arrowMiddle := toPointWithOffset - (unit * size). 
	arrowLeft :=  arrowMiddle- (u * size).
	arrowRight := arrowMiddle + (u * size).

	w :=  line width roValue: anEdge.
	c := line colorFor: anEdge.
	aCanvas line: toPointWithOffset to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: toPointWithOffset width: w color: c.
	
	^ Array with: toPointWithOffset with: arrowMiddle! !

!ROVerticalArrow methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 21:19'!
getDirectionVectorFrom: fromPoint to: toPoint
	^  0 @ (toPoint - fromPoint) y! !

ROObject subclass: #ROAbstractCanvas
	instanceVariableNames: 'camera extent nativeCanvas offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractCanvas commentStamp: 'AlexandreBergel 8/19/2012 13:01' prior: 0!
A ROAbstractCanvas is the abstract class of the canvases. In the core of Roassal, it has only one subclass, RONullCanvas. The platform package should subclass ROAbstractCanvas.

Instance Variables
	camera:		<ROCamera>
	canvas:		<Object>
	extent:		<Point>

camera
	- xxxxx

canvas
	- xxxxx

extent
	- xxxxx
!

!ROAbstractCanvas classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/19/2012 12:18'!
canvas: canvas camera: camera
	^ self new canvas: canvas; camera: camera; yourself! !

!ROAbstractCanvas classSide methodsFor: 'configuration' stamp: 'AlexandreBergel 4/19/2012 12:17'!
defaultExtent
	^ 40 @ 30! !

!ROAbstractCanvas classSide methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:19'!
onCamera: camera
	"Return a new canvas with a created canvas"
	"Implementation example: 
		| form canvas |
		form := Form extent: camera realExtent depth: Display depth.
		canvas := FormCanvas on: form.
		^ self canvas: canvas camera: camera
	"
	self subclassResponsibility! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
camera
	^ camera! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
camera: aROCamera
	camera := aROCamera! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 17:44'!
canvas
	^ nativeCanvas! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 17:44'!
canvas: aNativeCanvas 
	nativeCanvas := aNativeCanvas! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at: aPoint 
	"Render a string at a given position. No specification about the font is given. Use the default then"
	"Implementation example:
		canvas drawString: aByteString at:  (self virtualToRealPoint: aPoint) font: nil color: Color black
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at: aPoint color: color
	"Render a colored string at a given position. No specification about the font is given. Use the default then"
	"Implementation example:
			canvas drawString: aByteString at:  (self virtualToRealPoint: aPoint) font: nil color: color
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at:  p font: f color: color
	"Render a colored string at a given position using a particular font."
	"Implementation example:
		canvas drawString: aByteString at:  (self virtualToRealPoint: p) font: f color: color
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
extent: aPoint
	extent := aPoint! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	"Render an oval"
	"Implementation example
		canvas
		fillOval: (self virtualToRealRectangle: aRectangle)  color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
fillRectangle: aRectangle color: fillColor 
	"Render a rectangle"
	"Implementation example
	
		canvas fillRectangle: (self virtualToRealRectangle: aRectangle) color: fillColor
	"
	
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
form
	"Return a bitmap"
	"Implementation example
		^ canvas form
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:05'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor 
	"Render a framed rectangle. Implementation example:

	canvas 
		frameAndFillRectangle: (self virtualToRealRectangle: aRectangle) fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor.
	"
	
	self subclassResponsibility.! !

!ROAbstractCanvas methodsFor: 'initialize' stamp: 'AlexandreBergel 7/27/2012 15:47'!
initialize 
	super initialize.
	
	extent := self class defaultExtent.
	
	"Maybe a global camera would be useful. The camera object is never used normally. Since the camera of the view has to be set prior any drawing"
	camera := ROCamera new.
	
	offset := 0 @ 0! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
line: aPoint to: aPoint2 width: aSmallInteger color: aColor 
	"Draw a line between two points"
	"Implementation example
		canvas line: (self virtualToRealPoint: aPoint) to: (self virtualToRealPoint: aPoint2) width: aSmallInteger color: aColor.

	"
	self subclassResponsibility 
	


	! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 15:52'!
offset
	^ offset! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 15:22'!
offset: anOffsetAsPoint
	offset := anOffsetAsPoint ! !

!ROAbstractCanvas methodsFor: 'convenient' stamp: 'AlexandreBergel 4/19/2012 12:07'!
paintBackground: color

	self 
		frameAndFillRectangle: (camera realToVirtualRectangle: (0@0 extent: extent)) 
		fillColor: color
		borderWidth: 0 
		borderColor: Color white.! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:08'!
paintImage: aForm at: aPoint
	"Render a bitmap on screen"
	"Implementation example
		canvas paintImage: aForm at:  (self virtualToRealPoint: aPoint) 

	"
	self subclassResponsibility 
! !

!ROAbstractCanvas methodsFor: 'initialize' stamp: 'AlexandreBergel 4/19/2012 12:02'!
realToVirtualPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"

	^ camera realToVirtualPoint: aPoint
! !

!ROAbstractCanvas methodsFor: 'initialize' stamp: 'AlexandreBergel 4/19/2012 12:02'!
realToVirtualRectangle: aRectangle
	"Return a rectangle with virtual coordinates from one expressed in the real coordinates"
	
	^ camera realToVirtualRectangle: aRectangle! !

!ROAbstractCanvas methodsFor: 'util' stamp: 'AlexandreBergel 7/27/2012 15:51'!
virtualToRealPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"

	^ (camera virtualToRealPoint: aPoint) + offset
! !

!ROAbstractCanvas methodsFor: 'util' stamp: 'AlexandreBergel 7/27/2012 15:51'!
virtualToRealRectangle: aRectangle
	"Return a rectangle with real coordinates from one expressed in the virtual coordinates"
	
	^ (camera virtualToRealRectangle: aRectangle) translateBy: offset! !

ROAbstractCanvas subclass: #RONullCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!RONullCanvas classSide methodsFor: 'public' stamp: 'AlexandreBergel 7/29/2012 12:45'!
onCamera: camera
	self error: 'Should not be called'! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
drawString: aByteString at: aPoint 

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
drawString: aByteString at: aPoint color: color

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
drawString: aByteString at:  p font: f color: color

	! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
fillRectangle: aRectangle color: fillColor 
! !

!RONullCanvas methodsFor: 'util' stamp: 'AlexandreBergel 7/27/2012 09:33'!
form
! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor 

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
line: aPoint to: aPoint2 width: aSmallInteger color: aColor 

! !

!RONullCanvas methodsFor: 'rendering' stamp: 'AlexandreBergel 7/27/2012 09:33'!
paintImage: aForm at: aPoint
! !

ROObject subclass: #ROAbstractComponent
	instanceVariableNames: 'model eventHandler interactions view elements parent shape resizeStrategy attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractComponent classSide methodsFor: 'public' stamp: 'AlexandreBergel 8/19/2012 12:17'!
on: anObject 
	^ self basicNew on: anObject; initialize; yourself! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/10/2012 09:01'!
+ aShape 
	"Add a shape to myself. aShape could either be an instance of a shape class or a class"
	
	self addShape: aShape.
	^ self ! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/10/2012 09:00'!
- aShape 
	"Remove a shape from myself. aShape could either be an instance of a shape class or a class"
	
	self removeShape: aShape.
	^ self ! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 9/10/2012 09:01'!
@ anInteractionClassOrInstance
	"Add an interaction to the node"
	
	self addInteraction: anInteractionClassOrInstance! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'BenComan 10/14/2012 23:11'!
addInteraction: anInteractionClassOrInstance
	"Add an interaction to the node"
	
	interactions at: anInteractionClassOrInstance key put: (anInteractionClassOrInstance initializeElement: self)
	! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/10/2012 09:01'!
addShape: aShape 
	"Add a shape to myself. aShape could either be an instance of a shape class or simply a class"

	| s |
	s := (aShape installedOn: self).
	s addLast: shape.
	shape := s
! !

!ROAbstractComponent methodsFor: 'enumerating' stamp: 'AlexandreBergel 9/10/2012 09:03'!
allElementsDo: aBlock
	"aBlock is a one-arg block. This method executes aBlock for each element that I contains. 
	 The block receive the element as argument"
	
	self elementsDo: [:each | 
		aBlock value: each.
		each allElementsDo: aBlock ]! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 8/19/2012 13:20'!
announce: anEvent
	"trigger an event. Objects who registered to me will get notified"

	| eventToBeSent |
	eventToBeSent := anEvent isBehavior 
						ifTrue: [ anEvent new ]
						ifFalse: [ anEvent ]. 
	
	eventToBeSent element: self.
	eventHandler announce: eventToBeSent! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 10/2/2012 19:45'!
attributes
	"Return the list of attributes associated to the element. Attributes are useful for caching values"

	^ attributes ifNil: [ attributes := Dictionary new ]! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/10/2012 09:03'!
change: aShapeClass for: aShape
	"aDecorator could be a class or a shape"
	
	shape := shape change: aShapeClass for: (aShape installedOn: self).
! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'AlexandreBergel 9/10/2012 09:03'!
changeInteraction: anInteractionClass for: anInteraction
	"Change an interaction, instance of anInteractionClass, for an Interaction"
	
	self removeInteraction: anInteractionClass.
	self @ anInteraction! !

!ROAbstractComponent methodsFor: 'drawing' stamp: 'AlexandreBergel 9/14/2012 19:03'!
drawOn: aCanvas
	"This should be changed. drawOn: should not do an explicit iteration, but letting each shape call drawOn: on its next "

	shape chainedDrawOn: aCanvas for: self

! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:25'!
forShape: shapeClass do: aOneArgBlock
	"Find the shape that correspond to the shape class, and evaluate the block by passing the shape to it"

	| v |
	v := ( self getShape: shapeClass). 
	v ifNotNil: [ aOneArgBlock value: v  ]! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 8/19/2012 17:12'!
forward
	eventHandler forward! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 8/19/2012 17:12'!
forward: obj
	eventHandler forward: obj! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'AlexandreBergel 8/20/2012 09:19'!
getInteraction: anInteractionClass

	^ interactions at: anInteractionClass
! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'BenComan 10/14/2012 22:07'!
getInteraction: anInteractionClass ifPresent: aBlock

	^ interactions at: anInteractionClass ifPresent: aBlock
! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:26'!
getShape: shapeClass
	"Return a shape instance, instance of the shape class provided as parameter"

	^ self shapeDetect: [ :de | de isKindOf: shapeClass ]! !

!ROAbstractComponent methodsFor: 'initialize-release' stamp: 'AlexandreBergel 9/10/2012 09:14'!
initialize
	super initialize.
	parent := ROView nullView.
	
	eventHandler := ROAnnouncer new.
	view := ROView nullView.
	
	"Actually, I am not sure we need to have a variable interactions"
	interactions := IdentityDictionary new.
! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'AlexandreBergel 8/19/2012 17:16'!
interactionsDo: aBlock
	"Execute a block for each interaction"
	
	interactions ifNil: [ ^ self ].
	interactions values do: aBlock! !

!ROAbstractComponent methodsFor: 'testing' stamp: 'AlexandreBergel 8/19/2012 17:17'!
is: anInteractionClass

	interactions ifNil: [ ^ false ].
	^ interactions includesKey: anInteractionClass! !

!ROAbstractComponent methodsFor: 'testing' stamp: 'AlexandreBergel 8/19/2012 13:18'!
isNotEdge
	^ self isEdge not! !

!ROAbstractComponent methodsFor: 'testing' stamp: 'AlexandreBergel 8/19/2012 12:39'!
isShapedAs: aShapeClass
	^ shape isShapedAs: aShapeClass! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 8/19/2012 12:37'!
model
	"Return the object behind the element"

	^ model! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 8/19/2012 12:36'!
model: anObject 
	"Set the object behind the element"
	
	model := anObject
! !

!ROAbstractComponent methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/2/2012 20:44'!
numberOfInteractions
	"Answer the number of interactions"
	
"	^ eventHandler numberOfSubscriptions
"
	interactions ifNil: [ ^ 0 ].
	^ interactions size ! !

!ROAbstractComponent methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/5/2012 08:39'!
numberOfShapes
	"Return the number of shapes associated to the element"
	
	^ self shapes size ! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 9/2/2012 20:14'!
on: anObject 
	"Set the object model of myself. The object model is used by the shape when computing metrics that may be used by the shapes"

	model := anObject! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 9/2/2012 21:12'!
on: eventClass do: aBlock
	"Register a block as an handler for eventClass"
	

	eventHandler when: eventClass do: aBlock.
	"interactions at: eventClass put: aBlock"! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 9/2/2012 21:13'!
on: eventClass doOnce: aBlock
	"Register a block as an handler for eventClass. The callback is removed when exected"
	
	"interactions at: eventClass put: aBlock."
	eventHandler when: eventClass do: [ :arg | 
		aBlock value: arg.
		eventHandler unsubscribeForEvent: ROMouseClick.
		"self removeInteraction: eventClass "]! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 9/10/2012 09:04'!
parent
	"Return the node in which I am contained"
	
	^ parent! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 9/10/2012 09:04'!
parent: aViewOrAnElement
	"Set the node in which I am contained"

	parent := aViewOrAnElement! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 9/10/2012 09:07'!
parentAnnounce: event
	"Make the parent announce something"
		
	parent announce: event! !

!ROAbstractComponent methodsFor: 'actions' stamp: 'AlexandreBergel 10/18/2012 16:57'!
remove
	"Remove myself from the view I belong to (if I actually belong to the view, else do nothing)."
	parent remove: self ifAbsent: []! !

!ROAbstractComponent methodsFor: 'interaction' stamp: 'AlexandreBergel 9/2/2012 20:58'!
removeInteraction: anInteractionClass
	"Remove an interaction from the receiver. No error is raised if no interaction is found"
	
	| ds |
	ds := interactions select: [ :d | d isKindOf: anInteractionClass ].
	ds associationsDo: [ :assoc | 
		interactions removeKey: assoc key.
		eventHandler unsubscribe: assoc value ].
! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:26'!
removeShape: aShapeClass
	"Remove a shape of the element"

	shape := shape removeShape: aShapeClass! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/24/2012 11:26'!
reversedShapesDo: aBlock
	^ self shapes reversed do: aBlock! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:34'!
shapeDetect: aBlock
	^ shape shapeDetect: aBlock! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 13:05'!
shapes
	"Return the list of shapes"
	
	| ans d |
	ans := OrderedCollection new.
	d := shape. 
	[ d hasNext ] whileTrue: [ 
		ans add: d.
		d := d next ].
	ans add: d.
	^ ans.! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:34'!
shapesCollect: aBlock
	^ self shapes collect: aBlock! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 9/24/2012 11:56'!
shapesDo: aBlock
	^ shape shapesDo: aBlock! !

!ROAbstractComponent methodsFor: 'shapes' stamp: 'AlexandreBergel 8/19/2012 12:35'!
shapesSelect: aBlock
	^ self shapes select: aBlock! !

!ROAbstractComponent methodsFor: 'events' stamp: 'AlexandreBergel 8/19/2012 17:13'!
signalUpdate
	"Trigger a redisplay of the view"
	
	^ view signalUpdate! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 8/19/2012 12:41'!
view
	"Answer the view in which I am defined"
	^ view! !

!ROAbstractComponent methodsFor: 'accessing' stamp: 'AlexandreBergel 8/19/2012 12:41'!
view: aView
	"Set the view in which I am defined. All my elements should also belong to the same view"
	view := aView.
	elements do: [ :el | el view: aView ]
	! !

!ROAbstractComponent methodsFor: 'enumerating' stamp: 'TudorGirba 9/9/2012 21:40'!
withAllElementsDo: aBlock
	aBlock value: self.
	self allElementsDo: aBlock! !

ROAbstractComponent subclass: #ROEdge
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROEdge classSide methodsFor: 'public' stamp: 'AlexandreBergel 7/14/2012 15:01'!
arrowedLineFrom: f to: t
	^ (self from: f to: t)
		+ (ROLine new addBegining: ROArrow new) ;
		yourself! !

!ROEdge classSide methodsFor: 'public' stamp: 'TudorGirba 7/29/2012 22:44'!
from: fromNode to: toNode

	^ self on: nil from: fromNode to: toNode! !

!ROEdge classSide methodsFor: 'public' stamp: ''!
lineFrom: f to: t
	^ (self from: f to: t)
		+ ROLine ;
		yourself! !

!ROEdge classSide methodsFor: 'public' stamp: ''!
linesFor: associations 
	"Return a collection of edges, one for each provided association"

	^ associations collect: [ :assoc | self lineFrom: assoc key to: assoc value ]! !

!ROEdge classSide methodsFor: 'public' stamp: 'TudorGirba 7/29/2012 22:44'!
on: aModel from: f to: t
	self assert: [ f isKindOf: ROElement ].
	self assert: [ t isKindOf: ROElement ].
	^ (self on: aModel) from: f to: t; yourself! !

!ROEdge methodsFor: 'visiting' stamp: ''!
accept: aVisitor
	aVisitor visitEdge: self! !

!ROEdge methodsFor: 'actions' stamp: 'AlexandreBergel 8/19/2012 13:14'!
addedInAnElement: el
	el addElement: self.
	self parent: el; view: el view.

! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 8/19/2012 18:37'!
bounds
	^  Rectangle merging: (Array with: self from bounds with: self to bounds)! !

!ROEdge methodsFor: 'testing' stamp: 'AlexandreBergel 8/20/2012 10:01'!
contains: aPoint
	^ shape contains:  aPoint for: self
	"^ (self getShape: ROAbstractLine) contains:  aPoint for: self"
	"^ self bounds containsPoint: aPoint"! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 8/23/2012 22:52'!
elementAt: aPoint
	"Do nothing since an edge cannot contain other elements"
	^ self ! !

!ROEdge methodsFor: 'actions' stamp: 'AlexandreBergel 10/2/2012 20:41'!
elementFromModel: object
	"if the object is equal to the mode, then return itself, else nil"
	
	(self model = object) ifTrue: [ ^ self ].
	^ nil! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 8/19/2012 13:19'!
elementsDo: aBlock
	"Do nothing"! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/5/2012 09:16'!
extent
	^ self bounds extent ! !

!ROEdge methodsFor: 'accessing' stamp: ''!
from
	^ from! !

!ROEdge methodsFor: 'accessing' stamp: ''!
from: f to: t
	from := f.
	to := t! !

!ROEdge methodsFor: 'accessing' stamp: 'VanessaPena 8/29/2012 05:07'!
height 

	 ^((self from position y) - (self to position y)) abs! !

!ROEdge methodsFor: 'initialize-release' stamp: 'AlexandreBergel 9/4/2012 12:53'!
initialize
	super initialize.
	shape := RONullShape new.! !

!ROEdge methodsFor: 'testing' stamp: ''!
isEdge
	^ true! !

!ROEdge methodsFor: 'accessing' stamp: 'VanessaPena 8/26/2012 09:19'!
position 
	
	^self from position ! !

!ROEdge methodsFor: 'accessing' stamp: ''!
source
	^ self from! !

!ROEdge methodsFor: 'accessing' stamp: ''!
target
	^ self to! !

!ROEdge methodsFor: 'accessing' stamp: ''!
to 
	^ to! !

!ROEdge methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/25/2012 18:33'!
topLeft
	^ (shape lineSegmentsFor: self) first
	
	"| lines |
	lines := shape lineSegmentsFor: self.
	^ lines first min: lines last
	
 "! !

!ROEdge methodsFor: 'translation' stamp: 'VanessaPena 8/29/2012 05:05'!
translateBy: aPoint 
! !

!ROEdge methodsFor: 'translation' stamp: 'VanessaPena 8/29/2012 05:07'!
translateTo: aPoint 
! !

!ROEdge methodsFor: 'accessing' stamp: 'AlexandreBergel 8/19/2012 12:24'!
view: aView
	"Set the view in which I am defined."
	view := aView.

	! !

!ROEdge methodsFor: 'accessing' stamp: 'VanessaPena 8/29/2012 05:03'!
width 

	 ^(self getShape: ROLine) width  ! !

ROAbstractComponent subclass: #ROElement
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROElement subclass: #ROButtonElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets'!

!ROButtonElement classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/1/2012 15:01'!
named: aName do: aOneArgBlockAsCallback
	^ self basicNew initializeWithName: aName Callback: aOneArgBlockAsCallback! !

!ROButtonElement methodsFor: 'public' stamp: 'AlexandreBergel 6/1/2012 15:04'!
initializeWithName: aName Callback: callbackAsOneArgBlock
	super initialize.
	self + (ROLabel text: aName).
	self @ ROLightlyHighlightable.
	self on: ROMouseClick do: callbackAsOneArgBlock.
	! !

!ROElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/25/2012 20:23'!
bare
	"Only has a nullshape, no children shape"
	^ self basicNew initializeBare! !

!ROElement classSide methodsFor: 'defaults' stamp: ''!
defaultBounds
	^ (0@0 corner: 5@5)! !

!ROElement classSide methodsFor: 'public' stamp: ''!
forCollection: aCollection 
	^ (aCollection collect: [ :v | self on: v ]) asArray! !

!ROElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:43'!
label
	^ self new + ROLabel! !

!ROElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:51'!
labelOn: obj
	^ (self on: obj) + ROLabel! !

!ROElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 6/11/2012 12:38'!
labelsOn: collection
	^ (self forCollection: collection) collect: [ :v | v + ROLabel ]! !

!ROElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 5/7/2012 11:54'!
sprite

	^ self new
			extent: 50 @ 50;
			addInteraction: RODraggable;
			addShape: (ROBorder new color: Color red);
			yourself! !

!ROElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:44'!
spriteOn: value
	^ self sprite on: value! !

!ROElement classSide methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:44'!
spritesOn: values
	^ values collect: [:v | self sprite on: v ]! !

!ROElement methodsFor: 'accessing' stamp: ''!
absolutePosition
	"Return the absolute position of the element, the top left corner"

	^ parent 
		ifNil: [ self position ]
		ifNotNil: [ self position + parent absolutePosition ]! !

!ROElement methodsFor: 'visiting' stamp: ''!
accept: aVisitor
	aVisitor visitNode: self! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 10/17/2012 08:34'!
add: el
	self assert: [ el  isKindOf: ROAbstractComponent ].
	el addedInAnElement: self.
! !

!ROElement methodsFor: 'public' stamp: ''!
addAll: els
	els do: [:el | self add: el ]! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 8/19/2012 13:14'!
addElement: el
	elements add: el! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 8/19/2012 18:28'!
addedInAnElement: el
	self translateBy: el topLeft negated.
	el addElement: self.
	self parent: el; view: el view.
	
	el adjustSizeIfNecessary

! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 6/2/2012 14:25'!
adjustSizeIfNecessary
	resizeStrategy on: self! !

!ROElement methodsFor: 'accessing' stamp: ''!
bottomCenter
	^ self bounds bottomCenter! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 08:53'!
bottomLeft
	^ self bounds bottomLeft! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 08:53'!
bottomRight 
	^ self bounds bottomRight! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 09:16'!
bounds
	"Return the bounds of the element"
	
	^ self position extent: (shape extentFor: self)! !

!ROElement methodsFor: 'accessing' stamp: ''!
center
	^ self bounds center! !

!ROElement methodsFor: 'accessing' stamp: ''!
center: pos

	^ self translateTo: (pos - (self extent / 2))! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 09:18'!
center: aPoint radius: d

	position := (aPoint - (d @ d)).
	self extent: (2 * d @ ( 2 * d))! !

!ROElement methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 15:29'!
collectPathToRootIn: aCollection
	"Return the path from this graph to the root graph"

	aCollection addLast: self.
	self parent ifNotNil: [self parent collectPathToRootIn: aCollection]! !

!ROElement methodsFor: 'testing' stamp: 'AlexandreBergel 9/24/2012 19:08'!
contains: aPoint
	"Return true if aPoint is within the bounds of myself. Note that aPoint is relative to the owner of the element"

	^ shape element: self containsPoint: aPoint ! !

!ROElement methodsFor: 'copying' stamp: 'AlexandreBergel 5/7/2012 11:54'!
copy
	| answer |
	answer := self class new.
	answer 
			translateTo: self position;
			extent: self extent.
	self shapesDo: [ :d | answer + d ].
	self interactionsDo: [ :i | answer @ i ].
	^ answer
			! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/25/2012 15:17'!
elementAt: aPoint 
	"Return the element pointed by aPoint. The coordinate aPoint is local to the object receiver. 
	This means that aPoint = 0@0 refers to the top left of the bounds"

	^ shape elementAt: aPoint forElement: self
	
"	| elToLookupInto |
	elements isEmpty ifTrue: [ ^ self ].
	elToLookupInto := (elements detect: [ :el | el contains: (aPoint) ] ifNone: [ 
			^ (self extent >= aPoint)
				ifTrue: [ self ]
				ifFalse: [ view ] ]).
			
	^ elToLookupInto elementAt: (aPoint - elToLookupInto topLeft) 
"! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 4/14/2012 10:39'!
elementFromModel: object
	"Recursively look for the element with a model object"
	| v |
	
	(self model = object) ifTrue: [ ^ self ].
	
	v :=  elements 
		detect: [ :e | e model = object ]
		ifNone: [ nil ].
	v ifNotNil: [ ^ v ].
	
	elements do: [ :e |
		v := e elementFromModel: object.
		v ifNotNil: [ ^ v ] ].
	
	^ nil

	"^ (self elementsSuchThat: [ :el | object = el model ]) first"! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 6/5/2012 09:31'!
elements
	^ elements copy! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsCollect: aBlock
	^ elements collect: aBlock! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsDo: aBlock
	^ elements copy do: aBlock! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsFromModels: objects
	^ self elementsSuchThat: [ :el | objects includes: el model ]! !

!ROElement methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 8/19/2012 13:21'!
elementsNotEdge
	^ elements reject: #isEdge! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsSuchThat: aBlock
	^ elements select: aBlock! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 15:41'!
elementsWithModelDo: aBlock
	^ (elements copy select: [ :n | n model notNil ]) do: aBlock
	! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/15/2012 10:44'!
encompassingNestedRectangle
	elements isEmpty ifTrue: [ ^ Rectangle origin: self topLeft extent: 5 @ 5 ].
	^ ((Rectangle merging: (self elementsNotEdge collect: #bounds)) translateBy: self topLeft) extendBy: 5@5! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/15/2012 10:45'!
encompassingRectangle
	elements isEmpty ifTrue: [ ^ self bounds ].
	^ Rectangle merging: 
		(Array with: (self encompassingNestedRectangle)), 		
		(Array with: self bounds)! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 09:07'!
extent
	^ shape extentFor: self! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 10/1/2012 09:29'!
extent: aPoint 
	(aPoint = self extent) ifTrue: [ ^ self ].
	self announce: ROElementResized.
	shape extent: aPoint
! !

!ROElement methodsFor: 'testing' stamp: 'AlexandreBergel 6/18/2012 14:21'!
hasAttributes 
	"Return true if at least one attributes is present"
	
	^ attributes notNil and: [ attributes notEmpty ]! !

!ROElement methodsFor: 'accessing' stamp: ''!
height
	^ self extent y! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 13:57'!
height: h
	"h could either be a numerical constant, a symbol or a block. It is evaluated against the element"
	(h = shape width) ifTrue: [ ^ self ].
	self announce: ROElementResized.
	shape height: h
! !

!ROElement methodsFor: 'initialization' stamp: 'AlexandreBergel 9/25/2012 20:22'!
initialize 
	super initialize.

	position := 0 @ 0.

	shape := ROChildrenShape new.
	shape next: RONullShape new.
	
	elements := OrderedCollection new.
	
	"Per default, the parent is always extensible"
	resizeStrategy := ROExtensibleParent instance.
	
	! !

!ROElement methodsFor: 'initialization' stamp: 'AlexandreBergel 9/25/2012 20:23'!
initializeBare 
	super initialize.

	position := 0 @ 0.

	shape := RONullShape new.
	
	elements := OrderedCollection new.
	
	"Per default, the parent is always extensible"
	resizeStrategy := ROExtensibleParent instance.
	
	! !

!ROElement methodsFor: 'testing' stamp: ''!
isEdge
	^ false! !

!ROElement methodsFor: 'accessing' stamp: ''!
leftCenter
	^ self bounds leftCenter! !

!ROElement methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 15:15'!
mostSpecificParentCommonWith: anotherElement
	"Search the smallest possible element that is parent of self and of anotherNode"

	|  anotherPathToRoot | 
	anotherPathToRoot := anotherElement pathToRoot.

	self pathToRoot do: [ :eachElement | 
		(anotherPathToRoot includes: eachElement)
			ifTrue: [ ^ eachElement ] ]! !

!ROElement methodsFor: 'accessing' stamp: ''!
numberOfElements 
	^ elements size! !

!ROElement methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 15:22'!
pathToRoot
	"Return the path from this graph to the root graph"

	| path |
	path := OrderedCollection new.
	self parent ifNotNil: [self parent collectPathToRootIn: path].
	^path! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 09:18'!
position
	"Return the position of the element. Return a point of floats"
	
	^ position! !

!ROElement methodsFor: 'accessing' stamp: ''!
positionAsInteger
	"Return the position as integer"
	
	^ self position asIntegerPoint ! !

!ROElement methodsFor: 'accessing' stamp: ''!
positionRelativeTo: anElement
	"Return the position of myself against the position of one of my parent, anElement. The returned position is relative to it."
	"This method is useful to draw edges that are nested"

	(anElement == self)
		ifTrue: [ ^ 0 @ 0 ].
	
	^ self topLeft + (parent positionRelativeTo: anElement)! !

!ROElement methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	model ifNotNil: [ 
		stream nextPutAll: '<'.
		model printOn: stream.
		stream nextPutAll: '>' ]! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 5/17/2012 20:31'!
radius
	^ self extent r / 2
	
! !

!ROElement methodsFor: 'accessing' stamp: ''!
radius: d

	^ self center: self position radius: d! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 10/18/2012 16:56'!
remove: element
	elements remove: element! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 10/18/2012 16:56'!
remove: element ifAbsent: aBlock
	elements remove: element ifAbsent: aBlock! !

!ROElement methodsFor: 'actions' stamp: 'BenComan 10/8/2012 14:10'!
removeAllEdgesFrom
	self rawView allElementsDo: 
	[ 	:edge | 
		edge isEdge ifTrue: 
		[ 	(edge from == self) ifTrue: 
			[ 	edge remove
			] 
		] 
	].
! !

!ROElement methodsFor: 'actions' stamp: 'BenComan 10/8/2012 14:12'!
removeAllEdgesTo
	self view allElementsDo: 
	[ 	:edge | 
		edge isEdge ifTrue: 
		[ 	(edge to == self) ifTrue: 
			[ 	edge remove
			] 
		] 
	].
! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 10/18/2012 16:54'!
removeAllElements
	elements := OrderedCollection new.! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 14:26'!
resizeStrategy
	^ resizeStrategy! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 14:27'!
resizeStrategy: anInstanceOfROAbstractResizeStrategy
	resizeStrategy := anInstanceOfROAbstractResizeStrategy! !

!ROElement methodsFor: 'accessing' stamp: ''!
rightCenter
	^ self bounds rightCenter! !

!ROElement methodsFor: 'translation' stamp: ''!
setBounds:  aBounds
	self extent: aBounds extent.
	self translateTo: aBounds origin.! !

!ROElement methodsFor: 'accessing' stamp: ''!
size: d
	self extent: d @ d! !

!ROElement methodsFor: 'accessing' stamp: ''!
topCenter
	^ self bounds topCenter! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 08:52'!
topLeft
	^ self bounds topLeft ! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 08:52'!
topRight
	^ self bounds topRight! !

!ROElement methodsFor: 'translation' stamp: 'AlexandreBergel 5/22/2012 00:42'!
translateBy: aPoint 
	self translateWithoutUpdatingContainedElementsBy: aPoint.
	parent adjustSizeIfNecessary
! !

!ROElement methodsFor: 'translation' stamp: 'AlexandreBergel 9/16/2012 12:46'!
translateByRealPoint: aPoint 
	| p |
	p := self view camera virtualToRealPointNoTrunc: self position.
	self translateTo: (self view camera realToVirtualPointNoTrunc: (p + aPoint)).
! !

!ROElement methodsFor: 'translation' stamp: ''!
translateTo: aPoint 
	self translateBy: (aPoint - self bounds origin)! !

!ROElement methodsFor: 'translation' stamp: ''!
translateToRealPoint: aPoint 
	| p |
	p := self view camera realToVirtualPoint: aPoint. 
	"Transcript show: 'translateToRealPoint -- bounds:', self bounds asString, '    real:', aPoint asString , '  virtual:', p asString; cr."
	self translateTo: p.
! !

!ROElement methodsFor: 'translation' stamp: 'AlexandreBergel 10/1/2012 09:23'!
translateWithoutUpdatingContainedElementsBy: aPoint
	"translate myself without updating the parent."
	aPoint = (0 @ 0) ifTrue: [ ^ self ].
	
	position := position + aPoint.
	self announce: ROElementTranslated
	! !

!ROElement methodsFor: 'accessing' stamp: ''!
width
	^ self extent x! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 13:57'!
width: w
	"w could either be a numerical constant, a symbol or a block. It is evaluated against the element"
	(w = shape width) ifTrue: [ ^ self ].
	self announce: ROElementResized.
	shape width: w! !

ROElement subclass: #ROMenuElement
	instanceVariableNames: 'actionDictionary targetObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets'!

!ROMenuElement classSide methodsFor: 'example' stamp: 'AlexandreBergel 9/21/2012 14:00'!
example

"
self example
"

"Preambule. It includes the initialization. "
| rawView view element |
rawView := ROView new.
view := ROMondrianViewBuilder view: rawView.
"enter your script below"
"-------------"
"-------------" 

view shape rectangle size: 80.
element := view node: 100.

element on: ROMouseClick do: [ :ann |
	| menu |
	menu := ROMenuElement new.
	menu item: 'foo10' action: [ :an | 10 inspect ].
	menu item: 'foo20' action: [ :an | 20 inspect ].
	menu item: 'foo30' action: [ :an | 30 inspect ].
	
	menu create.
		
	view raw add: menu. 
	
	menu translateTo: ann position - (10 @ 40).
	 element on: ROMouseDragging do: [ :v | menu remove ].
	element on: ROMouseClick do: [ :v | menu remove ].
	 
	
	"element on: ROMouseLeave doOnce: [ :v | menu remove ].
	element on: ROMouseEnter doOnce: [ :v | menu remove ].
	"

view raw signalUpdate.
].

"-------------"
"-------------"
"Below is the initiation of the menu and opening the visualization"
"ROEaselMorphic new populateMenuOn: view."
view open! !

!ROMenuElement methodsFor: 'private' stamp: 'AlexandreBergel 9/2/2012 00:22'!
create
	self createEntries.
	self + ROBorder blue.
	! !

!ROMenuElement methodsFor: 'private' stamp: 'AlexandreBergel 9/4/2012 00:28'!
createEntries
	| nameElements |
	nameElements := actionDictionary keys collect: [ :title |
		(ROElement labelOn: title)
			@ ROLightlyHighlightable;
			"forward: ROMouseLeave;"
			on: ROMouseClick do: [ :ann | 
				(actionDictionary at: title) value: targetObject.
				self remove.
				self view signalUpdate ]
			yourself  ].
	 
	self addAll: nameElements.
	
	ROVerticalLineLayout on: nameElements.! !

!ROMenuElement methodsFor: 'public' stamp: 'AlexandreBergel 9/1/2012 19:51'!
evaluate: aTitleAsString
	"Evaluate the callback associate to the title given as parameter"
	
	(actionDictionary at: aTitleAsString) value: targetObject! !

!ROMenuElement methodsFor: 'initialization' stamp: 'AlexandreBergel 9/1/2012 23:35'!
initialize
	super initialize.
	targetObject := self.
	actionDictionary := Dictionary new.
	 ! !

!ROMenuElement methodsFor: 'public' stamp: 'AlexandreBergel 9/1/2012 19:45'!
item: aTitleAsString action: aBlock
	"Register a menu entry. The title is used as the entry name when the menu is displayed.
	 The callback is defined as a one-arg block. The block is evaluated with the content of the variable targetObject"

	actionDictionary at: aTitleAsString put: aBlock! !

!ROMenuElement methodsFor: 'accessing computed' stamp: 'AlexandreBergel 9/1/2012 19:38'!
numberOfActions
	"Return the number of actions"
	
	^ actionDictionary size! !

!ROMenuElement methodsFor: 'accessing' stamp: 'AlexandreBergel 9/1/2012 19:46'!
targetObject
	^ targetObject! !

!ROMenuElement methodsFor: 'public' stamp: 'AlexandreBergel 9/1/2012 19:46'!
targetObject: anObject
	"set the object that is passed to the callback blocks when being evaluated"

	targetObject := anObject! !

ROObject subclass: #ROAbstractResizeStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROAbstractResizeStrategy class
	instanceVariableNames: 'instance'!

!ROAbstractResizeStrategy commentStamp: 'AlexandreBergel 3/2/2012 19:40' prior: 0!
This hierarchy defines how a parent should behave when a child is resized.!

ROAbstractResizeStrategy class
	instanceVariableNames: 'instance'!

!ROAbstractResizeStrategy classSide methodsFor: 'public' stamp: ''!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!ROAbstractResizeStrategy methodsFor: 'action' stamp: ''!
on: childElement
	self subclassResponsibility ! !

ROAbstractResizeStrategy subclass: #ROExtensibleParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROExtensibleParent commentStamp: 'AlexandreBergel 3/2/2012 19:41' prior: 0!
The parent get expended!

!ROExtensibleParent methodsFor: 'action' stamp: 'AlexandreBergel 5/22/2012 00:33'!
on: element
	ROAdjustSizeOfNesting on: element! !

ROAbstractResizeStrategy subclass: #ROFixedSizedParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROFixedSizedParent commentStamp: 'AlexandreBergel 3/2/2012 19:41' prior: 0!
The size of the parent is fixed. !

!ROFixedSizedParent methodsFor: 'action' stamp: 'AlexandreBergel 5/22/2012 00:33'!
on: element
	"We do nothing"! !

ROAbstractResizeStrategy subclass: #ROShrinkingParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROShrinkingParent methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 9/16/2012 12:48'!
on: element
	ROShrikingSize on: element! !

ROObject subclass: #ROAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

ROAttachPoint class
	instanceVariableNames: 'instance'!

ROAttachPoint class
	instanceVariableNames: 'instance'!

!ROAttachPoint classSide methodsFor: 'public - creation' stamp: ''!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!ROAttachPoint classSide methodsFor: 'public - creation' stamp: 'AlexandreBergel 10/15/2012 13:06'!
resetInstance
	"
	self withAllSubclassesDo: #resetInstance
	"

	instance := nil.! !

!ROAttachPoint methodsFor: 'public - hooks' stamp: ''!
endingPointOf: anEdge
	self subclassResponsibility! !

!ROAttachPoint methodsFor: 'public - hooks' stamp: ''!
startingPointOf: anEdge
	self subclassResponsibility! !

ROAttachPoint subclass: #ROCenteredAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROCenteredAttachPoint methodsFor: 'public - hooks' stamp: ''!
endingPointOf: anEdge
	^ (anEdge to positionRelativeTo: anEdge parent) + (anEdge to extent / 2) asIntegerPoint! !

!ROCenteredAttachPoint methodsFor: 'public - hooks' stamp: ''!
startingPointOf: anEdge
	^ (anEdge from positionRelativeTo: anEdge parent) + (anEdge from extent / 2) asIntegerPoint! !

ROAttachPoint subclass: #ROHorizontalAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROHorizontalAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 5/31/2012 15:19'!
endingPointOf: anEdge
	^ (anEdge to positionRelativeTo: anEdge parent) + (0 @ (anEdge to bounds height / 2) asInteger)! !

!ROHorizontalAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 5/31/2012 15:17'!
startingPointOf: anEdge
	^ (anEdge from positionRelativeTo: anEdge parent) + (anEdge from bounds width @ (anEdge from bounds height / 2) asInteger)
	! !

ROAttachPoint subclass: #ROShorterDistanceAttachPoint
	instanceVariableNames: 'offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'DennisSchenk 10/9/2012 12:28'!
attachPointFor: anEdge on: anElement with: elementsPossibleAttachPoints
	"Returns the attach point having the shortest route for given edge on given element."
	| p dp t |
	p := (anElement positionRelativeTo: anEdge parent) + (anElement width @ anElement height).
	
	"We get the list of dot products"
	dp := elementsPossibleAttachPoints collect: [ :pp | 
		t := p - pp.
		Array with: (t dotProduct: t) with:  pp ].
	
	"We look for the shortest path and return the point"
	^ (dp inject: dp first into: [ :shorter :el | (shorter first < el first) ifTrue: [ shorter ] ifFalse: [ el ]]) second! !

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'DennisSchenk 10/9/2012 12:24'!
attachPointsFor: anEdge on: anElement
	"Return the four possible attach points for each of the four sides for given edge on given element."
	^ Array 
		"upper side"
		with: (anElement positionRelativeTo: anEdge parent) + (((anElement bounds width / 2) + offset) asInteger @ 0) 
		 "right side"
		with: (anElement positionRelativeTo: anEdge parent) + (anElement bounds width @ ((anElement  bounds height / 2) + offset) asInteger)
		"lower side"
		with: (anElement positionRelativeTo: anEdge parent) + (((anElement bounds width / 2) + offset) asInteger @ (anElement bounds height)) 
		"left side"
		with: (anElement positionRelativeTo: anEdge parent) + (0 @ ((anElement bounds height / 2) + offset) asInteger) 
		
	! !

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'DennisSchenk 10/9/2012 12:24'!
destinationAttachPointsFor: anEdge
	"Return the four possible attach points for each of the four sides for this edges destination node."
	^ self attachPointsFor: anEdge on: (anEdge to).
		
	! !

!ROShorterDistanceAttachPoint methodsFor: 'public - hooks' stamp: 'DennisSchenk 10/9/2012 12:26'!
endingPointOf: anEdge
	^ self attachPointFor: anEdge on: (anEdge from) with: (self destinationAttachPointsFor: anEdge).! !

!ROShorterDistanceAttachPoint methodsFor: 'initialize-release' stamp: 'AlexandreBergel 10/11/2012 13:13'!
initialize
	super initialize.
	offset := 0.! !

!ROShorterDistanceAttachPoint methodsFor: 'accessing' stamp: 'DennisSchenk 10/9/2012 09:39'!
offset
	^ offset.! !

!ROShorterDistanceAttachPoint methodsFor: 'accessing' stamp: 'DennisSchenk 10/9/2012 09:39'!
offset: aNumber
	offset := aNumber.! !

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'DennisSchenk 10/9/2012 12:24'!
startingAttachPointsFor: anEdge
	"Return the four possible attach points for each of the four sides for this edges starting node."
	^ self attachPointsFor: anEdge on: (anEdge from).! !

!ROShorterDistanceAttachPoint methodsFor: 'public - hooks' stamp: 'DennisSchenk 10/9/2012 12:26'!
startingPointOf: anEdge
	^ self attachPointFor: anEdge on: (anEdge to) with: (self startingAttachPointsFor: anEdge).! !

ROAttachPoint subclass: #ROVerticalAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROVerticalAttachPoint methodsFor: 'public - hooks' stamp: ''!
endingPointOf: anEdge
	^  (anEdge to positionRelativeTo: anEdge parent) + ((anEdge to bounds width / 2) asInteger @ 0)
	! !

!ROVerticalAttachPoint methodsFor: 'public - hooks' stamp: ''!
startingPointOf: anEdge
	^ (anEdge from positionRelativeTo: anEdge parent) + ((anEdge from bounds width / 2) asInteger @ (anEdge from bounds height ))
	! !

ROObject subclass: #ROCamera
	instanceVariableNames: 'position angle realExtent extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROCamera classSide methodsFor: 'defaults' stamp: ''!
defaultAngle
	^ 95! !

!ROCamera classSide methodsFor: 'defaults' stamp: ''!
defaultExtent
	"Maybe this has to be replaced by defaultAngle and default Height"
	^ 500 @ 500! !

!ROCamera classSide methodsFor: 'defaults' stamp: ''!
defaultHeight
	^ 200! !

!ROCamera classSide methodsFor: 'defaults' stamp: ''!
defaultPosition
	^ 0 @ 0! !

!ROCamera classSide methodsFor: 'public' stamp: ''!
realExtent: aPoint
	^ self new realExtent: aPoint! !

!ROCamera methodsFor: 'accessing' stamp: ''!
angle
	^ angle! !

!ROCamera methodsFor: 'accessing' stamp: ''!
angleInRadian
	^ angle asFloat / 180 * 3.1415! !

!ROCamera methodsFor: 'accessing' stamp: ''!
bounds
	"bounds "
	^ position extent: extent
	
"	| ra v p |
	ra := self angleInRadian.
	v := height * ra sin.
	p := position.
	^ ((p x - v) @ (p y - v)) asIntegerPoint corner: ((p x + v) @ (p y + v)) asIntegerPoint"! !

!ROCamera methodsFor: 'accessing' stamp: ''!
bounds: rec

	"Should be removed!!"
	position := rec topLeft.
	self extent: rec extent.! !

!ROCamera methodsFor: 'rendering' stamp: 'AlexandreBergel 7/25/2012 16:11'!
canvas
	^ ROPlatform current canvasClass onCamera: self! !

!ROCamera methodsFor: 'accessing' stamp: ''!
centerPosition
	^ self bounds center! !

!ROCamera methodsFor: 'accessing' stamp: ''!
extent
	^ extent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
extent: anExtent
	extent := anExtent! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 7/23/2012 15:39'!
height
	^ (self extent x / 2) / (self angleInRadian / 2 ) tan
	"^ self extent y"
	
"OLD VERSION:

height
	^ (self realExtent x / 2) / (self angleInRadian / 2 ) tan
	
	"! !

!ROCamera methodsFor: 'accessing' stamp: ''!
height: h
	| nx ny oldExtent |
	nx := 2 * h * (self angleInRadian / 2) tan.
	ny := self extent x * nx / self extent y.
	"stepForPosition := (realExtent - (nx asInteger @ ny asInteger)) / 2."
	
	oldExtent := extent.
	"self translateBy: stepForPosition asIntegerPoint negated."
	extent := nx asInteger @ ny asInteger.
	self translateBy: ((extent - oldExtent ) / 2) asIntegerPoint! !

!ROCamera methodsFor: 'initialize' stamp: 'AlexandreBergel 6/5/2012 00:24'!
initialize
	super initialize.
	angle := self class defaultAngle.
	position := self class defaultPosition.
	realExtent := self class defaultExtent.
	extent := self class defaultExtent! !

!ROCamera methodsFor: 'public' stamp: ''!
moveDown
	self height: self height - 10! !

!ROCamera methodsFor: 'public' stamp: ''!
moveToSee: aRectangle
	| t |
	t := aRectangle extent x min: aRectangle extent y.
	position := t @ t.
	"height := (t / 2 / (self angleInRadian / 2) tan) asInteger"
	"height := ((aRectangle extent x) / 2 / (self angleInRadian / 2) tan) asInteger"! !

!ROCamera methodsFor: 'public' stamp: ''!
moveUp
	self height: self height +10! !

!ROCamera methodsFor: 'accessing' stamp: ''!
position
	^ position! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realBounds
	^ position extent: realExtent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realBounds: rec

	"Should be removed!!"
	position := rec topLeft.
	self realExtent: rec extent.! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realExtent
	^ realExtent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realExtent: anObject
	realExtent := anObject! !

!ROCamera methodsFor: 'util' stamp: 'AlexandreBergel 7/26/2012 11:46'!
realToVirtualPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"
	
	| visibleBounds offset |
"	
	offset := visibleBounds origin.
"
	"Safe guard!!"
	(realExtent = (0 @ 0)) ifTrue: [ ^ 1 @ 1 ].
	
	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat / realExtent x * visibleBounds width + offset x) asInteger) @
	   ((aPoint y asFloat / realExtent y * visibleBounds height + offset y) asInteger)
! !

!ROCamera methodsFor: 'util' stamp: ''!
realToVirtualPointNoTrunc: aPoint
	"Return a real point from a one expressed in the virtual coordinates"
	
	| visibleBounds offset |
	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat / realExtent x * visibleBounds width + offset x) asFloat) @
	   ((aPoint y asFloat / realExtent y * visibleBounds height + offset y) asFloat)
! !

!ROCamera methodsFor: 'util' stamp: ''!
realToVirtualRectangle: aRectangle
	"Return a rectangle with virtual coordinates from one expressed in the real coordinates"
	
	^ (self realToVirtualPoint: aRectangle origin) corner: (self realToVirtualPoint: aRectangle corner)! !

!ROCamera methodsFor: 'public' stamp: ''!
translateBy: pos
	position := position + pos! !

!ROCamera methodsFor: 'public' stamp: ''!
translateBy: aPoint during: aBlock
	self translateBy: aPoint.
	aBlock value.
	self translateBy: aPoint negated.! !

!ROCamera methodsFor: 'public' stamp: ''!
translateByRealStep: aStep
	"aStep represents the step in pixel on what the user see the visu"
	
	self translateBy: (self realToVirtualPoint: aStep)! !

!ROCamera methodsFor: 'public' stamp: ''!
translateTo: pos
	position := pos! !

!ROCamera methodsFor: 'util' stamp: 'AlexandreBergel 7/23/2012 12:18'!
virtualToRealPoint: aPoint 
	"Return a virtual point from a one expressed in the real coordinates"
	
	^ (self virtualToRealPointNoTrunc: aPoint) asIntegerPoint ! !

!ROCamera methodsFor: 'util' stamp: ''!
virtualToRealPointNoTrunc: aPoint 
	"Return a virtual point from a one expressed in the real coordinates"
	
	| visibleBounds offset |
	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat - offset x  * realExtent x / visibleBounds width) asFloat) @
	   ((aPoint y asFloat - offset y * realExtent y / visibleBounds height) asFloat)
! !

!ROCamera methodsFor: 'util' stamp: ''!
virtualToRealRectangle: aRectangle
	"Return a rectangle with real coordinates from one expressed in the virtual coordinates"
	
	^ (self virtualToRealPoint: aRectangle origin) corner: (self virtualToRealPoint: aRectangle corner)! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 6/5/2012 11:17'!
width
	^ self extent x! !

ROObject subclass: #ROConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROConstraint classSide methodsFor: 'util' stamp: 'AlexandreBergel 9/30/2012 21:05'!
move: element above: anotherElement
	^ element translateTo: anotherElement position - (0 @ element height)! !

!ROConstraint classSide methodsFor: 'util' stamp: 'AlexandreBergel 9/30/2012 21:04'!
move: element below: anotherElement
	^ element translateTo: anotherElement position + (0 @ anotherElement height)! !

!ROConstraint classSide methodsFor: 'util' stamp: 'AlexandreBergel 9/30/2012 19:28'!
move: element onTheLeftOf: anotherElement
	^ element translateTo: anotherElement position - (element width @ 0)! !

!ROConstraint classSide methodsFor: 'util' stamp: 'AlexandreBergel 9/30/2012 21:02'!
move: element onTheRightOf: anotherElement
	^ element translateTo: anotherElement position + (anotherElement width @ 0)! !

!ROConstraint classSide methodsFor: 'public' stamp: 'AlexandreBergel 10/1/2012 09:30'!
stick: element above: anotherElement
	self move: element above: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element above: anotherElement ]! !

!ROConstraint classSide methodsFor: 'public' stamp: 'AlexandreBergel 10/2/2012 20:05'!
stick: element below: anotherElement
	self move: element below: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element below: anotherElement ].
	

! !

!ROConstraint classSide methodsFor: 'public' stamp: 'AlexandreBergel 10/1/2012 09:30'!
stick: element onTheLeftOf: anotherElement
	self move: element onTheLeftOf: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element onTheLeftOf: anotherElement ].
! !

!ROConstraint classSide methodsFor: 'public' stamp: 'AlexandreBergel 10/1/2012 09:30'!
stick: element onTheRightOf: anotherElement
	self move: element onTheRightOf: anotherElement.
	anotherElement
		on: ROElementEvent
		do: [ :event | self move: element onTheRightOf: anotherElement ].
! !

ROObject subclass: #ROCountingNullCanvas
	instanceVariableNames: 'numberOfRectangles numberOfLines numberOfImages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCountingNullCanvas classSide methodsFor: 'instance creation' stamp: ''!
on: aForm
	"we do nothing"
	^ self new! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
clipRect
	^1@1 extent: 100000@100000! !

!ROCountingNullCanvas methodsFor: 'drawing-rectangles' stamp: ''!
frameAndFillRectangle: bounds fillColor: c borderWidth: width borderColor: cc
	numberOfRectangles := numberOfRectangles + 1.
! !

!ROCountingNullCanvas methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize .
	numberOfRectangles := 0.
	numberOfLines := 0.
	numberOfImages := 0! !

!ROCountingNullCanvas methodsFor: 'drawing' stamp: ''!
line: fromPoint to: toPoint width: width color: color
	numberOfLines := numberOfLines + 1.! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfImages
	^ numberOfImages! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfLines
	^ numberOfLines! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfRectangles
	^ numberOfRectangles! !

!ROCountingNullCanvas methodsFor: 'drawing-images' stamp: ''!
paintImage: cacheForm at: position
	numberOfImages := numberOfImages + 1.
! !

!ROCountingNullCanvas methodsFor: 'hook' stamp: ''!
warpImage: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
	"We cancel this method. It is defined as abstract in the Canvas class"! !

ROObject subclass: #ROFontOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!ROFontOrganizer commentStamp: '<historical>' prior: 0!
Abstract class that tells about what a font looks like!

!ROFontOrganizer classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/25/2012 15:47'!
current
	^ self subclasses first! !

!ROFontOrganizer classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/27/2012 18:02'!
height
	self subclassResponsibility! !

!ROFontOrganizer classSide methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:35'!
offsetWhenDrawing
	^ 0 @ 0! !

!ROFontOrganizer classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/18/2012 15:50'!
widthOfString: string
	self subclassResponsibility! !

ROObject subclass: #ROGraphTransformation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Transformation'!

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:02'!
containsCycleIn: nodes with: edges 
	"Broken so far"
	^ self containsCycleIn: nodes with: edges alreadyPassedNodes: #() root: nodes first
! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:00'!
containsCycleIn: nodes with: edges alreadyPassedNodes: passedNodes root: rootNode

	| newNodes newPassedNode c res |
	nodes ifEmpty: [ ^ false ].
	(passedNodes includes: rootNode) ifTrue: [ ^ true ].
	
	newNodes := nodes.
	newPassedNode := passedNodes.
	
	res := false.
	nodes do: [ :node | 
		(passedNodes contains: node) ifTrue: [ ^ true ].
		newNodes := nodes copyWithout: rootNode.
		c := self getConnectedNodesFrom: node using: edges.
		newNodes := newNodes copyWithoutAll: c.
		newPassedNode := newPassedNode, (Array with: rootNode).
		
		res := res and: [self containsCycleIn: newNodes with: edges alreadyPassedNodes: passedNodes root: node]	
	].
	^ res
	! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:38'!
containsCycleIn: rootNode with: edges passedNodes: passedNodes

	| c usedEdges |
	edges ifEmpty: [ ^ false ].
	(passedNodes includes: rootNode) ifTrue: [ ^ true ].
	c := self getConnectedNodesFrom: rootNode using: edges.
	usedEdges := edges select: [ :edge | edge from == rootNode ].
	passedNodes add: rootNode.
	c do: [ :nr | 
		(self containsCycleIn: nr with: (edges copyWithoutAll: usedEdges) passedNodes: passedNodes)
			ifTrue: [ ^ true ].
		passedNodes add: nr. ].
	^ false! !

!ROGraphTransformation methodsFor: 'public' stamp: 'DennisSchenk 6/27/2012 13:39'!
fromEdgesToNesting: nodes edges: edges
	^ self fromEdgesToNesting: nodes edges: edges roots: (self rootNodesFor: nodes edges: edges).! !

!ROGraphTransformation methodsFor: 'public' stamp: 'DennisSchenk 6/27/2012 13:43'!
fromEdgesToNesting: nodes edges: edges root: root
	| connectedNodes t |
	"self assert: [ self containsCycleIn: nodes with: edges ] description: 'Cannot contain cycle'."
	
	connectedNodes := self getConnectedNodesFrom: root using: edges.
	t := nodes copy asOrderedCollection.
	connectedNodes do: [: n | t remove: n ifAbsent: []].
	
	connectedNodes := connectedNodes 
						collect: [ :node | self 
										fromEdgesToNesting: t 
										edges: edges 
										root: node ].
	connectedNodes do: #remove.
	root addAll: connectedNodes.
	
	^ root! !

!ROGraphTransformation methodsFor: 'public' stamp: 'DennisSchenk 6/27/2012 13:40'!
fromEdgesToNesting: nodes edges: edges roots: roots
	roots size > 1 ifTrue: [
		| result |
		result := OrderedCollection new.
		roots do: [ :root |
			result add: (self fromEdgesToNesting: nodes edges: edges root: root).
		].
		^ result.
	].
	^ self fromEdgesToNesting: nodes edges: edges root: roots first.
! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:49'!
getConnectedEdgesFrom: rootNode using: edges
	^ (edges select: [ :edge | edge from == rootNode ])! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 09:30'!
getConnectedNodesFrom: rootNode using: edges
	^ (edges select: [ :edge | edge from == rootNode ]) collect: #to! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 11:02'!
hasCycleIn: nodes with: edges	
	| connectedNodes connectedEdges runningNodes runningEdges |

	runningNodes := nodes.
	runningEdges := edges.
	nodes copy do: [ :n |	
		runningNodes := runningNodes copyWithout: n.
		
		connectedNodes := self getConnectedNodesFrom: n using: runningEdges.
		connectedEdges := self getConnectedEdgesFrom: n using: runningEdges.
		
		(runningNodes includesAllOf: connectedNodes) ifFalse: [ ^ true ].
		
		runningNodes := runningNodes copyWithoutAll: connectedNodes.
		runningEdges := runningEdges copyWithoutAll: connectedEdges.

		runningEdges ifEmpty: [ ^ false ].
		runningNodes ifEmpty: [ ^ false ].

	]! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'DennisSchenk 6/6/2012 12:41'!
parentsFor: aNode edges: edges
	| nodes |
	nodes := OrderedCollection new.
	edges do: [ :edge | edge to == aNode ifTrue: [ nodes add: edge from ] ].
	^ nodes.! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'DennisSchenk 6/6/2012 12:44'!
rootNodeFor: nodes edges: edges
	| rootNodes |
	rootNodes := self rootNodesFor: nodes edges: edges.
	rootNodes size > 1 ifTrue: [ self error: 'More than one root node found' ].
	^ rootNodes first.! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'DennisSchenk 6/6/2012 12:43'!
rootNodesFor: aNodeCollection edges: edges
	^ aNodeCollection select: [:node | (self parentsFor: node edges: edges) isEmpty ].! !

ROObject subclass: #ROIdentityMatrix
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row keys! !

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u at: v
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row
		at: v
		ifAbsent: [false]! !

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u at: v put: aBoolean
	
	| row |
	"u -> v"
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	row at: v put: aBoolean.	"v -> u"
	row := rows
		at: v
		ifAbsentPut: [IdentityDictionary new].
	row at: u put: aBoolean! !

!ROIdentityMatrix methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/18/2012 14:27'!
initialize
	
	rows := IdentityDictionary new! !

ROObject subclass: #ROInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

ROInteraction subclass: #ROAbstractExpandChildrenOnClick
	instanceVariableNames: 'childrenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAbstractExpandChildrenOnClick classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 6/21/2012 15:41'!
childrenBlock: aBlock
	^self new
		childrenBlock: aBlock;
		yourself.! !

!ROAbstractExpandChildrenOnClick classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 10/7/2012 13:10'!
childrenForModel: aBlock

	^ self childrenBlock: [ :el | 
		| children |
		children := aBlock value: el model.
		children collect: [:c | (ROElement on: c) + ROLabel + ROBox] ]! !

!ROAbstractExpandChildrenOnClick methodsFor: 'initialization' stamp: 'AlexandreBergel 6/21/2012 15:41'!
addChildren: newNode to: element

	| edge line |
	self adjustNode: newNode.
	element view add: newNode.
	
	line := ROLine new.
	edge := (ROEdge from: element to: newNode) + line.
	line attachPoint: ROVerticalAttachPoint new.
	element view add: edge.
	^ newNode! !

!ROAbstractExpandChildrenOnClick methodsFor: 'initialization' stamp: 'AlexandreBergel 6/21/2012 15:40'!
addChildrenFromModel: model to: element

	| newNode edge line |
	newNode := ROElement spriteOn: model.
	newNode + ROLabel @ (ROExpandChildrenOnClick childrenBlock: childrenBlock).
	element view add: newNode.
	
	line := ROLine new.
	edge := (ROEdge from: element to: newNode) + line.
	line attachPoint: ROVerticalAttachPoint new.
	element view add: edge.
	^ newNode! !

!ROAbstractExpandChildrenOnClick methodsFor: 'hooks' stamp: 'AlexandreBergel 6/21/2012 15:41'!
adjustNode: node
	self subclassResponsibility ! !

!ROAbstractExpandChildrenOnClick methodsFor: 'accessing' stamp: 'AlexandreBergel 6/21/2012 15:40'!
childrenBlock
	^ childrenBlock! !

!ROAbstractExpandChildrenOnClick methodsFor: 'accessing' stamp: 'AlexandreBergel 6/21/2012 15:40'!
childrenBlock: anObject
	childrenBlock := anObject! !

!ROAbstractExpandChildrenOnClick methodsFor: 'accessing' stamp: 'AlexandreBergel 10/7/2012 12:57'!
computeChildrenFor: element
	^ childrenBlock value: element! !

!ROAbstractExpandChildrenOnClick methodsFor: 'initialization' stamp: 'AlexandreBergel 6/21/2012 15:40'!
initializeElement: element

	element on: ROMouseClick do: [:event |
		| elements newElements roElements |
		
		newElements := childrenBlock value: element.
		roElements := newElements collect: [:children | 
			self addChildren: children to: element ].
		roElements do: [ :el | el translateTo: element position].


		elements := element view elementsSuchThat: #notNil.
		ROTreeLayout new
			translator: ROSmoothLayoutTranslator new;
			applyOn: elements.
			
		element signalUpdate. ].! !

ROAbstractExpandChildrenOnClick subclass: #ROExpandChildrenOnClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROExpandChildrenOnClick methodsFor: 'hooks' stamp: 'AlexandreBergel 6/21/2012 15:41'!
adjustNode: node
	! !

ROAbstractExpandChildrenOnClick subclass: #RORecursiveExpandOnClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RORecursiveExpandOnClick methodsFor: 'hooks' stamp: 'AlexandreBergel 6/21/2012 15:41'!
adjustNode: node
	node @ (ROExpandChildrenOnClick childrenBlock: childrenBlock).! !

ROInteraction subclass: #ROAbstractPopup
	instanceVariableNames: 'receivingView'
	classVariableNames: 'Popups'
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAbstractPopup classSide methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 10:46'!
defaultPopupOffset
	^ 10 @ 10! !

!ROAbstractPopup methodsFor: 'hooks' stamp: ''!
createElementFor: element
	self subclassResponsibility! !

!ROAbstractPopup methodsFor: 'creation' stamp: 'AlexandreBergel 6/1/2012 18:32'!
createPopupFor: element
	| el |
	el := self createElementFor: element.
	el on: ROMouseLeave do: [ :e | el view remove: el ifAbsent: [  ] ].

	(self receivingViewFor: element) add: el.	

	self popups add: el.

	^ el! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 6/1/2012 18:27'!
initialize
	super initialize.
	receivingView := [ :element | element view ]. ! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 8/2/2012 18:09'!
initializeElement: element
	 element on: ROMouseEnter do: [ :event | 
		| el popupPosition |
		self removeAllPopups.
		el := self createPopupFor: element.

		popupPosition := (self receivingViewFor: element) camera realToVirtualPoint: event realPosition.
		el translateTo: (popupPosition + self popupOffset).
		el signalUpdate ].
	
	 element on: ROMouseLeave do: [ :event | 
		self removeAllPopups.
		element signalUpdate  ].

	 element on: ROMouseDragging do: [ :event | 
		self removeAllPopups ].! !

!ROAbstractPopup methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 10:47'!
popupOffset
	^ self class defaultPopupOffset! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 5/21/2012 22:07'!
popups
	^ Popups ifNil: [ Popups := OrderedCollection new ]! !

!ROAbstractPopup methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 18:28'!
receivingView: rView
	receivingView := rView! !

!ROAbstractPopup methodsFor: 'creation' stamp: 'AlexandreBergel 6/1/2012 18:30'!
receivingViewFor: element
	"Return the view in which the popup has to be added. Per default this view is the view in which the element is contained.
	However, this may be different, especially when contained in a stack"
	^ receivingView roValue: element! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 5/28/2012 21:16'!
removeAllPopups
	self popups do: [ :p | self removePopup: p ].
	Popups := nil! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 5/28/2012 21:19'!
removePopup: el
	el ifNotNil: [ el view remove: el ifAbsent: [] ].! !

ROAbstractPopup subclass: #ROPopup
	instanceVariableNames: 'text textColor box'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROPopup classSide methodsFor: 'public' stamp: ''!
text: txtBlock
	^ self new text: txtBlock; yourself! !

!ROPopup methodsFor: 'accessing' stamp: 'DennisSchenk 10/2/2012 13:02'!
box
	^ box! !

!ROPopup methodsFor: 'accessing' stamp: 'DennisSchenk 10/2/2012 13:03'!
box: aROBox
	 box := aROBox.! !

!ROPopup methodsFor: 'creation' stamp: 'DennisSchenk 10/2/2012 16:39'!
createElementFor: element
	^ ROElement new
			add: (ROElement new 
					+ ((ROLabel 
						text: (text roValue: element model)) color: textColor))
					+ box copy;
			yourself! !

!ROPopup methodsFor: 'initialization' stamp: 'DennisSchenk 10/2/2012 16:35'!
initialize 
	super initialize.
	text := #yourself.
	textColor := Color white.
	box := ROBox new.! !

!ROPopup methodsFor: 'accessing' stamp: ''!
text
	^ text! !

!ROPopup methodsFor: 'accessing' stamp: ''!
text: anObject
	text := anObject! !

!ROPopup methodsFor: 'accessing' stamp: ''!
textColor
	^ textColor! !

!ROPopup methodsFor: 'accessing' stamp: ''!
textColor: anObject
	textColor := anObject! !

ROAbstractPopup subclass: #ROPopupView
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROPopupView classSide methodsFor: 'public' stamp: 'AlexandreBergel 7/6/2012 13:51'!
view: v
	^ self new view: v! !

!ROPopupView methodsFor: 'hooks' stamp: 'AlexandreBergel 8/2/2012 18:07'!
createElementFor: element
	| bitmap v extent encompassingRectangle |
	"We need here to have a proper extent here."
	v := (view roValue: element) view.
	encompassingRectangle := v encompassingRectangle.
	extent := encompassingRectangle corner asIntegerPoint + (1 @ 1).
	^ (ROElement new extent: extent) + (ROViewDisplayer new view: v; yourself)
! !

!ROPopupView methodsFor: 'accessing' stamp: ''!
view
	^ view! !

!ROPopupView methodsFor: 'accessing' stamp: ''!
view: aView
	view := aView! !

ROInteraction subclass: #ROAddName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAddName classSide methodsFor: 'public' stamp: 'AlexandreBergel 10/3/2012 18:16'!
removeFrom: anElement
 
	(anElement attributes includesKey: #addedName)
		ifTrue: [ (anElement attributes at: #addedName) remove.
				anElement attributes removeKey: #addedName ]! !

!ROAddName classSide methodsFor: 'public' stamp: 'AlexandreBergel 10/3/2012 18:19'!
toElement: anElement
	| label |

	"We first make sure no previous element are around"
	self removeFrom: anElement. 
	
	
	label := ROElement on: anElement model.
	label + ROLabel + ROBox white.

	anElement attributes at: #addedName put: label.	
	anElement view add: label.
	
	ROConstraint stick: label below: anElement! !

ROInteraction subclass: #ROAnimation
	instanceVariableNames: 'nbCycles afterBlock remainingCycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAnimation methodsFor: 'hooks' stamp: ''!
after: aBlock
	afterBlock := aBlock! !

!ROAnimation methodsFor: 'hooks' stamp: ''!
defaultNumberOfCycles
	^ 10! !

!ROAnimation methodsFor: 'testing' stamp: ''!
hasCompleted 
	^ remainingCycles = 0! !

!ROAnimation methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	nbCycles := self defaultNumberOfCycles.
	afterBlock := #yourself! !

!ROAnimation methodsFor: 'hooks' stamp: 'AlexandreBergel 9/29/2012 14:38'!
millisecondsToWait
	^ 3! !

!ROAnimation methodsFor: 'accessing' stamp: ''!
nbCycles
	^ nbCycles! !

!ROAnimation methodsFor: 'accessing' stamp: ''!
nbCycles: integer
	nbCycles := integer! !

!ROAnimation methodsFor: 'action' stamp: 'AlexandreBergel 9/29/2012 14:38'!
wait
	(Delay forMilliseconds: self millisecondsToWait) wait! !

!ROAnimation methodsFor: 'action' stamp: 'AlexandreBergel 9/1/2012 19:32'!
waitUntilDone

	200 timesRepeat: [
		self hasCompleted ifTrue: [ ^ self ].
		self wait
	].
	! !

ROAnimation subclass: #ROFocusView
	instanceVariableNames: 'increment view positionToFocusOn finalPositionOfTheCamera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROFocusView classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/29/2012 14:50'!
on: element
	^ self new on: element! !

!ROFocusView methodsFor: 'hooks' stamp: ''!
defaultNumberOfCycles
	^ 100! !

!ROFocusView methodsFor: 'private' stamp: 'AlexandreBergel 9/29/2012 14:59'!
highlightElement: element
	| sequence |
	ROHighlightElement on: element.
	sequence := ROSequenceOfInteraction new.
	sequence after: 1000 do: [ ROUnhighlightElement on: element ].
	^ sequence execute! !

!ROFocusView methodsFor: 'private' stamp: 'AlexandreBergel 9/29/2012 14:44'!
incrementalMovement: camera
	camera translateBy: increment.
	view signalUpdate.
	remainingCycles := remainingCycles - 1.
	^ self wait! !

!ROFocusView methodsFor: 'hooks' stamp: 'AlexandreBergel 9/29/2012 14:39'!
millisecondsToWait
	^ 1! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 10/1/2012 13:45'!
on: element
	"Public method"

	"There is some duplication with ROLinearMove. Need to check!!!!!!"

	self onWithoutProcess: element.
	"[ self onWithoutProcess: element ] fork"! !

!ROFocusView methodsFor: 'public deprecated' stamp: 'AlexandreBergel 9/29/2012 14:55'!
on: element view: aView 
	"Public method"
	"There is some duplication with ROLinearMove. Need to check!!!!!!"
	
	"Deprecated method"

	self on: element! !

!ROFocusView methodsFor: 'private' stamp: 'AlexandreBergel 10/1/2012 13:45'!
onWithoutProcess: element
	| camera |
	
	positionToFocusOn := element absolutePosition.
	view := element view.
	camera := view camera.
	remainingCycles := self defaultNumberOfCycles.
	self wholeMovement: camera.
	^ self highlightElement: element! !

!ROFocusView methodsFor: 'private' stamp: 'AlexandreBergel 10/1/2012 12:03'!
toElement: element
	"Move the camera to element"
	| destinationPoint camera |
	camera := element view camera.
	positionToFocusOn := element position.
	self wholeMovement: camera.	
! !

!ROFocusView methodsFor: 'private' stamp: 'AlexandreBergel 10/1/2012 12:08'!
toPosition: position
	"There is some duplication with ROLinearMove. Need to check!!!!!!"

	| camera destinationPoint |
	camera := view camera.
	positionToFocusOn := position.
	remainingCycles := self defaultNumberOfCycles.
	[ self wholeMovement: camera ] fork! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 9/29/2012 14:43'!
toPosition: position view: aView
	"Public method"
	"There is some duplication with ROLinearMove. Need to check!!!!!!"

	view := aView.
	self toPosition: position! !

!ROFocusView methodsFor: 'private' stamp: 'AlexandreBergel 10/1/2012 13:32'!
wholeMovement: camera
	finalPositionOfTheCamera := positionToFocusOn - camera centerPosition.
	increment := finalPositionOfTheCamera / nbCycles.
	nbCycles timesRepeat: [ self incrementalMovement: camera ].
	"camera translateTo: (finalPositionOfTheCamera - camera centerPosition)."! !

ROAnimation subclass: #ROFunctionMove
	instanceVariableNames: 'numberOfCycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROFunctionMove commentStamp: 'VanessaPena 8/26/2012 09:44' prior: 0!
A ROFunctionMove is just a test, is not a complete interaction yet :)
!

!ROFunctionMove methodsFor: 'hooks' stamp: 'VanessaPena 8/23/2012 16:21'!
defaultNumberOfCycles
	^ 100! !

!ROFunctionMove methodsFor: 'public' stamp: 'AlexandreBergel 10/3/2012 08:41'!
for: element function: aBlock intervalIni: ini IntervalEnd: end 

	|xIncrement yIncrement position|
	[
	xIncrement := ((end - ini)/ nbCycles) asFloat .
	"xIncrement inspect ."
	yIncrement := (aBlock value: ini).
	 remainingCycles := nbCycles + 1.
	  (1 to: nbCycles) do: [ :i |
		yIncrement := ((aBlock value: xIncrement * i)) - yIncrement.
		element translateBy: xIncrement @ yIncrement.
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		self wait.
		].
	   remainingCycles := remainingCycles - 1. ] fork
! !

!ROFunctionMove methodsFor: 'public' stamp: 'AlexandreBergel 10/3/2012 08:41'!
for: element function: aBlock intervalIni: ini IntervalEnd: end XFactor: factor

	|xIncrement yIncrement position|
	[
	xIncrement := ((end - ini)/ nbCycles) asFloat.
	"xIncrement inspect ."
	yIncrement := (aBlock value: ini).
	 remainingCycles := nbCycles + 1.
	  (1 to: nbCycles) do: [ :i |
		yIncrement := ((aBlock value: xIncrement * i)) - yIncrement.
		element translateBy: (xIncrement * factor)@ yIncrement.
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		self wait.
		].
	   remainingCycles := remainingCycles - 1. ] fork
! !

!ROFunctionMove methodsFor: 'public' stamp: 'AlexandreBergel 10/3/2012 08:41'!
for: element functionX: aXBlock Y: aYBlock intervalIni: ini IntervalEnd: end

	|xIncrement yIncrement position increment|
	[
	increment := ((end - ini)/ nbCycles) asFloat.
	yIncrement := (aYBlock value: ini).
	xIncrement := (aXBlock value: ini).
	 remainingCycles := nbCycles + 1.
	  (1 to: nbCycles) do: [ :i |
		yIncrement := ((aYBlock value: (increment * i)) - yIncrement) asFloat.
		xIncrement := ((aXBlock value: (increment * i)) - xIncrement) asFloat.
		element translateBy: (xIncrement@ yIncrement).
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		self wait.
		].
	   remainingCycles := remainingCycles - 1. ] fork
! !

!ROFunctionMove methodsFor: 'public' stamp: 'AlexandreBergel 10/3/2012 08:41'!
for: element functionXY: aBlock intervalIni: ini IntervalEnd: end XFactor: factor

	|xIncrement yIncrement position|
	[
	xIncrement := ((end - ini)/ nbCycles) asFloat.
	"xIncrement inspect ."
	yIncrement := (aBlock value: ini).
	 remainingCycles := nbCycles + 1.
	  (1 to: nbCycles) do: [ :i |
		yIncrement := ((aBlock value: xIncrement * i)) - yIncrement.
		element translateBy: (xIncrement * factor)@ 0.
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		self wait.
		].
	   remainingCycles := remainingCycles - 1. ] fork
! !

!ROFunctionMove methodsFor: 'hooks' stamp: 'AlexandreBergel 10/3/2012 08:41'!
millisecondsToWait
	^ 10 ! !

ROAnimation subclass: #ROIncrementalZoomMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROIncrementalZoomMove methodsFor: 'public' stamp: 'AlexandreBergel 4/30/2012 15:54'!
on: view
	| v |
	v := view camera bounds.
	v := (v origin + self step) corner: (v corner - self step).
	^ ROZoomMove new nbCycles: nbCycles; on: view to: v! !

ROIncrementalZoomMove subclass: #ROZoomInMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomInMove methodsFor: 'config' stamp: ''!
step
	^ 40 @ 40! !

ROIncrementalZoomMove subclass: #ROZoomOutMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomOutMove methodsFor: 'config' stamp: ''!
step
	^ -40 @ -40! !

ROAnimation subclass: #ROLinearMove
	instanceVariableNames: 'increment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROLinearMove commentStamp: 'AlexandreBergel 11/28/2011 10:50' prior: 0!
ROLinearMove moves an element in a number of cycles.

Example of usage:
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	| view el |
	view := ROView new.
	el := ROElement sprite.
	view add: el.
	view on: ROMouseLeftClick do: [ :event | 
		ROLinearMove new
			nbCycles: 180;
			for: el until: event position.
	].
	view open.
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=!

!ROLinearMove classSide methodsFor: 'public' stamp: ''!
for: element until: position
	^ self new for: element until: position! !

!ROLinearMove methodsFor: 'public' stamp: ''!
for: element until: position

	[
	 increment := ((position - element position) / nbCycles).
	 remainingCycles := nbCycles + 1.
	  nbCycles timesRepeat: [ 
		element translateBy: increment.
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		(Delay forMilliseconds: 1) wait.
		].
	   element translateTo: position.
	   remainingCycles := remainingCycles - 1. ] fork! !

ROAnimation subclass: #ROMotionMove
	instanceVariableNames: ''
	classVariableNames: 'RunningThreads'
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROMotionMove methodsFor: 'public' stamp: 'VanessaPena 5/11/2012 17:23'!
for: element initialSpeed: aPoint
	| process |
	aPoint isNil ifTrue: [ ^self].
	process := [
		| increment speed | 
		 increment := 1.
		speed := aPoint.
		[ speed r > 2 ] whileTrue:  [ 
			element translateBy: speed asIntegerPoint.
			speed := aPoint / increment.
			increment := increment + 1.
			element signalUpdate.
			(Delay forMilliseconds: 50) wait.
			].
		self runningThreads removeKey: element ifAbsent: [] ] fork.
	
	"Only one process per element. It does not make sense to have many"
	self runningThreads at: element ifPresent: [ :p | p terminate ].
	self runningThreads at: element put: process.

! !

!ROMotionMove methodsFor: 'util' stamp: ''!
runningThreads
	RunningThreads ifNil: [ RunningThreads := IdentityDictionary new ].
	^ RunningThreads! !

ROAnimation subclass: #ROZoomMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomMove methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize.
	nbCycles := 50.! !

!ROZoomMove methodsFor: 'public' stamp: 'AlexandreBergel 4/30/2012 15:54'!
on: view to: finalRealBounds

	| initialRealBounds incrementX1Y1 incrementX2Y2 topLeft bottomRight camera animBlock animation |
	camera := view camera.
	 initialRealBounds := camera bounds.
	incrementX1Y1 := ((finalRealBounds  topLeft - initialRealBounds topLeft) / nbCycles).
	incrementX2Y2 := ((finalRealBounds  bottomRight - initialRealBounds bottomRight) / nbCycles).
	 
	 topLeft := initialRealBounds topLeft.
	 bottomRight := initialRealBounds bottomRight.
	
	 animBlock := [ 
		topLeft := topLeft + incrementX1Y1.
		bottomRight := bottomRight + incrementX2Y2.
		camera bounds: (topLeft asIntegerPoint corner: bottomRight asIntegerPoint).
		].
	animation := ROBeginingAnimation new animation: animBlock; nbCycles: nbCycles.

	view announce: animation.	
	^ animation
"	
	   camera virtualBounds: finalRealBounds.
	   view signalUpdate.
	   afterBlock value.
"
! !

ROInteraction subclass: #RODraggable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RODraggable methodsFor: 'hooks' stamp: 'AlexandreBergel 7/16/2012 08:08'!
initializeElement: element
	 element on: ROMouseDragging do: [ :event | 
		element translateByRealPoint: (event step).
		element signalUpdate ].! !

ROInteraction subclass: #RODraggableWithVelocity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RODraggableWithVelocity methodsFor: 'initialization' stamp: 'AlexandreBergel 7/25/2012 17:12'!
initializeElement: element
	| lastStep lastTimeStamp |
	
	element on: ROMouseDragging do: [:event |
		lastStep := event step.
		lastTimeStamp := ROPlatform current timeOrganizerClass milliseconds ].

	 element on: ROMouseDragged do: [ :event | 
		ROMotionMove new for: element initialSpeed: lastStep
		 ].! !

ROInteraction subclass: #ROGrowable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROGrowable commentStamp: '<historical>' prior: 0!
A ROGrowable makes the object grow when clicking on it.
!

!ROGrowable methodsFor: 'initialization' stamp: ''!
initializeElement: element
	 element on: ROMouseClick do: [ :event | 
		ROGrow on: element by: 10.
		element signalUpdate ].! !

!ROInteraction classSide methodsFor: 'public' stamp: ''!
elementToBeAdded
	^ self new ! !

!ROInteraction classSide methodsFor: 'public' stamp: ''!
initializeElement: element
	^ self elementToBeAdded initializeElement: element; yourself! !

!ROInteraction classSide methodsFor: 'public' stamp: 'BenComan 10/14/2012 23:08'!
key 
	"Used in the dictionary each element has"

	^ self ! !

!ROInteraction methodsFor: 'accessing' stamp: ''!
elementToBeAdded
	^ self ! !

!ROInteraction methodsFor: 'hooks' stamp: ''!
initializeElement: element
	self subclassResponsibility ! !

!ROInteraction methodsFor: 'hooks' stamp: 'BenComan 10/14/2012 23:09'!
key 
	"Used in the dictionary each element has"

	^ self class
! !

ROInteraction subclass: #ROLightlyHighlightable
	instanceVariableNames: 'highlightColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROLightlyHighlightable commentStamp: '<historical>' prior: 0!
A ROLightlyHighlightable is a decorator that highlights the element when the mouse is over it.!

!ROLightlyHighlightable classSide methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 10:02'!
highlightedColor
	^ Color blue! !

!ROLightlyHighlightable classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:11'!
lightBlue
	^ self new highlightColor: Color lightBlue; yourself! !

!ROLightlyHighlightable classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:13'!
lightGray
	^ self new highlightColor: Color lightGray; yourself! !

!ROLightlyHighlightable classSide methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 09:59'!
unhighlightedColor
	^ Color gray! !

!ROLightlyHighlightable classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:13'!
veryVeryLightGray
	^ self new highlightColor: Color veryVeryLightGray; yourself! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/24/2012 11:11'!
cacheKey
	"Key used as attribute"
	
	^ #previousColorBeforeHighlighting! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/24/2012 12:07'!
defaultHighlightColor
	^ self class highlightedColor
	
! !

!ROLightlyHighlightable methodsFor: 'accessing' stamp: 'AlexandreBergel 9/24/2012 12:09'!
highlightColor
	^ highlightColor! !

!ROLightlyHighlightable methodsFor: 'accessing' stamp: 'AlexandreBergel 9/24/2012 12:09'!
highlightColor: aColor
	highlightColor := aColor! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/29/2012 15:25'!
highlightElement: element
	ROHighlightElement on: element color: highlightColor 
! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/24/2012 12:09'!
initialize
	super initialize.
	self highlightColor: self defaultHighlightColor! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/24/2012 11:04'!
initializeElement: element
	element
		on: ROMouseEnter
		do: [ 
			self highlightElement: element.
			element signalUpdate ].
	element
		on: ROMouseLeave
		do: [ 
			self unhighlightElement: element.
			element signalUpdate ].! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 9/29/2012 15:25'!
unhighlightElement: element

	ROUnhighlightElement on: element
! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 5/1/2012 09:59'!
unhighlightedColor
	^ self class unhighlightedColor
! !

ROInteraction subclass: #ROMenuActivable
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROMenuActivable methodsFor: 'accessing' stamp: ''!
addActions: someActions
	actions addAll: someActions! !

!ROMenuActivable methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize.
	actions := OrderedCollection new.
	! !

!ROMenuActivable methodsFor: 'hooks' stamp: ''!
initializeElement: element
	^ (element is: self class)
		ifTrue: [ self installOnExistingInteractionOn: element ]
		ifFalse: [ self installHandlerOn: element]! !

!ROMenuActivable methodsFor: 'hooks' stamp: 'AlexandreBergel 7/25/2012 16:14'!
installHandlerOn: element
	element on: ROMouseRightClick do: [ :event |
		ROPlatform current widgetFactory menuForAssociations: actions on: element
	]! !

!ROMenuActivable methodsFor: 'hooks' stamp: ''!
installOnExistingInteractionOn: element
	| el |
	el := (element getInteraction: ROMenuActivable).
	el addActions: actions.

	^ el! !

!ROMenuActivable methodsFor: 'public' stamp: ''!
item: titleAsString action: aBlockOrSymbol

	actions add: (titleAsString -> aBlockOrSymbol)! !

!ROMenuActivable methodsFor: 'accessing' stamp: ''!
numberOfEntries
	^ actions size! !

ROInteraction subclass: #RORubberBand
	instanceVariableNames: 'tmpLine tmpElement dropAction targetSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RORubberBand methodsFor: 'as yet unclassified' stamp: 'BenComan 10/15/2012 21:58'!
initializeElement: sourceElement
"
	ROExample new rubberBanding	
"
	
	sourceElement on: ROMouseDragging do: 
	[ 	:event | | relativePosition |
		tmpLine ifNil: 
		[
			tmpElement := ROElement new.
			tmpLine := (ROEdge from: event element to: tmpElement) + ROLine; yourself.
			sourceElement view add: tmpLine.
			sourceElement view add: tmpElement. 			
	
			sourceElement view allElementsDo: 
			[	:candidateTarget | 
				candidateTarget getInteraction: self ifPresent:
				[	:interaction |
					targetSelection source: sourceElement target: candidateTarget. 
				].
			].
		].

        	relativePosition := sourceElement view camera realToVirtualPoint: (event position).
        	tmpElement translateTo: relativePosition.
	
        	sourceElement view signalUpdate.
	].


	sourceElement on: ROMouseDragged do: 
	[ 	:event | | targetElement newEdgeRaw |
		tmpElement remove.
		tmpLine remove.
		tmpLine := nil.
		tmpElement := nil.
	
		targetElement := (sourceElement view elementAtRealPosition: event position).
		(targetSelection contains: targetElement) ifTrue:
		[	
			newEdgeRaw := ROEdge lineFrom: event element to: targetElement.
			dropAction ifNotNil: [ dropAction value: newEdgeRaw ] 
		].
		targetSelection clear.
		
		sourceElement view signalUpdate.
	].  ! !

!RORubberBand methodsFor: 'as yet unclassified' stamp: 'BenComan 10/14/2012 23:16'!
key 
	"Used in the dictionary each element has"
	"Key on instance rather than class"

	^ self
! !

!RORubberBand methodsFor: 'as yet unclassified' stamp: 'BenComan 10/14/2012 23:16'!
onDrop: aBlock
	dropAction := aBlock! !

!RORubberBand methodsFor: 'as yet unclassified' stamp: 'BenComan 10/15/2012 22:10'!
targeting: aBlock
	targetSelection := aBlock! !

ROInteraction subclass: #ROScrollbable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 23:17'!
horizontalScrollbarFor: aStack

	| scrollbar view |
	
	view := aStack firstView.
	
	scrollbar := ROElement new.
	scrollbar width: 80.
	scrollbar height: 15.
	scrollbar + ROBox.
	
	scrollbar on: ROMouseDragging do: [ :event | 
		scrollbar translateByRealPoint: (event step * (1@0)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: (aStack camera width - scrollbar width) @ 0).
		
		(scrollbar position x >= 0 and: [ scrollbar position x  <=  (aStack camera extent x - scrollbar width)])
			ifTrue: [ 
				| xView |
				xView := view encompassingRectangle width * scrollbar position x / view camera width negated.
				view translateTo: (xView @ view camera position y negated) asIntegerPoint ].
		scrollbar signalUpdate.
	].

"	view  on: ROMouseDragging do: [ :event | 
		| xView |
		xScroll := view encompassingRectangle width * scrollbar position x / view camera width negated.
		scrollbar translateTo: (xScroll @ 0).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: (aStack camera extent x - scrollbar width) @ 0).
	]."
 
	^ scrollbar! !

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 17:58'!
initializeElement: aStack
	| view horizontalScrollbar verticalScrollbar |
	self assert: [ aStack isKindOf: ROViewStack ].
	 
	view := aStack firstView.
	
	horizontalScrollbar := self horizontalScrollbarFor: aStack.
	verticalScrollbar := self verticalScrollbarFor: aStack.
	
	aStack add: horizontalScrollbar.
	aStack add: verticalScrollbar.! !

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 23:18'!
verticalScrollbarFor: aStack

	| scrollbar view |
	
	view := aStack firstView.
	
	scrollbar := ROElement new.
	scrollbar width: 15.
	scrollbar height: 80.
	scrollbar + ROBox.
	
	scrollbar on: ROMouseDragging do: [ :event | 

		scrollbar translateByRealPoint: (event step * (0@1)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: 0 @ (aStack camera extent y - scrollbar height)).
		
		(scrollbar position y >= 0 and: [ scrollbar position y  <=  (aStack camera extent y  - scrollbar height)])
			ifTrue: [ 
				| yView |
				yView := view encompassingRectangle height * scrollbar position y / view camera extent y  negated.
				view translateTo: (view camera position x negated @ yView) asIntegerPoint ].
		scrollbar signalUpdate.
	].

	view on: ROMouseDragging do: [ :event | 
		scrollbar translateBy: (event step negated * (0 @ 1)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: 0 @ aStack camera extent y - scrollbar height).
	].
 
	^ scrollbar! !

ROInteraction subclass: #ROSelection
	instanceVariableNames: 'filter inclusionAction exclusionAction selectedElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROSelection methodsFor: 'as yet unclassified' stamp: 'BenComan 10/15/2012 22:08'!
clear
	exclusionAction ifNotNil: [ selectedElements do: [ :element | exclusionAction value: element ] ].
	selectedElements := OrderedCollection new.
! !

!ROSelection methodsFor: 'comparing' stamp: 'BenComan 10/15/2012 22:23'!
contains: aROElement 
	selectedElements do: [ :element | (element = aROElement) ifTrue: [ ^true] ].
	^false.! !

!ROSelection methodsFor: 'as yet unclassified' stamp: 'BenComan 10/15/2012 22:05'!
for: aBlock 
	filter := aBlock.
	! !

!ROSelection methodsFor: 'as yet unclassified' stamp: 'BenComan 10/15/2012 22:12'!
initialize 
	super initialize.
	filter := [ :source :target | false ].
	selectedElements := OrderedCollection new.
! !

!ROSelection methodsFor: 'as yet unclassified' stamp: 'BenComan 10/15/2012 22:09'!
onExclusion: aBlock 
	exclusionAction := aBlock.
	! !

!ROSelection methodsFor: 'as yet unclassified' stamp: 'BenComan 10/15/2012 22:09'!
onInclusion: aBlock 
	inclusionAction := aBlock.
	! !

!ROSelection methodsFor: 'as yet unclassified' stamp: 'BenComan 10/15/2012 22:07'!
source: sourceElement target: targetElement
	(filter value: sourceElement value: targetElement) ifTrue:
	[
		selectedElements add: targetElement.
		inclusionAction ifNotNil: [ inclusionAction value: targetElement ].
	]! !

ROInteraction subclass: #ROZoomIntoElementOnClick
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomIntoElementOnClick methodsFor: 'initialization' stamp: ''!
initializeElement: element
	
	 element on: ROMouseClick do: [:event | 
		| move |
		move := ROZoomMove new.
		move after: [ stack addLast: (ROView new add: ROElement sprite) ].
		move on: element view to: element bounds ] ! !

!ROZoomIntoElementOnClick methodsFor: 'accessing' stamp: ''!
stack
	^ stack! !

!ROZoomIntoElementOnClick methodsFor: 'accessing' stamp: ''!
stack: aStack
	stack := aStack! !

ROInteraction subclass: #ROZoomOnClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomOnClick methodsFor: 'initialization' stamp: ''!
initializeElement: element
	 | el isZoomed originalBounds |
	isZoomed := false.
	
	 element on: ROMouseClick do: [:event | 
		isZoomed 
			ifTrue: [ ROZoomMove new on: element view to: originalBounds ]
			ifFalse: [
				originalBounds := element view camera bounds.
				ROZoomMove new on: element view to: element bounds ].
		isZoomed := isZoomed not ].
	
! !

ROObject subclass: #ROLayout
	instanceVariableNames: 'affectedNodes translator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROLayout subclass: #ROAbstractLineLayout
	instanceVariableNames: 'gapSize horizontalGap verticalGap horizontalOutGap verticalOutGap alignment horizontallyStretchable verticallyStretchable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractLineLayout classSide methodsFor: 'instance creation' stamp: ''!
withGap: anInteger
	
	^(self new)
		gapSize: anInteger;
		yourself! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignBottom
	
	alignment := #bottom! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignCenter
	
	alignment := #center! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignLeft
	
	alignment := #left! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignRight
	
	alignment := #right! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignTop
	
	alignment := #top! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignment
	
	^alignment! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignment: anObject
	
	alignment := anObject! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
center
	self alignment: #center! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	^self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
doCenter: aGraph
	self subclassResponsibility ! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:10'!
doExecute: aGraph 
	| pointer delta |
	pointer := self positionOriginalPointer: aGraph.
	aGraph do: 
		[ :element | 
		delta := self deltaFor: element.
		translator translate: element to: pointer - delta.
		self 
			movePointer: pointer
			accordingToFigure: element ].	

	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: aGraph ].
	verticallyStretchable ifTrue: 
		[ self doStretchVertical: aGraph ]! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
doStretchHorizontal: aGraph 
	"this method is executed after translating nodes"
	
 	| max parentBounds |
	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	max := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: el bounds width ].

	((parentBounds width >= max) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodes do: [ :node | 
						node bounds width: (parentBounds width - (2 * horizontalOutGap)).
						(node layout isLineLayout and: [ node layout horizontallyStretchable ])
							ifTrue: [ node layout doStretchHorizontal: node ]
					] ]
		ifFalse: [ aGraph nodes do: [ :node | node bounds width: max ] ]
	 
! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
doStretchVertical: aGraph 
	"this method is executed after translating nodes"

 	| max parentBounds |
	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	max := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: el bounds height ].

	((parentBounds height >= max) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodes do: [ :node | 
						node bounds height: (parentBounds height - (2 * verticalOutGap) ).
						(node layout isLineLayout and: [ node layout verticallyStretchable])
							ifTrue: [ node layout doStretchVertical: node ]
					] ]
		ifFalse: [ aGraph nodes do: [ :node | node bounds height: max ] ]! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
gapSize: aNumber
	gapSize := aNumber. " This value is never used actually "
	
	verticalGap := 2 * aNumber.
	horizontalGap := 2 * aNumber.
	verticalOutGap := aNumber.
	horizontalOutGap := aNumber! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalGap
	
	^horizontalGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalGap: anObject
	
	horizontalGap := anObject! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalOutGap
	
	^horizontalOutGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalOutGap: anObject
	
	horizontalOutGap := anObject! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
horizontallyStretchable
	^ horizontallyStretchable! !

!ROAbstractLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	verticalGap := 10.
	horizontalGap := 10.
	horizontalOutGap := 5.
	verticalOutGap := 5.
	horizontallyStretchable := verticallyStretchable := false! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
isLineLayout
	^ true! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
movePointer: pointer accordingToFigure: aNodeFigure
	
	self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
positionOriginalPointer: aGraph
	
	^self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretch
	horizontallyStretchable := verticallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretchHorizontally
	horizontallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretchVertically
	verticallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalGap
	
	^verticalGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalGap: anObject
	
	verticalGap := anObject! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalOutGap
	
	^verticalOutGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalOutGap: anObject
	
	verticalOutGap := anObject! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
verticallyStretchable
	^ verticallyStretchable! !

ROAbstractLineLayout subclass: #ROHorizontalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #bottom ifTrue: [delta := aNodeFigure height].
	self alignment == #center ifTrue: [delta := aNodeFigure height / 2.0].
	^0 @ delta! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
doCenter: aGraph 

 	| midTallest step |
	midTallest := 0.
	midTallest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds height )].
	midTallest := midTallest / 2.
	aGraph nodes do: [ :node | 
		step := 0@ (midTallest - (node bounds height /2)) asInteger.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:11'!
doExecute: aGraph 
	| pointer delta |
	pointer := self positionOriginalPointer: aGraph.
	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: aGraph ].
	aGraph do: 
		[ :element | 
		delta := self deltaFor: element.
		translator translate: element to: pointer - delta.
		pointer := self 
					movePointer: pointer
					accordingToFigure: element ].	

	verticallyStretchable ifTrue: 
		[ self doStretchVertical: aGraph ]! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
doStretchHorizontal: aGraph 

 	| parentBounds addedWidth parentBoundsWidth runningIndex newWidth origin |

	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	addedWidth := aGraph nodes 
		inject: 0
		into: [ :m :el | m + el width ].

	parentBoundsWidth := parentBounds width.
	parentBoundsWidth := parentBoundsWidth - ((aGraph nodes size - 1) * horizontalGap) - (2 * horizontalOutGap).
	
	runningIndex := horizontalOutGap.
	((parentBounds width > addedWidth) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodesDo: [ :node | 
						newWidth := (node width * parentBoundsWidth / addedWidth) asInteger.
						origin := node bounds origin.
						node bounds 
								origin: (runningIndex @ origin y) ;
								width: newWidth.
						runningIndex := runningIndex + newWidth + horizontalGap ] ]
! !

!ROHorizontalLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	self alignTop! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
movePointer: pointer accordingToFigure: element
	
	^ (pointer x + element width + self horizontalGap) @ pointer y! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
positionOriginalPointer: aGraph 
	| maxHeight delta |
	delta := 0.
	self alignment == #bottom ifTrue: 
		[ maxHeight := aGraph nodes maxValue: #height.
		delta := maxHeight ].
	self alignment == #center ifTrue: 
		[ maxHeight := aGraph nodes maxValue: #height.
		delta := maxHeight / 2.0 ].
	^ self horizontalOutGap @ (self verticalOutGap + delta)! !

ROAbstractLineLayout subclass: #ROVerticalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #right ifTrue: [delta := aNodeFigure width].
	self alignment == #center ifTrue: [delta := aNodeFigure width / 2.0].
	^delta @ 0! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
doCenter: aGraph 

 	| midWidest step |
	midWidest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds width )].
	midWidest := midWidest / 2.
	aGraph nodes do: [ :node | 
		step := (midWidest - (node bounds width /2)) asInteger @ 0.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
doStretchVertical: aGraph 

 	| parentBounds addedHeight parentBoundsHeight runningIndex newHeight origin |

	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	addedHeight := aGraph nodes 
		inject: 0
		into: [ :m :el | m + el height ].

	parentBoundsHeight := parentBounds height.
	parentBoundsHeight := parentBoundsHeight - ((aGraph nodes size - 1) * verticalGap) - (2 * verticalOutGap).
	
	runningIndex := verticalOutGap.
	((parentBounds height > addedHeight) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodesDo: [ :node | 
						newHeight := (node height * parentBoundsHeight / addedHeight) asInteger.
						origin := node bounds origin.
						node bounds 
								origin: (origin x @ runningIndex) ;
								height: newHeight.
						runningIndex := runningIndex + newHeight + verticalGap ] ]
! !

!ROVerticalLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	self alignLeft! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
movePointer: pointer accordingToFigure: aNodeFigure
	
	^pointer setX: pointer x setY: pointer y + aNodeFigure height + self verticalGap! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
positionOriginalPointer: elements 
	| maxWidth delta |
	delta := 0.
	self alignment == #right ifTrue: 
		[ maxWidth := elements maxValue: #width.
		delta := maxWidth ].
	self alignment == #center ifTrue: 
		[ maxWidth := elements maxValue: #width.
		delta := maxWidth / 2.0 ].
	^ (self horizontalOutGap + delta) @ self verticalOutGap! !

ROLayout subclass: #ROCircleLayout
	instanceVariableNames: 'factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROCircleLayout classSide methodsFor: 'instance creation' stamp: ''!
scaleBy: aNumber
	
	^self new scaleBy: aNumber! !

!ROCircleLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:09'!
doExecute: elements
	
	| angleTemp angle rad center |
	rad := elements size * self scaleFactor.
	center := Point x: rad y: rad.
	angleTemp := 2 * Float pi / elements size.
	angle := 0.
	elements
		do:
			[:each | 
			| point |
			point := center + (Point radius: rad theta: angle).
			angle := angle + angleTemp.
			translator translate: each to: point ]! !

!ROCircleLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self scaleBy: 11! !

!ROCircleLayout methodsFor: 'accessing' stamp: ''!
scaleBy: aNumber
	
	factor := aNumber! !

!ROCircleLayout methodsFor: 'accessing' stamp: ''!
scaleFactor
	
	^factor! !

ROLayout subclass: #ROEdgeDrivenLayout
	instanceVariableNames: 'edges userDefinedEdges fromPositions toPositions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROEdgeDrivenLayout subclass: #ROAbstractFlowLayout
	instanceVariableNames: 'maxWidth gapSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractFlowLayout classSide methodsFor: 'instance creation' stamp: ''!
withMaxWidth: anInteger
	
	^(self new)
		maxWidth: anInteger;
		yourself! !

!ROAbstractFlowLayout classSide methodsFor: 'instance creation' stamp: ''!
withMaxWidth: anInteger withGap: anotherInteger
	
	^(self new)
		maxWidth: anInteger;
		gapSize: anotherInteger;
		yourself! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
gapSize: anObject
	
	gapSize := anObject! !

!ROAbstractFlowLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	maxWidth := 100.
	gapSize := 5! !

!ROAbstractFlowLayout methodsFor: 'private' stamp: ''!
maxWidth
	
	^maxWidth! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
maxWidth: anObject
	
	maxWidth := anObject! !

ROAbstractFlowLayout subclass: #ROBottomFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROBottomFlowLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:17'!
doExecute: nodeElements 
	| x y maxLastLineHeight lineHeights lineNumber |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	lineHeights := OrderedCollection new.
	lineNumber := 1.
	nodeElements do: 
		[ :aNodeFigure | 
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ lineHeights addLast: maxLastLineHeight.
			x := self gapSize.
			maxLastLineHeight := 0 ] ].
	lineHeights addLast: maxLastLineHeight.
	x := self gapSize.
	nodeElements do: 
		[ :aNodeFigure | 
		| lineHeight |
		lineHeight := lineHeights at: lineNumber.
		translator translate: aNodeFigure to: x @ (y + lineHeight - aNodeFigure height).
		x := x + aNodeFigure width + (2 * self gapSize).
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + lineHeight.
			lineNumber := lineNumber + 1 ] ]! !

ROAbstractFlowLayout subclass: #ROFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROFlowLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:18'!
doExecute: nodeElements 
	| x y maxLastLineHeight |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	nodeElements do: 
		[ :aNodeFigure | 
		translator translate: aNodeFigure to: x @ y.
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + maxLastLineHeight.
			maxLastLineHeight := 0 ] ]! !

ROEdgeDrivenLayout subclass: #ROAbstractGraphLayout
	instanceVariableNames: 'verticalGap horizontalGap cachedChildren cachedParents cachedParentsWithHighestNestings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractGraphLayout classSide methodsFor: 'constants' stamp: ''!
horizontalGap
	
	^3.0! !

!ROAbstractGraphLayout classSide methodsFor: 'public' stamp: ''!
on: elements edges: edges
	"Do the layout of the elements tacking into account the provided edges"

	^ self new 
		userDefinedEdges: edges;
		applyOn: elements.! !

!ROAbstractGraphLayout classSide methodsFor: 'constants' stamp: ''!
verticalGap
	
	^20.0! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedChildren
	
	cachedChildren ifNil: [cachedChildren := IdentityDictionary new: 1000].
	^cachedChildren! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedParents
	
	cachedParents ifNil: [cachedParents := IdentityDictionary new: 1000].
	^cachedParents! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedParentsWithHighestNestings
	
	cachedParentsWithHighestNestings
		ifNil: [cachedParentsWithHighestNestings := IdentityDictionary new: 1000].
	^cachedParentsWithHighestNestings! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
childrenFor: aNode
	
	^self cachedChildren
		at: aNode
		ifAbsentPut:
			[| nodes |
			nodes := OrderedCollection new.
			self edgesDo:
					[:edge | 
					(edge from == aNode and: [edge to ~= aNode])
						ifTrue:
							[(nodes includes: edge from) ifFalse: [nodes add: edge to]]].
			nodes]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: 'TudorGirba 7/29/2012 20:20'!
childrenFor: aNode except: aNodeCollection
	
	^(self childrenFor: aNode) 
		reject: [:each | aNodeCollection includes: each]
	
	"we are explicitly not using the default Collection>>difference: behavior here because we want to preserve the order of the collection"! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
childrenWithHighestNestingLevelFor: aNode
	
	^(self childrenFor: aNode)
		select: [:eachChild | (self highestNestingParentFor: eachChild) == aNode]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
clear
	
	cachedParents := nil.
	cachedChildren := nil.
	cachedParentsWithHighestNestings := nil! !

!ROAbstractGraphLayout methodsFor: 'default values' stamp: ''!
defaultFromPositions
	
	^#(#bottomCenter)! !

!ROAbstractGraphLayout methodsFor: 'default values' stamp: ''!
defaultToPositions
	
	^#(#topCenter)! !

!ROAbstractGraphLayout methodsFor: 'hook' stamp: ''!
doInitialize: elements 
	super doInitialize: elements.
	self clear.
	self greedyCycleRemoval: elements! !

!ROAbstractGraphLayout methodsFor: 'battista' stamp: ''!
greedyCycleRemoval: aCollection
	"Di Battista Greedy-Cycle-Removal algorithm. Chapter 9.4, page 297. The last part is not like in the book. The original algorithm only takes
	 local optimas into account. This will break ordinary trees sometimes. This version also takes global optimas into account."
	
	| g sl sr s indeg outdeg degrees vertex |
	g := aCollection copy asOrderedCollection.
	sl := OrderedCollection new.
	sr := OrderedCollection new.	"While g contains a sink (aka leaf)"
	g copy
		do:
			[:node | 
			(self childrenFor: node) isEmpty
				ifTrue:
					[sr addFirst: node.
					g remove: node]	"self edges detect: [:edge | edge fromFigure == node] ifNone: [sr addFirst: node. g remove: node]"].	"While g contains a source (aka root)"
	g copy
		do:
			[:node | 
			(self parentsFor: node) isEmpty
				ifTrue:
					[sl addLast: node.
					g remove: node]	"self edges detect: [:edge | edge toFigure == node] ifNone: [sl addLast: node. g remove: node]"].	"Calculate deg for all remaining vertices"
	degrees := IdentityDictionary new.
	g
		do:
			[:node | 
			indeg := (self parentsFor: node) size.
			outdeg := (self childrenFor: node) size.	"indeg := self edges inject: 0 into: [:sum :edge | (edge toFigure == node) ifTrue: [sum + 1] ifFalse: [sum]].
		outdeg := self edges inject: 0 into: [:sum :edge | (edge fromFigure == node) ifTrue: [sum + 1] ifFalse: [sum]]."
			degrees
				at: node
				put: outdeg - indeg].	"While g not empty"
	g := g asSortedCollection: [:a :b | (degrees at: a) >= (degrees at: b)].
	[g isEmpty]
		whileFalse:
			[vertex := g
				detect: [:v | (self parentsFor: v) anySatisfy: [:w | sl includes: w]]
				ifNone: [g first].	"Corner case: Closed cycle with not root at all. Eg 1 -> 2 -> 3 -> 1"
			sl addLast: vertex.
			g remove: vertex].	"Remove all leftward edges"
	s := sl , sr.
	self edges notNil
		ifTrue: 
			[ self edges copy
				do:
					[:edge | 
					(s indexOf: edge source) > (s indexOf: edge target)
						ifTrue: [self edges remove: edge ] ] ].	
	"Reset the cache"
	self clear! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
highestNestingParentFor: aNodeFigure
	
	| parents |
	^self cachedParentsWithHighestNestings
		at: aNodeFigure
		ifAbsentPut:
			[parents := self parentsFor: aNodeFigure.
			parents isEmpty
				ifTrue: [0]
				ifFalse:
					[parents detectMax: [:eachParent | self nestingLevelFor: eachParent]]]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
horizontalGap
	
	^horizontalGap ifNil: [self class horizontalGap]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
horizontalGap: anInteger
	
	horizontalGap := anInteger! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
nestingLevelFor: aNodeFigure
	
	| parents parentsNesting |
	parents := self parentsFor: aNodeFigure.
	parentsNesting := parents
		collect: [:eachParent | self nestingLevelFor: eachParent].
	^parentsNesting isEmpty
		ifTrue: [0]
		ifFalse: [parentsNesting max + 1]
! !

!ROAbstractGraphLayout methodsFor: 'actions' stamp: 'AlexandreBergel 9/9/2012 20:00'!
on: el edges: edgs
	"Do the layout of the elements tacking into account the provided edges"

	self userDefinedEdges ifNil: [ self userDefinedEdges: edgs ].

	^ self applyOn: el.! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
parentsFor: aNode
	^ self cachedParents
		at: aNode
		ifAbsentPut:
			[ | nodes |
			nodes := OrderedCollection new.
			self edgesDo:
					[:edge | edge to == aNode ifTrue: [ nodes add: edge from ] ].
			nodes ]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: 'AlexandreBergel 8/19/2012 13:18'!
rootNodesFor: aCollection
	^ aCollection select: [:node | 
		node isNotEdge and: 
			[ (self parentsFor: node) isEmpty ] ].
	! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
verticalGap
	
	^verticalGap ifNil: [self class verticalGap]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
verticalGap: anInteger
	
	verticalGap := anInteger! !

ROAbstractGraphLayout subclass: #ROAbstractRegularTreeLayout
	instanceVariableNames: 'alreadyLayoutedNodes topGap leftGap nodesByLayer isLayered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROAbstractRegularTreeLayout subclass: #ROAbstractHorizontalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'BenComan 7/28/2012 13:43'!
computeChildrenFor: aNode
	self subclassResponsibility! !

!ROAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'BenComan 8/5/2012 15:53'!
defaultFromPositions
	
	^#(#rightCenter)
	
"BTC-2012-08-05 Not sure what effect this has or if this is a valid symbol - its just pattern matching."! !

!ROAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'BenComan 8/5/2012 15:53'!
defaultToPositions

	^#(#leftCenter)
	
"BTC-2012-08-05 Not sure what effect this has or if this is a valid symbol - its just pattern matching."! !

!ROAbstractHorizontalTreeLayout methodsFor: 'initialize-release' stamp: 'BenComan 7/28/2012 13:43'!
initialize
	super initialize.
	verticalGap := 3.
	horizontalGap := 20! !

!ROAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'AlexandreBergel 7/29/2012 08:50'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := x + each width + self horizontalGap.
		treeSize := each height
			max: (self layout: (self computeChildrenFor: each) atPoint: childrenPosition @ y atLayer: aNumber + 1).
		middleOfTree := y + (treeSize / 2.0) - (each height / 2.0).
		translator translate: each to: (x @ middleOfTree).
		y := y + treeSize + self verticalGap ].
	^ y - aPoint y - self verticalGap! !

!ROAbstractHorizontalTreeLayout methodsFor: 'private' stamp: 'TudorGirba 10/1/2012 14:10'!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self leftGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			translator translate: eachNode to: (cursor @ eachNode bounds top).
			max max: eachNode width ].
		cursor := cursor + layerDepthSize + self horizontalGap ]! !

ROAbstractHorizontalTreeLayout subclass: #ROHorizontalDominanceTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROHorizontalDominanceTreeLayout commentStamp: 'TudorGirba 10/1/2012 14:06' prior: 0!
The dominance tree layout is similar to a regular tree layout, only it poses a stronger condition in the way it places a node: a child is placed under the deepest parent. This layout is for example useful when identifying layers of dependencies.

Note: the layout is slower than the tree layout because of the more complex lookup!

!ROHorizontalDominanceTreeLayout methodsFor: 'hook-private' stamp: 'TudorGirba 9/27/2012 23:07'!
computeChildrenFor: aNode
	^ self childrenWithHighestNestingLevelFor: aNode! !

ROAbstractHorizontalTreeLayout subclass: #ROHorizontalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'BenComan 7/28/2012 13:50'!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

!ROAbstractRegularTreeLayout methodsFor: 'private' stamp: ''!
atLayer: aNumber add: aNodeCollection
	| collection |
	collection := nodesByLayer at: aNumber ifAbsentPut: [OrderedCollection new].
	collection addAll: aNodeCollection! !

!ROAbstractRegularTreeLayout methodsFor: 'hook' stamp: ''!
doExecute: elements
	| rootNodes |
	alreadyLayoutedNodes := OrderedCollection new.
	rootNodes := self rootNodesFor: elements.
	nodesByLayer := OrderedCollection new.
	self
		layout: rootNodes
		atPoint: self leftGap @ self topGap
		atLayer: 1.
	self isLayered ifTrue: [
		self rearrangeByLayers: elements ]! !

!ROAbstractRegularTreeLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	topGap := 5.
	leftGap := 5.
	isLayered := false! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
isLayered
	"Is the layout layered"
	
	^ isLayered! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
isLayered: boolean
	"Is the layout layered"
	
	isLayered := boolean! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
layered
	self isLayered: true! !

!ROAbstractRegularTreeLayout methodsFor: 'hook-private' stamp: ''!
layout: aNodeCollection atPoint: aPoint atLayer: anObject
	self subclassResponsibility! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
leftGap
	^ leftGap! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
leftGap: anInteger
	leftGap := anInteger! !

!ROAbstractRegularTreeLayout methodsFor: 'private' stamp: ''!
rearrangeByLayers: aGraph
	self subclassResponsibility! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
topGap
	^ topGap! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
topGap: anInteger
	topGap := anInteger! !

ROAbstractRegularTreeLayout subclass: #ROAbstractVerticalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: ''!
computeChildrenFor: aNode
	self subclassResponsibility! !

!ROAbstractVerticalTreeLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	verticalGap := 20.
	horizontalGap := 3! !

!ROAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: ''!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := y + each height + self verticalGap.
		treeSize := each width
			max: (self layout: (self computeChildrenFor: each) atPoint: x @ childrenPosition atLayer: aNumber + 1).
		middleOfTree := x + (treeSize / 2.0) - (each width / 2.0).
		translator translate: each to: middleOfTree @ y.
		x := x + treeSize + self horizontalGap ].
	^ x - aPoint x - self horizontalGap! !

!ROAbstractVerticalTreeLayout methodsFor: 'private' stamp: 'TudorGirba 10/1/2012 14:09'!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self topGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			eachNode translateTo: (eachNode bounds left @ cursor ).
			max max: eachNode height ].
		cursor := cursor + layerDepthSize + self verticalGap ]! !

ROAbstractVerticalTreeLayout subclass: #RODominanceTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RODominanceTreeLayout commentStamp: 'TudorGirba 10/1/2012 14:06' prior: 0!
The dominance tree layout is similar to a regular tree layout, only it poses a stronger condition in the way it places a node: a child is placed under the deepest parent. This layout is for example useful when identifying layers of dependencies.

Note: the layout is slower than the tree layout because of the more complex lookup!

!RODominanceTreeLayout methodsFor: 'hook-private' stamp: 'TudorGirba 10/1/2012 13:59'!
computeChildrenFor: aNode
	^ self childrenWithHighestNestingLevelFor: aNode! !

ROAbstractVerticalTreeLayout subclass: #ROTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROTreeLayout methodsFor: 'hook-private' stamp: ''!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

ROAbstractGraphLayout subclass: #RORadialTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RORadialTreeLayout methodsFor: 'hook' stamp: 'AlexandreBergel 7/29/2012 08:48'!
doExecute: nodeElements 
	| rootNodes maximumRadius xOffset |

	rootNodes := self rootNodesFor: nodeElements.
	xOffset := 0.
	rootNodes do: 
		[ :node | 
		node translateTo: 0 @ 0.	"Move the node to the origin of the coordinate system"
		maximumRadius := self 
			layoutLayer: (self childrenFor: node)
			radius: node radius
			from: 0
			to: 2 * Float pi.
		self 
			shiftTree: node
			by: (maximumRadius + xOffset) @ maximumRadius.
		xOffset := xOffset + (2 * maximumRadius) ]! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
gap
	
	^self verticalGap! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
layoutLayer: aCollection radius: oldRadius from: aFromAngle to: aToAngle
	
	| delta childRadius maximumRadius myRadius fromAngle toAngle |
	"Initialize with default value"
	maximumRadius := oldRadius.
	aCollection isEmpty
		ifFalse:
			[myRadius := oldRadius + self gap + (self maximumRadius: aCollection).
			childRadius := oldRadius + self gap + (self maximumDiameter: aCollection).	"This is a purely optical tweak"
			(aCollection size = 1 and: [aToAngle - aFromAngle = (2 * Float pi)])
				ifTrue:
					[delta := 0.4 * Float pi.
					fromAngle := 0.8 * Float pi.
					toAngle := fromAngle + delta]
				ifFalse:
					[delta := (aToAngle - aFromAngle) / aCollection size.
					fromAngle := aFromAngle.
					toAngle := aFromAngle + delta].
			aCollection
				do:
					[:child | 
					child
						translateTo:
							(Point
								r: myRadius
								theta: toAngle - (delta / 2.0)).
					maximumRadius := maximumRadius
						max:
							(self
								layoutLayer: (self childrenFor: child)
								radius: childRadius
								from: fromAngle
								to: toAngle).
					fromAngle := toAngle.
					toAngle := toAngle + delta]].
	^maximumRadius! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:23'!
maximumDiameter: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: (node radius * 2) ]
 ! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
maximumRadius: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: node radius]! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
shiftTree: aNode by: aPoint
	
	aNode translateBy: aPoint.
	(self childrenFor: aNode) do: [:child | self shiftTree: child by: aPoint]! !

ROAbstractGraphLayout subclass: #ROSugiyamaLayout
	instanceVariableNames: 'sortBlock labels layers layerNrs connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSugiyamaLayout classSide methodsFor: 'utils' stamp: ''!
sortBlock
	
	^ ROSortBlock new! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/3/2012 19:38'!
addDummyNodes
	
	| layer layerNr |
	connections := ROIdentityMatrix new.
	self edgesDo:
			[:edge | 
			| a b span fromNode toNode |
			"edge hints removeAll."
			a := layerNrs at: edge source.
			b := layerNrs at: edge target.
			span := (a - b) abs.
			span = 1
				ifTrue:
					[connections
						at: edge source
						at: edge target
						put: true].	"Normal case where nodes are in adjacent layers"
			fromNode := edge source.
			[span > 1]
				whileTrue:
					[span := span - 1.
					layerNr := b + span.
					layer := layers at: layerNr.
					toNode := RODummyNode
						on: edge
						slot: a - span.
					layer add: toNode.
					layerNrs at: toNode put: layerNr.
					connections at: fromNode at: toNode put: true.
					fromNode := toNode].
			(a - b) abs > 1
				ifTrue:
					[connections
						at: fromNode
						at: edge target
						put: true]]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:45'!
assignLabels: aNodeCollection 
	"Initialize label dictionary"
	| label vertices parentLabels |
	labels := IdentityDictionary new.
	label := 1.	"Assign labels to the roots"
	(self rootNodesFor: aNodeCollection) do: 
		[ :node | 
		labels 
			at: node
			put: label.
		label := label + 1 ].	"Assign labels to the rest"
	[ labels keys size < aNodeCollection size ] whileTrue: 
		[ vertices := SortedCollection sortBlock: self sortBlock.
		aNodeCollection do: 
			[ :node | 
			(labels includesKey: node) ifFalse: 
				[ parentLabels := ((self parentsFor: node) collect: 
					[ :pn | 
					labels 
						at: pn
						ifAbsent: [ self maxFloat ] ]) asSortedCollection.
				parentLabels last ~= self maxFloat ifTrue: [ vertices add: node -> parentLabels ] ] ].
		labels 
			at: vertices first key
			put: label.
		label := label + 1 ]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:45'!
buildLayers: g
	
	| w layerNr u vertices vertex layer done |
	w := self maxFloat.
	u := OrderedCollection new.
	layers := IdentityDictionary new.
	layerNrs := IdentityDictionary new.	"Assign all nodes to layers"
	[g isEmpty]
		whileFalse:
			[vertices := g
				select:
					[:e | (self childrenFor: e) allSatisfy: [:node | u includes: node]].
			vertex := vertices detectMax: [:e | labels at: e].
			done := false.
			layerNr := 1.
			[done]
				whileFalse:
					[layer := layers
						at: layerNr
						ifAbsentPut: [OrderedCollection new].
					(layer size >= w
						or:
							[(self childrenFor: vertex) anySatisfy: [:n | (layerNrs at: n) >= layerNr]])
						ifTrue: [layerNr := layerNr + 1]
						ifFalse: [done := true]].
			layer add: vertex.
			layerNrs at: vertex put: layerNr.
			u add: vertex.
			g remove: vertex]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: ''!
cl: layer u: u v: v
	"Calculates cuv. Di Battista, chapter 9.2.2, page 283"
	
	| partnersOfU partnersOfV c partnersOfUIndex partnersOfVIndex layerNr |
	layerNr := layerNrs at: u.	":= layerNrs at: v"
	partnersOfU := (connections at: u)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	partnersOfV := (connections at: v)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	c := 0.
	partnersOfUIndex := partnersOfU collect: [:node | layer indexOf: node].
	partnersOfVIndex := partnersOfV collect: [:node | layer indexOf: node].
	partnersOfUIndex
		do:
			[:uIndex | partnersOfVIndex do: [:vIndex | vIndex < uIndex ifTrue: [c := c + 1]]].
	^c! !

!ROSugiyamaLayout methodsFor: 'hook' stamp: ''!
doExecute: aNodeCollection 
	"Coffman-Graham-Layering. Di Battista Book, page 275, chapter, 9.2.1"
	self assignLabels: aNodeCollection.
	self buildLayers: aNodeCollection copy.
	self addDummyNodes.
	self reduceCrossing.
	self layoutAt: self verticalGap @ self horizontalGap! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:15'!
layoutAt: aPoint
	
	| treeWidth layerKeys layer layerWidth horizontalPosition verticalPosition layerHeight |
	treeWidth := layers values
		inject: self maxFloat negated
		into:
			[:max :e | max max: (e sum: #width) + ((e size - 1) * self horizontalGap)].
	verticalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection reverse.
	layerKeys
		do:
			[:aKey | 
			layer := layers at: aKey.
			layerWidth := (layer sum: #width)
				+ ((layer size - 1) * self horizontalGap).
			layerHeight := (layer detectMax: #height) height.
			horizontalPosition := treeWidth / 2.0 + aPoint x - (layerWidth / 2.0).
			layer
				do:
					[:node | 
					translator translate: node to:  horizontalPosition @ verticalPosition.
					
					horizontalPosition := horizontalPosition + node width
						+ self horizontalGap].
			verticalPosition := verticalPosition + layerHeight + self verticalGap]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:44'!
maxFloat
	^ 1e10! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/3/2012 19:16'!
reduceCrossing
	"Crossing reduction"
	
	| layer2 u v c1 c2 layer1 done |
	2
		to: layers keys size
		do:
			[:index | 
			layer1 := layers at: index - 1.
			layer2 := layers at: index.
			done := false.
			[done]
				whileFalse:
					[done := true.
					2
						to: layer2 size
						do:
							[:i | 
							u := layer2 at: i - 1.
							v := layer2 at: i.
							c1 := self cl: layer1 u: u v: v.
							c2 := self cl: layer1 u: v v: u.
							c1 > c2
								ifTrue:
									[layer2 roSwapElement: u withElement: v.
									done := false]]]]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: ''!
sortBlock
	
	sortBlock isNil ifTrue: [ sortBlock := self class sortBlock ].
	^sortBlock! !

!ROEdgeDrivenLayout classSide methodsFor: 'instance creation' stamp: ''!
withEdges: aCollection
	
	^self new initialize userDefinedEdges: aCollection! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodes
	
	^affectedNodes! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodes: anObject
	
	affectedNodes := anObject! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodesOf:  aNode 
	^ affectedNodes ifNil: [ aNode nodes ]! !

!ROEdgeDrivenLayout methodsFor: 'default values' stamp: ''!
defaultFromPositions
	^ #()
	! !

!ROEdgeDrivenLayout methodsFor: 'default values' stamp: ''!
defaultToPositions
	^ #()
! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: ''!
doExecute: aGraphElement
	
	self subclassResponsibility! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: ''!
doIncrementallyExecute: anElementNode
	"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."
	
	self doExecute: anElementNode! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: ''!
doInitialize: elements
	
	super doInitialize: elements.
	"elements edgesDo: [ :edge | edge isVisible: true ]"! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/22/2012 13:59'!
doPost: elements
	"Hook method"
! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
edges
	
	^edges! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
edges: aCollection
	
	edges := aCollection! !

!ROEdgeDrivenLayout methodsFor: 'iterator' stamp: ''!
edgesDo: aBlock
	"Iterates over all the edges of the receiver."
	
	edges ifNil: [ ^ self ].
	edges do: aBlock
! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/18/2012 16:03'!
executeOnElements: elements 
	"Execute the layout, myself, on the elements"

	self userDefinedEdges isNil 
		ifTrue: [ self setEdgesFromElements: elements ]
		ifFalse: 
			[ | flat |
			flat := OrderedCollection new.
			self userDefinedEdges do: 
				[ :each | 
				each isCollection 
					ifTrue: [ flat addAll: each ]
					ifFalse: [ flat add: each ] ].
			self edges: flat ].
		
	super executeOnElements: elements! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
fromPositions
	
	^fromPositions ifNil: [fromPositions := self defaultFromPositions]! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
fromPositions: anArray
	
	fromPositions := anArray! !

!ROEdgeDrivenLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialization"
	super initialize.
	edges := nil! !

!ROEdgeDrivenLayout methodsFor: 'testing' stamp: ''!
isLineLayout
	^ false! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 7/20/2012 18:17'!
setEdgesFromElements: elements 
	| view |
	elements isEmpty ifTrue: [ ^ self ].
	self assert: [ (elements collect: #view) asSet size = 1 ].
	
	elements isEmpty ifTrue: [ ^ self ].
	
	view := elements anyOne view.
	self edges: (view elementsSuchThat: [ :el | ((el isKindOf: ROEdge) and: [ elements includes: el from ]) and: [ elements includes: el to ] ]).
	! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
toPositions
	
	^toPositions ifNil: [toPositions := self defaultToPositions]! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
toPositions: anArray
	
	toPositions := anArray! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
userDefinedEdges
	
	^userDefinedEdges! !

!ROEdgeDrivenLayout methodsFor: 'initialize-release' stamp: 'AlexandreBergel 9/9/2012 20:03'!
userDefinedEdges: aCollectionOfEdges
	"useful to tell to the layout which edges have to be used for the layout"

	userDefinedEdges := aCollectionOfEdges.
	! !

ROEdgeDrivenLayout subclass: #ROForceBasedLayout
	instanceVariableNames: 'iterations repellingForce attractingForce layoutInitial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
attractingForce: aBlock
	"Attracting force between edges."
	
	attractingForce := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
attractingForceFor: aFigure
	
	^attractingForce roValue: aFigure! !

!ROForceBasedLayout methodsFor: 'hook' stamp: 'AlexandreBergel 6/11/2012 22:55'!
doExecute: nodeElements
	| nodes nodeCenterA nodeCenterB deltaX deltaY distance xForces yForces xForce yForce force random edgesIndices nodeCenter nodeRadius nodeRadiusA nodeRadiusB nodeOrigin minX minY delta |
	"Start by placing the nodes at random"
	self initialPositionOfNodes: nodeElements.
	
	random := Random new.	"Create array with the node center and radius. Like this we don't need to move the actual nodes"
	nodes := nodeElements asArray.
	nodeCenter := Array new: nodes size.
	nodeRadius := Array new: nodes size.
	1 to: nodes size do: [ :index | 
		nodeCenter at: index put: (nodes at: index) center.
		nodeRadius at: index put: (nodes at: index) radius ].	"Create array with the indices of the edge nodes"
	edgesIndices := Array new: self edges size.
	1 to: self edges size do: [ :index | 
		| edge |
		edge := self edges at: index.
		edgesIndices at: index put: (Array with: (nodes indexOf: edge source) with: (nodes indexOf: edge target)) ].
	1 to: (self iterationsFor: nodeElements) do: [ :iteration | 
		xForces := (Array new: nodes size) atAllPut: 0.
		yForces := (Array new: nodes size) atAllPut: 0.	"Node forces"
		1 to: nodes size do: [ :i | 
			i + 1 to: nodes size do: [ :j | 
				nodeCenterA := nodeCenter at: i.
				nodeCenterB := nodeCenter at: j.
				deltaX := nodeCenterB x - nodeCenterA x.
				deltaY := nodeCenterB y - nodeCenterA y.
				distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt.
				distance < 0.01
					ifTrue: [ 
						deltaX := random next + 5.
						deltaY := random next + 5.
						distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt ].
				distance < 100
					ifTrue: [ 
						nodeRadiusA := nodeRadius at: i.
						nodeRadiusB := nodeRadius at: j.
						force := (self repellingForceFor: nodeElements) * nodeRadiusA * nodeRadiusB / distance / distance.
						xForce := force * deltaX / distance.
						yForce := force * deltaY / distance.
						xForces at: i put: (xForces at: i) - xForce.
						yForces at: i put: (yForces at: i) - yForce.
						xForces at: j put: (xForces at: j) + xForce.
						yForces at: j put: (yForces at: j) + yForce ] ] ].	"Edge forces"
		edgesIndices
			do: [ :indices | 
				nodeCenterA := nodeCenter at: indices first.
				nodeCenterB := nodeCenter at: indices last.
				deltaX := nodeCenterB x - nodeCenterA x.
				deltaY := nodeCenterB y - nodeCenterA y.
				distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt.
				distance < 0.01
					ifTrue: [ 
						deltaX := random next + 5.
						deltaY := random next + 5.
						distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt ].
				distance := distance min: 15.
				force := (self attractingForceFor: nodeElements) * distance.
				xForce := force * deltaX / distance.
				yForce := force * deltaY / distance.
				xForces at: indices first put: (xForces at: indices first) + xForce.
				yForces at: indices first put: (yForces at: indices first) + yForce.
				xForces at: indices last put: (xForces at: indices last) - xForce.
				yForces at: indices last put: (yForces at: indices last) - yForce ].	"Move centers"
		1 to: nodes size do: [ :index | 
			deltaX := xForces at: index.
			deltaY := yForces at: index.
			deltaX := deltaX min: 30.
			deltaX := deltaX max: -30.
			deltaY := deltaY min: 30.
			deltaY := deltaY max: -30.
			nodeCenter at: index put: ((nodeCenter at: index) translatedBy: deltaX @ deltaY) ] ].	"Node origins"
	nodeOrigin := Array new: nodes size.
	minX := 10000000.	"minX := Unlimited positive."
	minY := 10000000.	"minY := Unlimited positive."
	1 to: nodes size do: [ :index | 
		| origin node |
		node := nodes at: index.
		origin := (nodeCenter at: index) - ((node width / 2.0) @ (node height / 2.0)).
		nodeOrigin at: index put: origin.
		minX := minX min: origin x.
		minY := minY min: origin y ].	"Move nodes"
	minX := -1 * minX.
	minY := -1 * minY.
	delta := minX @ minY + (5 @ 5).
	1 to: nodes size do: [ :index | translator translate: (nodes at: index) to: (nodeOrigin at: index) + delta ]! !

!ROForceBasedLayout methodsFor: 'hook' stamp: 'AlexandreBergel 6/11/2012 23:01'!
initialPositionOfNodes: nodeElements

	layoutInitial new executeOnElements: nodeElements! !

!ROForceBasedLayout methodsFor: 'hook' stamp: 'AlexandreBergel 6/11/2012 23:09'!
initialize
	
	super initialize.
	iterations := 300.
	repellingForce := 10.
	attractingForce := 0.02.
	layoutInitial := RORadialTreeLayout.	! !

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
iterations: aBlock
	
	iterations := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
iterationsFor: aFigure
	
	^iterations roValue: aFigure! !

!ROForceBasedLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 6/11/2012 23:00'!
layoutInitial: aLayoutClass
	layoutInitial := aLayoutClass! !

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
repellingForce: aBlock
	"Repelling force between nodes."
	
	repellingForce := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
repellingForceFor: aFigure
	
	^repellingForce roValue: aFigure! !

ROLayout subclass: #ROGridLayout
	instanceVariableNames: 'gapSize lineItemsCountBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROGridLayout classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 6/30/2012 01:16'!
defaultGap
	^ 5! !

!ROGridLayout classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 6/30/2012 01:16'!
new
	^ self withGap: self defaultGap! !

!ROGridLayout classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 6/30/2012 14:29'!
on: aCollectionOfElements withLineItemsCount: aBlock
	"place the elements in a grid with (aBlock roValue: aCollectionOfElements) as the amount of elements horizontally

	For example:
	self on: (ROElement forCollection: (1 to: 20)) withLineItemsCount: 5
	=> place the 20 elements on a grid 5 x 4
	
	self on: (ROElement forCollection: (1 to: 20)) withLineItemsCount: [ :elements | elements size // 3 ]
	=> place the 20 elements on a grid 3 x 7
	"
	
	
	| myLayout |
	myLayout := self new gapSize: self defaultGap;  lineItemsCount: aBlock.
	myLayout applyOn: aCollectionOfElements.
	^ aCollectionOfElements! !

!ROGridLayout classSide methodsFor: 'instance creation' stamp: ''!
withGap: anInteger 
	^ self 
		withGap: anInteger
		withLineItemsCount: 
			[ :graph | 
			| height width |
			(graph size < 3 
				ifTrue: [ (graph size max: 1) @ 1 ]
				ifFalse: 
					[ height := (graph size * 0.618034) sqrt ceiling truncated.
					width := (graph size / height) ceiling truncated.
					width @ height ]) x ]! !

!ROGridLayout classSide methodsFor: 'instance creation' stamp: ''!
withGap: anInteger withLineItemsCount: aBlock
	
	^(super new)
		gapSize: anInteger;
		lineItemsCount: aBlock;
		yourself! !

!ROGridLayout classSide methodsFor: 'instance creation' stamp: ''!
withLineItemsCount: aBlock
	
	^(super new)
		gapSize: 2;
		lineItemsCount: aBlock;
		yourself! !

!ROGridLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:12'!
doExecute: elements 
	| pointer lineItemCount lineItemSize maxLastLineHeight |
	pointer := self gapSize @ self gapSize.
	lineItemSize := self lineItemsCountBlock roValue: elements.
	lineItemCount := 0.
	maxLastLineHeight := 0.
	elements do: 
		[ :element | 
		translator translate: element to: pointer.
		pointer := (pointer x + element width + (self gapSize * 2)) @ pointer y.
		lineItemCount := lineItemCount + 1.
		maxLastLineHeight := maxLastLineHeight max: element height.
		lineItemCount >= lineItemSize ifTrue: 
			[ pointer := self gapSize @ (pointer y + (self gapSize * 2) + maxLastLineHeight).
			maxLastLineHeight := 0.
			lineItemCount := 0 ] ]! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
gapSize: anObject
	
	gapSize := anObject! !

!ROGridLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	gapSize := 5! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
lineItemsCount: aBlock
	
	lineItemsCountBlock := aBlock! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
lineItemsCountBlock
	
	^ lineItemsCountBlock! !

!ROLayout classSide methodsFor: 'public' stamp: ''!
on: aCollection
	self new applyOn: aCollection.
	^ aCollection! !

!ROLayout classSide methodsFor: 'public' stamp: ''!
on: elements edges: edges
	"To make all the layout polymorphic"
	
	^ self on: elements ! !

!ROLayout methodsFor: 'hook' stamp: ''!
applyOn: elements
	
	self executeOnElements: elements! !

!ROLayout methodsFor: 'hook' stamp: ''!
doInitialize: elements! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/22/2012 14:02'!
doPost: elements! !

!ROLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 13:59'!
executeOnElements: elements 
	"Execute the layout, myself, on the elements"

"	self userDefinedEdges isNil 
		ifTrue: [ self setEdgesFromElements: elements ]
		ifFalse: 
			[ | flat |
			flat := OrderedCollection new.
			self userDefinedEdges do: 
				[ :each | 
				each value isCollection 
					ifTrue: [ flat addAll: each value ]
					ifFalse: [ flat add: each value ] ].
			self edges: flat ]."
		
	self doInitialize: elements.
	self doExecute: elements asOrderedCollection.
	self doPost: elements! !

!ROLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	translator := ROLayoutTranslator default! !

!ROLayout methodsFor: 'hook' stamp: ''!
on: elements
	self applyOn: elements! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/18/2012 11:38'!
on: elements edges: edges
	self applyOn: elements! !

!ROLayout methodsFor: 'accessing' stamp: ''!
translator
	^ translator! !

!ROLayout methodsFor: 'accessing' stamp: ''!
translator: t
	translator := t! !

ROLayout subclass: #RONullLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RONullLayout methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/14/2012 15:52'!
doExecute: elements
	"do nothing"! !

ROLayout subclass: #ROScatterplotLayout
	instanceVariableNames: 'horizontalPadding verticalPadding xBlock yBlock xOffset yOffset upSideDown scaleFactorX scaleFactorY scaledToWidth scaledToHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROScatterplotLayout methodsFor: 'adjusting' stamp: ''!
defaultAdjustHeightFor: childrenBounds and: myBounds
	
	| deltaY |
	deltaY := childrenBounds top - myBounds top.
	^childrenBounds height + deltaY + self yOutGap! !

!ROScatterplotLayout methodsFor: 'adjusting' stamp: ''!
defaultAdjustWidthFor: childrenBounds and: myBounds
	
	| deltaX |
	deltaX := childrenBounds left - myBounds left.
	^childrenBounds width + deltaX + self xOutGap! !

!ROScatterplotLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/21/2012 23:46'!
doExecute: elements

	| maxWidth maxHeight nodesToLayout x y origin newX newY |
	maxWidth := 0.
	maxHeight := 0.
	nodesToLayout := affectedNodes ifNil: [ elements ] ifNotNil: [ :arg | affectedNodes ].
	nodesToLayout
		do: [ :node | 
			x := (xBlock value: node model) * scaleFactorX.
			y := (yBlock value: node model) * scaleFactorY.
			maxWidth := maxWidth max: x.
			maxHeight := maxHeight max: y.	"x = #centered ifTrue: [ x := 0 ]."
			x := x + xOffset.
			y := upSideDown
				ifTrue: [ y - yOffset ]
				ifFalse: [ y + yOffset ].
			translator translate: node to: x @ y ].	"We scale them to the width and height"
	elements
		do: [ :node | 
			origin := node bounds origin.
			newX := origin x.
			newY := origin y.
			scaledToWidth ifNotNil: [ :arg | newX := (origin x / maxWidth * scaledToWidth) asInteger ].
			scaledToHeight ifNotNil: [ :arg | newY := (origin y / maxHeight * scaledToHeight) asInteger ].
			translator translate: node to:  newX @ newY ].
	scaledToHeight ifNotNil: [ :arg | maxHeight := scaledToHeight ].
	upSideDown
		ifFalse: [ ^ self ].	"We need to inverse the plots"
	nodesToLayout
		do: [ :node | 
			y := node bounds origin y.
			node translateBy: 0 @ (maxHeight - (2 * y)) ]! !

!ROScatterplotLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.

	horizontalPadding := 5.
	verticalPadding := 5.
	xOffset := 0.
	yOffset := 0.
	scaleFactorX := 1.
	scaleFactorY := 1.
	upSideDown := false.
	xBlock := yBlock := [:aNode | aNode ]! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
offset: anInt

	xOffset := anInt.
	yOffset := anInt.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
outGap
	
	^ self xOutGap @ self yOutGap! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
outGap: anObject
	
	self xOutGap: anObject.
	self yOutGap: anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactor: aValue
	scaleFactorX := aValue.
	scaleFactorY := aValue! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactorX: aValue
	scaleFactorX := aValue.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactorY: aValue
	scaleFactorY := aValue.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToHeight
	^ scaledToHeight! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToHeight: anObject
	scaledToHeight := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToWidth
	^ scaledToWidth! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToWidth: anObject
	scaledToWidth := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
upSideDown
	upSideDown := upSideDown not! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
x: aBlock
	xBlock := aBlock! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
xOutGap
	
	^horizontalPadding! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
xOutGap: anObject
	
	horizontalPadding := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
y: aBlock
	yBlock := aBlock! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
yOutGap
	
	^verticalPadding! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
yOutGap: anObject
	
	verticalPadding := anObject! !

ROLayout subclass: #ROTreeMapLayout
	instanceVariableNames: 'rootNodes weightBlock interactionBlock leafBlock canvas view inset minInset minAreaPerNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROTreeMapLayout classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 8/21/2012 10:12'!
withWeightBlock: aWeightBlock
	| layout |
	layout := self new.
	layout weightBlock: aWeightBlock.
	^ layout.! !

!ROTreeMapLayout methodsFor: 'interaction' stamp: 'DennisSchenk 5/23/2012 09:48'!
addInteraction: aNode
	"Adds interactions defined in interactionBlock to given node."
	interactionBlock notNil ifTrue: [
		interactionBlock value: aNode.
	].! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 7/3/2012 11:00'!
addLeafBlock: aNode
	"Applies leaf block to given node."
	leafBlock notNil ifTrue: [
		leafBlock value: aNode.
	].! !

!ROTreeMapLayout methodsFor: 'utility' stamp: 'DennisSchenk 5/22/2012 09:27'!
calculateWeight: firstHalf secondHalf: secondHalf
	| weight sumFirstHalf sumSecondHalf sum |
	
	"Initializing values"
	sumFirstHalf := 0.
	sumSecondHalf := 0.
	sum := 0.
	
	firstHalf do: [ :e |
		sumFirstHalf := sumFirstHalf + (self weightBlock value: e)
	].
	secondHalf do: [ :e |
		sumSecondHalf := sumSecondHalf + (self weightBlock value: e)
	].
	
	"Make sure its always at least one."
	sumFirstHalf < 1 ifTrue: [
		sumFirstHalf := 1.
	].
	sumSecondHalf < 1 ifTrue: [
		sumSecondHalf := 1.
	].
	
	sum := sumFirstHalf + sumSecondHalf.
	
	weight := sumFirstHalf / sum.
	
	"Should never be less than 0.1 or more than 0.9, 
	so it looks okay graphically and nodes are not disapearing."
	weight > 0.9 ifTrue: [
		weight := 0.9.
	].
	weight < 0.1 ifTrue: [
		weight := 0.1.
	].
	
	 ^ weight asFloat.
! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 6/5/2012 10:17'!
childrenFor: aNode
	^ aNode elements.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 6/6/2012 11:30'!
childrenSortedFor: aNode
	"Returns all children of given node sorted by weight block."
	| children |
     
	"Sort children by layouts weight block."
	children := SortedCollection sortBlock: [ :e1 :e2 | 
		(self weightBlock value: e1) <= (self weightBlock value: e2) ].

	children addAll: (self childrenFor: aNode).

	^ children.! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 6/12/2012 11:18'!
defaultBounds
	^ Rectangle origin: 5@5 corner: 225@225.! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 9/11/2012 10:01'!
defaultInset
	"This is the default value for insets we use for intetendation inside containment nodes to their children."
	^ 5! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 6/13/2012 12:54'!
defaultMinArea 
	"We assume we need a 20x20 rectangle for a treemap at least."
	^ 400! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 9/11/2012 10:16'!
defaultMinAreaPerNode
	"The smallest node we want to draw has a size of roughly 5x5."
	^ 25! !

!ROTreeMapLayout methodsFor: 'default values' stamp: 'DennisSchenk 9/12/2012 10:38'!
defaultMinInset
	"This is the default minimal value for insets in containment nodes we use."
	^ 3! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 6/12/2012 09:43'!
defineNodeShape: node rectangle: rectangle level: level
	"Sets a nodes shape and does other necessary stuff."

	node setBounds: rectangle.

	"Add specific interaction to node, if interactionBlock is set"
	self addInteraction: node.! !

!ROTreeMapLayout methodsFor: 'hook' stamp: 'DennisSchenk 9/4/2012 15:13'!
doExecute: nodeCollection

	"Create the treemap layout."
	self layout: rootNodes rectangle: canvas level: 0.! !

!ROTreeMapLayout methodsFor: 'hook' stamp: 'DennisSchenk 9/11/2012 11:33'!
doInitialize: nodeCollection
	"Let's make sure that everything is set up correctly to draw a treemap layout."
	| givenBounds |
	
	"Nothing to draw...."
	(nodeCollection isEmpty) ifTrue: [ ^ self ]. "TODO: What would be the correct return value in this case?"

	"Can't draw a treemap without a weight definition."
	(weightBlock isNil) ifTrue: [
		self error: 'weightBlock has to be set!!'.
	].

	"Getting the view we are in."
	view := nodeCollection first view.

	"Before we do anything else, we tell the nodes that they have a fixed size in a treemap."
	nodeCollection do: [ :node | 
		node resizeStrategy: ROFixedSizedParent instance.
	].
	
	"Setting up canvas we draw the treemap in based on given nodes."
	givenBounds := self prepareGraph: nodeCollection.
	self setupCanvas: givenBounds.! !

!ROTreeMapLayout methodsFor: 'hook' stamp: 'DennisSchenk 9/4/2012 14:52'!
doPost: aNodeCollection
	"Doing things after the layout has been generated."
	
	aNodeCollection notEmpty ifTrue: [
		"The treemap has to be draggable as a whole, 
		so we forward drag events from all nodes except the rootNodes."
		rootNodes size > 1 ifTrue: [
			aNodeCollection do: [ :node | node forward: ROMouseDragging ].
		]
		ifFalse: [
			(aNodeCollection reject: [ :node | node = rootNodes first ]) 
				do: [ :node | node forward: ROMouseDragging ].
		].
	].! !

!ROTreeMapLayout methodsFor: 'initialize-release' stamp: 'DennisSchenk 9/11/2012 10:33'!
initialize

	"Canvas is the Rectangle where we draw the treemap in."
	canvas := Rectangle origin: (5@5) corner: (150@150).
	
	"Inset is the indentation we use for containment nodes (to their children)."
	inset := self defaultInset.
	
	"This inset will never get smaller than the minimum though."
	minInset := self defaultMinInset.
	
	"This is the minimum area a node shuld have to be drawn."
	minAreaPerNode := self defaultMinAreaPerNode.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 09:54'!
inset
	^ inset.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 09:54'!
inset: aNumber
	inset := aNumber.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
interactionBlock
	^ interactionBlock.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
interactionBlock: aBlock
	"Sets an interaction block which will be set to every individual node."
	interactionBlock := aBlock.! !

!ROTreeMapLayout methodsFor: 'layouting' stamp: 'DennisSchenk 9/11/2012 10:11'!
layout: nodes rectangle: rectangle level: level
	"Main (recursive) method that lays out given nodes in given rectangle"
	
	"Nothing to draw..."
	(nodes isNil) ifTrue: [ ^ self. ].
	
	"If we have only one node we can lay it out directly."
	nodes size == 1 ifTrue: [
		self layoutNode: (nodes first) rectangle: rectangle level: level.
	]

	"If we have more then one node, we need to split them up."
	ifFalse: [

		"Make sure nodes are sorted by weight block."
		| sortedNodes | 
		nodes class ~= SortedCollection ifTrue: [
			sortedNodes := SortedCollection sortBlock: [ :e1 :e2 | 
				(self weightBlock value: e1) <= (self weightBlock value: e2) ].
			sortedNodes addAll: nodes.
		]
		ifFalse: [ sortedNodes := nodes. ].
	
		"Layout multiple nodes."
		self layoutNodes: sortedNodes rectangle: rectangle level: level.
	].! !

!ROTreeMapLayout methodsFor: 'layouting' stamp: 'DennisSchenk 9/12/2012 10:25'!
layoutNode: node rectangle: rectangle level: level
	"Lays out a single node"
	| children |
	
	"Set bounds of the node."
	self defineNodeShape: node rectangle: rectangle level: level.
	
	"Get sorted children."
	children := self childrenSortedFor: node.

	"Are we rendering a leaf node?"
	(children isNil or: children isEmpty) ifTrue: [
		self styleLeafNode: node level: level.
		self addLeafBlock: node.
	]

	"Else it is a containment node, style accordingly"
	 ifFalse: [
		
		"If a containment node gets too small, we don't draw its children, instead we just mark it in a special way."
		(rectangle area < (self minAreaNeededFor: children)) ifTrue: [
			
			"We need to remove the nodes we don't draw from the graph."
			node removeAllElements.
			self styleContainmentNodeWithOmittedChildren: node level: level.
			
		]
		ifFalse: [
			| innerRectangle insetToUse |

			"Style as containment node"
			self styleContainmentNode: node level: level.
			
			"Making insets a little bit thinner the more nested in the graph we are,
			but cap at min inset pixels."
			insetToUse := (inset - (level * 0.2)) ceiling .
			insetToUse < minInset  ifTrue: [
				insetToUse := minInset.	
			].
		
			"Creating a containment border for the children."
			innerRectangle := rectangle insetBy: insetToUse.
			
			"In Roassal nested nodes are defined with relative bounds."
			innerRectangle := Rectangle origin: (insetToUse@insetToUse) extent: innerRectangle extent.
			
			"Layout children"
			self layout: children rectangle: innerRectangle level: level+1.
		].
	].! !

!ROTreeMapLayout methodsFor: 'layouting' stamp: 'DennisSchenk 9/11/2012 10:03'!
layoutNodes: nodes rectangle: rectangle level: level
	"Split up given nodes by weightBlock."
	| firstHalf secondHalf firstRectangle secondRectangle weight |
		
	"Split up nodes"
	firstHalf := self splitCollection: nodes.
	secondHalf := nodes copy reject: [ :element |	
		firstHalf includes: element.
	].
	
	"Calculate weights of the halves"
	weight := self calculateWeight: firstHalf secondHalf: secondHalf.
		
	"Prepare and split up rectangles for the children..."
	firstRectangle := Rectangle new.
	secondRectangle := Rectangle new.		

	"Either vertically or..."
	(rectangle width > rectangle height) ifTrue: [
		self splitRectangleVertically: rectangle first: firstRectangle second: secondRectangle weight: weight.
	]
	"....horizontally"
	ifFalse: [
		self splitRectangleHorizontally: rectangle first: firstRectangle second: secondRectangle weight: weight.
	].
	
	"Recurse to draw nodes."
	self layout: firstHalf rectangle: firstRectangle level: level+1.
	self layout: secondHalf rectangle: secondRectangle level: level+1.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
leafBlock
	^ leafBlock! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
leafBlock: aBlock
	"Sets the leaf block: it will be called on all leaf nodes, can be used to style them in a certain way."
	leafBlock := aBlock.! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 9/11/2012 11:53'!
minAreaNeededFor: nodesChildren
	^ (((minAreaPerNode * (nodesChildren size)) sqrt) + (2 * inset)) squared.! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'DennisSchenk 9/11/2012 11:52'!
minAreaNeededForNode: node
	^ (((minAreaPerNode * (node size)) sqrt) + (2 * inset)) squared.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 10:16'!
minAreaPerNode
	^ minAreaPerNode.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 10:16'!
minAreaPerNode: aNumber
	minAreaPerNode := aNumber.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/12/2012 10:33'!
minInset
	^ minInset.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/12/2012 10:33'!
minInset: aNumber
	minInset := aNumber.! !

!ROTreeMapLayout methodsFor: 'initialization' stamp: 'DennisSchenk 9/19/2012 12:27'!
prepareGraph: nodeCollection
	"Checks if the given nodeColection and the (implicit contained) graph are in the expected format
	 and tries to transform it automatically if not. Returns bounds that were given from the outside.
	
	TODO: The automatic transformation of graphs needs to be much more generic, 
	so far we only capture single possible configurations..."

	| givenBounds |

	"In most cases we expect exactly one node, which is the root node."
	"Here we have more than one root node."
	nodeCollection size > 1 ifTrue: [
		| edges parent roots |

		parent := nodeCollection first parent.
		edges := parent elements select: [ :e | e isEdge ].
		
		"But if we have more than one node in the collection, maybe we got an edge driven definition of a graph. 
		Let's try to transform it to a node-nested graph."
		(edges notEmpty) ifTrue: [ 		

			roots := ROGraphTransformation new fromEdgesToNesting: nodeCollection edges: edges.

			(roots isKindOf: Collection) ifFalse: [
				roots := OrderedCollection with: roots.	
			].

			parent class = ROElement ifTrue: [
				parent removeAllElements.
				parent addAll: roots.
				
				"TODO: HACK HACK: this if-else is used to distinguish between setting size of shape
				 externally of the treemap layout or on the nodes inside of it."
				roots first extent = (5@5) ifTrue: [
					givenBounds :=  parent bounds insetBy: inset.
				] 
				ifFalse: [
					givenBounds := roots first bounds.
				]
				
			].
		
			parent class = ROView ifTrue: [
				"Dont need edges anymore, all nodes are now nested."
				edges do:  [ :edge | edge remove ].
				givenBounds := nodeCollection first bounds
			].

			rootNodes := OrderedCollection withAll: roots.
		]
	
		"If we have no edges, we have multiple root nodes (alone or with nested children)."
		ifFalse: [		
			rootNodes := nodeCollection.
			
			parent class = ROView ifTrue: [
				givenBounds := rootNodes first bounds.
			]
			ifFalse: [
				givenBounds := parent bounds insetBy: inset.
			]
		].
	]

	"...as expected: only one root node."
	ifFalse: [
		| edges nodes roots |
		rootNodes := nodeCollection.
		givenBounds := rootNodes first bounds.
		
		"TODO: HACK HACK: we have two seperate configurations here. 
		If givenBounds of first rootNode are only 5@5, we can assume, that the bounds given from the outside, were actually given to its parent."
		givenBounds extent = (5@5) ifTrue: [
			givenBounds := rootNodes first parent bounds insetBy: inset.	
		].
		
		"Another possibility is that only the first level is nested, but then we have a graph driven defintion, 
		so lets try to transform it to a nested graph."
		nodes :=  nodeCollection first elements.
		edges :=  nodeCollection first elements select: [ :e | e isEdge ].
		(edges notEmpty) ifTrue: [ 		
			roots := (ROGraphTransformation new fromEdgesToNesting: nodes edges: edges) select: [ :e | e isNotEdge].
			rootNodes first removeAllElements.
			rootNodes first addAll: roots.
		].
	].

	^ givenBounds.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/23/2012 09:32'!
recursiveChildrenFor: aNode
	"Returns all children, childrens children etc. of given node in a Set"
	| allChildren myChildren |
     
	allChildren := Set new.
	myChildren := Set new.
	
	myChildren addAll: (self childrenFor: aNode).
	allChildren addAll: myChildren.
	myChildren do: [ :each | allChildren addAll: (self recursiveChildrenFor: each) ].

	^ allChildren.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 9/11/2012 10:12'!
recursiveChildrenSortedFor: aNode
	"Returns all children, childrens children etc. of given node in a SortedCollection sorted by weight block."
	| allChildren myChildren |
     
	allChildren := SortedCollection sortBlock: [ :e1 :e2 | 
		(self weightBlock value: e1) <= (self weightBlock value: e2) ].
	
	myChildren := Set new.
	
	myChildren addAll: (self childrenFor: aNode).
	allChildren addAll: myChildren.
	myChildren do: [ :each | allChildren addAll: (self recursiveChildrenFor: each) ].

	^ allChildren.! !

!ROTreeMapLayout methodsFor: 'initialization' stamp: 'DennisSchenk 9/19/2012 11:43'!
setupCanvas: givenBounds
	"Setting up the dimensions and position of the canvas we draw the treemap on."
	
	"If bounds are specified from the outside (e.g. view shape width: 400; height: 400) we have to apply
	these bounds only to the canvas of the treemap, not all the nodes."

	"Leave some space to possible parent."
	canvas := Rectangle origin: (inset@inset) extent: givenBounds extent.   ! !

!ROTreeMapLayout methodsFor: 'utility' stamp: 'DennisSchenk 7/3/2012 11:01'!
splitCollection: aSortedCollection
	"Returns the first half of a SortedCollection"
	"TODO: this does not belong here and can surely be solved more elegant."
	| indexOfSplitElement n firstHalf |

	indexOfSplitElement := (aSortedCollection size / 2) floor.
	
	n := 1.
	
	firstHalf := SortedCollection sortBlock: aSortedCollection sortBlock.
	
	[ n <= indexOfSplitElement ] whileTrue: [ 
		| element |
		element := aSortedCollection at: n.
		firstHalf add: element.
		n := n+1.
	].
	
	^ firstHalf.! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'AlexandreBergel 8/27/2012 09:57'!
splitRectangleHorizontally: rectangle first: firstRectangle second: secondRectangle weight: weight
	"Splits given rectangle to given rectangles by given weight on the y axis"
	| y |

	"This is where we are going to split on the y-axis"
	y := ((((rectangle bottomLeft y) - (rectangle topLeft y)) * weight) floor + rectangle topLeft y).

	"HACKY: Subtract 1 of the seconds rectangles origin y value, 
	so the borders between the rectangles are overlaying eachother, so we dont have thick borders"
	firstRectangle roOrigin: (rectangle origin); roCorner: (rectangle corner x)@y.
	secondRectangle roOrigin: (rectangle origin x)@(y-1); roCorner: (rectangle corner).
! !

!ROTreeMapLayout methodsFor: 'layouting-utility' stamp: 'AlexandreBergel 8/27/2012 09:58'!
splitRectangleVertically: rectangle first: firstRectangle second: secondRectangle weight: weight
	"Splits given rectangle to given rectangles by given weight on the x axis"
	| x |
	
	"This is where we are going to split on the x-axis"
	x := ((((rectangle topRight x) - (rectangle topLeft x)) * weight) floor + rectangle topLeft x).
	
	"HACKY: Subtract 1 of the seconds rectangles origin x value, 
	so the borders between the rectangles are overlaying eachother, so we dont have thick borders"
	firstRectangle roOrigin: (rectangle origin); roCorner: x@(rectangle corner y).
	secondRectangle roOrigin: (x-1)@(rectangle origin y); roCorner: (rectangle corner).
	! !

!ROTreeMapLayout methodsFor: 'styling' stamp: 'DennisSchenk 9/12/2012 10:41'!
styleContainmentNode: node level: level
	| shape |
	shape := (node getShape: ROBox).
	shape color:  ((Color r: 0.934 g: 0.934 b: 0.934) adjustBrightness: -0.03 * level).
	shape borderColor: ((Color r: 0.2 g: 0.2 b: 0.2) adjustBrightness: -0.008 * level).
	! !

!ROTreeMapLayout methodsFor: 'styling' stamp: 'DennisSchenk 9/12/2012 10:42'!
styleContainmentNodeWithOmittedChildren: node level: level
	| shape |
	shape := (node getShape: ROBox).
	shape color:  ((Color r: 0.884 g: 0.884 b: 0.884) adjustBrightness: -0.03 * level).
	shape borderColor: ((Color r: 0.2 g: 0.2 b: 0.2) adjustBrightness: -0.008 * level).

	! !

!ROTreeMapLayout methodsFor: 'styling' stamp: 'AlexandreBergel 8/22/2012 19:23'!
styleLeafNode: node level: level
	| shape |
	shape := node getShape: ROBox.
	
	shape color: Color white.
	shape borderColor: Color gray.

	leafBlock notNil ifTrue: [
			leafBlock value: node.
	].! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
weightBlock
	^ weightBlock ! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 5/22/2012 09:24'!
weightBlock: aWeightBlock
	weightBlock := aWeightBlock.! !

!ROTreeMapLayout methodsFor: 'accessing' stamp: 'DennisSchenk 7/25/2012 11:12'!
weightFor: aNode
	"Returns weight for given node based on weightBlock"
	self assert: weightBlock notNil description: 'weightBlock has to be set!!'.
	^ weightBlock value: aNode.! !

ROObject subclass: #ROMondrianFrame
	instanceVariableNames: 'parent view shape interactions layout elements children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder'!

!ROMondrianFrame commentStamp: '<historical>' prior: 0!
The Mondrian specific language structures a visualization as a tree (using nodes:forEach:). 
A ROMondrianFrame is an element of this tree. A frame correspond to what has to be pushed and popup.
It also contains funcionalities to lookup nodes.

Instance Variables
	children:		<ROMondrianFrameS>
	elements:		<ROElementS>
	interactions:		<Object>
	layout:		<Object>
	parent:		<Object>
	shape:		<Object>
	view:		<Object>

children
	- the list of children frames

elements
	- elements (nodes and edges) that are defined in the frame
	
interactions
	- xxxxx

layout
	- xxxxx

parent
	- xxxxx

shape
	- xxxxx

view
	- xxxxx
!

!ROMondrianFrame methodsFor: 'adding' stamp: 'AlexandreBergel 7/24/2012 17:57'!
addChild: aFrame
	children add: aFrame! !

!ROMondrianFrame methodsFor: 'adding' stamp: 'AlexandreBergel 7/25/2012 11:03'!
addEdge: edge

	"we need to add the edge in the frame that includes both the from and to"
	| frameTo frameFrom |
	frameTo := self frameOfElement: edge to.
	frameFrom := self frameOfElement: edge from.

	(frameTo == frameFrom)
		ifTrue: [ frameFrom addElement: edge ]
		ifFalse: [ 
			"This looks like to be a weir case"
			self addElement: edge ]! !

!ROMondrianFrame methodsFor: 'adding' stamp: 'AlexandreBergel 7/25/2012 11:17'!
addElement: element
"self haltIf: [ element class == ROEdge ]."
	elements add: element! !

!ROMondrianFrame methodsFor: 'adding' stamp: 'AlexandreBergel 7/25/2012 11:03'!
addElements: elementss
	elementss do: [:e | self addElement: e]
	! !

!ROMondrianFrame methodsFor: 'actions' stamp: 'AlexandreBergel 7/25/2012 10:01'!
applyLayout
	children do: [ :frameChild | frameChild applyLayout ].
	layout 
		on: self nodes edges: self edges.! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/25/2012 09:46'!
children
	^ children copy! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 11:35'!
edges	
	^ (elements select: [ :el | el class == ROEdge ]) asArray! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/25/2012 09:48'!
elements
	^ elements copy asArray! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 11:16'!
frameOfElement: element
	"Return the frame that contains element.
	 In case several frames contains the same element, the result is unspecified"

	^ self frameOfElement: element ifFound: [ :foundFrame | ^ foundFrame ]! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 11:15'!
frameOfElement: element ifFound: aBlock
	"aBlock takes an argument, the frame just found"
	
	"Return the frame that contains element.
	 In case several frames contains the same element, the result is unspecified"

	(elements includes: element) 
		ifTrue: [ ^ aBlock value:  self ].
		
	children do: [ :childFrame |
		childFrame frameOfElement: element ifFound: aBlock.
	].

	! !

!ROMondrianFrame methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/24/2012 17:46'!
initialize 
	super initialize.
	elements := OrderedCollection new.
	children := OrderedCollection new.! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
interactions
	^ interactions ! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
interactions: ints
	interactions := ints! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
layout
	^ layout! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
layout: aLayoutClass
	layout := aLayoutClass ! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 09:59'!
nodes
	^ (elements select: [ :el | el class ~~ ROEdge ]) asArray ! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/25/2012 09:45'!
numberOfChildren
	^ children size! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 17:33'!
numberOfElements
	^ elements size! !

!ROMondrianFrame methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 7/24/2012 17:47'!
numberOfFrames
	^  children inject: 1 into: [ :s :e | s + e numberOfFrames ]! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:43'!
parent
	^ parent! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:43'!
parent: aFrame
	parent := aFrame! !

!ROMondrianFrame methodsFor: 'printing' stamp: 'AlexandreBergel 7/25/2012 09:30'!
printOn: stream
	super printOn: stream.
	self parent == self 
		ifTrue: [ stream nextPutAll: '<root>' ]
	  ! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
shape
	^ shape
	! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:05'!
shape: aShape
	shape := aShape! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:04'!
view
	^ view! !

!ROMondrianFrame methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 17:04'!
view: aView
	view := aView! !

ROObject subclass: #ROMondrianViewBuilder
	instanceVariableNames: 'shape color selfDefinedInteraction title shouldHavePopup menu parentBehavior viewStack rawView structureTree currentFrame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder'!

!ROMondrianViewBuilder commentStamp: '<historical>' prior: 0!
A ROMondrianViewBuilder models the Mondrian Domain Specific Language. It is mostly compatible with the original Mondrian language (cf., Mondrian paper and website).

Instance Variables
	color:		<Object>
	container:		<Object>
	height:		<Object>
	isLayouted:		<Object>
	selfDefinedInteraction:		<Object>
	shape:		<Object>
	title:		<Object>
	width:		<Object>

color
	- xxxxx

container
	- xxxxx

height
	- xxxxx

isLayouted
	- xxxxx

selfDefinedInteraction
	- xxxxx

shape
	- xxxxx

title
	- xxxxx

width
	- xxxxx
!

!ROMondrianViewBuilder classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/20/2012 12:29'!
initializedView: aView
	
	^ self basicNew
		initializeWithRoassalView: aView; 
		yourself! !

!ROMondrianViewBuilder classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/26/2012 11:17'!
nonDraggable
	"Create a builder with a non draggable roView in it"
	
	^ self initializedView: ROView new! !

!ROMondrianViewBuilder classSide methodsFor: 'public' stamp: ''!
titled: aTitleAsString
	^ self basicNew
		initializeWithTitle: aTitleAsString; 
		yourself! !

!ROMondrianViewBuilder classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/20/2012 12:30'!
titled: aTitleAsString view: aView
	"Take a string and an instance of ROView as parameter"

	aView @ RODraggable @ RODraggableWithVelocity.

	^ self basicNew
		initializeWithTitle: aTitleAsString roassalView: aView; 
		yourself! !

!ROMondrianViewBuilder classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/20/2012 12:29'!
view: aView
	"Take an instance of ROView as parameter"
	
	aView @ RODraggable @ RODraggableWithVelocity.
	
	^ self initializedView: aView! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/18/2012 14:38'!
action: aBlockOrSymbol
	^ self item: aBlockOrSymbol printString action: aBlockOrSymbol! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/25/2012 11:04'!
addEdge: edge
	"private"
	| commonParentNode frameOfCommonNode |
	commonParentNode := (edge from mostSpecificParentCommonWith: edge to).
	commonParentNode add: edge.
	
	frameOfCommonNode := structureTree frameOfElement: commonParentNode.
	frameOfCommonNode addEdge: edge! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/25/2012 11:29'!
addEdges: edges
	"private"
	edges do: [ :e | self addEdge: e ]! !

!ROMondrianViewBuilder methodsFor: 'command' stamp: 'AlexandreBergel 5/18/2012 09:19'!
addMenu: name callBack: aCallBack
	"aCallback has to be one-arg block that accepts a view stack. It is convenient to receive the stack and not directly the view to add menu for example"
	
	menu add: name -> aCallBack! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
addUserCommand: anArray 
	"TODO"! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: 'AlexandreBergel 7/25/2012 10:01'!
applyLayout

	structureTree applyLayout! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 6/13/2012 00:26'!
arrowedLine
	^ self arrowedLineWithOffset: 0! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'TudorGirba 10/17/2012 11:18'!
arrowedLineWithOffset: aFloat
	shape := ROLine new.
	shape add: (ROArrow new offset: aFloat).
	self color: self defaultLineColor.
	^ shape! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
borderColor
	^ shape borderColor! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 11:58'!
borderColor: aBlockOrSymbol
	"aBlockOrSymbol expect to be evaluated against the model. It may either be a symbol or a one-arg block"

	shape borderColor: [ :element | aBlockOrSymbol roValue: element model ]
	
	! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/23/2012 09:00'!
borderWidth: aBlockOrSymbol
	"aBlockOrSymbol expect to be evaluated against the model. It may either be a symbol or a one-arg block"

	shape borderWidth: [ :element | aBlockOrSymbol roValue: element model ]
	! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:58'!
bottomFlowLayout
	^ self layout: ROBottomFlowLayout new! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 8/20/2012 09:18'!
buildEdgeFrom: fromNode to: toNode for: anObject
	"Shape is not initialized here"
	
	| edge |
	edge := (ROEdge on: anObject from: fromNode to: toNode) + shape.
	selfDefinedInteraction do: [:int | int value: (Array with: edge) ].
	^ edge! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/20/2012 14:49'!
circle
	shape := ROCircle new.
	self color: self defaultNodeColor.
	shape borderWidth: 1.
	! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
circleLayout
	^ self layout: ROCircleLayout new! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'TudorGirba 10/17/2012 11:16'!
color: aBlockOrSymbol
	color := aBlockOrSymbol.
	shape color: [ :element | aBlockOrSymbol roValue: element model ]
	
	! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 7/24/2012 14:35'!
createMondrianView
	"Creating the view that will contain all the nodes and edges"
	
	| v |
	v := ROView titled: title.
	v @RODraggable @ RODraggableWithVelocity.
	^ v! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 09:35'!
currentFrame
	^ currentFrame! !

!ROMondrianViewBuilder methodsFor: 'configuration' stamp: ''!
defaultColor 
	^ Color veryLightGray
! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 7/24/2012 14:34'!
defaultHeight
	"Default height of a node"
	
	^ 5! !

!ROMondrianViewBuilder methodsFor: 'configuration' stamp: ''!
defaultLineColor
	^ Color veryLightGray! !

!ROMondrianViewBuilder methodsFor: 'configuration' stamp: ''!
defaultNodeColor
	^ Color white! !

!ROMondrianViewBuilder methodsFor: 'configuration' stamp: ''!
defaultTextColor
	^ Color black! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 7/24/2012 14:35'!
defaultWidth
	"Default width of a node"
	
	^ 5! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'TudorGirba 10/1/2012 14:00'!
dominanceTreeLayout
	self setEdgesAttachPoint: ROVerticalAttachPoint.
	^self layout: RODominanceTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:43'!
edge: object from: fromBlock to: toBlock
	"Add an edge going from (fromBlock roValue: object) to (toBlock roValue: object)"
	
	^ self edgeFromAssociation: ((fromBlock roValue: object) -> (toBlock roValue: object))
	! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 15:01'!
edgeFromAssociation: assoc
	"Create an edge from an association
	e.g.,
	
	view nodes: #(1 2).
	view edgeFromAssociation: 1 -> 2.
	"
 	| edge |
	(assoc key isNil or: [ assoc value isNil ]) ifTrue: [ ^ nil ].
	(assoc key == assoc value) ifTrue: [ ^ nil ].
	
	self prepareForNewEdge.
	edge := self rawEdgeFromAssociation: assoc.
	edge notNil ifTrue: [ self addEdge: edge ].
	self unsetShape.
	^ edge! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:19'!
edges
	^ self raw elementsSuchThat: [ :v | v class == ROEdge ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 23:03'!
edges: objects from: fromBlock to: toBlock
	"-  aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each element of the collection and return one edge source each time.
	- aToBlock will be called on each element of the collection and return the destination node.
	Note that there is no restriction on the elements of aCollection, as long as aFromBlock returns a node.
	"

	| edges |
	edges :=  self rawEdges: objects from: fromBlock to: toBlock.
	self addEdges: edges.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 14:52'!
edges: objects from: fromBlock toAll: toAllBlock
	"- objects is the collection of from which the edges are defined from.
	- fromBlock will be called on each entity of the collection and return one edge source each time.
	- toAllBlock will be called similarly to return a collection of destination correpsonding to each source.
	Note that there is no restriction on the entities of aCollection, as long as aFromBlock returns a node and aToBlock returns a collection of nodes.
	For example:
	  aView edges: someFamixInvocations from: #sender toAll: #candidates

	Or:
	
	| collection |
	collection := #(1 2 3 4 5 6 7 8 9 10).
	view shape label.
	view nodes: collection.
	view edges: collection from: #yourself toAll: (collection select: #odd).
	view circleLayout
		
	aToBlock should return a collection, edges will be drawn from the entity returned by aFromBlock to this collection"
	
	| associations |
	associations := OrderedCollection new.
	objects do: [ :obj |
		| from |
		from := fromBlock roValue: obj.
		(toAllBlock roValue: obj) do: [:to | 
			associations add: (from -> to)
		]
	].
	^ self edgesFromAssociations: associations! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/25/2012 11:29'!
edgesFrom: symbolOrBlock
	"The message edgesFrom: defines one edge per node. For each node that has been added in the visualization, an edge is defined between this node and a node lookup from the provided block."

	| edges |
	edges := self rawEdgesFrom: symbolOrBlock.
	self addEdges: edges.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 15:02'!
edgesFromAssociations: associations
	| answer edge interestingEdges |
	
	self prepareForNewEdge.

	interestingEdges := associations select: [ :assoc | 
						assoc key notNil and: [ assoc value notNil ] ].
	interestingEdges := interestingEdges select: [ :assoc |
						assoc key ~~ assoc value ].
					
	answer := interestingEdges collect: [ :assoc | 
		edge := self rawEdgeFromAssociation: assoc.
		edge notNil ifTrue: [ self addEdge: edge ].
		
		edge ].
	self unsetShape.
	^ answer! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 7/24/2012 15:02'!
edgesToAll: symbolOrBlock
	| edges |
	edges := self rawEdgesToAll: symbolOrBlock.
	edges do: [ :e | self addEdge: e ].
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
fillColor
	^ shape color! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/15/2012 10:00'!
fillColor: aBlockOrSymbol
	"aBlockOrSymbol expect to be evaluated against the model. It may either be a symbol or a one-arg block"

	shape color: [ :element | aBlockOrSymbol roValue: element model ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 5/21/2012 23:58'!
fixedSize
	parentBehavior := ROFixedSizedParent instance! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:58'!
flowLayout
	^ self layout: ROFlowLayout new! !

!ROMondrianViewBuilder methodsFor: 'todo' stamp: ''!
fontSize: aBlockOrASymbolOrAnObject! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
forNode: aValue do: aBlock
	"Enable one to add a subview for a given node"
	
	| node oldPos|
	"For some strange reason, doing an applyLayout reset to 0@0 the origin of the node, it should not"
	
	node := self lookupNode: aValue globally: true.

	node removeAllEdges; removeAllNodes.
	node clearLookupCacheRecursively.
	
	oldPos := node bounds origin.
	self with: node during: [ self resetInteraction. aBlock value. node applyLayout ].
	node bounds origin: oldPos. 

	node bounds extent: (node shape computeExtentFor: node).
	node resetFormCache.
	node owner ifNotNil: [ node owner resetFormCache ].
	
	"We might have to update the bounds of the root"
	(node owner isRoot and: [( node owner absoluteBounds containsRect: node absoluteBounds) not])
		ifTrue: [ node owner updateBounds ].
		
	self root resetElementsToDisplayCacheRecursively.
	self root resetElementsToLookup.
	self resetInteraction.
	^ node! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
forNodes: values do: oneBlockArg
	"Enable one to add a subview for a given nodes"

	^ values collect: [:v | self forNode: v do: [ oneBlockArg value: v ] ]! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
forceBasedLayout
	
	^ self layout: ROForceBasedLayout new! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forward
	self forwarder! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forward: event

	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node forward: event ] ]! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forwarder

	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node forward ] ]! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
fromPositions: v
	"For compatibility reason"! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 12:07'!
getShape
	^ shape! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
gridLayout
	
	^ self layout: (ROGridLayout new gapSize: 2)
		! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 12:24'!
height: aHeightBlock
	shape height: [ :elem | aHeightBlock roValue: elem model ] ! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
highlightNodesWhenOver: aBlockOrSymbol
	self highlightNodesWhenOver: aBlockOrSymbol color: Color red! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
highlightNodesWhenOver: aBlockOrSymbol color: aColorAsBlockOrSymbol
	self interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := (aBlockOrSymbol roValue: n element) . 
		ROHighlightElements 
			on: nodes 
			color: (aColorAsBlockOrSymbol roValue: n element model).
		n element signalUpdate  ].

	self interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := (aBlockOrSymbol roValue: n element).
		ROUnhighlightElements  
			on: nodes.
		n element signalUpdate  ].! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: 'AlexandreBergel 7/3/2012 17:09'!
highlightWhenOver: aBlockOrSymbol
	"(aBlockOrSymbol roValue: element) should return a collection of the models that should be highlighted"

	self highlightWhenOver: aBlockOrSymbol color: Color red! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: 'AlexandreBergel 7/6/2012 13:07'!
highlightWhenOver: aBlockOrSymbol color: aColorAsBlockOrSymbol
	"We use 'nodes asSet' to make sure that we do not go twice over the same node, else it behaves strangely'"
	
	self interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := self raw elementsFromModels: (aBlockOrSymbol roValue: n element model) . 
		ROHighlightElements 
			on: nodes asSet
			color: (aColorAsBlockOrSymbol roValue: n element model) ].

	self interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := self raw elementsFromModels:  (aBlockOrSymbol roValue: n element model).
		ROUnhighlightElements  
			on: nodes asSet ].! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'TudorGirba 9/27/2012 23:08'!
horizontalDominanceTreeLayout
	self setEdgesAttachPoint: ROHorizontalAttachPoint.
	^self layout: ROHorizontalDominanceTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:53'!
horizontalLineLayout
	^ self layout: ROHorizontalLineLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'BenComan 8/5/2012 16:04'!
horizontalTreeLayout
	self setEdgesAttachPoint: ROHorizontalAttachPoint.
	^self layout: ROHorizontalTreeLayout new.! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/15/2012 10:07'!
if: conditionBlock borderColor: colorBlock
	"If conditionBlock is evaluated at true, then colorBlock is used to pick the color to use. Both conditionBlock and colorBlock are evaluated with the model value of the node."

	| oldBlockOrValue |
	oldBlockOrValue := self borderColor ifNil: [ self defaultBorderColor ].
	^ self borderColor: [ :aModel | (conditionBlock roValue: aModel)
									ifTrue: [ colorBlock roValue: aModel ] 
									ifFalse: [ 
										"Having to create a new element is rather ugly. 
										Ideally, the oldBlockOrValue has to be 'unwrapped' for the translation"
										oldBlockOrValue roValue: (ROElement on: aModel) ]].! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/15/2012 10:07'!
if: conditionBlock fillColor: colorBlock
	"If conditionBlock is evaluated at true, then colorBlock is used to set the color of the node. Both conditionBlock and colorBlock are evaluated with the model value of the node."

	| oldBlockOrValue |
	oldBlockOrValue := self fillColor ifNil: [ self defaultFillColor ].
	^self fillColor: [ :aModel | (conditionBlock roValue: aModel)
									ifTrue: [ colorBlock roValue: aModel ] 
									ifFalse: [ 
										"Having to create a new element is rather ugly. 
										Ideally, the oldBlockOrValue has to be 'unwrapped' for the translation"
										oldBlockOrValue roValue: (ROElement on: aModel) ]].
							
						
! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 7/9/2012 08:25'!
if: conditionBlock popupText: popupTextBlock
	"If conditionBlock is evaluated at true, then popupTextBlock is used to for the popup"

	^ self  popupView: [ :entity :myView | 
		(conditionBlock roValue: entity) 
			ifTrue:  
		[ myView shape rectangle.
	  	 myView node: entity forIt: [ 
			myView shape label.
			myView node: (popupTextBlock roValue: entity)
		] ] ] 

"	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | 
			| oldBlockOrValue |
			oldBlockOrValue := 
				(node is: ROPopupView)
					ifTrue: [ node getInteraction: ROPopupView ] 
					ifFalse: [ #printString ].
			self popupText: [ :each |
				(conditionBlock roValue: each)
					ifTrue: [ popupTextBlock roValue: each ]
					ifFalse: [ oldBlockOrValue roValue: each ] ] ] ] 
			"! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 11:36'!
initFrame
	
	structureTree := ROMondrianFrame new.
	structureTree view: rawView.
	structureTree shape: shape.
	structureTree interactions: selfDefinedInteraction.
	
	structureTree parent: structureTree.
	currentFrame :=  structureTree! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 4/29/2012 11:25'!
initialize
	self initializeWithTitle: ROView defaultWindowTitle.! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 5/3/2012 09:23'!
initializeWithRoassalView: aView
	self initializeWithTitle: ROView defaultWindowTitle roassalView: aView! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 5/3/2012 09:14'!
initializeWithTitle: aTitleAsString
	self initializeWithTitle: aTitleAsString roassalView: self createMondrianView.
! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 7/25/2012 11:38'!
initializeWithTitle: aTitleAsString roassalView: aView
	super initialize.

	title := aTitleAsString.
	rawView := aView.
	aView title: title.
	shouldHavePopup := true.
	menu := OrderedCollection new.

	self initFrame.
	
	viewStack := ROViewStack new addView: rawView; title: rawView title.
	self setNodeShapeIfNecessary.
	self setUpSize.
	self setUpInteraction.
	self horizontalLineLayout.
	self popupText
	! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 10/2/2012 20:15'!
interaction
	"For compatibility with Mondrian"! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
item: titleAsString action: aBlockOrSymbol

	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :n | n @ (ROMenuActivable new item: titleAsString action: aBlockOrSymbol) ] ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'TudorGirba 10/17/2012 11:20'!
label
	shape := self newLabel! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/24/2012 16:54'!
lastFrame
	^ structureTree last! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: 'AlexandreBergel 7/25/2012 10:05'!
layout: aLayout
	currentFrame layout: aLayout.
	^ aLayout ! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'TudorGirba 10/17/2012 11:17'!
line
	shape := ROLine new.
	self color: self defaultLineColor.
	^ shape! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/30/2012 11:16'!
linearFillColor: block within: groupOfObjects
	"Set the linear fill color for the nodes. The gradient goes from white to black. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."
	
	| max |
	"If the collection is empty, then we return an arbitrary color. 
	 If the script is properly done, the color should not be used"
	groupOfObjects isEmpty ifTrue: [ ^ Color red ].
	
	max := (groupOfObjects collect: block) max.
	shape color: [ :v | Color gray256: 256 - ((block roValue: v model) max: max in: (1 to: 256)) ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
logHeight: aBlock
	self height: [ :v | ((aBlock value: v) + 1) log * 10 ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
logWidth: aBlock
	self width: [ :v | ((aBlock value: v) + 1) log * 10 ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'TudorGirba 7/29/2012 23:22'!
lookup: anObject
	"Return the node that has the object as model"
	
	| ans |
	ans := self raw elementsSuchThat: [ :n | n isEdge not and: [n model = anObject ] ].
	ans isEmpty ifTrue: [ ^ self nestedLookup: anObject ].
	ans size ~= 1 ifTrue: [ self error: 'Several candidates' ].
	^ ans first! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: ''!
needToSetup
	^ shape isNil! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 6/9/2012 15:19'!
nestedLookup: anObject
	"Return the node that has the object as model, it goes "
	
	self raw elementsDo: [ :el | 
		| t |
		t := self nestedLookup: anObject in: el.
		t ifNotNil: [ ^ t ] ].
	^ nil! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
nestedLookup: anObject in: aNode
	"Return the node that has the object as model, it goes "
	
	| ans |
	(aNode model = anObject)
		ifTrue: [ ^ aNode ].
		
	aNode elementsDo: [ :n | 
		| t |
		t := self nestedLookup: anObject in: n.
		t ifNotNil: [ ^ t ] ].
	
	^ nil. 
		! !

!ROMondrianViewBuilder methodsFor: 'util' stamp: 'AlexandreBergel 9/20/2012 12:08'!
newCenteredLabel
	^ ROCenteredLabel new color: self defaultTextColor; yourself! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/30/2012 19:38'!
newLabel
	^ ROLabel new color: self defaultTextColor; yourself! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 7/14/2012 15:51'!
noLayout
	^ self layout: RONullLayout
	! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 8/20/2012 09:12'!
noPopup 

	selfDefinedInteraction add: [ :listOfElements | 
		listOfElements do: [ :element | element removeInteraction: ROAbstractPopup ] ].! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
node: object
	^ (self nodes: (Array with: object)) first! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
node: object forIt: aBlock
	^ (self nodes: (Array with: object) forEach: [ :v | aBlock value ]) first! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:18'!
nodes
	^ self raw elementsSuchThat: [ :v | v class == ROElement ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 10/17/2012 12:27'!
nodes: objects
	| els copyShape |
	self assert: [ objects isCollection] description: 'Should provide a collection as parameter'.
		
	self prepareForNewNode.
	
	els := ROElement forCollection: objects.

	copyShape := shape copy.

	els do: [ :el | 
		el + shape copy @ RODraggable. 
		"Ideally, we would like to write:"
		"copyShape width: [ :elem | width roValue: elem model ] copy.
		copyShape height: [ :elem | height roValue: elem model ] copy."
		"copyShape width: ([ :w | [ :elem | w roValue: elem model ]] value: width).
		copyShape height: ([ :h | [ :elem | h roValue: elem model ]] value: height)."

		el resizeStrategy: parentBehavior.
						
						"width: [ :v | el width max: (width roValue: v)]; 
						height: [ :v | el height max: (height roValue: v)];"
						 ].
	
	selfDefinedInteraction do: [:int | int value: els ].
	
	
	self assert: [ els allSatisfy: [ :e | e model notNil ] ].
	rawView addAll: els.
	self unsetShape.
	
	selfDefinedInteraction := OrderedCollection new.
	self popupText. "Make sure the next nodes have a popup"

	currentFrame addElements: els.
	
	^ els! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 7/25/2012 10:06'!
nodes: objects forEach: aBlock
	"Create a set of nodes, each representing an element of objects. Each node then acts as a view on its own."

	| nodes oldContainer oldShape oldInteraction oldLayout |
	nodes := self nodes: objects.

	
	nodes do: [ :n | 
		self push.
		self horizontalLineLayout.
		
		rawView := n.
		selfDefinedInteraction := OrderedCollection new.
		self popupText.
		
		aBlock roValue: n model.
		n adjustSizeIfNecessary.
		self pop.
		 ].
	self unsetShape.
	^ nodes! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:21'!
nodesAndEdges
	^ rawView elementsSuchThat: [ :v | true ]! !

!ROMondrianViewBuilder methodsFor: 'todo' stamp: 'AlexandreBergel 4/30/2012 19:53'!
nodraggable
	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | node removeInteraction: RODraggable ] ]! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/9/2012 07:33'!
numberOfDefinedInteractions
	"Used essentially for debugging purpose"

	^ selfDefinedInteraction size! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/24/2012 18:05'!
numberOfFrames
	"number of children of the root node"

	^ structureTree numberOfFrames! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
on: event do: block
	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node on: event do: block ] ]! !

!ROMondrianViewBuilder methodsFor: 'opening' stamp: 'AlexandreBergel 7/25/2012 11:38'!
open
	"Open the view. Return the system window opened"

	| whiteBox realView |
	self applyLayout.

	self populateMenuOn: viewStack.
	^ viewStack open
	! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 11:36'!
pop

	rawView := currentFrame view.
	shape := currentFrame shape.
	selfDefinedInteraction := OrderedCollection new.

	currentFrame := currentFrame parent! !

!ROMondrianViewBuilder methodsFor: 'command' stamp: 'AlexandreBergel 9/29/2012 15:26'!
populateMenuOn: aStackView
	| labels |
	labels := OrderedCollection new. 
	menu do: [ :assoc |
		| label |
		label := ROElement labelOn: assoc key.
		label @ ROLightlyHighlightable lightGray + ROBorder gray + ROBox white. 
		label on: ROMouseLeftClick do: [ :event | 
			ROUnhighlightElement on: label.
			label view signalUpdate.
			
			assoc value roValue: aStackView ].
		aStackView add: label.
		labels add: label ].
	
	ROHorizontalLineLayout on: labels.! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/18/2012 14:40'!
popupText
	^ self popupText: [ :v | (v class == 'ab' class) ifTrue: [ v ] ifFalse: [ v printString ] ]! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 7/9/2012 08:24'!
popupText: aBlockOrSelector

	^ self  popupView: [ :entity :myView | 
		myView shape rectangle.
		myView node: entity forIt: [ 
			myView shape label.
			myView node: (aBlockOrSelector roValue: entity)
		] 
	]
"	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | 
			| int |
			int := ROPopup text: aBlockOrSelector.
			int receivingView: stack.
			int textColor: Color black.
			node changeInteraction: ROAbstractPopup for: int.
			 ] ]
		
	"
	! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 7/6/2012 13:36'!
popupView: aTwoArgsBlock
	"aTwoArgsBlock is in the form [ :entity :myView |  ... ]"
	
	^ self popupView: aTwoArgsBlock delay: 100
! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 9/20/2012 15:58'!
popupView: aTwoArgsBlock delay: delayAsInteger
	"aTwoArgsBlock is in the form [ :entity :myView |  ... ]"

	selfDefinedInteraction add: [ :listOfElements | 
		listOfElements do: [ :element | 
			element changeInteraction: ROAbstractPopup for: 
				(ROPopupView new 
					 receivingView: viewStack;
					view: [ :entity | 
						| v |
						v := self class new.
						aTwoArgsBlock value: entity model value: v.
						v applyLayout.
						v ] ) ] ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 8/20/2012 09:09'!
prepareForNewEdge

	self needToSetup ifTrue: 
		[self setUpSize.
		self setLineShapeIfNecessary ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 5/21/2012 23:59'!
prepareForNewNode

	self needToSetup ifTrue: 
		[ self setUpSize.
		  self setNodeShapeIfNecessary ].
	parentBehavior ifNil: [ parentBehavior := ROExtensibleParent instance ]
! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/24/2012 17:32'!
prepareStack
	structureTree isEmpty ifTrue: [ self push ]! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/25/2012 11:36'!
push
	
	| newFrame |
	newFrame := ROMondrianFrame new.
	newFrame  view: rawView.
	newFrame shape: shape.
	newFrame interactions: selfDefinedInteraction.
	
	currentFrame addChild: newFrame.
	newFrame parent: currentFrame.
	
	currentFrame := newFrame.! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 09:03'!
radialTreeLayout
	
	^ self layout: RORadialTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:21'!
raw
	^ rawView! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 22:48'!
rawEdgeFromAssociation: assoc
	| from to |
	from := self lookup: assoc key.
	to := self lookup: assoc value.
	(from isNil or: [ to isNil ])
		ifTrue: [ ^ nil ].
	^ self buildEdgeFrom: from to: to for: assoc! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 23:05'!
rawEdges: objects from: symbolOrBlockFrom to: symbolOrBlockTo
	| edges |
	edges := OrderedCollection new.
	self prepareForNewEdge.
	objects 
		do: [ :obj | 
			| from to |
			from := self lookup: (symbolOrBlockFrom roValue: obj).
			to := self lookup: (symbolOrBlockTo roValue: obj).
			(from notNil and: [ to notNil ])
				ifTrue: [ edges add: (self buildEdgeFrom: from to: to for: obj) ] ].
	self unsetShape.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
rawEdgesFrom: symbolOrBlockFrom
	^ self rawEdgesFrom: symbolOrBlockFrom to: #yourself! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 22:49'!
rawEdgesFrom: symbolOrBlockFrom to: symbolOrBlockTo
	| edges |
	edges := OrderedCollection new.
	self prepareForNewEdge.
	rawView
		elementsWithModelDo: [ :el | 
			rawView
				elementsWithModelDo: [ :el2 | 
					self assert: [ el model notNil ].
					self assert: [ el2 model notNil ].
					(symbolOrBlockFrom roValue: el model) = (symbolOrBlockTo roValue: el2 model)
						ifTrue: [ 
							el ~~ el2
								ifTrue: [ edges add: (self buildEdgeFrom: el2 to: el for: el2 model) ] ] ] ].
	self unsetShape.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'TudorGirba 7/29/2012 22:49'!
rawEdgesToAll: symbolOrBlock
	| edges values v |
	edges := OrderedCollection new.
	self prepareForNewEdge.
	rawView
		elementsDo: [ :el | 
			values := symbolOrBlock roValue: el model.
			rawView
				elementsDo: [ :el2 | 
					v := values detect: [ :n | n == el2 model ] ifNone: [ nil ].
					v ifNotNil: [ edges add: (self buildEdgeFrom: el2 to: el for: el2) ] ] ].
	self unsetShape.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'TudorGirba 10/17/2012 11:17'!
rectangle
	shape := ROBox new.
	self color: self defaultNodeColor.
	shape borderWidth: 1.
	! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'TudorGirba 10/17/2012 11:18'!
rectangleWithoutBorder
	shape := ROBox new.
	self color: self defaultNodeColor! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
root
	^ self ! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 09:04'!
scatterPlotLayout
	
	^ self layout: ROScatterplotLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: 'AlexandreBergel 9/28/2012 09:42'!
setEdgesAttachPoint: attachPointClass
	
	self edges do: [ :ed | 
		(ed isShapedAs: ROShape) 
			ifTrue: [
				(ed getShape: ROShape) attachPoint: attachPointClass instance ]
			ifFalse: [ ROLine new color: color; attachPoint: attachPointClass instance ] ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
setLineShapeIfNecessary
	"If no shape for edge is defined, then we set up a default one"

	shape ifNil: [ self shape line ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
setNodeShapeIfNecessary
	"If no shape for node is defined, then we set up a default one"

	shape ifNil: [ self shape rectangle ]! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 4/30/2012 17:22'!
setUpInteraction
	selfDefinedInteraction := OrderedCollection new.
! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 10/17/2012 14:09'!
setUpSize
"	width := self defaultWidth.
	height := self defaultHeight"! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
shape
! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 5/21/2012 22:17'!
shape: aShape
	shape := aShape! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 13:47'!
size: aSizeBlock
	self width: aSizeBlock.
	self height: aSizeBlock.	! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/25/2012 11:38'!
stack
	^ viewStack! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/25/2012 11:38'!
stack: aStack
	"This method is essentially used in the VW Easel. It should not be existing actually"
	viewStack := aStack! !

!ROMondrianViewBuilder methodsFor: 'stack' stamp: 'AlexandreBergel 7/24/2012 16:36'!
structureTree
	^ structureTree! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'BenComan 8/5/2012 16:00'!
sugiyamaLayout
	self setEdgesAttachPoint: ROVerticalAttachPoint.
	^ self layout: ROSugiyamaLayout new
	! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'TudorGirba 10/18/2012 09:33'!
text: aBlockOrSymbol
	"aBlockOrSymbol expect to be evaluated against the model. It may either be a unary symbol or a one-arg block"

	shape text: [ :element | aBlockOrSymbol roValue: element model ]! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
title
	"Return a string"
	
	^ title! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
title: aString
	"Define the title of the view"

	title := aString! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
toPositions: v
	"For compatibility reason"! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'BenComan 8/5/2012 16:10'!
treeLayout
	self setEdgesAttachPoint: ROVerticalAttachPoint.
	^ self layout: ROTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
unsetShape
	shape := nil.
	self setUpSize.! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:53'!
verticalLineLayout
	^ self layout: ROVerticalLineLayout new.
	! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 18:38'!
view
	"This method is made to have the builder, roelement and roview polymorphic. Useful in the class ROPopupView"

	^ self raw! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/9/2012 15:21'!
view: aView
	rawView := aView! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 12:24'!
width: aWidthBlock
	shape width: [ :elem | aWidthBlock roValue: elem model ] ! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 9/20/2012 12:07'!
withCenteredText
	^ self withCenteredText: [ :element | element model ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 14:09'!
withCenteredText: aBlockOrASymbolAnOrObject
	| label |
	shape next: (label := self newCenteredLabel text: aBlockOrASymbolAnOrObject).
"	width := [ :v | label widthOfString: v printString ].
	height := [ :v | label heightOfString: v printString ]."! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/30/2012 17:23'!
withPopup 
	shouldHavePopup := true! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/15/2012 10:15'!
withText
	^ self withText: #yourself! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 10/17/2012 14:09'!
withText: aBlockOrASymbolAnOrObject
	| label |
	label := self newLabel text: [ :anElement | aBlockOrASymbolAnOrObject roValue: anElement model ].
	shape next: label.
"	width := [ :v | label widthOfString: v printString ].
	height := [ :v | label heightOfString: v printString ]."! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
withoutBorder
	"We assume we want to have a rectangle"
	
	self rectangleWithoutBorder! !

ROObject subclass: #RONAbstractNormalizer
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

RONAbstractNormalizer subclass: #ROMultipleColorLinearNormalizer
	instanceVariableNames: 'normalizers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!ROMultipleColorLinearNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:05'!
valueRange: anArrayOfNumbers colorRange: anArrayOfColors

	^ self new valueRange: anArrayOfNumbers colorRange: anArrayOfColors! !

!ROMultipleColorLinearNormalizer methodsFor: 'private-accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
detectNormalizerFor: aValue

	normalizers keysAndValuesDo: [:range :norm |
		(range rangeIncludes: aValue)
			ifTrue: [^ norm] ].
	self error: aValue asString, ' not in declared ranges'! !

!ROMultipleColorLinearNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 16:05'!
initialize

	command := #yourself! !

!ROMultipleColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 18:35'!
roValue: anEntity

	| value |
	value := self command value: anEntity.
	"detect range for the value, retrieve and call corresponding normalizers"
	^ (self detectNormalizerFor: value) roValue: value! !

!ROMultipleColorLinearNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/4/2012 01:06'!
valueRange: anArrayOfNumbers colorRange: anArrayOfColors
	" {1. 2. 3} {Color red. Color yellow. Color green}"
	
	| size start end |
	normalizers := Dictionary new.
	self assert: anArrayOfNumbers size = anArrayOfColors size.
	size := anArrayOfNumbers size.
	1 to: size - 1 do: [ :i |
		start := anArrayOfNumbers at: i.
		end :=  anArrayOfNumbers at: i + 1.
		normalizers
			at: (start to: end)
			put: (RONColorLinearNormalizer
						inContext: (Array with: start with: end)
						lowColor: (anArrayOfColors at: i)
						highColor: (anArrayOfColors at: i + 1))
	].
! !

!RONAbstractNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
command
	
	^command! !

!RONAbstractNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
command: aBlock
	
	command := aBlock! !

!RONAbstractNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:13'!
roValue: anEntity
	
	self subclassResponsibility! !

RONAbstractNormalizer subclass: #RONIdentityNormalizer
	instanceVariableNames: 'dictionary colorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

RONIdentityNormalizer subclass: #RONExplicitIdentityNormalizer
	instanceVariableNames: 'colors defaultColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!RONExplicitIdentityNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:05'!
withCommand: aBlock withColors: aCollection withDefaultColor: aColor
	
	^(self withCommand: aBlock)
		colors: aCollection;
		defaultColor: aColor;
		yourself! !

!RONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
colors
	
	^colors! !

!RONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
colors: anObject
	
	colors := anObject! !

!RONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
defaultColor
	
	^defaultColor! !

!RONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:05'!
defaultColor: anObject
	
	defaultColor := anObject! !

!RONExplicitIdentityNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/4/2012 00:21'!
nextColor
	
	colorIndex := colorIndex + 1.
	^colorIndex > self colors size
		ifTrue: [ self defaultColor ]
		ifFalse: [ self colors at: colorIndex ]! !

!RONIdentityNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/14/2012 10:43'!
beginingAtBlue
	^ self new
			setIndexTo: #blue;
			yourself! !

!RONIdentityNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/14/2012 10:40'!
beginingAtRed
	^ self new
			setIndexTo: #red;
			yourself! !

!RONIdentityNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:05'!
withCommand: aBlock
	
	^(self new)
		command: aBlock;
		yourself! !

!RONIdentityNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 16:05'!
initialize
	
	super initialize.
	colorIndex := 0.
	dictionary := IdentityDictionary new.
	command := #yourself! !

!RONIdentityNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 16:05'!
nextColor
	
	colorIndex := colorIndex \\ Color colorNames size + 1.
	^Color perform: (Color colorNames at: colorIndex)! !

!RONIdentityNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 00:12'!
roValue: anEntity
	
	^dictionary
		at: (command roValue: anEntity)
		ifAbsentPut: [ self nextColor ]! !

!RONIdentityNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/14/2012 10:42'!
setIndexTo: colorAsSymbol
	"colorAsSymbol has to be one of Color colorNames. 
	The method set the current index to the color given in parameter"
	
	colorIndex := (Color colorNames indexOf: colorAsSymbol) - 1! !

RONAbstractNormalizer subclass: #RONLinearNormalizer
	instanceVariableNames: 'maximumValue context minimumValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

RONLinearNormalizer subclass: #RONColorLinearNormalizer
	instanceVariableNames: 'minBrightness maxBrightness lowColor highColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!RONColorLinearNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection lowColor: lowColor highColor: highColor
	
	| normalizer |
	normalizer := self inContext: aCollection.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	^normalizer! !

!RONColorLinearNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection lowColor: lowColor lowThreshold: lowThreshold highColor: highColor highThreshold: highThreshold
	
	| normalizer |
	normalizer := self inContext: aCollection.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	normalizer minBrightness: lowThreshold.
	normalizer maxBrightness: highThreshold.
	^normalizer! !

!RONColorLinearNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection withCommand: aBlock lowColor: lowColor highColor: highColor
	
	| normalizer |
	normalizer := self inContext: aCollection withCommand: aBlock.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	^normalizer! !

!RONColorLinearNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection withCommand: aBlock lowColor: lowColor lowThreshold: lowThreshold highColor: highColor highThreshold: highThreshold
	
	| normalizer |
	normalizer := self inContext: aCollection withCommand: aBlock.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	normalizer minBrightness: lowThreshold.
	normalizer maxBrightness: highThreshold.
	^normalizer! !

!RONColorLinearNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 16:06'!
blend: aColor with: aColorValue weight: wt
	"Answer a new ColorValue which is a weighted blend of the receiver and the
	supplied ColorValue."
	"Simply interpolates in RGB space."

	| rv gv bv invWt |
	
	invWt := 1-wt.
	rv := ((aColor red * invWt) + ((aColorValue red)*wt)) "rounded".
	gv := ((aColor green  * invWt) + ((aColorValue green)*wt)) "rounded".
	bv := ((aColor blue *invWt)+ ((aColorValue blue)*wt)) "rounded".
	^Color r: rv g: gv b: bv! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
highColor: aBlock
	
	highColor := aBlock! !

!RONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'AlexandreBergel 7/3/2012 18:35'!
highColorFor: anEntity
	
	^highColor roValue: anEntity! !

!RONColorLinearNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 16:06'!
initialize
	
	super initialize.
	lowColor := Color white.
	highColor := Color black! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
lowColor: aBlock
	
	lowColor := aBlock! !

!RONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'AlexandreBergel 7/3/2012 18:35'!
lowColorFor: anEntity
	
	^lowColor roValue: anEntity! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
maxBrightness: aBlock
	
	maxBrightness := aBlock! !

!RONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'AlexandreBergel 7/3/2012 18:35'!
maxBrightnessFor: anEntity
	
	^maxBrightness isNil
		ifTrue: [1.0]
		ifFalse: [maxBrightness roValue: anEntity]! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
minBrightness: aBlock
	
	minBrightness := aBlock! !

!RONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'AlexandreBergel 7/3/2012 18:35'!
minBrightnessFor: anEntity
	
	^minBrightness isNil
		ifTrue: [0.0]
		ifFalse: [minBrightness roValue: anEntity]! !

!RONColorLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:14'!
roValue: anEntity
	"Calculates the color of the entity based on the context."
	
	| myValue myHighColor myLowColor myMinBrightness myMaxBrightness weight minValue maxValue |
	"Get color specific data"
	minValue :=  self minimumValue: anEntity.
	maxValue :=  self maximumValue: anEntity.
	myMinBrightness := self minBrightnessFor: anEntity.
	myMaxBrightness := self maxBrightnessFor: anEntity.
	myHighColor := self highColorFor: anEntity.
	myLowColor := self lowColorFor: anEntity.	"Get data"
	weight := minValue = maxValue 
		ifTrue: [(myMinBrightness + myMaxBrightness) / 2]
		ifFalse: [	
			myValue := (self command value: anEntity) - (self minimumValue: anEntity).
			myMinBrightness + (myValue abs / (maxValue - minValue) * (myMaxBrightness - myMinBrightness)) ].
	^self blend: myLowColor with: myHighColor weight: weight! !

RONLinearNormalizer subclass: #RONFontLinearNormalizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!RONFontLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 00:12'!
roValue: anEntity
	"Calculates the color of the entity based on the context."
	
	| value |
	value := self command roValue: anEntity.
	^5 + (38 * (value abs / (self maximumValue: anEntity))) asInteger! !

!RONLinearNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection
	
	^self inContext: aCollection withCommand: #yourself! !

!RONLinearNormalizer classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 16:06'!
inContext: aCollection withCommand: aBlock
	
	^(self new)
		context: aCollection;
		command: aBlock;
		yourself! !

!RONLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
command: aBlock
	
	super command: aBlock.
	self flushCache! !

!RONLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
context
	
	^context! !

!RONLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
context: aContext
	
	context := aContext.
	self flushCache! !

!RONLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:06'!
flushCache
	
	maximumValue := nil! !

!RONLinearNormalizer methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 16:06'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	maximumValue := nil! !

!RONLinearNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/3/2012 00:12'!
maximumValue: anEntity
	"Returns the largest value that the color metric provides"
	
	maximumValue isNil
		ifTrue:
			[maximumValue := (self context roValue: anEntity)
				inject: 1
				into:
					[:maximum :entity | maximum max: (self command roValue: entity)]].
	^maximumValue! !

!RONLinearNormalizer methodsFor: 'private' stamp: 'AlexandreBergel 7/4/2012 00:15'!
minimumValue: anEntity
	"Returns the smallest value that the color metric provides"
	
	minimumValue isNil
		ifTrue:
			[minimumValue := (self context roValue: anEntity)
				inject: 100000000000 
				into:
					[:minimum :entity | minimum min: (self command roValue: entity)]].
	^minimumValue! !

RONLinearNormalizer subclass: #RONumberLinearNormalizer
	instanceVariableNames: 'scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Normalizers'!

!RONumberLinearNormalizer methodsFor: 'initialization' stamp: 'AlexandreBergel 7/2/2012 16:07'!
initialize
	super initialize.
	scale := 1! !

!RONumberLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 00:13'!
roValue: anEntity
	"Normalize value based on maximum value."
	
	| value |
	value := self command roValue: anEntity.
	^ ((value abs / (self maximumValue: anEntity)) asFloat * self scale) asInteger! !

!RONumberLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:07'!
scale
	^ scale! !

!RONumberLinearNormalizer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 16:07'!
scale: anObject
	scale := anObject! !

ROObject subclass: #RONativeExampleUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!RONativeExampleUtility classSide methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:48'!
current
	^self allSubclasses first ! !

!RONativeExampleUtility classSide methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:50'!
getMethodsForClass: aClass
	^self subclassResponsibility ! !

!RONativeExampleUtility classSide methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:51'!
substringsFor: aString
	^self subclassResponsibility ! !

ROObject subclass: #RONativeWidgetFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!RONativeWidgetFactory commentStamp: 'AlexandreBergel 4/23/2012 17:31' prior: 0!
RONativeWidgetFactory is useful to create a ROMorph or ROVWVisual, depending on where the platform is running!

!RONativeWidgetFactory classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/23/2012 17:34'!
current
	^ self subclasses first! !

!RONativeWidgetFactory classSide methodsFor: 'public' stamp: 'AlexandreBergel 5/7/2012 18:38'!
forView: aView
	"Return an instance of ROMorph of ROVWVisual without opening the window. "
	
	self subclassResponsibility! !

!RONativeWidgetFactory classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/26/2012 17:07'!
forView: aView windowSized: aPoint
	"Return an instance of ROMorph of ROVWVisual and open the window. This depends on which platform it is run"
	
	self subclassResponsibility! !

!RONativeWidgetFactory classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/26/2012 17:09'!
menuForAssociations: associations on: element
	"associations is a list of association following: #aSymbol -> [ :model | ... ]
	The block contains in the association is evaluated with the model provided by the element."
	
	self subclassResponsibility! !

!ROObject classSide methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/24/2012 17:52'!
new
	^ self basicNew initialize! !

!ROObject methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/17/2012 20:19'!
initialize! !

ROObject subclass: #ROPlatform
	instanceVariableNames: 'name canvasClass timeOrganizerClass fontOrganizerClass widgetFactory hostVisualElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-PlatformIndependent'!

ROPlatform class
	instanceVariableNames: 'current platforms'!

ROPlatform class
	instanceVariableNames: 'current platforms'!

!ROPlatform classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/25/2012 15:38'!
add: aPlatform
	aPlatform check.
	
	self platforms at: aPlatform name put: aPlatform ! !

!ROPlatform classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/25/2012 15:17'!
current
	^ current! !

!ROPlatform classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/25/2012 15:17'!
names
	^ nil! !

!ROPlatform classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/25/2012 15:36'!
numberOfPlatforms
	^ self  platforms size ! !

!ROPlatform classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/25/2012 15:18'!
platforms
	^ platforms ifNil: [ platforms := Dictionary new ]! !

!ROPlatform classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/25/2012 15:42'!
removeNamed: aName
	self platforms removeKey: aName! !

!ROPlatform classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/25/2012 15:44'!
removeNamed: aName ifAbsent: aBlock
	self platforms removeKey: aName ifAbsent: aBlock! !

!ROPlatform classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/25/2012 15:56'!
setCurrent: aPlatformName
	current := self platforms at: aPlatformName! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:32'!
canvasClass
	^ canvasClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 15:28'!
canvasClass: aClass
	canvasClass := aClass ! !

!ROPlatform methodsFor: 'util' stamp: 'AlexandreBergel 7/25/2012 17:59'!
check
	self assert: [ self name class == 'abc' class ] description: 'A platform name should be a string'.
	self assert: [ self canvasClass superclass ==  ROAbstractCanvas ] description: 'A platform canvas should be a subclass of ROAbstractCanvas'.
	self assert: [ self fontOrganizerClass superclass ==  ROFontOrganizer ] description: 'A platform font organizer should be a subclass of ROFontOrganizerMorphic'.
	self assert: [ self widgetFactory superclass ==  RONativeWidgetFactory  ] description: 'A platform widget organizer should be a subclass of ROFontOrganizerMorphic'.
	self assert: [ self timeOrganizerClass superclass ==  ROTimeOrganizer  ] description: 'A platform time organizer should be a subclass of ROTimeOrganizer'.
	self assert: [ self hostVisualElement notNil ] description: 'You need to provide a host visual element (a Morph or a Visual)'.
! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:50'!
fontOrganizerClass
	^ fontOrganizerClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 16:05'!
fontOrganizerClass: aClass
	^ fontOrganizerClass := aClass! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 17:55'!
hostVisualElement
	^ hostVisualElement! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 17:58'!
hostVisualElement: visualElement
	"Typically a morph (Pharo) or a visual (VW)"
	
	hostVisualElement := visualElement! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:43'!
name
	^ name! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 15:35'!
name: aString
	name := aString! !

!ROPlatform methodsFor: 'util' stamp: 'AlexandreBergel 7/25/2012 15:44'!
remove
	ROPlatform removeNamed: self name ifAbsent: []! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:50'!
timeOrganizerClass
	^ timeOrganizerClass! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 17:10'!
timeOrganizerClass: aClass
	^ timeOrganizerClass := aClass! !

!ROPlatform methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2012 15:52'!
widgetFactory
	^ widgetFactory! !

!ROPlatform methodsFor: 'mutators' stamp: 'AlexandreBergel 7/25/2012 16:05'!
widgetFactory: aClass
	^ widgetFactory := aClass! !

ROObject subclass: #ROSequenceOfInteraction
	instanceVariableNames: 'sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROSequenceOfInteraction methodsFor: 'actions' stamp: 'AlexandreBergel 5/4/2012 09:53'!
after: nbOfMilliseconds do: aBlock
	sequence add: (Array with: nbOfMilliseconds with: aBlock)! !

!ROSequenceOfInteraction methodsFor: 'actions' stamp: 'AlexandreBergel 8/19/2012 10:07'!
execute
	
	[ [ self isComplete ] whileFalse: [ self step ] ] fork! !

!ROSequenceOfInteraction methodsFor: 'initialize-release' stamp: 'AlexandreBergel 5/4/2012 09:41'!
initialize

	super initialize.
	sequence := OrderedCollection new.! !

!ROSequenceOfInteraction methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 8/19/2012 10:07'!
isComplete
	^ self leftToDo = 0! !

!ROSequenceOfInteraction methodsFor: 'accessing' stamp: 'AlexandreBergel 5/4/2012 09:41'!
leftToDo
	^ sequence size! !

!ROSequenceOfInteraction methodsFor: 'actions' stamp: 'AlexandreBergel 8/19/2012 10:07'!
step
	"Execute the first action in the sequence"
	| seq |
	self isComplete ifTrue: [ ^ self ].
	seq := sequence first.
	(Delay forMilliseconds: seq first) wait.
	seq second value.
	sequence removeFirst.! !

!ROSequenceOfInteraction methodsFor: 'actions' stamp: 'AlexandreBergel 8/19/2012 10:07'!
waitUntilDone
	"The caller of this method will wait until all the step have been executed"
	[ self isComplete ] whileFalse: [ (Delay forMilliseconds: 5) wait ]! !

ROObject subclass: #ROShape
	instanceVariableNames: 'color next width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROShape commentStamp: 'AlexandreBergel 10/15/2012 13:21' prior: 0!
A ROShape represents the graphical representation of an element.
Decorator has a color, and they are link together.

All the accessors in Mondrian's builder operates on the model.
However, outside the builder, shapes accepts roassal elements.

For example:
-=-=-=-=-=-=-=-=-=-=-=-=
testIfFillColor

        | nodes |
        view shape rectangle
                if: #odd fillColor: [ :model | model + 1];
                if: #even fillColor: [ :model | model + 10].
        nodes := view nodes: #(2 3 4 5 6).

        self assert: (nodes collect: [ :n | (n getShape: ROBox) colorFor: n]) = #(12 4 14 6 16)
-=-=-=-=-=-=-=-=-=-=-=-=

This piece of code works only in the test since a number is not a color. But it illustrates the point.

Then fillColor: is defined as:
-=-=-=-=-=-=-=-=-=-=-=-=
ROMondrianBuilder>>fillColor: aBlockOrSymbol
        "aBlockOrSymbol expect to be evaluated against the model. It may either be a symbol or a one-arg block"

        shape color: [ :element | aBlockOrSymbol roValue: element model ]
-=-=-=-=-=-=-=-=-=-=-=-=

Something is left ugly, that I cannot easily remove:


-=-=-=-=-=-=-=-=-=-=-=-=
ROMondrianBuilder>>if: conditionBlock fillColor: colorBlock
        "If conditionBlock is evaluated at true, then colorBlock is used to set the color of the node. Both conditionBlock and colorBlock are evaluated with the model value of the node."

        | oldBlockOrValue |
        oldBlockOrValue := self fillColor ifNil: [ self defaultFillColor ].
        ^self fillColor: [ :aModel | (conditionBlock roValue: aModel)
                                                                        ifTrue: [ colorBlock roValue: aModel ]
                                                                        ifFalse: [
                                                                                "Having to create a new element is rather ugly.
                                                                                Ideally, the oldBlockOrValue has to be 'unwrapped' for the translation"
                                                                                oldBlockOrValue roValue: (ROElement on: aModel) ]].
-=-=-=-=-=-=-=-=-=-=-=-=

Instance Variables
	color:		<Object>
	colorCache:		<Object>
	next:		<Object>

color
	- xxxxx

colorCache
	- xxxxx

next
	- xxxxx
!

ROShape subclass: #ROAbstractChildrenShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractChildrenShape methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 12:32'!
drawChildrenOn: aCanvas for: aROElement
	aROElement view camera 
		translateBy: aROElement topLeft negated 
		during: [ aROElement elements do: [ :n | n drawOn: aCanvas ] ]! !

!ROAbstractChildrenShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/28/2012 11:15'!
element: aROElement containsPoint: aPoint
	
	^ aROElement bounds containsPoint: aPoint
! !

!ROAbstractChildrenShape methodsFor: 'looking up elements' stamp: 'AlexandreBergel 9/25/2012 15:59'!
subElementsAt: aPoint forElement: aROElement
	"Return one of the direct children element of aROElement pointed by aPoint. Return null if none"
	"Note that we are here interested only in direct children. The recursion is done later on"

	aROElement elementsDo: [ :childrenElement | 
		(self boundsFor: childrenElement containsPoint: (aPoint - childrenElement position))
			ifTrue: [ ^ childrenElement ] ].

	"None have been found!!"
	^ nil! !

ROAbstractChildrenShape subclass: #ROChildrenShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROChildrenShape commentStamp: '<historical>' prior: 0!
A ROChildrenShape is used to paint the children of a particular node.

This shape is the terminal of the shape chain.!

!ROChildrenShape methodsFor: 'rendering' stamp: 'AlexandreBergel 7/23/2012 15:27'!
drawOn: aCanvas for: aROElement
	self drawChildrenOn: aCanvas for: aROElement! !

ROAbstractChildrenShape subclass: #ROLevelledChildrenShape
	instanceVariableNames: 'altitudeThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROLevelledChildrenShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/23/2012 15:58'!
altitudeThreshold: aNumber
	altitudeThreshold := aNumber! !

!ROLevelledChildrenShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/23/2012 16:04'!
drawOn: aCanvas for: aROElement
	(self shouldDisplayChildrenFor: aROElement)
		ifTrue: [ self drawChildrenOn: aCanvas for: aROElement ]! !

!ROLevelledChildrenShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/23/2012 15:58'!
initialize
	super initialize.
	altitudeThreshold := 300.! !

!ROLevelledChildrenShape methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/23/2012 16:04'!
shouldDisplayChildrenFor: aROElement
	^ aROElement view camera height < altitudeThreshold
		! !

ROShape subclass: #ROAbstractLabel
	instanceVariableNames: 'text textVerticalPadding textHorizontalPadding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:05'!
drawOn: aCanvas for: aROElement
	self subclassResponsibility ! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'AlexandreBergel 9/20/2012 12:03'!
extentFor: element
	^ (super extentFor: element) max: (self preferedExtentFor: element)! !

!ROAbstractLabel methodsFor: 'todo' stamp: 'AlexandreBergel 9/20/2012 12:04'!
fontSize: aBlockOrASymbolOrAnObject! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:04'!
heightFor: aROElement
	"Return the height for the element"
	
	^ self heightOfString: (self textFor: aROElement).
	! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:04'!
heightOfString: string
	"Return the height of a string"
	
	| lineCount height |
	lineCount := string lineCount.
	height := ROPlatform current fontOrganizerClass height.
	^ (( height asInteger + self interlineSpace) * lineCount) + (2 * textVerticalPadding) ! !

!ROAbstractLabel methodsFor: 'initialize' stamp: 'AlexandreBergel 9/20/2012 12:04'!
initialize 
	super initialize.
	text := #model.
	textHorizontalPadding := textVerticalPadding := 0 ! !

!ROAbstractLabel methodsFor: 'initialize' stamp: 'AlexandreBergel 9/20/2012 12:04'!
interlineSpace
	"Space between lines in a multi-line text"

	^ 3! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:04'!
linesOf: aString
	"Return a collection of strings got from aString."
	
	| ans runner |
	ans := OrderedCollection new.
	runner := ''.
	aString do: [ :c |
		c = Character cr
			ifTrue: [ ans add: runner. runner := '' ]
			ifFalse: [ runner := runner, (String with: c) ].
	].
	runner isEmpty ifFalse: [ ans add: runner ].
	^ ans asArray! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:04'!
longestTextLineFor: aROElement
	"Return the longest line for the textFor: of the element. This is use to compute the right width of the label"
	
	| lines |
	lines := self linesOf: (self textAdaptedFor: aROElement).
	lines size = 0 ifTrue: [ ^ '' ].
	^ lines inject: lines first into: [ :longest :line | 
		line size > longest size 
			ifTrue: [ line ] ifFalse: [ longest ] ]! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'AlexandreBergel 9/20/2012 12:04'!
preferedExtentFor: aROElement
	^ (self widthFor: aROElement) @ (self heightFor: aROElement)! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'AlexandreBergel 9/20/2012 12:05'!
text
	^ text! !

!ROAbstractLabel methodsFor: 'accessing' stamp: 'AlexandreBergel 9/20/2012 12:05'!
text: anObject
	text := anObject! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 10/15/2012 20:16'!
textAdaptedFor: anElement
	"Return the text from anElement. All the tabulation are replaced"
	
	^ (self textFor: anElement) copyReplaceAll: '	' with: '      '! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:05'!
textFor: aROElement
	 | v |
	v := (text roValue: aROElement).
	^ (v class == 'abc' class)
			ifTrue: [ v ]
			ifFalse: [ v printString ]
! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:05'!
widthFor: aROElement
	"Return the width for the element"
	
	^ self widthOfString: (self longestTextLineFor: aROElement).
	! !

!ROAbstractLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 9/20/2012 12:05'!
widthOfString: string
	"Return the length of a string"
	
	^ROPlatform current fontOrganizerClass widthOfString: string! !

ROAbstractLabel subclass: #ROCenteredLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROCenteredLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 10/18/2012 09:31'!
drawOn: aCanvas for: aROElement
	| h str runner |
	h := self heightFor: aROElement.
	str := self textAdaptedFor: aROElement.
	runner := 
		aROElement center + 
		ROPlatform current fontOrganizerClass offsetWhenDrawing - ((0 @ h) / 2).
	
	str linesDo: [ :line | 
		| lineOffset |
		lineOffset := ( (self widthOfString: line) / 2 ) @ 0.
		aCanvas drawString: line at: (runner - lineOffset) color: (self colorFor: aROElement ).
		runner := runner + (0 @ (self heightOfString: line))
	]! !

ROAbstractLabel subclass: #ROLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROLabel classSide methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/5/2012 20:22'!
defaultColor
	^ Color black! !

!ROLabel classSide methodsFor: 'public' stamp: ''!
text: aBlock
	^ self new text: aBlock! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 8/5/2012 11:44'!
drawOn: aCanvas for: aROElement
	| str runner |
	str := self textAdaptedFor: aROElement.

	runner := aROElement topLeft + ROPlatform current fontOrganizerClass offsetWhenDrawing.
	str linesDo: [ :line |
		aCanvas drawString: line at: runner color: (self colorFor: aROElement ).
		runner := runner + (0 @ (self heightOfString: line))
	]! !

ROShape subclass: #ROAbstractLine
	instanceVariableNames: 'attachPoint arrows strokeWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
add: aROArrow 
	arrows add: aROArrow! !

!ROAbstractLine methodsFor: 'arrowing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
add: aROArrow offset: aNumber 
	aROArrow offset: aNumber.
	self add: aROArrow! !

!ROAbstractLine methodsFor: 'arrowing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
addBegining: aROArrow 
	self add: aROArrow offset: 0! !

!ROAbstractLine methodsFor: 'accessing' stamp: ''!
attachPoint
	
	^ attachPoint! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 05:56'!
attachPoint: attach
	
	attachPoint := attach! !

!ROAbstractLine methodsFor: 'testing' stamp: 'AlexandreBergel 9/25/2012 18:26'!
contains: aPoint for: anEdge
	"Return true if aPoint is contained in at least one of the line segments"

	| segments index nodeRelativePoint | 
	segments := self lineSegmentsFor: anEdge.
	nodeRelativePoint := aPoint + segments first.
	index := segments first.
	segments allButFirst do: [ :p |
		(nodeRelativePoint onLineFrom: index to: p within: 2) 
			ifTrue: [ ^ true].
		index := p.
	 ].	
	^ false! !

!ROAbstractLine methodsFor: 'hooks' stamp: 'AlexandreBergel 9/4/2012 12:53'!
defaultShape 
	^ RONullShape new! !

!ROAbstractLine methodsFor: 'initialize' stamp: 'TudorGirba 7/29/2012 21:58'!
defaultWidth
	^ 1! !

!ROAbstractLine methodsFor: 'computing attach point' stamp: 'AlexandreBergel 5/31/2012 14:46'!
endingPointOf: anEdge
	^ attachPoint endingPointOf: anEdge! !

!ROAbstractLine methodsFor: 'testing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
hasArrow
	"True if some arrows have been added"
	
	^ arrows isNil or: [ arrows notEmpty ]! !

!ROAbstractLine methodsFor: 'initialize' stamp: 'AlexandreBergel 10/17/2012 08:40'!
initialize
	super initialize.
	attachPoint := ROShorterDistanceAttachPoint instance.
	strokeWidth := self defaultWidth.
	arrows := OrderedCollection new! !

!ROAbstractLine methodsFor: 'hooks' stamp: 'AlexandreBergel 8/19/2012 12:27'!
installedOn: element
	"This method is meant to be overriden in case a special treatment has to be realized on the element"
	
! !

!ROAbstractLine methodsFor: 'hooks' stamp: 'AlexandreBergel 8/23/2012 22:41'!
lineSegmentsFor: anEdge
	self subclassResponsibility ! !

!ROAbstractLine methodsFor: 'arrowing' stamp: 'AlexandreBergel 9/28/2012 09:47'!
numberOfArrows
	"Answer the number of arrows the edge contains"
	
	^ arrows size ! !

!ROAbstractLine methodsFor: 'computing attach point' stamp: 'AlexandreBergel 5/31/2012 14:46'!
startingPointOf: anEdge
	^ attachPoint startingPointOf: anEdge! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:40'!
width
	^ strokeWidth! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:40'!
width: aNumber
	strokeWidth := aNumber! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 10/14/2012 19:09'!
widthFor: anEdge
	^ self width roValue: anEdge! !

ROAbstractLine subclass: #ROLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROLine methodsFor: 'rendering' stamp: 'AlexandreBergel 8/20/2012 11:08'!
drawOn: aCanvas for: anEdge 
	| maxArrowSize unit startingPoint endingPoint rawStartingPoint rawEndingPoint |		
			
	rawEndingPoint  := attachPoint startingPointOf: anEdge.
	rawStartingPoint := attachPoint endingPointOf: anEdge.
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		aCanvas 
			line: rawStartingPoint 
			to: arr first 
			width: (self widthFor: anEdge) 
			color: (self colorFor: anEdge).
		rawStartingPoint := arr second.
		 ].
	
	"We draw a line after the arrow"
	aCanvas line: rawStartingPoint to: rawEndingPoint width: (self widthFor: anEdge) color: (self colorFor: anEdge).
! !

!ROLine methodsFor: 'utility' stamp: 'AlexandreBergel 8/19/2012 21:01'!
lineSegmentsFor: anEdge
	| rawStartingPoint rawEndingPoint |
	rawStartingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPoint := attachPoint endingPointOf: anEdge.

	^ Array with: rawStartingPoint with: rawEndingPoint! !

!ROLine methodsFor: 'enumerating' stamp: 'AlexandreBergel 8/20/2012 10:42'!
lineSegmentsFor: anEdge do: aTwoArgBlock

	| segments p |
	segments := self lineSegmentsFor: anEdge.
	p := segments first.
	segments allButFirst do: [ :point| 
		aTwoArgBlock value: p value: point.
		p := point
	]! !

!ROLine methodsFor: 'utility' stamp: 'AlexandreBergel 6/12/2012 15:24'!
unitFor: anEdge

	| vector toPoint fromPoint u unit |
	fromPoint := self startingPointOf: anEdge.
	toPoint := self endingPointOf: anEdge.

	vector := toPoint - fromPoint.
	u := vector normal.
	unit := vector / vector r.
	^ unit! !

ROAbstractLine subclass: #ROOrthoHorizontalLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROOrthoHorizontalLineShape methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 08:40'!
drawOn: aCanvas for: anEdge 
	| maxArrowSize unit startingPoint endingPoint rawStartingPoint rawEndingPoint edgeBound midx w c rawEndingPointOriginal rawStartingPointOriginal |		
			
	rawEndingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPointOriginal := rawEndingPoint.
	
	rawStartingPoint := attachPoint endingPointOf: anEdge.
	rawStartingPointOriginal := rawStartingPoint.
	
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		"aCanvas line: rawStartingPoint to: arr first width: (width roValue: anEdge) color: color."
		(arrow offset = 0) 
			ifTrue: [ rawStartingPoint := arr second ] 
			ifFalse: [ rawEndingPoint := arr first ].
		 ].
	"-------- "

	edgeBound := rawStartingPointOriginal corner: rawEndingPointOriginal.
	
	midx := ((edgeBound corner x - edgeBound origin x) / 2) asInteger + edgeBound origin x.
	w := strokeWidth roValue: anEdge.
	c := color.

	aCanvas line: rawStartingPoint to: (midx @ edgeBound origin y) width: w color: c.
	aCanvas line: (midx @ edgeBound origin y) to: (midx @ edgeBound corner y) width: w color: c.
	aCanvas line: (midx @ edgeBound corner y) to: rawEndingPoint width: w color: c.! !

!ROOrthoHorizontalLineShape methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 19:06'!
lineSegmentsFor: anEdge 		
	| rawEndingPoint rawStartingPoint edgeBound midx |
	rawStartingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPoint := attachPoint endingPointOf: anEdge.
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ #() ].
	
	edgeBound := rawStartingPoint corner: rawEndingPoint.
	
	midx := ((edgeBound corner x - edgeBound origin x) / 2) asInteger + edgeBound origin x.

	^ Array 
		with: rawStartingPoint 
		with: (midx @ edgeBound origin y) 
		with: (midx @ edgeBound corner y) 
		with: rawEndingPoint ! !

ROAbstractLine subclass: #ROOrthoVerticalLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROOrthoVerticalLineShape methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 08:40'!
drawOn: aCanvas for: anEdge 
	| maxArrowSize unit startingPoint endingPoint rawStartingPoint rawEndingPoint edgeBound midy w c rawEndingPointOriginal rawStartingPointOriginal |		
			
	rawEndingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPointOriginal := rawEndingPoint.
	
	rawStartingPoint := attachPoint endingPointOf: anEdge.
	rawStartingPointOriginal := rawStartingPoint.
	
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ self ].
	
	"We draw a line before each arrow"
	arrows do: [ :arrow | 
		| arr |
		arr := arrow drawOn: aCanvas for: anEdge line: self.
		"aCanvas line: rawStartingPoint to: arr first width: (width roValue: anEdge) color: color."
		(arrow offset = 0) 
			ifTrue: [ rawStartingPoint := arr second ] 
			ifFalse: [ rawEndingPoint := arr first ].
		 ].
	
	"We draw a line after the arrow"
"	aCanvas line: rawStartingPoint  to:  rawEndingPoint width: (width roValue: anEdge) color: (color roValue: anEdge).
"	"-------- "

	edgeBound := rawStartingPointOriginal corner: rawEndingPointOriginal.
	
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.
	w := strokeWidth roValue: anEdge.
	c := color.

	aCanvas line: rawStartingPoint to: (edgeBound origin x @ midy) width: w color: c.
	aCanvas line: (edgeBound origin x @ midy) to: (edgeBound corner x @ midy) width: w color: c.
	aCanvas line: (edgeBound corner x @ midy) to: rawEndingPoint width: w color: c.! !

!ROOrthoVerticalLineShape methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 19:14'!
lineSegmentsFor: anEdge 		
	| rawEndingPoint rawStartingPoint edgeBound midy |
	rawStartingPoint  := attachPoint startingPointOf: anEdge.
	rawEndingPoint := attachPoint endingPointOf: anEdge.
	(rawStartingPoint = rawEndingPoint)
		ifTrue: [ ^ #() ].
	
	edgeBound := rawStartingPoint corner: rawEndingPoint.
	
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.

	^ Array 
		with: rawStartingPoint 
		with: (edgeBound origin x @ midy) 
		with: (edgeBound corner x @ midy) 
		with: rawEndingPoint ! !

ROShape subclass: #ROBorder
	instanceVariableNames: 'strokeWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROBorder commentStamp: '<historical>' prior: 0!
A ROBorder defines a border to be added to an element.

Instance Variables
	width:		Number

width
	- Width of the border!

!ROBorder classSide methodsFor: 'public' stamp: ''!
defaultColor
	^ Color black! !

!ROBorder methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 08:41'!
drawOn: aCanvas for: aROElement
	| b c |
	b := aROElement bounds.
	c := color roValue: aROElement model.
	aCanvas 
		line: b topLeft to: b topRight width: strokeWidth color: c.
	aCanvas 
		line: b topRight to: b bottomRight width: strokeWidth color: c.
	aCanvas 
		line: b bottomRight to: b bottomLeft width: strokeWidth color: c.
	aCanvas 
		line: b topLeft to: b bottomLeft width: strokeWidth color: c.
! !

!ROBorder methodsFor: 'initialization' stamp: 'AlexandreBergel 10/17/2012 08:41'!
initialize 
	super initialize.
	strokeWidth := 1.
	color := self class defaultColor! !

ROShape subclass: #ROBox
	instanceVariableNames: 'borderColorCache borderColor borderWidthCache borderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROBox commentStamp: '<historical>' prior: 0!
A ROBox draws a box

Instance Variables
	borderColor:		<Color | BlockContext | Normalizer>
	borderColorCache:		<Color>
	borderWidth:		<Number | Block>
	borderWidthCache:		<Number>

borderColor
	- could be a block, a color or a normalizer. Used to determine the color of the element being painted
	
borderColorCache
	- used as a cache

borderWidth
	- a block or a number that represent the border width.

borderWidthCache
	- cache of the width
!

!ROBox classSide methodsFor: 'defaults' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROBox methodsFor: 'rendering' stamp: ''!
borderColor
	^ borderColor! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 12:16'!
borderColor: aBlockOrSymbolOrObject
	borderColor := aBlockOrSymbolOrObject.
	! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 12:16'!
borderColorFor: element
	^ borderColor roValue: element! !

!ROBox methodsFor: 'rendering' stamp: ''!
borderWidth
	^ borderWidth! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 12:16'!
borderWidth: aBlockOrSymbolOrObject
	borderWidth := aBlockOrSymbolOrObject.! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 12:16'!
borderWidthFor: element
	^ borderWidth roValue: element! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 9/27/2012 17:52'!
drawOn: aCanvas for: aROElement

	aCanvas 
		frameAndFillRectangle: ((self boundsFor: aROElement) translateBy: aROElement position)
		fillColor: (self colorFor: aROElement) 
		borderWidth: (self borderWidthFor: aROElement) 
		borderColor: (self borderColorFor: aROElement)! !

!ROBox methodsFor: 'initialize' stamp: ''!
initialize 
	super initialize.
	borderColor := Color black.
	borderWidth := 0.! !

ROShape subclass: #ROCircle
	instanceVariableNames: 'borderColor borderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROCircle commentStamp: '<historical>' prior: 0!
A ROCircle draws a circle!

!ROCircle classSide methodsFor: 'public' stamp: ''!
color: aColor
	^ self new color: aColor! !

!ROCircle classSide methodsFor: 'defaults' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROCircle methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 11:55'!
borderColor
	^ borderColor ! !

!ROCircle methodsFor: 'rendering' stamp: 'AlexandreBergel 10/15/2012 13:12'!
borderColor: aBlockOrSymbolOrObject
	borderColor := aBlockOrSymbolOrObject.! !

!ROCircle methodsFor: 'rendering' stamp: 'BenComan 9/16/2012 20:38'!
borderOnly
		self borderWidth: 1. 
		self borderColor: Color black.
		self color: Color transparent.
		! !

!ROCircle methodsFor: 'rendering' stamp: 'BenComan 9/3/2012 02:08'!
borderWidth
	^borderWidth 
! !

!ROCircle methodsFor: 'rendering' stamp: 'BenComan 9/3/2012 02:06'!
borderWidth: anInteger
	borderWidth := anInteger. 
! !

!ROCircle methodsFor: 'rendering' stamp: 'AlexandreBergel 10/20/2012 21:19'!
drawOn: aCanvas for: aROElement
	aCanvas
		fillOval: aROElement bounds 
		color: (color roValue: aROElement) 
		borderWidth: (borderWidth roValue: aROElement) 
		borderColor: (borderColor roValue: aROElement)! !

!ROCircle methodsFor: 'rendering' stamp: 'AlexandreBergel 10/17/2012 08:46'!
extent: anExtentPoint
	| max | 
	max := anExtentPoint x max: anExtentPoint y.
	width := max.
	height := max.
	next extent: anExtentPoint! !

!ROCircle methodsFor: 'rendering' stamp: 'BenComan 9/3/2012 02:05'!
initialize
		super initialize.
		borderWidth := 0. 
		borderColor := Color black.! !

ROShape subclass: #ROImage
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROImage methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement
	aCanvas
		paintImage: (form roValue: aROElement) at: aROElement topLeft
! !

!ROImage methodsFor: 'accessing' stamp: ''!
form
	^ form! !

!ROImage methodsFor: 'accessing' stamp: ''!
form: aFormBlockOrObject
	form := aFormBlockOrObject! !

!ROImage methodsFor: 'hooks' stamp: ''!
installedOn: element
	"This method is meant to be overriden in case a special treatment has to be realized on the element"
	
	| p | 
	super installedOn: element.
	p := (form roValue: element) extent.
	element extent < p
		ifTrue: [ element extent: p ].
	! !

!ROImage methodsFor: 'accessing' stamp: 'AlexandreBergel 5/29/2012 10:22'!
preferedExtentFor: element
	^ (form roValue: element) extent! !

ROShape subclass: #RONullShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!RONullShape commentStamp: '<historical>' prior: 0!
A RONullShape is the terminator of the shape chain. A new element will have an instance of null shape in it.!

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:02'!
addLast: aShape
	^ aShape! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:03'!
addLast: aShape in: elementToAdd

	elementToAdd next: aShape! !

!RONullShape methodsFor: 'rendering' stamp: 'AlexandreBergel 9/14/2012 19:03'!
chainedDrawOn: aCanvas for: aROElement 
	self drawOn: aCanvas for: aROElement ! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/22/2012 08:45'!
change: aShapeClass for: aShape
	^ self ! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 8/20/2012 10:03'!
contains: aPoint for: aROEdge 
	^ false! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 9/4/2012 12:50'!
defaultShape 
	^ RONullShape new! !

!RONullShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/24/2012 18:53'!
element: aROElement containsPoint: aPoint
	"Return true if aPoint is contained in the bounds defined by myself for the element"
	
	^ self boundsFor: aROElement containsPoint: aPoint
		! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 10/17/2012 08:45'!
extent: anExtentPoint
	width := anExtentPoint x.
	height := anExtentPoint y.! !

!RONullShape methodsFor: 'hooks' stamp: 'AlexandreBergel 10/17/2012 08:45'!
extentFor: element
	^ (width roValue: element) @ (height roValue: element)! !

!RONullShape methodsFor: 'util' stamp: 'AlexandreBergel 8/19/2012 13:06'!
hasNext
	^ false! !

!RONullShape methodsFor: 'initialize' stamp: 'AlexandreBergel 10/17/2012 08:46'!
initialize
	color := self class defaultColor.
	self extent: self defaultExtent.
! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:09'!
isShapedAs: aShapeClass
	^ false! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/22/2012 08:23'!
removeShape: aShapeClass
	^ self ! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 8/20/2012 08:55'!
removeShape: aShapeClass previousShape: aShape
	^ self ! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 9/24/2012 11:46'!
shapeDetect: aBlock
	(aBlock value: self) ifTrue: [ ^ self ].
	self error: 'Not found'! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 7/23/2012 14:53'!
shapesDetect: aBlock
	self error: 'Not found'! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 9/24/2012 11:55'!
shapesDo: aBlock
	aBlock value: self! !

!RONullShape methodsFor: 'looking up elements' stamp: 'AlexandreBergel 9/25/2012 09:59'!
subElementsAt: aPoint forElement: aROElement
	"Return one of the direct children element of aROElement pointed by aPoint. Return null if none"

	^ nil! !

!ROShape classSide methodsFor: 'public' stamp: 'AlexandreBergel 6/4/2012 00:53'!
blue
	^ self new color: Color blue! !

!ROShape classSide methodsFor: 'public' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROShape classSide methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 19:00'!
element
	^ self elementOn: nil! !

!ROShape classSide methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 18:58'!
elementOn: object
	"Easy way to create element from a shape"
	
	^ (ROElement on: object) + self! !

!ROShape classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:12'!
gray
	^ self new color: Color gray! !

!ROShape classSide methodsFor: 'public' stamp: ''!
green
	^ self new color: Color green! !

!ROShape classSide methodsFor: 'public' stamp: ''!
installedOn: element
	^ self new installedOn: element; yourself! !

!ROShape classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/24/2012 12:12'!
lightGray
	^ self new color: Color lightGray! !

!ROShape classSide methodsFor: 'public' stamp: ''!
red
	^ self new color: Color red! !

!ROShape classSide methodsFor: 'public' stamp: ''!
white
	^ self new color: Color white! !

!ROShape classSide methodsFor: 'public' stamp: ''!
yellow
	^ self new color: Color yellow! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 8/19/2012 11:25'!
addLast: aShape
	"Instance variable 'next' must be a RONullShape to provide the exit condition of this recursive call.  This is ensured by instance initialization. The Null Object design pattern is here applied"

	self addLast: aShape in: self! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 11:43'!
addLast: aShape in: elementToAdd
	next addLast: aShape in: self! !

!ROShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/28/2012 08:21'!
boundsFor: aROElement
	^ 0 @ 0 extent: aROElement extent! !

!ROShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/25/2012 09:49'!
boundsFor: aROElement containsPoint: aPoint
	"Return true if aPoint is contained in one of the chain of shape"
	
	^ (self boundsFor: aROElement) containsPoint: aPoint! !

!ROShape methodsFor: 'rendering' stamp: 'AlexandreBergel 9/14/2012 19:08'!
chainedDrawOn: aCanvas for: aROElement 
	self drawOn: aCanvas for: aROElement.
	next chainedDrawOn: aCanvas for: aROElement! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 9/27/2012 17:05'!
change: aShapeClass for: aShape
	"Replace a shape per another shape"

	^ (self isKindOf: aShapeClass) 
		ifTrue: [ aShape next: self next; yourself ]
		ifFalse: [ self next: (self next change: aShapeClass for: aShape) ]! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 9/27/2012 17:05'!
color
	"Color associated to the shape"
	
	^ color! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 12:19'!
color: anObject
	"Set a color. For practical reason, the color is cached and the cache needs to be reset"
	
	color := anObject.
! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 12:19'!
colorFor: element
	"Compute the color of the element"
	^ color roValue: element! !

!ROShape methodsFor: 'initialize' stamp: 'AlexandreBergel 9/4/2012 12:18'!
defaultExtent
	"Each shape has a minimum size of 5@5"

	^ 5 @ 5! !

!ROShape methodsFor: 'hooks' stamp: 'AlexandreBergel 9/25/2012 20:21'!
defaultShape 
	^ RONullShape new! !

!ROShape methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement 
	! !

!ROShape methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 19:00'!
element
	"Easy way to create element from a shape"

	^ self elementOn: nil! !

!ROShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/24/2012 18:53'!
element: aROElement containsPoint: aPoint
	"Return true if aPoint is contained in the bounds defined by myself for the element"

	^ (self boundsFor: aROElement containsPoint: aPoint)
		ifTrue: [ true ]
		ifFalse: [ next element: aROElement containsPoint: aPoint ]! !

!ROShape methodsFor: 'looking up elements' stamp: 'AlexandreBergel 9/27/2012 17:25'!
elementAt: aPoint forElement: aROElement
	"Return the element pointed by aPoint for a given element.
	 The coordinate aPoint is local to the element aROElement. This means that aPoint = 0@0 refers to the topLeft of aROElement"

	"If the point does not refer to myself, then we simply return the view"
	| subElement |
	 
	(((0 @ 0) corner: (self extentFor: aROElement)) containsPoint: aPoint)
		ifFalse: [ ^ aROElement view ].
		
	"The point refers to myself. We now have to check whether a subelement is pointed"
	subElement := self subElementsAt: aPoint forElement: aROElement.
	^ subElement notNil
		ifTrue: [ subElement elementAt: (aPoint - subElement position)  ]
		ifFalse: [ aROElement ]
	! !

!ROShape methodsFor: 'public' stamp: 'AlexandreBergel 6/9/2012 19:00'!
elementOn: object
	"Easy way to create element from a shape"
	
	^ (ROElement on: object) + self! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:43'!
extent
	"Return the extent of the shape. Note that the width and height may be block and not immediate value.
	  Use extentFor: to get immediate value"
	^ width @ height! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:42'!
extent: anExtentPoint

	width := anExtentPoint x.
	height := anExtentPoint y.
	next extent: anExtentPoint! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:47'!
extentFor: element
	"Return the extent of element"
	
	^ ((width roValue: element) @ (height roValue: element)) max: (next extentFor: element)! !

!ROShape methodsFor: 'testing' stamp: 'AlexandreBergel 8/19/2012 13:05'!
hasNext
	^ true! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:58'!
height
	^ height! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:58'!
height: anObject
	height := anObject! !

!ROShape methodsFor: 'initialize' stamp: 'AlexandreBergel 10/17/2012 08:44'!
initialize 
	super initialize.
	color := self class defaultColor.
	next := self defaultShape.
	
	self extent: self defaultExtent.
! !

!ROShape methodsFor: 'hooks' stamp: 'AlexandreBergel 10/17/2012 09:42'!
installedOn: element
	"This method is meant to be overriden in case a special treatment has to be realized on the element"
	
	"self extent: (self preferedExtentFor: element)."
	"element extent: (element extent max: extent)."
	! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:09'!
isShapedAs: aShapeClass
	^ (self isKindOf: aShapeClass) or: [ self next isShapedAs: aShapeClass ]! !

!ROShape methodsFor: 'accessing' stamp: ''!
next
	^ next! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 5/7/2012 11:52'!
next: aShape
	next := aShape! !

!ROShape methodsFor: 'hooks' stamp: 'AlexandreBergel 9/28/2012 11:15'!
preferedExtentFor: element
	"Override this method is you want the element to have a particular shape"

	^ self extentFor: element! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 8/20/2012 08:55'!
removeShape: aShapeClass
	"Remove a shape of the element"

	^ (self isKindOf: aShapeClass)
		ifTrue: [ next ]
		ifFalse: [ next removeShape: aShapeClass previousShape: self ]
! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 8/20/2012 08:56'!
removeShape: aShapeClass previousShape: aShape
	"Remove a shape of the element. Return the element that has been removed"

	^ (self isKindOf: aShapeClass)
		ifTrue: [ aShape next: next. self ]
		ifFalse: [ next removeShape: aShapeClass previousShape: next next ]! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 11:44'!
shapeDetect: aBlock

	(aBlock value: self) ifTrue: [ ^ self ].
	^ self next shapeDetect: aBlock! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 9/24/2012 11:55'!
shapesDo: aBlock

	aBlock value: self.
	^ self next shapesDo: aBlock! !

!ROShape methodsFor: 'looking up elements' stamp: 'AlexandreBergel 9/25/2012 10:03'!
subElementsAt: aPoint forElement: aROElement
	"Return one of the direct children element of aROElement pointed by aPoint. Return null if none"
	"Note that we are here interested only in direct children. The recursion is done later on"

	"For a shape that is not an abstractchildren one, there is nothing to do."
	^ next subElementsAt: aPoint forElement: aROElement! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:59'!
width
	^ width! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 10/17/2012 08:59'!
width: anObject
	width := anObject! !

ROShape subclass: #ROViewDisplayer
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROViewDisplayer commentStamp: 'AlexandreBergel 8/2/2012 18:07' prior: 0!
ROViewDisplayer is a shape that is used to display a view. It simply wraps a view into a shape.

Instance Variables:
	view	<ROView>!

!ROViewDisplayer methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 09:56'!
drawOn: aCanvas for: aROElement
	| previousOffset |
	previousOffset := aCanvas offset.
	aCanvas offset: (aROElement position).
	view drawElementsOn: aCanvas.
	aCanvas offset: previousOffset! !

!ROViewDisplayer methodsFor: 'accessing' stamp: 'AlexandreBergel 7/27/2012 15:11'!
view: aView
	"Take a roassal view as argument"
	
	view := aView! !

ROObject subclass: #ROTimeOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!ROTimeOrganizer commentStamp: '<historical>' prior: 0!
Abstract class for the time passing.!

!ROTimeOrganizer classSide methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:42'!
current
	^ self subclasses first! !

!ROTimeOrganizer classSide methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:44'!
milliseconds
	"Return the elapsed amount of milliseconds"
	
	self subclassResponsibility ! !

!ROTimeOrganizer classSide methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:42'!
now
	^ Time now! !

ROObject subclass: #ROView
	instanceVariableNames: 'camera eventHandler elements title backgroundColor'
	classVariableNames: 'NullView'
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROView classSide methodsFor: 'configuration' stamp: ''!
defaultWindowTitle
	^ 'Roassal visualization'! !

!ROView classSide methodsFor: 'accessing' stamp: 'AlexandreBergel 9/10/2012 09:20'!
nullView
	"Used when creating new element. For example, we have the relation:
	  ROElement new view == ROView nullView"
	
	^ NullView ifNil: [ NullView := self new ].! !

!ROView classSide methodsFor: 'public' stamp: ''!
titled: aTitle
	"Create an instance of the view and set a title to it"

	^ self new 
		title: aTitle; 
		yourself! !

!ROView methodsFor: 'interaction' stamp: ''!
@ anInteractionClassOrInstance

	anInteractionClassOrInstance initializeElement: self ! !

!ROView methodsFor: 'accessing' stamp: ''!
absolutePosition
	^ 0 @ 0! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 9/10/2012 09:14'!
add: element 
	"Add an element in the view. Do nothing if the element is already in"
	(element view ~~ ROView nullView) ifTrue: [ ^ self ].
	
	elements add: element.
	element parent: self.
	element view: self! !

!ROView methodsFor: 'accessing' stamp: ''!
addAll: els 
	self assert: [ els isKindOf: Collection ].
	els do: [:n | self add: n ]! !

!ROView methodsFor: 'accessing' stamp: ''!
addAllNoContaining:  els
	"Used for  polymorphism with the containing elements. This really ugly. This cannot be left like this."
	^ self addAll: els! !

!ROView methodsFor: 'accessing' stamp: ''!
addFirst: element 
	elements addFirst: element.
	element view: self! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 00:42'!
adjustSizeIfNecessary
	"do nothing"! !

!ROView methodsFor: 'enumerating' stamp: 'TudorGirba 9/9/2012 21:44'!
allElementsDo: aBlock
	self elements do: [ :each | each withAllElementsDo: aBlock ]! !

!ROView methodsFor: 'events' stamp: ''!
announce: event
	eventHandler announce: event! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 20:58'!
backgroundColor
	^ backgroundColor ! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 20:58'!
backgroundColor: aColor
	
	backgroundColor := aColor! !

!ROView methodsFor: 'camera' stamp: ''!
camera
	^ camera! !

!ROView methodsFor: 'camera' stamp: ''!
cameraTranslateBy: point
	camera translateBy: point.
	self signalUpdate! !

!ROView methodsFor: 'camera' stamp: ''!
cameraTranslateByRealStep: aStep
	camera translateByRealStep: aStep.
	self signalUpdate! !

!ROView methodsFor: 'camera' stamp: 'AlexandreBergel 6/5/2012 00:29'!
cameraTranslateTo: point
	camera translateTo: point.
	self signalUpdate! !

!ROView methodsFor: 'rendering' stamp: ''!
canvasForRealSize: realSize
	^ camera extent: realSize; realExtent: realSize; canvas! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 7/24/2012 15:22'!
collectPathToRootIn: aCollection
	"Return the path from this graph to the root graph"

	aCollection addLast: self.! !

!ROView methodsFor: 'opening' stamp: ''!
defaultWindowSize
	^ 500 @ 500! !

!ROView methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 09:56'!
drawElementsOn: canvas
	canvas camera: self camera.
	elements do: [ :n | n drawOn: canvas ]! !

!ROView methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 09:56'!
drawOn: canvas
	canvas paintBackground: backgroundColor.
	self drawElementsOn: canvas
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementAt: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	^ self localElementAt: aPoint
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementAtRealPosition: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	^ self elementAt: (self camera realToVirtualPoint: aPoint)
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementDetect: aBlock
	^ elements copy detect: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 4/14/2012 10:36'!
elementFromModel: object
	| v |
	elements do: [: e |
		v := e elementFromModel: object.
		v ifNotNil: [ ^ v ] ].
	^ nil
	
	"^ (self elementsSuchThat: [ :el | objects includes: el model ]) first"! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/28/2012 13:58'!
elements
	"We return a copy to not let anyone fiddling with it"
	^ elements copy! !

!ROView methodsFor: 'accessing' stamp: ''!
elementsDo: aBlock
	^ elements copy do: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 4/14/2012 18:33'!
elementsFromModels: objects
	^ (objects collect: [ :o | self elementFromModel: o ]) copyWithout:  nil
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementsSuchThat: aBlock
	^ elements copy select: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 15:41'!
elementsWithModelDo: aBlock
	^ (elements copy select: [ :n | n model notNil ]) do: aBlock
	! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 6/3/2012 15:11'!
encompassingRectangle
	"Return the encompassing rectangle of the view. All the elements are contained in this rectangle"

	| max maxPoint lowerPoint |
	max := 1000000.
	maxPoint := max negated @ max negated.
	lowerPoint := max @ max.
	
	self elementsDo: [ :el |
		maxPoint := maxPoint max: el bounds bottomRight.
		lowerPoint := lowerPoint min: el position ].

	^ lowerPoint corner: maxPoint! !

!ROView methodsFor: 'initialize' stamp: 'AlexandreBergel 6/9/2012 15:13'!
initialize 
	super initialize.
	elements := OrderedCollection new.
	camera := ROCamera new.
	eventHandler := ROAnnouncer new.
	title := self class defaultWindowTitle.
	backgroundColor := Color white.! !

!ROView methodsFor: 'testing' stamp: 'AlexandreBergel 4/18/2012 15:35'!
is: aClass
	"Not sure whether this is important or not"
	^ false! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 9/25/2012 15:42'!
localElementAt: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	| el |
	el := (elements reverse detect: [ :e | e contains: (aPoint - e topLeft) ] ifNone: [ ^ self ]).
	^ el elementAt: (aPoint - el topLeft)
	! !

!ROView methodsFor: 'accessing' stamp: ''!
localElementAtRealPoint: aPoint

	^ self localElementAt: (camera realToVirtualPoint: aPoint)! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 7/29/2012 09:20'!
model
	"To be polymorphic with ROElement"
	
	^ self ! !

!ROView methodsFor: 'accessing' stamp: ''!
numberOfElements
	^ elements size ! !

!ROView methodsFor: 'accessing' stamp: ''!
numberOfNodes
	^ elements size ! !

!ROView methodsFor: 'events' stamp: 'AlexandreBergel 4/18/2012 13:58'!
on: event do: aBlock
	eventHandler when: event do: aBlock! !

!ROView methodsFor: 'opening' stamp: ''!
open
	^ self openInWindow! !

!ROView methodsFor: 'opening' stamp: ''!
openInWindow
	^ self openInWindowSized: self defaultWindowSize! !

!ROView methodsFor: 'opening' stamp: 'AlexandreBergel 7/25/2012 16:15'!
openInWindowSized: aPoint

	^ ROPlatform current widgetFactory forView: self windowSized: aPoint
	! !

!ROView methodsFor: 'accessing' stamp: ''!
positionRelativeTo: anElement
	^ 0 @ 0! !

!ROView methodsFor: 'accessing' stamp: 'VanessaPena 8/29/2012 05:08'!
remove: element 
	elements remove: element ifAbsent:[].
	! !

!ROView methodsFor: 'accessing' stamp: ''!
remove: element ifAbsent: aBlock
	elements remove: element ifAbsent: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 14:26'!
resizeStrategy
	^ ROFixedSizedParent instance! !

!ROView methodsFor: 'events' stamp: ''!
signalUpdate
	self announce: RORefreshNeeded! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 13:55'!
sortElementsWith: aTwoArgBlock
	elements sort: aTwoArgBlock
	
! !

!ROView methodsFor: 'accessing' stamp: ''!
title
	^ title! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 7/6/2012 13:58'!
title: aString
	"Set the title of the view. Useful when opening up a window"
	
	title := aString! !

!ROView methodsFor: 'camera' stamp: ''!
translateBy: point
	self cameraTranslateBy: point negated! !

!ROView methodsFor: 'camera' stamp: ''!
translateByRealPoint: aPoint 
	| p1 p2 |
	p1 := self camera position.
	p2 := self camera realToVirtualPoint: aPoint. 
	self translateBy: (p2 - p1).
! !

!ROView methodsFor: 'camera' stamp: 'AlexandreBergel 6/5/2012 00:30'!
translateTo: point
	self cameraTranslateTo: point negated! !

!ROView methodsFor: 'accessing' stamp: ''!
view
	^ self ! !

ROView subclass: #ROViewStack
	instanceVariableNames: 'views'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROViewStack methodsFor: 'accessing' stamp: ''!
addFirst: aView
	views addFirst: aView.
	self announce: (ROViewChanged new newView: aView).! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
addLast: aView
	views addLast: aView.
	self announce: (ROViewChanged new newView: aView).! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
addView: aView
	self addLast: aView! !

!ROViewStack methodsFor: 'rendering' stamp: 'AlexandreBergel 8/19/2012 09:56'!
drawOn: aROCanvas
	self viewDo: [ :v | v drawOn: aROCanvas ].
	self drawElementsOn: aROCanvas
! !

!ROViewStack methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2012 17:36'!
elementAtRealPosition: aPoint
	"Override of the superclass. If nothing is found in myself, then we look in the embedded views"

 	| t el |
	
	el := self elementAt: (self camera realToVirtualPoint: aPoint).
	(el == self) 
		ifTrue: [ self viewDo: [ :v | 
					^ v elementAtRealPosition: aPoint ] ]
		ifFalse: [ ^ el ].
	^ self
! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
firstView
	^ views first! !

!ROViewStack methodsFor: 'initialize' stamp: ''!
initialize
	super initialize.
	views := OrderedCollection new.
	 ! !

!ROViewStack methodsFor: 'interactions' stamp: ''!
on: eventClass do: aBlock
	super on: eventClass do: aBlock.
	self viewDo: [ :v | v on: eventClass do: aBlock ]! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
replaceFirstBy: view
	views removeFirst.
	self addFirst: view ! !

!ROViewStack methodsFor: 'opening' stamp: ''!
viewDo: aBlock
	views do: [:v | aBlock value: v ].! !

!ROViewStack methodsFor: 'opening' stamp: ''!
viewReverseDo: aBlock
	views do: [:v | aBlock value: v ].
				
	! !

ROObject subclass: #ROVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

ROVisitor subclass: #ROCountingVisitor
	instanceVariableNames: 'nbOfNodes nbOfEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROCountingVisitor methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	nbOfEdges := 0.
	nbOfNodes := 0! !

!ROCountingVisitor methodsFor: 'accessing' stamp: ''!
nbOfEdges
	^ nbOfEdges! !

!ROCountingVisitor methodsFor: 'accessing' stamp: ''!
nbOfNodes
	^ nbOfNodes! !

!ROCountingVisitor methodsFor: 'visiting' stamp: ''!
visitEdge: anEdge
	nbOfEdges := nbOfEdges + 1! !

!ROCountingVisitor methodsFor: 'visiting' stamp: ''!
visitNode: aNode
	nbOfNodes := nbOfNodes + 1! !

ROVisitor subclass: #ROHighlighter
	instanceVariableNames: 'elementsToHighlight color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROHighlighter classSide methodsFor: 'public' stamp: ''!
for: aBlockOrSymbol in: view

	^ self on: (view elementsSuchThat: aBlockOrSymbol) in: view! !

!ROHighlighter classSide methodsFor: 'public' stamp: 'AlexandreBergel 4/17/2012 17:00'!
on: elementsOrSingleElement in: view
	elementsOrSingleElement isCollection ifFalse: [ ^ self on: (Array with: elementsOrSingleElement) ].

	^ self new on: elementsOrSingleElement in: view! !

!ROHighlighter methodsFor: 'accessing' stamp: ''!
color
	^ color! !

!ROHighlighter methodsFor: 'accessing' stamp: ''!
color: anObject
	color := anObject! !

!ROHighlighter methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/5/2012 21:48'!
initialize
	super initialize.
	color := Color red! !

!ROHighlighter methodsFor: 'public' stamp: 'AlexandreBergel 4/30/2012 17:58'!
on: elements in: view

	(elements isCollection and: [ elements notEmpty ]) ifFalse: [ ^ self ].
	
	elementsToHighlight := elements.
	self runOn: view.
	elements first signalUpdate! !

!ROHighlighter methodsFor: 'visiting' stamp: 'AlexandreBergel 5/7/2012 11:48'!
visitNode: aNode
	| v |
	(elementsToHighlight includes: aNode)
		ifTrue: [ v := ( aNode getShape: ROBox). 
			v ifNotNil: [ v  borderColor: self color ] ]! !

!ROVisitor methodsFor: 'public' stamp: ''!
runOn: aROView 
	aROView elementsDo: [ :el | el accept: self ] ! !

!ROVisitor methodsFor: 'visit' stamp: ''!
visitEdge: anEdge! !

!ROVisitor methodsFor: 'visit' stamp: ''!
visitNode: aNode! !

Object subclass: #ROSortBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSortBlock methodsFor: 'accessing' stamp: ''!
fixTemps! !

!ROSortBlock methodsFor: 'accessing' stamp: ''!
value: assocA value: assocB
	"Return false if assocA is bigger than assocB.
	Return true if assocA is smaller than assocB.
	-> Inverted list with biggest elements first"
	
	| a b offset |
	offset := 0.
	a := assocA value.
	b := assocB value.
	[(a size > offset)
		and: [(b size > offset) and: [(a at: a size - offset) = (b at: b size - offset)]]]
		whileTrue: [offset := offset + 1].	"Corner cases"
	(a size = b size and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3], [3, 3]"
	(a size > offset and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3, 6], [3, 3]"
	(b size > offset and: [a size = offset]) ifTrue: [ ^ false ].	"[3, 3], [3, 3, 6]"	"Normal case"
	^(a at: a size - offset) >= (b at: b size - offset)! !

!Symbol methodsFor: '*roassal-core' stamp: ''!
roValue: anObject 
	^ anObject perform: self! !

!Color class methodsFor: '*roassal-core' stamp: ''!
gray256: intensity
	"between 0 and 256"
	| i |
	i := intensity asFloat / 256.
	^ self r:  i g: i b: i ! !

!Color class methodsFor: '*roassal-core' stamp: ''!
wheel: s alpha: a
	^ (Color wheel: 6) collect: [:c | c alpha: a ].! !
